/*
** Copyright (C) 2001 Albert L. Faber
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


//ss #include <AfxWin.h> // for CString
#include <windows.h> // for BOOL, DWORD.. etc
#include <stdio.h> // for sprintf

#include "Ini.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CIni::CIni(  )
{
}


CIni::~CIni()
{
}



// **********************************************************************************

BOOL CIni::SetValue(const char * cSection, const char * cItem, const char * cVal)
{
	//ss ASSERT( !m_strFileName.IsEmpty() );
	if(m_strFileName[0] == 0)
		return false;

	return WritePrivateProfileString( cSection, cItem, cVal, m_strFileName );
}

BOOL CIni::SetValue(const char * cSection, const char * cItem, const int iVal)
{
	char strEntry[ 128 ]; //ss CString strEntry;
	sprintf(strEntry, "%d", iVal); //ss strEntry.Format( "%d", iVal );
	return SetValue( cSection, cItem, strEntry );
}

BOOL CIni::SetValue(const char * cSection, const char * cItem, const long lVal)
{
	return SetValue( cSection, cItem, (int) lVal );
}

BOOL CIni::SetValue(const char * cSection, const char * cItem, const DWORD dwVal)
{
	return SetValue( cSection, cItem, (int)dwVal );
}



//ss CString CIni::GetValue( const char * cSection, const char * cItem, CString strDefault )
char * CIni::GetValue( const char * cSection, const char * cItem, char * strDefault )
{
	//ss ASSERT( !m_strFileName.IsEmpty() );
	if(m_strFileName[0] == 0)
		return NULL;

	memset(m_lpszValue, 0, sizeof(m_lpszValue)); //ss CHAR lpszValue[ 1024 ] = {'\0',};

	::GetPrivateProfileString(	cSection,
								cItem,
								strDefault,
								m_lpszValue, //ss lpszValue,
								sizeof(m_lpszValue), //ss sizeof( lpszValue),
								m_strFileName );

// printf("m_strFileName='%s' m_lpszValue='%s'\n", m_strFileName, m_lpszValue); //ss

	return m_lpszValue; //ss return CString( lpszValue );
}

INT CIni::GetValue( const char * cSection, const char * cItem, const INT nDefault )
{
	INT nReturn = nDefault;

	//ss CString strReturn = GetValue( cSection, cItem, "" );
	char *strReturn = GetValue( cSection, cItem, "" );

	//ss if ( !strReturn.IsEmpty() )
	if (strReturn[0] != 0)
	{
		nReturn = atoi( (LPSTR)(LPCSTR)strReturn );
	}

	return nReturn;
}

LONG CIni::GetValue( const char * cSection, const char * cItem, const LONG nDefault )
{
	return (LONG) GetValue ( cSection, cItem, (INT) nDefault );
}

DWORD CIni::GetValue( const char * cSection, const char * cItem, const DWORD nDefault )
{
	return (DWORD) GetValue ( cSection, cItem, (INT) nDefault );
}



