#!/bin/sh

# mamkfaacosx.sh

# this script makes libfaac.a for OSX
# from the faac-1.28.tar.gz release

# run from the MoreAmp/libs dir

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamkfaacosx.sh : not in libs"
 echo >&2 "mamkfaacosx.sh : not in libs"
 exit 1
fi

osxdir="osx"

# newer faac requires autoconf >= 2.60, which we don't have on osx 10.4
# so we don't build, we just copy the libs in libsosx104
#
# to build the faac libs for OS X 10.4 we run this script on OS X 10.6
# and exit between configure, before make, then run make in OS X 10.4
# and save the libs made on OS X 10.4 in libsosx104.
# Build liblame on 10.4 and copy the libtool from liblame to faac and faad2 before make.

## osversion=`sw_vers | grep 'ProductVersion:' | grep -o '[0-9]*\.[0-9]' | cut -c 1-4`
## if [ "10.4" == "$osversion" ] ; then
osversion=`sw_vers | grep 'ProductVersion:' | grep "10.4." | cut -c 17-20`
if [ "" != "$osversion" ] ; then
 echo "mamkfaacosx.sh : not rebuilt"
 cd faac
 cp -fp ../libsosx104/libfaac.a $osxdir/libfaac.a
 cp -fp ../libsosx104/libmp4v2.a $osxdir/libmp4v2.a
 cd ..
 exit
else
 cd faac
fi

# cleanup from any previous builds

make clean 2>/dev/null
make distclean 2>/dev/null
rm -fr aclocal.m4 bootstrapnu config.h config.h.in config.log config.status
rm -fr configure libtool ltmain.sh Makefile Makefile.in mkinstalldirs stamp-h1
rm -fr autom4te.cache ../../ltmain.sh
rm -fr ./.libs
rm -fr ./.deps
rm -f $osxdir/libfaac.a
rm -f $osxdir/libmp4v2.a
# in case we still have these
rm -f common/mp4v2/.libs/libmp4v2.a
rm -f common/mp4v2/libmp4v2.a

# in case we can't make faac/common/mp4v2/mpeg4ip_config.h
## touch config.h; ln -fs config.h common/mp4v2/mpeg4ip_config.h

# build the libs

chmod a+x bootstrap
./bootstrap
./configure --disable-shared

# exit here when configuring on OS X 10.6 to 'make' on OS X 10.4
## exit

cd libfaac
make
cd ..

cd common/mp4v2
make
# NU ignore this message:
# make: *** No rule to make target `mpeg4ip_config.h', needed by `all-am'.  Stop.

# back to faac
cd ../..

# copy our lib to dir $osxdir/
mkdir -p $osxdir

cp -p libfaac/.libs/libfaac.a ./$osxdir/libfaac.a

# OLD  common/mp4v2/.libs/libmp4v2.a
if [ -f "common/mp4v2/.libs/libmp4v2.a" ] ; then
 cp -p common/mp4v2/.libs/libmp4v2.a ./$osxdir/libmp4v2.a
fi

# NU
if [ -f "common/mp4v2/libmp4v2.a" ] ; then
 cp -p common/mp4v2/libmp4v2.a ./$osxdir/libmp4v2.a
fi

# we need to save these for building MoreAmp
if [ -f "config.h" ] ; then
 cp -fp config.h configtmp.h
 cp -fp config.h common/mp4v2/mpeg4ip_configtmp.h
fi
if [ -f "common/mp4v2/mpeg4ip_config.h" ] ; then
  cp -fp common/mp4v2/mpeg4ip_config.h common/mp4v2/mpeg4ip_configtmp.h
fi

# optional cleanup
make clean 2>/dev/null
#make distclean 2>/dev/null
#rm -fr aclocal.m4 config.h config.h.in config.log config.status
rm -fr aclocal.m4 config.h.in config.log config.status
rm -fr configure libtool ltmain.sh Makefile Makefile.in mkinstalldirs stamp-h1
rm -fr autom4te.cache ../../ltmain.sh
rm -fr ./.libs
rm -fr ./.deps

if [ -f "common/mp4v2/mpeg4ip_configtmp.h" ] ; then
    faac/common/mp4v2/mpeg4ip_configtmp.h
   mv -f common/mp4v2/mpeg4ip_configtmp.h common/mp4v2/mpeg4ip_config.h
fi
if [ -f "configtmp.h" ] ; then
   mv -f configtmp.h config.h
fi

# back to MoreAmp/libs dir
cd ..


