#!/bin/sh

# mamkfaacunix.sh

# this script makes libfaac.a for unix/linux
# from the faac-1.28.tar.gz release

#--------------------------------------------------------------------------

# run from the MoreAmp/libs dir

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamkfaacunix.sh : not in libs"
 echo >&2 "mamkfaacunix.sh : not in libs"
 exit 1
fi

cd faac

# cleanup from any previous builds
make clean 2>/dev/null
make distclean 2>/dev/null
rm -fr aclocal.m4 config.h.in config.h ltmain.sh configure
rm -fr autom4te.cache install-sh mkinstalldirs missing
#rm -fr config.guess config.sub Makefile.in compile depcomp libtool config.status
rm -fr config.guess config.sub Makefile.in compile libtool config.status
rm -fr Makefile faac.spec stamp-h1 config.log
rm -fr libfaac/.libs
rm -fr libfaac/.deps
rm -f libfaac/Makefile
rm -f libfaac.a

# fix line feeds
# chmod +x ../fixlf.sh
# ../fixlf.sh

# reconfigure everything

# fix and run bootstrap
# faac-1.2.6 bootstrap now tests for Darwin
# sed "s/glibtoolize --automake -f/glibtoolize --automake/" bootstrap >tmpfaac0
# sed "s/glibtoolize --automake/glibtoolize --automake -f/" tmpfaac0 >bootstrap
# rm tmpfaac0
 chmod +x bootstrap
./bootstrap

# remove "tag=CC" "tag=cc" "tag=CXX" from Makefile.in's
chmod +x ../fixtag.sh
../fixtag.sh

# build libfaac.a
./configure --disable-shared
cd libfaac
make
cd ..

# build libmp4v2.a
cd common/mp4v2
make
cd ../..

# copy our libs
cp -p libfaac/.libs/libfaac.a .
## cp -p common/mp4v2/.libs/libmp4v2.a .
cp -p common/mp4v2/libmp4v2.a .

# optional cleanup
# make clean 2>/dev/null
# make distclean 2>/dev/null
# rm -fr libfaac/.libs
# rm -fr libfaac/.deps

# back to MoreAmp/libs dir
cd ..
