#!/bin/sh

# mamkfaad2osx.sh

# this script makes libfaad.a and libmp4ff.a for OSX
# from the faad2-2.7.tar.gz.tar release

# run from the MoreAmp/libs dir

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamkfaad2osx.sh : not in libs"
 echo >&2 "mamkfaad2osx.sh : not in libs"
 exit 1
fi

osxdir="osx"

# newer faac requires autoconf >= 2.60, which we don't have on osx 10.4
# so we don't build, we just copy the libs in libsosx104
#
# faad2 builds ok on 10.4 but we want to build the same way as as on 10.6
#
# to build the faad2 libs for OS X 10.4 we run this script on OS X 10.6
# and exit between configure, before make, then run make in OS X 10.4
# and save the libs made on OS X 10.4 in libsosx104
# Build liblame on 10.4 and copy the libtool from liblame to faac and faad2 before make.

## osversion=`sw_vers | grep 'ProductVersion:' | grep -o '[0-9]*\.[0-9]' | cut -c 1-4`
## if [ "10.4" == "$osversion" ] ; then
osversion=`sw_vers | grep 'ProductVersion:' | grep "10.4."`
if [ "" != "$osversion" ] ; then
 cd faad2
 cp -fp ../libsosx104/libfaad.a $osxdir/libfaad.a
 cp -fp ../libsosx104/libmp4ff.a $osxdir/libmp4ff.a
 cd ..
 exit
else
 cd faad2
fi

# cleanup from any previous builds

make clean 2>/dev/null
make distclean 2>/dev/null
rm -fr config.h config.h.in config.status Makefile faad2.spec stamp-h1
rm -fr config.log aclocal.m4 autom4te.cache Makefile.in configure libtool
rm -fr libfaad/.libs common/mp4ff/.libs
rm -fr libfaad/.deps common/mp4ff/.deps
rm -f $osxdir/libfaad.a $osxdir/libmp4ff.a
# in case we still have these
rm -f common/mp4ff/.libs/libmp4ff.a
rm -f common/mp4ff/libmp4ff.a

# reconfigure everything

chmod a+x bootstrap
./bootstrap

# build the libs

# ./configure --disable-shared --disable-server --without-xmms --with-drm=no --with-mpeg4ip=no
./configure --disable-shared --disable-server --without-xmms 

# exit here when configuring on OS X 10.6 to 'make' on OS X 10.4
## exit

cd libfaad
make clean 2>/dev/null
make
cd ..

cd common/mp4ff
make clean 2>/dev/null
make
cd ../..

# copy our libs to dir $osxdir/
mkdir -p $osxdir

cp -p libfaad/.libs/libfaad.a $osxdir/libfaad.a

# OLD  common/mp4v2/.libs/libmp4v2.a
if [ -f "common/mp4ff/.libs/libmp4ff.a" ] ; then
 cp -p common/mp4ff/.libs/libmp4ff.a $osxdir/libmp4ff.a
fi

# NU
if [ -f "common/mp4ff/libmp4ff.a" ] ; then
 cp -p common/mp4ff/libmp4ff.a $osxdir/libmp4ff.a
fi

# optional cleanup

make clean 2>/dev/null
make distclean 2>/dev/null
rm -f ltmain.sh ../../ltmain.sh
#rm -fr config.h config.h.in config.status Makefile faad2.spec stamp-h1
rm -fr config.h.in config.status Makefile faad2.spec stamp-h1
rm -fr config.log aclocal.m4 autom4te.cache Makefile.in configure libtool
rm -fr libfaad/.libs common/mp4ff/.libs
rm -fr libfaad/.deps common/mp4ff/.deps frontend/.deps plugins/mpeg4ip/.deps

# back to MoreAmp/libs dir

cd ..
