// maAudioPA.h


/*
 * MoreAmp
 * Copyright (C) 2004-2014 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __MAAUDIOPA_H__
#define __MAAUDIOPA_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include "maConfig.h"
#include "portaudio.h"
#include "maPlayer.h"

#define PAFIFOOUTBUFSIZE (4 * MAFIFOBUFSIZE)
#define PAFIFOINBUFSIZE (4 * MAFIFOBUFSIZE)
#define PABYTESPERFRAME 4 // a frame here is bytesperchannel * channels
#define PABYTESPERFRAMEMONO 2

#define PAMAXFRAMESOUT 8192 // big enough for paFramesPerBufferUnspecified ?
#define PAMAXFRAMESIN 8192

#define PAFRAMESPERBUFFERIN 2048
#define PAFRAMESPERBUFFEROUT 2048
#define PAFRAMESPERBUFFERINOUT 2048

#if !defined(NODECODEAUDIOIN)
 int maOpenPAStreamIn();
 void maClosePAStreamIn();
 int maOpenPAStreamInOut(PaHostApiIndex host, PaDeviceIndex devicein, PaDeviceIndex deviceout);
void maClosePAStreamInOut();
#endif
int maOpenPAStreamOut(PaHostApiIndex host, PaDeviceIndex device);
void maStopPAStreams();
void maStartPAStreams();
void maClosePAStreamOut(int wait, int force);
void maOutputSetVolume(int volumeL, int volumeR);	

extern char g_pafifooutbuf[];
extern maFifo g_pafifoout;
extern maFifo *g_ppafifoout;
#if !defined(NODECODEAUDIOIN)
 extern maFifo g_pafifoin;
 extern maFifo *g_ppafifoin;
 extern char g_pafifoinbuf[PAFIFOINBUFSIZE];
#endif
int maPaInitialize();
int maPaTerminate();


int maGetAudioInputIndex(int index);
int maGetAudioOutputIndex(int index);	 
int maFreeAudioHosts();
int maScanAudioDevices();
int maRescanAudioDevices(PaHostApiIndex hostin, PaHostApiIndex hostout);
int maSetAudioInputDevice();
int maSetAudioOutputDevice();

typedef struct
{
 fschar *name[MAX_PATH];
 const PaDeviceInfo *info;
 int index; // 0-based popup item index
 int devindex; // 0-based portaudio device index
} maaudiodevice;

typedef struct
{
 fschar *name[MAX_PATH];
 const PaHostApiInfo *info;
 int ndevices;
 maaudiodevice **paudiodevice;
} maaudiohost;
extern maaudiohost **g_paudiohost;

extern int g_numaudiohosts;
extern PaHostApiIndex g_audiohostin;
extern PaHostApiIndex g_audiohostout;
extern PaDeviceIndex g_audiodevicein;
extern PaDeviceIndex g_audiodeviceout;

#ifdef __cplusplus
}
#endif

#endif // __MAAUDIOPA_H_

// eof
