// maControls.cpp

/*
 * MoreAmp
 * Copyright (C) 2004-2014 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "maConfig.h" // included by all moreamp files

#ifdef MAGUIWX

#if defined(MAUSEMABUTTON) || defined(MAUSEMASLIDER) || defined(MAUSEMACHECKBOX)

// this code contains extracts from audacity :
/**********************************************************************

  Audacity: A Digital Audio Editor

  AButton.cpp

  Dominic Mazzoni

  This is a custom button class for Audacity.  The main feature it
  supports that a wxButton does not is mouseovers.  It uses an image
  for all of its states: up, over, down, and disabled, allowing any
  sort of customization you want.  Currently it does not support
  transparency effects, so the images must be rectangular and
  opaque.

**********************************************************************/

// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
 #include "wx/wx.h"
#endif

#include "wx/image.h"
#include "wx/dcclient.h"
#include "wx/dcmemory.h"
#include "wx/control.h"
#include <math.h>
#include "wx/defs.h"
#include "wx/msgdlg.h"
#include "wx/panel.h"
#include "wx/tooltip.h"

#if !defined(MASETFONT)
 #if defined(MASMALLERFONT)
  #include "wx/font.h"
  extern wxFont g_mafont;
  #define MASETFONT(f) f->SetFont(g_mafont)
 #else
  #define MASETFONT(f)
 #endif
#endif

#include "maTypes.h"
 
#if defined(MAUSEMASLIDER)
 #include "maButtonsPlayer/BMSliderThumb.xpm"
 #include "maButtonsPlayer/BMSliderThumbA.xpm"
#endif

#if defined(MAUSEMABUTTON)
 #include "maButtonsPlayer/BMHiliteButton.xpm"
 #include "maButtonsPlayer/BMUpButton.xpm"
 #include "maButtonsPlayer/BMDownButton.xpm"

 // Player controls
 #include "maButtonsPlayer/BMFFwdMask.xpm"
 #include "maButtonsPlayer/BMFFwdDisabled.xpm"
 #include "maButtonsPlayer/BMFFwd.xpm"

 #include "maButtonsPlayer/BMPlayMask.xpm"
 #include "maButtonsPlayer/BMPlayDisabled.xpm"
 #include "maButtonsPlayer/BMPlay.xpm"

 #include "maButtonsPlayer/BMQuitMask.xpm"
 #include "maButtonsPlayer/BMQuitDisabled.xpm"
 #include "maButtonsPlayer/BMQuit.xpm"

 #include "maButtonsPlayer/BMRewindMask.xpm"
 #include "maButtonsPlayer/BMRewindDisabled.xpm"
 #include "maButtonsPlayer/BMRewind.xpm"

 #include "maButtonsPlayer/BMStopMask.xpm"
 #include "maButtonsPlayer/BMStopDisabled.xpm"
 #include "maButtonsPlayer/BMStop.xpm"

 #include "maButtonsPlayer/BMPause.xpm"
 #include "maButtonsPlayer/BMPauseDisabled.xpm"
 #include "maButtonsPlayer/BMPauseMask.xpm"

 // Eq controls
 #include "maButtonsEq/BMMinusMask.xpm"
 #include "maButtonsEq/BMMinusDisabled.xpm"
 #include "maButtonsEq/BMMinus.xpm"

 #include "maButtonsEq/BMPlusMask.xpm"
 #include "maButtonsEq/BMPlusDisabled.xpm"
 #include "maButtonsEq/BMPlus.xpm"

 #include "maButtonsEq/BMMid.xpm"
 //#include "maButtonsEq/BMMidDisabled.xpm"
 #include "maButtonsEq/BMMidMask.xpm"

 #include "maButtonsEq/BMCopyMask.xpm"
 #include "maButtonsEq/BMCopyDisabled.xpm"
 #include "maButtonsEq/BMCopy.xpm"

 #include "maButtonsEq/BMPasteMask.xpm"
 #include "maButtonsEq/BMPasteDisabled.xpm"
 #include "maButtonsEq/BMPaste.xpm"

 #include "maButtonsEq/BMResetMask.xpm"
 #include "maButtonsEq/BMResetDisabled.xpm"
 #include "maButtonsEq/BMReset.xpm"

 #include "maButtonsEq/BMShiftLMask.xpm"
 //#include "maButtonsEq/BMShiftLDisabled.xpm"
 #include "maButtonsEq/BMShiftL.xpm"

 #include "maButtonsEq/BMShiftRMask.xpm"
 //#include "maButtonsEq/BMShiftRDisabled.xpm"
 #include "maButtonsEq/BMShiftR.xpm"

 #include "maButtonsEq/BMInvertMask.xpm"
 //#include "maButtonsEq/BMInvertDisabled.xpm"
 #include "maButtonsEq/BMInvert.xpm"

 // List controls
 #include "maButtonsList/BMInfoMask.xpm"
 #include "maButtonsList/BMInfoDisabled.xpm"
 #include "maButtonsList/BMInfo.xpm"

 #include "maButtonsList/BMLoadedMask.xpm"
 #include "maButtonsList/BMLoadedDisabled.xpm"
 #include "maButtonsList/BMLoaded.xpm"

 #include "maButtonsList/BMSonginfo.xpm"
 #include "maButtonsList/BMSonginfoDisabled.xpm"
 #include "maButtonsList/BMSonginfoMask.xpm"

 #include "maButtonsList/BMSonglistMask.xpm"
 #include "maButtonsList/BMSonglistDisabled.xpm"
 #include "maButtonsList/BMSonglist.xpm"
#endif

#ifdef USE_STATIC_BITMAP
	#include "green.xpm"
	#include "red.xpm"
#endif // USE_STATIC_BITMAP

#include "maControls.h"
#include "maPlayer.h"


#if defined(MAUSEMABUTTON) || defined(MAUSEMASLIDER)
// This looks at the first pixel in the image, and shifts
// the entire image by the vector difference between that 
// pixel and the dstColour.  For better control, use
// ChangeImageColour(wxImage, wxColour*, wxColour*) below
wxImage *ChangeImageColour(wxImage * srcImage, wxColour & dstColour) 
{
	unsigned char *src = srcImage->GetData();
	wxColour c;
	c.Set(src[0], src[1], src[2]);
	return ChangeImageColour(srcImage, c, dstColour);
}

//This will explicitly shift the image color from
// srcColour to dstColour. 
wxImage *ChangeImageColour(wxImage * srcImage,
									wxColour & srcColour,
									wxColour & dstColour) 
{
	// This function takes a source image, which it assumes to
	// be grayscale, and smoothly changes the overall color
	// to the specified color, and returns the result as a
	// new image.  This works well for grayscale 3D images.
	// Use these routines to make tbuttons adapt to the color
	// scheme of the user.

	unsigned char *src = srcImage->GetData();
	int width = srcImage->GetWidth();
	int height = srcImage->GetHeight();

	wxImage * dstImage = new wxImage(width, height);
	unsigned char *dst = dstImage->GetData();

	// Get the source color
	int srcVal[3], srcOpp[3];
	srcVal[0] = srcColour.Red();
	srcVal[1] = srcColour.Green();
	srcVal[2] = srcColour.Blue();

	int dstVal[3], dstOpp[3];
	dstVal[0] = dstColour.Red();
	dstVal[1] = dstColour.Green();
	dstVal[2] = dstColour.Blue();

	int i;
	for(i = 0; i < 3; i++)
	{
		srcOpp[i] = 255 - srcVal[i];
		dstOpp[i] = 255 - dstVal[i];
	}

	int c = 0;
	for(i = 0; i < width * height * 3; i++)
	{
		int s = (int) *src;

		if(s > srcVal[c])
			*dst++ = dstVal[c] + dstOpp[c] * (s - srcVal[c]) / srcOpp[c];

		else
			*dst++ = dstVal[c] * s / srcVal[c];
		src++;
		c = (c + 1) % 3;
	}

	return dstImage;
}
#endif


#if defined(MAUSEMABUTTON)
wxImage *OverlayImage(wxImage * background, wxImage * foreground,
							 wxImage * mask, int xoff, int yoff) 
{
	// Takes a background image, foreground image, and mask
	// (i.e. the alpha channel for the foreground), and
	// returns an new image where the foreground has been
	// overlaid onto the background using alpha-blending,
	// at location (xoff, yoff).
	unsigned char *bg = background->GetData();
	unsigned char *fg = foreground->GetData();
	unsigned char *mk = mask->GetData();

	int bgWidth = background->GetWidth();
	int bgHeight = background->GetHeight();
	int fgWidth = foreground->GetWidth();
	int fgHeight = foreground->GetHeight();
	int mkWidth = mask->GetWidth();
	int mkHeight = mask->GetHeight();

	// Now, determine the dimensions of the images to be masked together
	// on top of the background.  This should be equal to the area of the
	// smaller of the foreground and the mask, as long as it is 
	// within the area of the background, given the offset.

	// Make sure the foreground size is no bigger than the mask
	int wCutoff = (fgWidth < mkWidth) ? fgWidth : mkWidth;
	int hCutoff = (fgHeight < mkHeight) ? fgHeight : mkHeight;

	// If the masked foreground + offset is bigger than the background, masking
	// should only occur within these bounds of the foreground image
	wCutoff = (bgWidth - xoff > wCutoff) ? wCutoff : bgWidth - xoff;
	hCutoff = (bgHeight - yoff > hCutoff) ? hCutoff : bgHeight - yoff;

	// Make a new image the size of the background
	wxImage * dstImage = new wxImage(bgWidth, bgHeight);
	unsigned char *dst = dstImage->GetData();
	memcpy(dst, bg, bgWidth * bgHeight * 3);

	// Go through the foreground image bit by bit and mask it on to the
	// background, at an offset of xoff,yoff.
	// BUT...Don't go beyond the size of the background image,
	// the foreground image, or the mask 
	int x, y;
	for(y = 0; y < hCutoff; y++)
	{

		unsigned char *bkp = bg + 3 * ((y + yoff) * bgWidth + xoff);
		unsigned char *dstp = dst + 3 * ((y + yoff) * bgWidth + xoff);

		for(x = 0; x < wCutoff; x++) {

			int value = mk[3 * (y * mkWidth + x)];
			int opp = 255 - value;

			for(int c = 0; c < 3; c++)
				dstp[x * 3 + c] = 
					((bkp[x * 3 + c] * opp) + 
					 (fg[3 * (y * fgWidth + x) + c] * value)) / 255;
		}
	} 
	return dstImage;
}
#endif


#if defined(MAUSEMASLIDER)
// Creates an image with a solid background color
wxImage *CreateBackground(int width, int height, wxColour colour)
{
	wxImage *i = new wxImage(width, height);
	unsigned char *ip;
	int srcVal[3];
	int x;

	srcVal[0] = colour.Red();
	srcVal[1] = colour.Green();
	srcVal[2] = colour.Blue();

	ip = i->GetData();
	for(x=0; x<width*height; x++)
	{
		*ip++ = srcVal[0];
		*ip++ = srcVal[1];
		*ip++ = srcVal[2];
	}

	return i;
}


bool AColor::inited = false;
wxBrush AColor::lightBrush[2];
wxBrush AColor::mediumBrush[2];

wxBrush AColor::darkBrush[2];
wxPen AColor::lightPen[2];
wxPen AColor::mediumPen[2];
wxPen AColor::darkPen[2];

void AColor::Light(wxDC * dc, bool selected)
{
	if(!inited)
		Init();
	int index = (int) selected;
	dc->SetBrush(lightBrush[index]);
	dc->SetPen(lightPen[index]);
}

void AColor::Medium(wxDC * dc, bool selected)
{
	if(!inited)
		Init();
	int index = (int) selected;
	dc->SetBrush(mediumBrush[index]);
	dc->SetPen(mediumPen[index]);
}

void AColor::Dark(wxDC * dc, bool selected)
{
	if(!inited)
		Init();
	int index = (int) selected;
	dc->SetBrush(darkBrush[index]);
	dc->SetPen(darkPen[index]);
}

void AColor::Init()
{
	if(inited)
		return;
		
#if defined(__WXMSW__)
	wxColour light =
		wxSystemSettingsNative::GetColour(wxSYS_COLOUR_3DHIGHLIGHT);
	wxColour med = wxSystemSettingsNative::GetColour(wxSYS_COLOUR_3DFACE);
	wxColour dark =
		wxSystemSettingsNative::GetColour(wxSYS_COLOUR_3DSHADOW);

	// unselected
	lightBrush[0].SetColour(light);
	mediumBrush[0].SetColour(med);
	darkBrush[0].SetColour(dark);
	lightPen[0].SetColour(light);
	mediumPen[0].SetColour(med);
	darkPen[0].SetColour(dark);

	// selected
	lightBrush[1].SetColour(204, 204, 255);
	mediumBrush[1].SetColour(200, 200, 214);
	darkBrush[1].SetColour(148, 148, 170);
	lightPen[1].SetColour(204, 204, 255);
	mediumPen[1].SetColour(200, 200, 214);
	darkPen[1].SetColour(0, 0, 0);

#else

 #if defined(__WXMAC__) // && defined(TARGET_CARBON)

	// unselected
	lightBrush[0].SetColour(236, 236, 236);
	mediumBrush[0].SetColour(220, 220, 220);
	darkBrush[0].SetColour(140, 140, 160);
	lightPen[0].SetColour(246, 246, 255);
	mediumPen[0].SetColour(232, 232, 232);
	darkPen[0].SetColour(140, 140, 160);

	// selected
	lightBrush[1].SetColour(204, 204, 255);
	mediumBrush[1].SetColour(180, 180, 192);
	darkBrush[1].SetColour(148, 148, 170);
	lightPen[1].SetColour(204, 204, 255);
	mediumPen[1].SetColour(180, 180, 192);
	darkPen[1].SetColour(0, 0, 0);

 #else

	// unselected
	lightBrush[0].SetColour(255, 255, 255);
	mediumBrush[0].SetColour(204, 204, 204);
	darkBrush[0].SetColour(130, 130, 130);
	lightPen[0].SetColour(255, 255, 255);
	mediumPen[0].SetColour(204, 204, 204);
	darkPen[0].SetColour(130, 130, 130);

	// selected
	lightBrush[1].SetColour(204, 204, 255);
	mediumBrush[1].SetColour(180, 180, 192);
	darkBrush[1].SetColour(148, 148, 170);
	lightPen[1].SetColour(204, 204, 255);
	mediumPen[1].SetColour(180, 180, 192);
	darkPen[1].SetColour(0, 0, 0);

 #endif

#endif

	inited = true;
	
} // Init
#endif // MAUSEMASLIDER


#if defined(MAUSEMABUTTON)
BEGIN_EVENT_TABLE(maButton, wxWindow)
#if defined(MAMOUSEWHEELnot)
	EVT_MOUSEWHEEL(maButton::OnMouseEvent)
#endif
	EVT_LEFT_DOWN(maButton::OnMouseEvent)
	EVT_LEFT_UP(maButton::OnMouseEvent)
	EVT_PAINT(maButton::OnPaint)
END_EVENT_TABLE()


maButton::maButton(wxWindow * parent, wxWindowID id,
					  const wxPoint & pos,
					  const wxSize & size,
					  char **upXPM,
					  char **overXPM,
					  char **downXPM,
					  char **disXPM,
					  bool processdownevents) : wxControl/*wxWindow*/(parent, id, pos, size)
{
	mWasShiftDown = false;
	mButtonIsDown = false;
	mButtonState = AButtonUp;
	mIsClicking = false;
	mEnabled = true;
	mPaintDown = false;
	mProcessDownEvents = processdownevents;

	mBitmap[0] = new wxBitmap((const char **) upXPM);
	mBitmap[1] = new wxBitmap((const char **) overXPM);
	mBitmap[2] = new wxBitmap((const char **) downXPM);
	mBitmap[3] = new wxBitmap((const char **) disXPM);

	GetSize(&mWidth, &mHeight);
}


maButton::maButton(wxWindow * parent, wxWindowID id,
					  const wxPoint & pos,
					  const wxSize & size,
					  wxImage *up,
					  wxImage *over,
					  wxImage *down,
					  wxImage *dis,
					  bool processdownevents) : wxControl/*wxWindow*/(parent, id, pos, size)
{
	mWasShiftDown = false;
	mButtonIsDown = false;
	mButtonState = AButtonUp;
	mIsClicking = false;
	mEnabled = true;
	mPaintDown = false;
	mProcessDownEvents = processdownevents;

#if (MAGUIWX == 4)
	mBitmap[0] = new wxBitmap(up);
	mBitmap[1] = new wxBitmap(over);
	mBitmap[2] = new wxBitmap(down);
	mBitmap[3] = new wxBitmap(dis);
#else
	wxImage &upref = *up;
	wxImage &overref = *over;
	wxImage &downref = *down;
	wxImage &disref = *dis;
	mBitmap[0] = new wxBitmap(upref);
	mBitmap[1] = new wxBitmap(overref);
	mBitmap[2] = new wxBitmap(downref);
	mBitmap[3] = new wxBitmap(disref);
#endif
	
	GetSize(&mWidth, &mHeight);
}


maButton::~maButton()
{
	delete mBitmap[0];
	delete mBitmap[1];
	delete mBitmap[2];
	delete mBitmap[3];
}


void maButton::OnPaint(wxPaintEvent& WXUNUSED(event))
{
	wxPaintDC dc(this);
	int bitmap = (mEnabled && !mPaintDown) ? AButtonUp : AButtonDown;	

#if defined(__MAOSX__)
	dc.DrawBitmap(*mBitmap[bitmap], 0, 0);
#else
	wxMemoryDC memDC;
	memDC.SelectObject(*mBitmap[bitmap]);
	dc.Blit(0, 0, mWidth, mHeight, &memDC, 0, 0, wxCOPY, FALSE);
#endif
	
} // OnPaint


void maButton::OnMouseEvent(wxMouseEvent &event)
{
	/*
	if(event.Leaving()){
		GetActiveProject()->TP_DisplayStatusMessage("",0);
	}

	// In windows, Leave/Enter events appear to clobber each other,
	// so the new enter event doesn't get processed.  If we change to a newer
	// version of WXWINDOWS, (Post version 2), this may be fixed

#if defined(__WXMSW__)
	else
	{
#else
	else if(event.Entering())
	{
#endif

	// Display the tooltip in the status bar
		wxString tip = this->GetToolTip()->GetTip();
		if(!mEnabled)
			tip += _(" (disabled)");
		GetActiveProject()->TP_DisplayStatusMessage(tip, 0);
	}
	*/
	
#if defined(MAMOUSEWHEELnot)
	int wheelRotation;
	if(g_sets.mousewheel && (wheelRotation = event.GetWheelRotation()) != 0)
	{
		if(wheelRotation > 0)
			ChangeVolume(MAWHEELVOLUMEDELTA);
		else
			ChangeVolume(-MAWHEELVOLUMEDELTA);
		return;
	}
#endif

	// If the graphical button is disabled, or the button is down
	// the button can't process down events, get out of here
	
	if(!mEnabled || (mButtonIsDown && !mProcessDownEvents))
	{
		this->Refresh(false);
		return;
	}

	// If the mouse button is released, the following stuff happens
	
	if(event.ButtonUp())
	{
		mIsClicking = false;
		if(HasCapture())
			ReleaseMouse();

		// Only process the event if you are releasing on the button
		// if you moved off the button, dump the event
		
		if(event.m_x >= 0 && event.m_y >= 0 && event.m_x < mWidth && event.m_y < mHeight)
		{
			// Although this may be a little redundant, I'm segregating
			// two types of buttons for clarity
			// mProcessDownEvents=false buttons can only by pushed down-their pushing up must
			// be handled immediately, by the action of another button, or by
			// some other event (e.g., the file ending stops playing and pops up
			// the play button.
			// mProcessDownEvents=true buttons can be pushed down and then pushed up again
			// by clicking on them again once in the down state
			
			if(mProcessDownEvents)
			{
				if(mButtonIsDown)
				{		
					// If the button is down, set the button state to up and 'over'--highlighted
					
					mButtonState = AButtonOver;
					mButtonIsDown = false;			 
				}
				else
				{
					// If the button is up, set the button state to down
					
					mButtonState = AButtonDown;
					mButtonIsDown = true;
				}
			}
			else
			{
				// If it is a one-state button, set the button state to down undconditionally
				
				mButtonState = AButtonDown;
				mButtonIsDown = true;
			}

			mWasShiftDown = event.ShiftDown();

			// Create an event for the parent window to process
			
			wxCommandEvent *e = new wxCommandEvent(wxEVT_COMMAND_BUTTON_CLICKED, GetId());

#if (MAGUIWX == 9)
			GetParent()->GetEventHandler()->ProcessEvent(*e);
#else
            GetParent()->ProcessEvent(*e);
#endif
			delete e;
		}

		this->Refresh(false);
		return;
		
	} // if(event.ButtonUp()
	
	// This handles the mouse down event
	
	else if(event.ButtonDown())
	{
		mIsClicking = true;
		CaptureMouse();
	}

	// This following logic handles button in situations other than the up-click
	
	if(mProcessDownEvents)
	{
		if(mIsClicking)
		{
			if(event.m_x >= 0 && event.m_y >= 0 && event.m_x < mWidth && event.m_y < mHeight)
				mButtonState =  AButtonDown;
			else
				mButtonState = mButtonIsDown ? AButtonDown : AButtonUp;
		}
		else
		{
			/*
			if(event.Entering())
				mButtonState = mButtonIsDown ? AButtonDown : AButtonOver;
				
			// If mouse leaves the button, put it in its previous state
			
			else if(event.Leaving())
				mButtonState = mButtonIsDown ? AButtonDown : AButtonUp;
			*/
		}
	}
	else  // This is a push-down-only traditional button
	{
		if(mIsClicking)
		{
			if(event.m_x >= 0 && event.m_y >= 0 && event.m_x < mWidth && event.m_y < mHeight)
				mButtonState = AButtonDown;
			else
				mButtonState = AButtonUp;
		}
		else
		{
			/*
			if(event.Entering())
				mButtonState = AButtonOver;
			else if(event.Leaving())
				mButtonState = AButtonUp;
			*/
		}
	}
	
	// Do a final Refresh() event
	this->Refresh(false);

} // OnMouseEvent


bool maButton::WasShiftDown()
{
	return mWasShiftDown;
}


bool maButton::Enable(bool enable)
{
	bool ret = (enable == mEnabled) ? FALSE : TRUE;
	
	mEnabled = (enable) ? TRUE : FALSE;
	
	if(mButtonIsDown)
		mButtonState = AButtonDown;
	else
		mButtonState = AButtonUp;
		
	this->Refresh(false);
	
	return ret;
	
} // Enable


bool maButton::Disable()
{
	mEnabled = false;
	
	mButtonState = AButtonDis;
	
	if(GetCapture() == this)
		ReleaseMouse();
		
	this->Refresh(false);
	
	return TRUE;
	
} // Disable


void maButton::PushDown()
{
	mButtonIsDown = true;
	mButtonState = AButtonDown;
	this->Refresh(false);
}


void maButton::PopUp()
{
	mButtonIsDown = false;
	mButtonState = AButtonUp;
	if(GetCapture()==this)
		ReleaseMouse();
	this->Refresh(false);
}


void maButton::PaintUp()
{
	mPaintDown = false;
	this->Refresh(false);
}


void maButton::PaintDown()
{
	mPaintDown = true;
	this->Refresh(false);
}


void maButton::Command(wxCommandEvent &event)
{
	/* from wx button.cpp
	if((ControlHandle) m_macControl )
	{
		HiliteControl((ControlHandle) m_macControl , kControlButtonPart );
		unsigned long finalTicks;
		Delay( 8 , &finalTicks );
		HiliteControl((ControlHandle) m_macControl , 0);
	}
	*/
	PushDown();
#if defined(__MAUNIX__) || defined(__WXGTK__)
 #if (MAGUIWX == 9)
	GetParent()->GetEventHandler()->ProcessEvent(event);
 #else
	GetParent()->ProcessEvent(event);
 #endif
#else
 	ProcessCommand(event);
#endif
}
#endif // MAUSEMABUTTON


#if defined(MAUSEMACHECKBOX)
maCheckBox::maCheckBox(wxWindow *parent, wxWindowID id, const wxString& label,
	const wxPoint& pos,
	const wxSize& size, long style,
	const wxString& name)
	//: MACHECKBOXCLASS() 
	//: MACHECKBOXCLASS(parent,id, label, pos, size, style, validator, name)
	: MACHECKBOXCLASS(	parent, id, 
						//Create(parent, -1, label, pos, size, style, validator, name), // blue == unchecked
						CreateBitmapForButton(FALSE),
						pos, wxSize(CHECKBOXWIDTH, CHECKBOXHEIGHt), //wxDefaultSize,
						wxBU_EXACTFIT)
{
	wxPoint lpos = pos;
#if defined(__WXGTK__) // font size will affect this
 #if (defined(__MAOSX__) || defined(MACUNIX))
	lpos.y += 4;
 #else
	lpos.y += 2;
 #endif
#endif
 	Create(parent, id, label, lpos, size, style, name);
}


maCheckBox::~maCheckBox()
{
	if(m_plabel)
		delete m_plabel;
}


wxBitmap maCheckBox::Create(wxWindow *parent, wxWindowID id, const wxString& label,
			const wxPoint& pos,
			const wxSize& size,
			long style,
			const wxString& name)
{
#ifdef USE_STATIC_BITMAP
 #error USE_STATIC_BITMAP needs work
	m_button = new wxStaticBitmap(this/*parent*/, id, wxIcon(red_xpm));
#else
	m_bmBlue =	CreateBitmapForButton(0); // blue == unchecked
	m_bmGreen =	CreateBitmapForButton(1); // green == checked
	m_bmRed =	CreateBitmapForButton(2); // red == alt checked
	
	m_button = this;// new wxBitmapButton(parent, id, m_bmBlue, // blue == unchecked
					//	pos, wxSize(CHECKBOXWIDTH, CHECKBOXHEIGHt), //wxDefaultSize,
					//	wxBU_EXACTFIT);
#endif

	m_value = false;
	m_parent = parent;
	m_id = id;
	m_label = label;
	m_pos = pos;
	m_size = size;
	m_style = style;
	
	if(style)
		m_onalt = true;		// on is red
	else
		m_onalt = false;	// on is green
	
	m_name = name;
	
	m_plabel = new wxStaticText(parent, -1, label, wxPoint(pos.x + CHECKBOXWIDTH, pos.y - 1));
		
	MASETFONT(m_plabel);
	
	return m_bmBlue; //(m_button) ? TRUE : FALSE;
	
} // Create

	
void maCheckBox::SetLabel(wxString label)
{
	if(m_plabel)
		m_plabel->SetLabel(label);

} // SetLabel


void maCheckBox::SetValue(bool value)
{
	m_value = (value) ? TRUE : FALSE;

	if(!m_button)
		return;
	
	if(m_value) // checked, green or red
	{	
#ifdef USE_STATIC_BITMAP
		m_button->SetIcon(wxICON(green_xpm));
#else
		if(m_onalt)
			m_button->SetBitmapLabel(m_bmRed); // CreateBitmapForButton(2));
		else
			m_button->SetBitmapLabel(m_bmGreen); // CreateBitmapForButton(1));
		
		m_button->Refresh();	
#endif
	}
	else // unchecked, blue
	{
#ifdef USE_STATIC_BITMAP
		m_button->SetIcon(wxICON(red_xpm));
#else
		m_button->SetBitmapLabel(m_bmBlue); // CreateBitmapForButton(0));
		m_button->Refresh();
#endif
	}
	
} // SetValue


bool maCheckBox::GetValue()
{
	return m_value;
}
	

bool maCheckBox::IsChecked()
{
	return m_value;
}


#if (defined(__MAOSX__) || defined(__WXMAC__)) && !defined(__WXGTK__)
 void maCheckBox::MacHandleControlClick(WXWidget control, wxInt16 controlpart)
 {
	SetValue(!GetValue());
	wxCommandEvent event(wxEVT_COMMAND_CHECKBOX_CLICKED, m_id);
	event.SetInt(GetValue());
	event.SetEventObject(this);
	ProcessCommand(event);
 }
#endif

	
void maCheckBox::LabelHide()
{
	if((const void*)m_label != NULL)
		SetLabel(_T(""));
}


void maCheckBox::LabelShow()
{
	if((const void*)m_label != NULL)
		SetLabel(m_label);
}


#if defined(__MAUNIX__)
 void maCheckBox::Command(wxCommandEvent &event)
 {
	OnButton(event);
 }
#else
 void maCheckBox::Command(wxCommandEvent& WXUNUSED(event))
 {
	/* from wx button.cpp
	if((ControlHandle)m_macControl)
	{
		HiliteControl((ControlHandle)m_macControl, kControlButtonPart);
		unsigned long finalTicks;
		Delay(8, &finalTicks);
		HiliteControl((ControlHandle)m_macControl, 0);
	}
	
	 ProcessCommand (event);
	*/
 }
#endif


#if defined(MAMOUSEWHEELnot)
void maCheckBox::OnMouseEvent(wxMouseEvent &event)
{
	int wheelRotation;
	
	if(g_sets.mousewheel && (wheelRotation = event.GetWheelRotation()) != 0)
	{
		if(wheelRotation > 0)
			ChangeVolume(MAWHEELVOLUMEDELTA);
		else
			ChangeVolume(-MAWHEELVOLUMEDELTA);
	}
}
#endif


void maCheckBox::OnButton(wxCommandEvent& WXUNUSED(event))
{
	SetValue(!GetValue());
	wxCommandEvent event(wxEVT_COMMAND_CHECKBOX_CLICKED, m_id);
	event.SetInt(GetValue());
	event.SetEventObject(this);
#if defined(__MAUNIX__) || defined(__WXGTK__)
 #if (MAGUIWX == 9)
	GetParent()->GetEventHandler()->ProcessEvent(event);
 #else
	GetParent()->ProcessEvent(event);
 #endif
 #else
 	ProcessCommand(event);
 #endif
}


/*
void wxCheckBox::Command(wxCommandEvent &event)
{
	SetValue ((event.GetInt() != 0));
	ProcessCommand (event);
}

void wxCheckBox::MacHandleControlClick(WXWidget WXUNUSED(control), wxInt16 WXUNUSED(controlpart) ) 
{
	SetValue( !GetValue() );
	wxCommandEvent event(wxEVT_COMMAND_CHECKBOX_CLICKED, m_windowId );
	event.SetInt(GetValue());
	event.SetEventObject(this);
	ProcessCommand(event);
}
*/

/*
WXDLLEXPORT_DATA(extern wxBrush*)	 wxBLUE_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxGREEN_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxWHITE_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxBLACK_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxGREY_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxMEDIUM_GREY_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxLIGHT_GREY_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxTRANSPARENT_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxCYAN_BRUSH;
WXDLLEXPORT_DATA(extern wxBrush*)	 wxRED_BRUSH;
wxBrush* brush = wxTheBrushList->FindOrCreateBrush(wxColour(220, 220, 220), wxSOLID);
 */

//#define BRUSH_ON wxCYAN_BRUSH //wxTRANSPARENT_BRUSH //wxCYAN_BRUSH //wxGREEN_BRUSH
//#define BRUSH_OFF wxLIGHT_GREY_BRUSH //wxRED_BRUSH
#define BRUSH_BACKGROUND wxLIGHT_GREY_BRUSH //wxTRANSPARENT_BRUSH //wxLIGHT_GREY_BRUSH

// pastels
//#define RGBRED		0xbe, 0x81, 0x81 // as exit button
#define RGBRED			0xff, 0x00, 0x00 // bright red for checkbox alternate on
#define RGBYELLOWDARK	0xe7, 0xb7, 0x57 // as stop buton
#define RGBYELLOW		0xff, 0xda, 0x5c
#define RGBGREEN		0x75, 0xd5, 0x70 // as play button
#define RGBGREENLIGHT	0x76, 0xe4, 0x78
#define RGBBLUE			0x46, 0x68, 0xee // as pause button
#define RGBBLUELIGHT	0x76, 0xad, 0xde // as slider thumb inner
#define RGBBLUEDARK		0x10, 0x58, 0xad // as slider thumb outer

#define BRUSH_ON 			(wxTheBrushList->FindOrCreateBrush(wxColour(RGBGREEN),		wxSOLID))
#define BRUSH_ONALT			(wxTheBrushList->FindOrCreateBrush(wxColour(RGBRED),		wxSOLID))
#define BRUSH_OFF			(wxTheBrushList->FindOrCreateBrush(wxColour(RGBBLUE),		wxSOLID))
//#define BRUSH_BACKGROUND	(wxTheBrushList->FindOrCreateBrush(wxColour(RGBBLUELIGHT),	wxSOLID))

wxBitmap maCheckBox::CreateBitmapForButton(int on)
{
#ifdef __MAUNIX__
	static const int BMP_BUTTON_SIZE_X = CHECKBOXWIDTH - 4;
	static const int BMP_BUTTON_SIZE_Y = CHECKBOXHEIGHt - 4;
#else
	static const int BMP_BUTTON_SIZE_X = CHECKBOXWIDTH - 2;
	static const int BMP_BUTTON_SIZE_Y = CHECKBOXHEIGHt - 2;
#endif

	wxBitmap bitmap(BMP_BUTTON_SIZE_X, BMP_BUTTON_SIZE_Y);
	wxMemoryDC dc;
	dc.SelectObject(bitmap);
	
	if(on == 1)
		dc.SetBrush(*BRUSH_ON);
	else if(on == 2)
		dc.SetBrush(*BRUSH_ONALT);
	else
		dc.SetBrush(*BRUSH_OFF);
	
	dc.SetBackground(*BRUSH_BACKGROUND);
	dc.Clear();
#ifdef __MAUNIX__ // DrawRectangle
	dc.DrawRectangle(-1, -1, BMP_BUTTON_SIZE_X, BMP_BUTTON_SIZE_Y); // dc.DrawEllipse(0, 0, BMP_BUTTON_SIZE_X, BMP_BUTTON_SIZE_Y);
#else
	dc.DrawEllipse(0, 0, BMP_BUTTON_SIZE_X, BMP_BUTTON_SIZE_Y);
#endif
	dc.SelectObject(wxNullBitmap);

	return bitmap;
}


/*
void maCheckBox::OnSize(wxSizeEvent &event)
{
	/ *
	wxRect rect;
	
	GetFieldRect(Field_Bitmap, rect);
	wxSize size = m_button->GetSize();

	m_button->Move( rect.x + (rect.width  - size.x) / 2,
					rect.y + (rect.height - size.y) / 2);
	* /
	event.Skip();
}
*/

//	EVT_SIZE(maCheckBox::OnSize)
BEGIN_EVENT_TABLE(maCheckBox, MACHECKBOXCLASS)
#if defined(MAMOUSEWHEELnot)
	EVT_MOUSEWHEEL(maCheckBox::OnMouseEvent)
#endif
	EVT_BUTTON(-1, maCheckBox::OnButton)
END_EVENT_TABLE()
#endif // MAUSEMACHECKBOX


#if defined(MAUSEMASLIDER)
LWSlider::LWSlider(wxWindow *parent, wxString name, const wxPoint &pos,
					const wxSize &size, int style, bool heavyweight)
{
	mName = name;
	mValue = 0;
	mIsDragging = false;
	mParent = parent;
	mStyle = style;
	mHW = heavyweight;
	mID = -1;

	mWidth = size.x;
	mHeight = size.y;

	mAxisX = mWidth  / 2; //- 9;
	mAxisY = mHeight / 2; //- 9;

	wxMemoryDC *dc = new wxMemoryDC();
	wxBitmap *bitmap = new wxBitmap(8, 8);
	dc->SelectObject(*bitmap);
	AColor::Medium(dc, false);
	wxColour bkgnd = dc->GetPen().GetColour();
	AColor::Medium(dc, true);	
	wxColour selBkgnd = dc->GetPen().GetColour();
	wxImage *backgroundImage;	
	backgroundImage = CreateBackground(mHeight, mWidth, bkgnd);
	
#if (MAGUIWX == 4) 
	wxBitmap backgroundBitmap = backgroundImage->ConvertToBitmap(); // wx 2.4	
#else
	wxImage &backgroundImageref = *backgroundImage;
	wxBitmap backgroundBitmap = wxBitmap(backgroundImageref);
#endif
	
	wxImage *thumbImage;
	if(mStyle & 0x8000)
		thumbImage = new wxImage(wxBitmap(BMSliderThumbA).ConvertToImage()); // alt color
	else
		thumbImage = new wxImage(wxBitmap(BMSliderThumb).ConvertToImage());
		
	wxImage *thumb1 = ChangeImageColour(thumbImage, bkgnd);
	wxImage *thumb2 = ChangeImageColour(thumbImage, selBkgnd);
#if (MAGUIWX == 4)
	mThumbBitmap = new wxBitmap(thumb1);
#else
	wxImage &thumb1ref = *thumb1;
	mThumbBitmap = new wxBitmap(thumb1ref);
#endif
#if (MAGUIWX == 4)
	mSelThumbBitmap = new wxBitmap(thumb2);
#else
	wxImage &thumb2ref = *thumb2;
	mSelThumbBitmap = new wxBitmap(thumb2ref);
#endif
	delete thumb1;
	delete thumb2;
	delete thumbImage;
	delete dc;
	delete bitmap;

	mThumbWidth = mThumbBitmap->GetWidth();
	mHalfThumbWidth = mThumbWidth / 2;
	
	mThumbHeight = mThumbBitmap->GetHeight();
	mHalfThumbHeight = mThumbHeight / 2;

	mBottomY = mHeight - mHalfThumbHeight - 1;
	mRightX  = mWidth  - mHalfThumbWidth  - 1;
	
	if(mStyle & wxSL_VERTICAL)
		mRange = mBottomY - mHalfThumbHeight;
	else
		mRange = mRightX  - mHalfThumbWidth;
	
	int i;
	for(i = 0; i < 2; i++)
	{
		wxBitmap *bitmap;

		bitmap = new wxBitmap(mWidth, mHeight);
		wxMemoryDC *dc = new wxMemoryDC();
		dc->SelectObject(*bitmap);

		if(mHW)
			dc->DrawBitmap(backgroundBitmap, 0, 0);
		else
		{
			AColor::Medium(dc, i==1);
			dc->DrawRectangle(0, 0, mWidth, mHeight);
		}

		AColor::Light(dc, i==1);

		if(mStyle & wxSL_VERTICAL)
			dc->DrawLine(mAxisX, mHalfThumbHeight, mAxisX, mBottomY+1);
		else
			dc->DrawLine(mHalfThumbWidth, mAxisY, mRightX+1, mAxisY);
		
		AColor::Dark(dc, i==1);

		if(mStyle & wxSL_VERTICAL)
			dc->DrawLine(mAxisX+1, mHalfThumbHeight, mAxisX+1, mBottomY+1);
		else
			dc->DrawLine(mHalfThumbWidth, mAxisY+1, mRightX+1, mAxisY+1);
		
		int divs;
		double d = 0;
		int int_d = -1;
		double upp;
	
		if(mStyle & wxSL_VERTICAL)
		{
			divs = 10;
			upp = divs / (double)(mRange - 1);
			for(int p = 0; p <= mRange; p++)
			{
				if(((int)d) > int_d)
				{
					int_d = (int)d;
					int ht = (int_d == 0 || int_d == divs ? 5 : 3);
					AColor::Light(dc, false);
					dc->DrawLine(mAxisX - ht,	  mHalfThumbHeight + p,	  mAxisX, mHalfThumbHeight + p);
					AColor::Dark(dc, false);
					dc->DrawLine(mAxisX - ht + 1, mHalfThumbHeight + p + 1, mAxisX, mHalfThumbHeight + p + 1);
				}
				d += upp;
			}
		}
		else
		{
			divs = 40;
			upp = divs / (double)(mRange - 1);
			for(int p = 0; p <= mRange; p++)
			{
				if(((int)d) > int_d)
				{
					int_d = (int)d;
					int ht = (int_d == 0 || int_d == divs ? 5: 3);
					AColor::Light(dc, false);
					dc->DrawLine(mHalfThumbWidth+p, mAxisY-ht, mHalfThumbWidth+p, mAxisY);
					AColor::Dark(dc, false);
					dc->DrawLine(mHalfThumbWidth+p+1, mAxisY-ht+1, mHalfThumbWidth+p+1, mAxisY);
				}
				d += upp;
			}
		}

		delete dc;

		if(i == 0)
			mBitmap = bitmap;
		else
			mSelBitmap = bitmap;
	}

	delete backgroundImage;

	mPopWin = NULL;
	Move(pos);
	
} // LWSlider

LWSlider::~LWSlider()
{
	delete mBitmap;
	delete mSelBitmap;
	delete mThumbBitmap;
	delete mSelThumbBitmap;
}

void LWSlider::SetId(wxWindowID id)
{
	mID = id;
}

void LWSlider::Move(const wxPoint &newpos)
{
	mLeft = newpos.x;
	mTop = newpos.y;
}

void LWSlider::OnPaint(wxDC &dc, bool selected)
{
	int thumbPos;
	int thumbC;
	wxBitmap *bitmap;
	wxBitmap *thumbBitmap;

	if(mStyle & wxSL_VERTICAL)
	{
		thumbC = mAxisX - mHalfThumbWidth;
		thumbPos = mRange - mValue;
	}
	else
	{
		thumbC = mAxisY - mHalfThumbHeight;
		thumbPos = mValue;
	}
	
	if(selected)
	{
		bitmap = mSelBitmap;
		thumbBitmap = mSelThumbBitmap;
	}
	else
	{
		bitmap = mBitmap;
		thumbBitmap = mThumbBitmap;
	}

#if defined(__WXMAC__) || defined(__WXMSW__)
	dc.DrawBitmap(*bitmap, mLeft, mTop);
	
	if(mStyle & wxSL_VERTICAL)
		dc.DrawBitmap(*thumbBitmap, mLeft + thumbC,	mTop + thumbPos);
	else
		dc.DrawBitmap(*thumbBitmap, mLeft + thumbPos, mTop + thumbC);
#else
	wxMemoryDC memDC;
	memDC.SelectObject(*bitmap);
	dc.Blit(mLeft, mTop, mWidth, mHeight, &memDC, 0, 0, wxCOPY, FALSE);
	memDC.SelectObject(*thumbBitmap);
	if(mStyle & wxSL_VERTICAL)
		dc.Blit(mLeft + thumbC,	mTop + thumbPos, mThumbWidth, mThumbHeight, &memDC, 0, 0, wxCOPY, FALSE);
	else
		dc.Blit(mLeft + thumbPos, mTop + thumbC, mThumbWidth, mThumbHeight, &memDC, 0, 0, wxCOPY, FALSE);	
#endif

} // OnPaint


void LWSlider::OnMouseEvent(wxMouseEvent &event)
{
	/*
	if(event.Entering()) {
		// Display the tooltip in the status bar
		if(mParent->GetToolTip()) {
			wxString tip = mParent->GetToolTip()->GetTip();
			GetActiveProject()->TP_DisplayStatusMessage(tip, 0);
			Refresh();
		}
	}
	else if(event.Leaving()) {
		GetActiveProject()->TP_DisplayStatusMessage("",0);
		Refresh();
	}
	*/
	
	int oldValue = mValue;

#if defined(MAMOUSEWHEELnot)
	int wheelRotation;
	if(g_sets.mousewheel && (wheelRotation = event.GetWheelRotation()) != 0)
	{
		if(wheelRotation > 0)
			ChangeVolume(MAWHEELVOLUMEDELTA);
		else
			ChangeVolume(-MAWHEELVOLUMEDELTA);
		return;
	}
#endif
		
	if(event.ButtonDown())
	{
		// This jumps the thumb to clicked position
		
		if(!mIsDragging)
		{
			// First, figure out where the thumb center should go:
			// The thumb center should go at event.m_x
			// or thumb should go at event.m_y,
			// BUT, shouldn't be less than 0 or greater than width - thumbwidth - 1
			// BUT, shouldn't be less than 0 or greater than height + thumbheight - 1
			
			if(mStyle & wxSL_VERTICAL)
			{
				int newValue = mRange - ((event.m_y - mTop) - mHalfThumbHeight);
			
				if(newValue < 0)
					newValue = 0;
				else if(newValue > mRange)
					newValue = mRange;

				if(abs(newValue - mValue) > mHalfThumbHeight)
					mValue = newValue;

				mClickY = event.m_y - mTop;
			}
			else
			{
				int newValue = (event.m_x - mLeft) - mHalfThumbWidth;
			
				if(newValue < 0)
					newValue = 0;
				else if(newValue > mRange)
					newValue = mRange;

				if(abs(newValue - mValue) > mHalfThumbWidth)
					mValue = newValue;

				mClickX = event.m_x - mLeft;
			}
			
			mClickValue = mValue;
			mIsDragging = true;
			mParent->CaptureMouse();
		}
		return;
	}
	else if(event.ButtonUp() && mIsDragging)
	{
		mIsDragging = false;
		mParent->ReleaseMouse();
	}
	else if(event.Dragging() && mIsDragging)
	{
		// If we're dragging, figure out where the thumb should go

		if(mStyle & wxSL_VERTICAL)
			mValue = mClickValue - ((event.m_y - mTop) - mClickY);
		else
			mValue = mClickValue + (event.m_x - mLeft) - mClickX;

		if(mValue < 0)
			mValue = 0;
		else if(mValue > mRange)
			mValue = mRange;
	}

	if(oldValue != mValue)
	{
		wxCommandEvent *e = new wxCommandEvent(wxEVT_COMMAND_SLIDER_UPDATED, mID);
		e->SetInt(mValue);

#if (MAGUIWX == 9)
		mParent->GetEventHandler()->ProcessEvent(*e);
#else
        mParent->ProcessEvent(*e);
#endif
		delete e;
	}
	
} // OnMouseEvent


float LWSlider::Get()
{
	return mValue;
}


void LWSlider::Set(float value)
{
	if(mIsDragging)
		return;

	mValue = (int)value;

	if(mValue < 0)
		mValue = 0;
	else if(mValue > mRange)
		mValue = mRange;
	
	//Refresh();
}

int LWSlider::GetValue()
{
	return mValue;
}

void LWSlider::SetValue(int value)
{
	if(mIsDragging)
		return;

	mValue = value;

	//Refresh();
}

void LWSlider::Refresh()
{
	if(mHW)
		mParent->Refresh(false);
}


// maSlider

BEGIN_EVENT_TABLE(maSlider, wxWindow)
#if defined(MAMOUSEWHEELnot)
	EVT_MOUSEWHEEL(maSlider::OnMouseEvent)
#endif
	EVT_LEFT_DOWN(maSlider::OnMouseEvent)
	EVT_LEFT_UP(maSlider::OnMouseEvent)
	EVT_MOTION(maSlider::OnMouseEvent)
	EVT_PAINT(maSlider::OnPaint)
	EVT_LEFT_DCLICK(maSlider::OnLeftDClick)
END_EVENT_TABLE()

maSlider::maSlider(wxWindow *parent, wxWindowID id,
					int value, int minValue, int maxValue,
					const wxPoint& pos,
					const wxSize& size,
					long style,
					const wxString& name) : wxWindow(parent, id, pos, size)
{
	m_parent = parent;
	m_id = id;
	m_Style = style;
	m_range = maxValue - minValue;
		
	if((m_xSize = size.x) <= 0)
		m_xSize = 1;
	if((m_ySize = size.y) <= 0)
		m_ySize = 1;
		
	m_name = name;
	m_parentSize = m_parent->GetSize();
	
	mLWSlider = new LWSlider(this, m_name, wxPoint(0, 0), wxSize(m_xSize, m_ySize), m_Style, false);
	mLWSlider->SetId(id);
	SetValue(value);	
}

maSlider::~maSlider()
{
	delete mLWSlider;
}

void maSlider::OnPaint(wxPaintEvent& WXUNUSED(event))
{
	if(!(m_Style & wxSL_VERTICAL))
	{
		wxSize parentSize = m_parent->GetSize();
		if(m_parentSize.x != parentSize.x)
		{
			int value = GetValue();
			int xdiff = parentSize.x - m_parentSize.x;
			m_parentSize.x = parentSize.x;
			m_xSize += xdiff;
			delete mLWSlider;
			mLWSlider = new LWSlider(this, m_name, wxPoint(0, 0), wxSize(m_xSize, m_ySize), m_Style, false);
			mLWSlider->SetId(m_id);
			SetValue(value);	
		}
	}
	
	wxPaintDC dc(this);
	mLWSlider->OnPaint(dc, false);
}


void maSlider::OnMouseEvent(wxMouseEvent &event)
{
	mLWSlider->OnMouseEvent(event);
}


void maSlider::OnLeftDClick(wxMouseEvent& WXUNUSED(event))
{
	wxCommandEvent *e = new wxCommandEvent(wxEVT_COMMAND_SLIDER_UPDATED, m_id);
	e->SetInt(-1); // tell app to set its default value for this slider 
	ProcessEvent(*e);
	delete e;
}


float maSlider::Get()
{
	return mLWSlider->Get();
}

void maSlider::Set(float value)
{
	mLWSlider->Set(value);
}

int maSlider::GetValue()
{
	return (int)(((float)mLWSlider->GetValue() * m_range) / mLWSlider->mRange);
}

void maSlider::SetValue(int value)
{
	mLWSlider->Set(((float)value * mLWSlider->mRange) / m_range);
}
#endif // MAUSEMASLIDER

#endif // MAUSEMABUTTON || MAUSEMASLIDER || MAUSEMACHECKBOX

#endif // MAGUIWX

// eof
