// maEqualizer.h

/*
 * MoreAmp
 * Copyright (C) 2004-2014 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __MAEQUALIZER_H__
#define __MAEQUALIZER_H__

#include "maTypes.h"
#include "maDefs.h"

#ifdef __cplusplus
extern "C"
{
#endif

typedef int magboolean;
typedef int magint;

typedef struct
{
	magint band_num;
	//magboolean use_xmms_original_freqs, use_independent_channels;
	magboolean equalizer_active;
	magboolean extra_filtering;
#ifdef EQUSEFIXED
	magboolean use_fixed;
#endif
	//magint freq;
	magboolean bits16;
}
EQConfig;

typedef struct
{
	int Enabled;
	int Levels[EQBANDS31];
	int Levels2[EQBANDS31];
} maEqualizerSettings;

extern maEqualizerSettings g_EqualizerSettings;
extern EQConfig eqcfg;

void maEqualizerReset(int bands, int bits16, int extra);
void maEqualizerSetLevels(int bands31, int dboffset);
void maEqualizeBlock(void* pcmblock, unsigned long pcmblocksize);

#ifdef __cplusplus
}
#endif

#endif // __MAEQUALIZER_H__

// eof

