// maGUI.h

/*
 * MoreAmp
 * Copyright (C) 2004-2014 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __MAGUI_H__
#define __MAGUI_H__

#include "maTypes.h"
#include "maDefs.h"

#ifdef __cplusplus
extern "C"
{
#endif

// factory window positions and sizes
///////////////////////////////////////////////////////////////////////

// by platform:
#if defined(MAGUICARBON) && !defined(MAGUIWX) // osx carbon // with-gui=carbon
 #define YSIZEADJUST 0
 #define YSIZEAUDIOPOPUPS 152
 #define YPOSADJUST_CHK_ENABLE 121

 #define SCROLLERWIDTH 16

 #define XPOSDEF 20
 #define YPOSDEF 62
 #define XSIZEDEF 300
 #define YSIZEDEF (272 + YSIZEAUDIOPOPUPS)

 #define XPOSMIN 20
 #define YPOSMIN 20
 #define XSIZEMIN 20
 #define YSIZEMIN 20
 
 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + 8)
 #define LISTXSIZEDEF 293

 #define EQYPOSDEF (YPOSDEF + YSIZEDEF + 46)
 #define EQXSIZEDEF 601
 #define EQYSIZEDEF 252
 
 #define EQ2POSDELTA 10

 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF 291

 #define EFFECTSXSIZEDEF 272

 #define YSIZEDEF2 50
 
 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF LISTYSIZEDEF

 #define VIEWERXSIZEDEF 530
 #define VIEWERYSIZEDEF 670
 
 #define PROMPTNUMXSIZEDEF 354 
 #define PROMPTNUMYSIZEDEF 144
#endif // MAGUICARBON

///////////////////////////////////////////////////////////////////////

#if defined(__MAOSX__) && !defined(MAGUICARBON) // wxosx // with-gui=wx (default)
 #define YSIZEADJUST 0
 #define YSIZEAUDIOPOPUPS 152

 #if defined(__WXMAC__)
  #define YPOSADJUST_CHK_ENABLE 121
 #else
  #define YPOSADJUST_CHK_ENABLE 119 // 121 __WXGTK__
 #endif


 #define SCROLLERWIDTH 20

 #define XPOSDEF 20
 #define YPOSDEF 44
 #define XSIZEDEF 302
 #define YSIZEDEF (308 + YSIZEADJUST + YSIZEAUDIOPOPUPS)

 #define XPOSMIN 20
 #define YPOSMIN 20
 #define XSIZEMIN 20
 #define YSIZEMIN 20

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + 12)
 #define LISTXSIZEDEF 450
 #define EQYPOSDEF (YPOSDEF + YSIZEDEF + 8)
 #define EQXSIZEDEF 762
 #define EQYSIZEDEF (280 + YSIZEADJUST)

 #define EQ2POSDELTA 10
 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF (271 + YSIZEADJUST)

 #define EFFECTSXSIZEDEF 320
 #define YSIZEDEF2 (86 + YSIZEADJUST)

 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF LISTYSIZEDEF

 #define VIEWERXSIZEDEF 530
 #define VIEWERYSIZEDEF 670
  
 #define PROMPTNUMXSIZEDEF 344
 #define PROMPTNUMYSIZEDEF 144
#endif // __MAOSX__

///////////////////////////////////////////////////////////////////////

#if defined(__MAWIN__) // wxwin // with-gui=wx (default)
 #define YSIZEADJUST 0 // win, not used
 #define XSIZEADJUST7 14 // for windows 7 textctrl width so we can see the Vertical Slider
 #define YSIZEADJUST7 14 // for windows 7 buttons ypos
 #define YSIZEADJUST7b 12 // for windows 7 ysize
 #define YSIZEAUDIOPOPUPS 152
 #define YPOSADJUST_CHK_ENABLE 121

 #define SCROLLERWIDTH 20

 #define XPOSDEF 20
 #define YPOSDEF 42
 #define XSIZEDEF 312
 #define YSIZEDEF (336 + YSIZEAUDIOPOPUPS)

 #define XPOSMIN 20
 #define YPOSMIN 20
 #define XSIZEMIN 20
 #define YSIZEMIN 20

#define LISTXPOSDEF (XPOSDEF + XSIZEDEF)
#define LISTXSIZEDEF 450

 #define EQYPOSDEF (YPOSDEF + YSIZEDEF)
 #define EQXSIZEDEF 762
 #define EQYSIZEDEF 308

 #define EQ2POSDELTA 10

 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF 293

 #define EFFECTSXSIZEDEF 300

 #define YSIZEDEF2 120

 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF LISTYSIZEDEF

 #define VIEWERXSIZEDEF 530
 #define VIEWERYSIZEDEF 670
 
 #define PROMPTNUMXSIZEDEF 354 
 #define PROMPTNUMYSIZEDEF 144
#endif // __MAWIN__

///////////////////////////////////////////////////////////////////////

#if defined( __MAUNIX__) && !defined(MAGUIGTK2) // wxgtk // with-gui=wx (default)
 #if defined(__WXX11__)
  #define YSIZEADJUST 0 // wxx11
  #define MENUBARYSIZE 24
 #else
  #define YSIZEADJUST 0 // wxgtk
  #define MENUBARYSIZE 24
 #endif

 #define YSIZEAUDIOPOPUPS 152
 #define YPOSADJUST_CHK_ENABLE 119 // 121

 #define SCROLLERWIDTH 20
 
 #define XPOSDEF 20
 #define YPOSDEF 62
 #define XSIZEDEF 312
 #define YSIZEDEF (314 + YSIZEAUDIOPOPUPS)

 #define XPOSMIN 20
 #define YPOSMIN 20
 #define XSIZEMIN 20
 #define YSIZEMIN 20

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + 9)
 #define LISTXSIZEDEF 422

 #define EQYPOSDEF (YPOSDEF + MENUBARYSIZE + YSIZEDEF + 7)
 #define EQXSIZEDEF 743
 #define EQYSIZEDEF (305 - MENUBARYSIZE)

 #define EQ2POSDELTA 10

 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF 241

 #define EFFECTSXSIZEDEF 320

 #define YSIZEDEF2 90

 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF LISTYSIZEDEF

 #define VIEWERXSIZEDEF 530
 #define VIEWERYSIZEDEF 670
 
 #define PROMPTNUMXSIZEDEF 354 
 #define PROMPTNUMYSIZEDEF 144
#endif // __MAUNIX__ && !MAGUIGTK2

///////////////////////////////////////////////////////////////////////

#if defined( __MAUNIX__) && defined(MAGUIGTK2) // gtk2 // with-gui=gtk2
 #define YSIZEADJUST 0
 #define YSIZEAUDIOPOPUPS 152
 #define YPOSADJUST_CHK_ENABLE 121

#define MENUBARYSIZE 24
 
 #define SCROLLERWIDTH 30 // for sizing column0
 
 #define XPOSDEF 20
 #define YPOSDEF 40
 #define XSIZEDEF 312
 #define YSIZEDEF (312 + YSIZEAUDIOPOPUPS)

 #define XPOSMIN (-20)
 #define YPOSMIN (-20)
 #define XSIZEMIN 20
 #define YSIZEMIN 20

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + 9)
 #define LISTXSIZEDEF 304

 #define EQYPOSDEF (YPOSDEF + YSIZEDEF + MENUBARYSIZE + MENUBARYSIZE - 12)
 #define EQXSIZEDEF 625
 #define EQYSIZEDEF (262 - MENUBARYSIZE)

 #define EQ2POSDELTA 10

 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF 245

 #define EFFECTSXSIZEDEF 320

 #define YSIZEDEF2 100

 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF LISTYSIZEDEF

 #define VIEWERXSIZEDEF 530
 #define VIEWERYSIZEDEF 670
 
 #define PROMPTNUMXSIZEDEF 354 
 #define PROMPTNUMYSIZEDEF 144
#endif // __MAUNIX__ && MAGUIGTK2

// all
#define SPLASHXPOSDEF XPOSDEF
#define SPLASHYPOSDEF YPOSDEF
#define SPLASHXSIZEDEF 300
#define SPLASHYSIZEDEF 100

#define LISTYPOSDEF YPOSDEF
#define LISTYSIZEDEF (YSIZEDEF + YSIZEADJUST)
#define LISTCOLXSIZEDEF (LISTXSIZEDEF - SCROLLERWIDTH)

#define EQXPOSDEF XPOSDEF
#define EQ2XPOSDEF (EQXPOSDEF + EQ2POSDELTA)
#define EQ2YPOSDEF (EQYPOSDEF + EQ2POSDELTA)
#define EQ2XSIZEDEF EQXSIZEDEF
#define EQ2YSIZEDEF EQYSIZEDEF

#define FILEOUTXPOSDEF EQXPOSDEF
#define FILEOUTYPOSDEF EQYPOSDEF

#define EFFECTSXPOSDEF LISTXPOSDEF
#define EFFECTSYPOSDEF EQYPOSDEF
#define EFFECTSYSIZEDEF FILEOUTYSIZEDEF

#define XPOSDEF2 XPOSDEF
#define YPOSDEF2 YPOSDEF
#define XSIZEDEF2 XSIZEDEF

#define EQXPOSDEF2 EQXPOSDEF
#define EQYPOSDEF2 EQYPOSDEF
#define EFFECTSXPOSDEF2 EFFECTSXPOSDEF
#define EFFECTSYPOSDEF2 EFFECTSYPOSDEF
#define LISTXPOSDEF2 LISTXPOSDEF
#define LISTYPOSDEF2 LISTYPOSDEF
#define FILEOUTXPOSDEF2 FILEOUTXPOSDEF
#define FILEOUTYPOSDEF2 FILEOUTYPOSDEF
#define EQXSIZEDEF2 EQXSIZEDEF
#define EQYSIZEDEF2 EQYSIZEDEF
#define EFFECTSXSIZEDEF2 EFFECTSXSIZEDEF
#define EFFECTSYSIZEDEF2 EFFECTSYSIZEDEF
#define LISTXSIZEDEF2 LISTXSIZEDEF
#define LISTYSIZEDEF2 LISTYSIZEDEF
#define FILEOUTXSIZEDEF2 FILEOUTXSIZEDEF
#define FILEOUTYSIZEDEF2 FILEOUTYSIZEDEF 
#define LISTCOLXSIZEDEF2 LISTCOLXSIZEDEF

#define EQ2XPOSDEF2 (EQXPOSDEF2 + EQ2POSDELTA)
#define EQ2YPOSDEF2 (EQYPOSDEF2 + EQ2POSDELTA)
#define EQ2XSIZEDEF2 EQXSIZEDEF2
#define EQ2YSIZEDEF2 EQYSIZEDEF2

#define ADVANCEDXPOSDEF LISTXPOSDEF
#define ADVANCEDYPOSDEF LISTYPOSDEF

#define AUDIOCDXPOSDEF ADVANCEDXPOSDEF
#define AUDIOCDYPOSDEF ADVANCEDYPOSDEF
#define AUDIOCDXSIZEDEF ADVANCEDXSIZEDEF
#define AUDIOCDYSIZEDEF ADVANCEDYSIZEDEF
 
// viewer windows
#define VIEWERXDELTA 66

#define VIEWERXPOSDEF LISTXPOSDEF
#define VIEWERYPOSDEF YPOSDEF
 
#define LOGXPOSDEF (VIEWERXPOSDEF + 1 * VIEWERXDELTA)
#define LOGYPOSDEF YPOSDEF
#define LOGXSIZEDEF VIEWERXSIZEDEF
#define LOGYSIZEDEF VIEWERYSIZEDEF
 
#define ABOUTXPOSDEF (VIEWERXPOSDEF + 2 * VIEWERXDELTA)
#define ABOUTYPOSDEF YPOSDEF
#define ABOUTXSIZEDEF VIEWERXSIZEDEF
#define ABOUTYSIZEDEF VIEWERYSIZEDEF

#define KEYBINDINGSXPOSDEF (VIEWERXPOSDEF + 3 * VIEWERXDELTA)
#define KEYBINDINGSYPOSDEF YPOSDEF
#define KEYBINDINGSXSIZEDEF VIEWERXSIZEDEF
#define KEYBINDINGSYSIZEDEF VIEWERYSIZEDEF

#define PLAYLISTXPOSDEF (VIEWERXPOSDEF + 4 * VIEWERXDELTA)
#define PLAYLISTYPOSDEF YPOSDEF
#define PLAYLISTXSIZEDEF VIEWERXSIZEDEF
#define PLAYLISTYSIZEDEF VIEWERYSIZEDEF

#define CATALOGXPOSDEF (VIEWERXPOSDEF + 5 * VIEWERXDELTA)
#define CATALOGYPOSDEF YPOSDEF
#define CATALOGXSIZEDEF VIEWERXSIZEDEF
#define CATALOGYSIZEDEF VIEWERYSIZEDEF

#define READMEXPOSDEF (VIEWERXPOSDEF + 6 * VIEWERXDELTA)
#define READMEYPOSDEF YPOSDEF
#define READMEXSIZEDEF VIEWERXSIZEDEF
#define READMEYSIZEDEF VIEWERYSIZEDEF

///////////////////////////////////////////////////////////////////////

// for maFileDialogM
typedef struct {
	int nitems;
	fschar **pitems;
} maArray;

#if defined(MAGUICARBON) || defined(MAGUIGTK2)
 extern int g_linenum;
#endif

// api
void SpinButtonEnable(int windowid, int button);
void SpinButtonDisable(int windowid, int button);

void PushButtonPaintUp(int windowid, int button);
void PushButtonPaintDown(int windowid, int button);
void PushButtonPopup(int windowid, int button);

void PushButtonEnable(int windowid, int button);
void PushButtonDisable(int windowid, int button);
void PushButtonSimulateClick(int windowid, int button);
void PushButtonSetDescriptor(int windowid, int button, machar *desc);
void PushButtonGetDescriptor(int windowid, int button, machar *desc);

void PopupButtonEnable(int windowid, int popup);
void PopupButtonDisable(int windowid, int popup);
void PopupButtonClear(int windowid, int popup);
void PopupButtonAppend(int windowid, int popup, machar *text);
void PopupButtonSetValue(int windowid, int popup, int value);
void PopupButtonSetText(int windowid, int popup, int item, machar *text);
void PopupButtonGetSelection(int windowid, int popup, int *item);
void PopupButtonSetSelection(int windowid, int popup, int item);
// void PopupButtonGetText(int windowid, int edittext, int item, machar *outBuffer, int inBufferLength, long *outTextLength);

void LittleArrowEnable(int windowid, int arrow);
void LittleArrowDisable(int windowid, int arrow);

//void StaticTextEnable(int windowid, int statictext);
//void StaticTextDisable(int windowid, int statictext);

void StaticTextSetText(int windowid, int statictext, machar *text);
void StaticTextSetValue(int windowid, int statictext, int value);
void StaticTextRefresh(int windowid, int statictext);

void EditTextEnable(int windowid, int edittext);
void EditTextDisable(int windowid, int edittext);
void EditTextSetText(int windowid, int edittext, machar *p0);
void EditTextGetText(int windowid, int edittext, machar *outBuffer, int inBufferLength, long *outTextLength, long from, long to);
#if !defined(NOTEXTVIEWER)
 void EditTextGetSelection(int windowid, int edittext, long *start, long *end);
 void EditTextSetSelection(int windowid, int edittext, long start, long end);
 void EditTextSetEditable(int windowid, int edittext, int editable);
 int EditTextHasFocus(int windowid, int edittext);
 void EditTextSetFocus(int windowid, int edittext);
 void EditTextShowPosition(int windowid, int edittext, long pos);
 // int EditTextLoadFile(int windowid, int edittext, fschar *fpath);
 // int EditTextSaveFile(int windowid, int edittext, fschar *fpath);
 int EditTextGetSize(int windowid, int edittext, size_t *pfsize);
#endif

void ListAppend(int windowid, int list, machar *text);
void ListClear(int windowid, int list);
int ListGetRowSelected(int windowid, int list);
void ListEnsureVisible(int windowid, int list, int row);
void ListSelect(int windowid, int list, int row);
void ListGetText(int windowid, int list, int row, machar *text);
// not used void ListSetText(int windowid, int list, int row, machar *text);
void ListSetHeader(int windowid, int list, int col, machar *header);
void ListSetColumnWidth();
void ListFreeze();
void ListThaw();
void ListResize();

void MenuSetChecked(int menu, int item, int value);
// int MenuIsChecked(int menu, int item);
void MenuEnable(int menu, int item);
void MenuDisable(int menu, int item);
void MenuSetLabel(int menu, machar *label);
void MenuGetLabel(int menu, machar *label);
void UpdateSubMenusRecent();
#if defined(USE_KEYBOARD) && defined(MAGUIWX)
 void CheckBoxSetFocus(int windowid, int checkbox);
#endif
void CheckBoxSetValue(int windowid, int checkbox, int value);
int CheckBoxGetValue(int windowid, int checkbox);
// void CheckBoxToggle(int windowid, int checkbox);
void CheckBoxSetDescriptor(int windowid, int checkbox, machar *desc);
void CheckBoxHide(int windowid, int checkbox);
void CheckBoxShow(int windowid, int checkbox);
void CheckBoxEnable(int windowid, int checkbox);
void CheckBoxDisable(int windowid, int checkbox);

void maLogAPI(const machar *whence, int windowid, int item);

void DisplayGetSize(int *x, int *y);

void WindowClose(int windowid);
void WindowDestroy(int windowid);
int WindowIsShown(int windowid);
#if defined(MAGUIGTK2)
 void WindowWidgetSetSize(int windowid, int widget, int xsize, int ysize);
#endif
void WindowSetSize(int windowid, int xsize, int ysize);
void WindowMove(int windowid, int xpos, int ypos);
void WindowShow(int windowid);
void WindowSetTitle(int windowid, machar *title);
void WindowGetCoordinates(int windowid, int *xpos, int *ypos, int *xsize, int *ysize);
void WindowItemHide(int windowid, int item);
void WindowItemShow(int windowid, int item);
void WindowActivate(int windowid);

int	AppWindowMake();
void ListWindowMake();
// void SplashWindowMake();
void EqualizerWindowMake();
void Equalizer2WindowMake();
void EffectsWindowMake();
#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
 void AudioCDWindowMake();
#endif
void AdvancedWindowMake();
void FileOutWindowMake();
void PromptNumWindowMake();
void AboutWindowMake();

int SliderGetValue(int windowid, int slider);
void SliderSetValue(int windowid, int slider, int value);
int HSliderGetValue(int windowid, int slider);
void HSliderSetValue(int windowid, int slider, int value);
void SliderEnable(int windowid, int slider);
void SliderDisable(int windowid, int slider);

int maFileDialog(fschar *selectedpath, int windowid, machar *prompt, fschar *defdir, machar *deffile, machar *wildcard, int flags);
int maFileDialogM(maArray *parray,   int windowid, machar *prompt, fschar *defdir, machar *deffile, machar *wildcard, int flags);
void maFileDialogMFree(maArray *parray);
int maDirSelector(fschar *pdirpath, machar *prompt);

void guiAppYield();
int maMessageBox(machar *s1, machar *s2, int flags);

int ViewerWindowMake(int windowid, machar *wintitle);

void DoTimerChangePlaylist(int delay);
void DoTimerPlayPlaylist(int delay);
void DoTimerRunLoop(int delay);
void DoTimerPlay(int delay);
// void DoTimerStop(int delay);

void maGUIfree();
void maGUIQuit();

int maModKeyDown();

#ifdef __cplusplus
}
#endif

#endif // __MAGUI_H__

// eof
