// maMemFile.h

/*
 * MoreAmp
 * Copyright (C) 2004-2014 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef _MAMEMFILE_H_
#define _MAMEMFILE_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

#ifdef __MAWIN__
 #include <sys/types.h>
#else
 #include <unistd.h>
#endif

#include "maTypes.h"

extern int g_noamem;
extern int g_nobmem;
extern int g_noimem;

// mbm* functions use g_nobmem to access files on disk or loaded in memory
// used only by maPlayFlac io callbacks as of MoreAmp 0 1 29
int mbmfseeko(FILE *stream, maoff_t64 offset, int whence);
maoff_t64 mbmftello(FILE *stream);
size_t mbmfread(void *ptr, size_t size, size_t nmemb, FILE *stream);
// FILE *mbmfopen(const fschar *fsfilename, fschar *mode);
// int mbmfseek(FILE *stream, long offset, int whence);
// int mbmlseek(int stream, off_t offset, int whence);
// int mbmfclose(FILE *stream);
// long int mbmftell(FILE *stream);
// void mbmrewind(FILE *stream);
// int mbmread(int fd, char *ptr, int size);
// int mbmstat(const fschar *filename, struct stat *buf);
// int mbmfstat(int j, struct stat *buf);
// int mbmfeof(FILE *stream);
// int mbmfgetpos(FILE *stream, fpos_t *pos);
// int mbmfsetpos(FILE *stream, const fpos_t *pos);
// int mbmferror(FILE *stream);
// void mbmclearerr(FILE *stream);

// mim* functions use g_noimem to access files on disk or loaded in memory
// used only by modified libid3tag
FILE *mimfopen(const fschar *filename, fschar *mode);
int mimfseek(FILE *stream, long offset, int whence);
size_t mimfread(void *ptr, size_t size, size_t nmemb, FILE *stream);
int mimfclose(FILE *stream);
long int mimftell(FILE *stream);
void mimrewind(FILE *stream);
int mimfgetpos(FILE *stream, fpos_t *pos);
int mimfsetpos(FILE *stream, const fpos_t *pos);
void mimclearerr(FILE *stream);
// int mimlseek(int stream, off_t offset, int whence);
// int mimread(int fd, char *ptr, int size);
// int mimstat(const fschar *filename, struct stat *buf);
// int mimfstat(int j, struct stat *buf);
// int mimfeof(FILE *stream);
// int mimferror(FILE *stream);


// mem* functions access files in memory
FILE *memfopen(const fschar *filename);
int memfseek(FILE *stream, long offset, int whence);
int memfseeko(FILE *stream, maoff_t64 offset, int whence);
int memlseek(int fd, off_t offset, int whence);
size_t memfread(void *ptr, size_t size, size_t nmemb, FILE *stream);
int memfclose(FILE *stream);
int memclose(int fd);
long int memftell(FILE *stream);
long int memftello(FILE *stream);
long int memtelli(int fd);
void memrewind(FILE *stream);
int memopen(fschar *filename);
int memread(int fd, char *ptr, int size);
int memfstat(int j, struct stat *buf);
int memfeof(FILE *stream);
int memferror(FILE *stream);
int memfileno(FILE *stream);
void memclearerr(FILE *stream);
int memfgetpos(FILE *stream, fpos_t *pos);
int memfsetpos(FILE *stream, const fpos_t *pos);

int maSetFilePointer(FILE * file, long position, int method, int nomem);
int maSetFilePointero(FILE * file, maoff_t64  position, int method, int nomem);
int maGetFileSize(FILE * file, int nomem);
int maReadFile(FILE *file, unsigned char *buffer, int bytes, int *pbytes, int nomem);
FILE *maCreateFile(fschar *path, int nomem);
// int maWriteFile(FILE *file, unsigned char *buffer, int bytes, int *pbytes, int what);

#ifdef __cplusplus
}
#endif

#endif // _MAMEMFILE_H_

// eof
