// maGUIgtk.c

/*
 * MoreAmp
 * Copyright (C) 2004-2014 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "maConfig.h" // included by all moreamp files

#if defined(MAGUIGTK2)

// #define MATRACEGUIGTK

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>

#include <gtk/gtk.h>
#include <gtk/gtkfilesel.h>

#if GTK_MAJOR_VERSION == 2
 #if !defined(MAGUIGTK2)
  #warning MAGUIGTK2 should be defined with GTK2
 #endif
#else
 #error Only GTK+-2 is supported
#endif

#include "gdk/gdkkeysyms.h"

#include "maGUI.h"
#include "maUtils.h"
#include "maPlayer.h"
#include "maSongList.h"
#include "maTextView.h"
#include "maAudioPA.h"

/*
// Player controls
#include "maButtonsPlayer/BMFFwdMask.xpm"
#include "maButtonsPlayer/BMFFwdDisabled.xpm"
#include "maButtonsPlayer/BMFFwd.xpm"

#include "maButtonsPlayer/BMPlayMask.xpm"
#include "maButtonsPlayer/BMPlayDisabled.xpm"
#include "maButtonsPlayer/BMPlay.xpm"

#include "maButtonsPlayer/BMQuitMask.xpm"
#include "maButtonsPlayer/BMQuitDisabled.xpm"
#include "maButtonsPlayer/BMQuit.xpm"

#include "maButtonsPlayer/BMRewindMask.xpm"
#include "maButtonsPlayer/BMRewindDisabled.xpm"
#include "maButtonsPlayer/BMRewind.xpm"

#include "maButtonsPlayer/BMStopMask.xpm"
#include "maButtonsPlayer/BMStopDisabled.xpm"
#include "maButtonsPlayer/BMStop.xpm"

#include "maButtonsPlayer/BMPause.xpm"
#include "maButtonsPlayer/BMPauseDisabled.xpm"
#include "maButtonsPlayer/BMPauseMask.xpm"
*/

#define MABUTTONWDEF 70
#define MABUTTONHDEF 26

enum
{
	maGDK_DELETE = 1,
	maGDK_CONFIGURE,
	maBUTTONFIND,
	maBUTTONVPLAY,
	maBUTTONEDIT,
	maBUTTONCLOSE,
	maENTRYKEYPRESS,
	maMOUSEBUTTON,
};

#ifdef __cplusplus
extern "C"
{
#endif

// these mawidget structs are filled in when making a widget and
// passed to the widget's callback function
#define NUMSLIDERS (ID_SLIDER_LAST - ID_SLIDER_FIRST + 1)
typedef struct
{
	int id;
	void *adj;
	int skip;
	void *slider;
} maslider;
maslider l_slider[NUMSLIDERS];

#define NUMSPINBUTTON (ID_SPIN_LAST - ID_SPIN_FIRST + 1)
typedef struct
{
	int id;
	void *adj;
	int skip;
} maspinbutton;
maspinbutton l_spinbutton[NUMSPINBUTTON];

#define SPSIZx 16
#define SPSIZy 20

#define ID_MANONE 0

#define NUMPOPUPBUTTONS (ID_POPUP_LAST - ID_POPUP_FIRST + 1)
typedef struct
{
	int id;
	int value; // 0-based index
	int nitems;
	void *optionmenu;
} mapopupbutton;
mapopupbutton l_popupbutton[NUMPOPUPBUTTONS];

#define ID_TEXT_VIEWERFOUNDREADME		ID_TEXT_VIEWERFOUND
#define ID_TEXT_VIEWERFOUNDLOG			(ID_TEXT_LAST + 1)
#define ID_TEXT_VIEWERFOUNDCATALOG		(ID_TEXT_LAST + 2)
#define ID_TEXT_VIEWERFOUNDPLAYLIST		(ID_TEXT_LAST + 3)
#if defined(MAKEYBOARD)
 #define ID_TEXT_VIEWERFOUNDKEYBINDINGS	(ID_TEXT_LAST + 4)
#endif
#define ID_TEXT_MONODIFF				(ID_TEXT_LAST + 5)
typedef struct
{
	int id;
	void *text;
} matext;

#define ID_BTN_EDITSAVEREADME			ID_BTN_EDITSAVE
#define ID_BTN_EDITSAVELOG				(ID_BTN_LAST + 1)
#define ID_BTN_EDITSAVECATALOG			(ID_BTN_LAST + 2)
#define ID_BTN_EDITSAVEPLAYLIST			(ID_BTN_LAST + 3)

#define ID_BTN_VIEWERFINDREADME			ID_BTN_VIEWERFIND
#define ID_BTN_VIEWERFINDLOG			(ID_BTN_LAST + 4)
#define ID_BTN_VIEWERFINDCATALOG		(ID_BTN_LAST + 5)
#define ID_BTN_VIEWERFINDPLAYLIST		(ID_BTN_LAST + 6)

#if defined(MAKEYBOARD)
 #define ID_BTN_EDITSAVEKEYBINDINGS		(ID_BTN_LAST + 7)
 #define ID_BTN_VIEWERFINDKEYBINDINGS	(ID_BTN_LAST + 8)
 #define ID_BTN_LAST_PLUS								8
#else
 #define ID_BTN_LAST_PLUS								6
#endif

#define NUMBTNS (ID_BTN_LAST - ID_BTN_FIRST + ID_BTN_LAST_PLUS + 1)
typedef struct
{
	int id;
	void *btn;
	int skip;
} mabutton;
mabutton l_button[NUMBTNS];

#define NUMTEXTS (ID_TEXT_LAST - ID_TEXT_FIRST + 1) // 190
matext l_text[NUMTEXTS];

#define NUMCHECKBOXES (ID_CHECKBOX_LAST - ID_CHECKBOX_FIRST + 1)
typedef struct
{
	int id;
	void *cb;
	int skip;
	int color;
	void *text;
} macheckbox;
macheckbox l_checkbox[NUMCHECKBOXES];
GdkColor rgbred = { 0, 0xffff, 0x0000, 0x0000 };
GdkColor rgbblack = { 0, 0x0000, 0x0000, 0x0000 };
GtkStyle *pcheckboxred = NULL;
GtkStyle *pcheckboxblack = NULL;

guint l_timerchangeplaylist = -1;
guint l_timerplayplaylist = -1;
guint l_timerrunloop = -1;
guint l_timerplay = -1;
// guint l_timerstop = -1;

GtkItemFactory *l_item_factory = NULL;
GtkItemFactory *l_subitem_factory1 = NULL;
GtkItemFactory *l_subitem_factory2 = NULL;
GtkWidget *l_menubar = NULL;
GtkWidget *l_main_vbox = NULL;
GtkWidget *l_list_vbox = NULL;
GtkWidget *l_eq_vbox = NULL;
GtkWidget *l_audiocd_vbox = NULL;
GtkWidget *l_advanced_vbox = NULL;
GtkWidget *l_effects_vbox = NULL;
GtkWidget *l_fileout_vbox = NULL;
GtkWidget *l_promptnum_vbox = NULL;
GtkWidget *l_fixed = NULL;
GtkWidget *l_eqentry = NULL;
GtkWidget *l_promptnumentry = NULL;
GtkWidget *l_clist = NULL;
GtkWidget *l_scale = NULL;
maslider l_hslider;

int g_linenum = 0;

int MenuEventHandler(gpointer callback_data, guint callback_action, GtkWidget *widget);
int CommandEventHandler(gpointer callback_data, guint callback_action, GtkWidget *widget);
#if defined(MAKEYBOARD)
  gint KeyboardEventHandler(GtkWidget *widget, GdkEventKey *event, gpointer data);
#endif
#if defined(MAMOUSEWHEEL)
 gint MouseWheelEventHandler(GtkWidget *widget, GdkEventScroll *event, gpointer data);
#endif
gint AppWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint EqualizerWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
void aboutviewercallback(GtkWidget *widget, gpointer callback_data);
void GetColumn0Width();
void MakeMenus();
void hslidercallback(GtkWidget *widget, maslider *lslider);
void slidercallback(GtkWidget *widget, maslider *lslider);
int IdByWindow(int windowid, int id);
int CheckboxIndexFromId(int id);
int TextIndexFromId(int id);
int PushButtonIndexFromId(int windowid, int pbid);
int PopupButtonIndexFromId(int id);
int SliderIndexFromId(int id);
int SpinButtonIndexFromId(int id);
void OnViewerKeyPressed(int windowid, void *widget, int keyval);
void maTrace(machar *str);

gint OnTimerChangePlaylist(gpointer data);
gint OnTimerPlayPlaylistg(gpointer data);
gint OnTimerRunLoop(gpointer data);
gint OnTimerPlay(gpointer data);
// gint OnTimerStop(gpointer data);

void maGuiLog(machar *str);
int SetupMenuRecentLabels();
void RebuildMenus();
void BuildMenus();
void DeleteMenus();
#if !defined(NOTEXTVIEWER)
 void lEditTextShowPosition(maviewer *v, long pos);
#endif
void eqentrycallback(GtkWidget *widget);


#ifdef MATRACEGUIGTK
 void maTrace(machar *str)
 {
	printf("%s\n", str);
 }
#endif


gint OnTimerChangePlaylist(gpointer data) 
{
#ifdef MATRACEGUIGTK
	maTrace("OnTimerChangePlaylist");
#endif

	ChangePlaylist(g_changeplaylist);
	
	return 0;
}


gint OnTimerPlayPlaylist(gpointer data) 
{
#ifdef MATRACEGUIGTK
	maTrace("OnTimerPlayPlaylistgpointer");
#endif

	PlayPlaylistB(g_newplaylist);
	
	return 0;
}


gint OnTimerRunLoop(gpointer data) 
{
#ifdef MATRACEGUIGTK
	maTrace("OnTimerRunLoop");
#endif

	RunLoop();
	
	return 0; // false, destroys the timer
}


gint OnTimerPlay(gpointer data) 
{
#ifdef MATRACEGUIGTK
	maTrace("OnTimerPlay");
#endif

	DoPlay();
	
	return 0;
}


/* gint OnTimerStop(gpointer data) 
{
#ifdef MATRACEGUIGTK
	maTrace("OnTimerStop");
#endif

	DoStop();
	
	return 0;
}
*/


#ifdef MATRACEGUIGTK
 void maGuiLog(machar *str)
 {
	maprintf(L"%ls%ls", str, g_maeol);
 }
#endif


int main(int argc, char *argv[]) // MAGUIGTK2
{
	g_argc = argc;
	g_argv = argv;

	if(argc == 2 && !strcmp(argv[1], "maclearlocks")) // run this in case we have a stuck lock
	{
		InstanceClearAll();
		printf("cleared locks\n");
		exit(0);
	}

	if(argc == 2 && !strcmp(argv[1], "malistlocks")) // run this to see locks
	{
		fssprintf(g_logpath, MAX_PATH, fsT("malistlocks.txt"));
		InstanceListAll();
		printf("listed locks\n");
		exit(0);
	}

	masprintf(&g_abouttext[mastrlen(g_abouttext) - STRLEN64], STRLEN64,	L" GTK+%d.%d.%d GUI",
						GTK_MAJOR_VERSION, GTK_MINOR_VERSION, GTK_MICRO_VERSION); 
	
	// for cd
#if defined(__MAOSX__) || defined(MACDAOSX)
	InitAppleEvents(NULL);
#endif
	
	if(!OnInit_())		
		return 1; // failed

	// main loop
	gtk_main();

	return(0);
	
} // main 


GtkItemFactoryCallback1 menucallback(gpointer callback_data, guint callback_action, GtkWidget *widget)
{
	machar mastr[MAXLOGLINELEN];
	
	if(callback_action < 0 || callback_action > ID_MENU_LAST)
	{
		masprintf(mastr, MAXLOGLINELEN, L"menucallback callback_action=%d", callback_action);
		maLog(mastr);
		return (GtkItemFactoryCallback1)FALSE;
	}
	if(MenuEventHandler(callback_data, callback_action, widget))
		return (GtkItemFactoryCallback1)FALSE; // not handled
	return (GtkItemFactoryCallback1)TRUE;
}


fschar l_menurecentlabelUTF8[MAXOPENRECENT][(MAX_PATH + 1) * 4];  // max sizeof(UTF-8)
machar l_menurecentlabel[MAXOPENRECENT][MAX_PATH + 1] =
{
	L"/Item 1", // ID_SUBMENU_OPENRECENT1
	L"/Item 2",
	L"/Item 3",
	L"/Item 4",
	L"/Item 5",
	L"/Item 6",
	L"/Item 7",
	L"/Item 8",
	L"/Item 9",
	L"/Item 10", // exactly MAXOPENRECENT submenus
};


#define MAXMENULABELS 88
fschar l_menulabelmb[MAXMENULABELS][STRLEN64 * 4]; // multipyte, max sizeof(UTF-8)
machar l_menulabel[MAXMENULABELS][STRLEN64] = // all have 4 trailing spaces for key bindings
{
	{0},
	// MoreAmp menu
	L"/Help/About moreamp    ", // ID_MENU_FIRST
	// File menu
	L"/File/Open Playlist...    ",
	L"/File/Make Playlist...    ",
	L"/File/Save Playlist As...    ",
	L"/File/Delete Playlist...    ",
	L"/File/Play Song Files...    ",
	L"/File/Open Recent...    ",
	L"/Item 1    ", // ID_SUBMENU_OPENRECENT1 // these need to be MAX_PATH
	L"/Item 2    ",
	L"/Item 3    ",
	L"/Item 4    ",
	L"/Item 5    ",
	L"/Item 6    ",
	L"/Item 7    ",
	L"/Item 8    ",
	L"/Item 9    ",
	L"/Item 10    ", // exactly MAXOPENRECENT submenus
	L"/File/Quit    ",
	// Controls menu
	L"/Controls/Stop    ",
	L"/Controls/Pause    ",
	L"/Controls/Previous    ",
	L"/Controls/Play    ",
	L"/Controls/Next    ",
	L"/Controls/Play CD    ",
	L"/Controls/Eject CD    ",
	L"/Controls/Audio In    ",
	// Settings menu
	L"/Settings/Save Settings    ",
	L"/Settings/Saved Settings    ",
	L"/Settings/Default Settings    ",
	L"/Settings/Factory Settings    ",
	L"/Settings/Copy Settings...    ",
	L"/Settings/Save Settings As Default    ",
#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
	L"/Settings/Set Audio CD Drives...    ", // ID_MENU_SETAUDIOCD,
#endif
	L"/Settings/Effects    ",
	L"/Settings/Random    ",
	L"/Settings/Repeat Played    ",
	L"/Settings/Loop Loaded    ",
	L"/Settings/Loop List    ",
	L"/Settings/Equalizer    ",
	L"/Settings/Eq 31 Bands    ",
	L"/Settings/EqExtra    ",	
	L"/Settings/Mono    ",
	L"/Settings/Invert Right    ",
	L"/Settings/Single Play    ",
	L"/Settings/Input Monitor    ",
	L"/Settings/Title Info...    ",
	L"/List Name    ",
	L"/Song Name    ",
	L"/Numbers    ",
	L"/Settings/Auto Start    ",
	L"/Settings/Error Logging    ",
	L"/Settings/Set Virtual Disk...    ",
	L"/Settings/Multiple Instances    ",
#if defined(MAKEYBOARD)
	L"/Settings/Use Keyboard    ",	
#endif
#if defined(MAMOUSEWHEEL)
	L"/Settings/Use MouseWheel    ",	
#endif
	L"/Settings/Advanced Settings...    ",
	// Tools menu
	L"/Tools/Zero List    ",
	L"/Tools/Make Catalog    ",
#if !defined(NOTEXTVIEWER)
	L"/Tools/Edit Catalog    ",
	L"/Tools/Edit Playlist    ",
	L"/Tools/Edit Log    ",
#endif
	L"/Tools/Clear Log    ",
#if !defined(NOTEXTVIEWER)
 #if defined(MAKEYBOARD)
	L"/Tools/Edit Key Bindings    ",
	L"/Tools/Blank Key Bindings    ",
	L"/Tools/Factory Key Bindings    ",
 #endif
	L"/Tools/Rescan Audio Devices    ",
#endif
	// Show menu
	L"/Show/Lists    ",
	L"/Show/Equalizer    ",
	L"/Show/Effects    ",
	L"/Show/File Output    ",
	L"/Show/Alt Sizes    ",
	L"/Show/Saved Sizes    ",
	L"/Show/Default Sizes    ",
	L"/Show/Factory Sizes    ",
#if !defined(NOTEXTVIEWER)
	// Help menu
	L"/Help/README    ", // ID_MENU_LAST
#endif
}; // l_menulabel


GtkItemFactoryEntry l_menu_items[] =
{
	// File menu
	{ "/File", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_OPENLIST, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MAKELIST, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SAVELISTAS, NULL },
	{ "/File/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_DELETELIST, NULL },
	{ "/File/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PLAYFILE, NULL },
	{ "/File/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, NULL, ID_MENU_OPENRECENT, "<Item>" },
	{ "/File/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_QUIT, NULL },

	// Controls menu
	{ "/Controls", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_STOP, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PAUSE, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PREVIOUS, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PLAY, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_NEXT, NULL },
	{ "/Controls/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PLAYCD, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EJECTCD, NULL },
	{ "/Controls/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_AUDIOIN, NULL },

	// Settings menu
	{ "/Settings", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SAVEMASETS, NULL },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETSAVED, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETDEFAULT, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETFACTORY, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETCOPY, NULL },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SAVEMASETSDEFAULT, NULL },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EQUALIZER, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EQ31BANDS, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EQEXTRA, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EFFECTS, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_RANDOM, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_REPTPLAYED, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_LOOPLOADED, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_LOOPLIST, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MONO, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_INVERTRIGHT, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SINGLEPLAY, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_INPUTMONITOR, "<CheckItem>" },
	{ NULL, NULL, NULL, ID_MENU_TITLEINFO, "<Item>" },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_AUTOSTART, "<CheckItem>" },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ERRLOGGING, "<CheckItem>" },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETVDISK, NULL },
#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETAUDIOCD, NULL },
#endif
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MULTIPLEINST, "<CheckItem>" },
#if defined(MAKEYBOARD)
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_KEYBOARD, "<CheckItem>" },	
#endif
#if defined(MAMOUSEWHEEL)
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MOUSEWHEEL, "<CheckItem>" },	
#endif
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ADVANCED, NULL },	

	// Tools menu
	{ "/Tools", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ZEROLIST, NULL },
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MAKECATALOG, NULL },
#if !defined(NOTEXTVIEWER)
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_VIEWCATALOG, NULL },
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_VIEWPLAYLIST, NULL },
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_VIEWLOG, NULL },
#endif
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_CLEARLOG, NULL },
#if !defined(NOTEXTVIEWER)
 #if defined(MAKEYBOARD)
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EDITKEYBINDINGS, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_BLANKKEYBINDINGS, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_FACTORYKEYBINDINGS, NULL },
 #endif
#endif
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_RESCANAUDIODEVICES, NULL },

	// Show menu
	{ "/Show", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SHOWLIST, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SHOWEQ, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SHOWEFFECTS, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SHOWFILEOUT, "<CheckItem>" },
	{ "/Show/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ALTSIZE, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SAVEDSIZE, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_DEFAULTSIZE, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_FACTORYSIZE, NULL },

	// Help menu
	{ "/Help", NULL, NULL, 0, "<Branch>" },
#if !defined(NOTEXTVIEWER)
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_README, NULL }, // MAREADME	
#endif
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ABOUT, NULL }, // masprintf(mastr, MAXLOGLINELEN, L"About %ls", MOREAMP_NAME);
}; // l_menu_items


GtkItemFactoryEntry l_submenu1_items[] =
{
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT1, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT2, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT3, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT4, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT5, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT6, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT7, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT8, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT9, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT10, NULL },
};


GtkItemFactoryEntry l_submenu2_items[] =
{
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_TITLEINFO1, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_TITLEINFO2, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_TITLEINFO3, "<CheckItem>" },
};


#if defined(MAKEYBOARD)
void SetupMenuKbLabels()
{
#ifdef MATRACEGUIGTK
	maTrace("SetupMenuKbLabels");
#endif
	int i;
	int l;
	int menuid;
	machar nulabel[STRLEN256];
	
	if(!g_w[WINDOWAPP])
		return;

	for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
	{
		if(!l_menulabel[menuid] ||
			(menuid >= ID_SUBMENU_OPENRECENT1 && menuid < (ID_SUBMENU_OPENRECENT1 + MAXOPENRECENT)))
			continue;
		mastrcpy(nulabel, l_menulabel[menuid]);

		if((l = mastrlen(nulabel) - 3) < 3)
		{
			maLog(L"SetupMenuKbLabels l_menulabel too short");
			continue;
		}
		mastrcpy(&nulabel[l], L"   "); // 3 spaces
		for(i = 0; i < MANUMKEYS; i++)
		{
			if(g_sets.keyboard && g_keybindings[i].keyx.makey[0] != L'\0' && menuid == g_keybindings[i].menuid)
			{
				masprintf(&nulabel[l], STRLEN256, L"'%ls'", g_keybindings[i].keyx.makey);
				break;
			}
		}

		mastrcpy(l_menulabel[menuid], nulabel);
	}

} // SetupMenuKbLabels
#endif


void DeleteMenus()
{
#ifdef MATRACEGUIGTK
	maTrace("DeleteMenus");
#endif
	if(!g_w[WINDOWAPP])
		return;
	if(l_subitem_factory2)
	{
		gtk_object_destroy((GtkObject *)l_subitem_factory2);
		l_subitem_factory2 = NULL;
	}
	if(l_subitem_factory1)
	{
		gtk_object_destroy((GtkObject *)l_subitem_factory1);
		l_subitem_factory1 = NULL;
	}
	if(l_item_factory)
	{
		gtk_object_destroy((GtkObject *)l_item_factory);
		l_item_factory = NULL;
	}

} // DeleteMenus


void BuildMenus()
{
#ifdef MATRACEGUIGTK
	maTrace("BuildMenus");
#endif
	int j;
	int sub1 = 0;
	int sub2 = 0;
	int menuid;
	GtkWidget *w;
	machar mastr[MAXLOGLINELEN];
	
	// menu
	gpointer callback_data = (machar *)0;
	gint nmenu_items = sizeof(l_menu_items) / sizeof(l_menu_items[0]);
	for(j = 1; j < nmenu_items; j++)
	{
		if(l_menu_items[j].callback_action == ID_MENU_OPENRECENT)
			sub1 = j;
		else if(l_menu_items[j].callback_action == ID_MENU_TITLEINFO)
			sub2 = j;
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_menu_items[j].callback_action == menuid)
			{
				ma2fs(l_menulabelmb[menuid], l_menulabel[menuid]);
 #if defined(__MAOSX__) || defined(__MACUNIX__) // we need UTF-8-MAC instead of UTF-8
				StrUTF8toUTF8MAC(l_menulabelmb[menuid]); 
 #endif
				l_menu_items[j].path = (gchar *)l_menulabelmb[menuid];
				break;
			}
		}
		if(l_menu_items[j].callback_action && !l_menu_items[j].path)
		{
			masprintf(mastr, MAXLOGLINELEN, L"BuildMenus null l_menu_items[%d].path", j);
			maLog(mastr);
		}
	}
	l_item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", NULL);
	gtk_item_factory_create_items(l_item_factory, nmenu_items, l_menu_items, callback_data);

	// submenu 1
	callback_data = (machar *)1;
	nmenu_items = sizeof(l_submenu1_items) / sizeof(l_submenu1_items[0]);
	for(j = 0; j < nmenu_items && j < MAXOPENRECENT; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_submenu1_items[j].callback_action == menuid)
			{
 				ma2fs(l_menurecentlabelUTF8[j], l_menurecentlabel[j]);
				l_submenu1_items[j].path = l_menurecentlabelUTF8[j];
				break;
			}
		}
		if(l_menurecentlabel[j][0] == L'\0') // no blank submenus
			break;
	}
	l_subitem_factory1 = gtk_item_factory_new(GTK_TYPE_MENU, "<main>", NULL);
	gtk_item_factory_create_items(l_subitem_factory1, j, l_submenu1_items, callback_data);
	if(sub1)
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(gtk_item_factory_get_widget(l_item_factory, l_menu_items[sub1].path)),
								 GTK_WIDGET(gtk_item_factory_get_widget(l_subitem_factory1, "")));

	// submenu 2
	callback_data = (machar *)1;
	nmenu_items = sizeof(l_submenu2_items) / sizeof(l_submenu2_items[0]);
	for(j = 0; j < nmenu_items; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_submenu2_items[j].callback_action == menuid)
			{
				l_submenu2_items[j].path = (gchar *)l_menulabel[menuid];
				break;
			}
		}
	}
	l_subitem_factory2 = gtk_item_factory_new(GTK_TYPE_MENU, "<main>", NULL);
	gtk_item_factory_create_items(l_subitem_factory2, nmenu_items, l_submenu2_items, callback_data);
	if(sub2)
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(gtk_item_factory_get_widget(l_item_factory, l_menu_items[sub2].path)),
								 GTK_WIDGET(gtk_item_factory_get_widget(l_subitem_factory2, "")));

	l_menubar = gtk_item_factory_get_widget(l_item_factory, "<main>");
	gtk_widget_set_name(l_menubar, "mamenu");
	
	// assign name for gtkrc
	nmenu_items = sizeof(l_menu_items) / sizeof(l_menu_items[0]);
	for(j = 1; j < nmenu_items; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_menu_items[j].callback_action == menuid)
			{
				if((w = gtk_item_factory_get_widget(l_item_factory, l_menu_items[j].path)))
					gtk_widget_set_name(w, "mamenu");
				break;
			}
		}
	}
	nmenu_items = sizeof(l_submenu1_items) / sizeof(l_submenu1_items[0]);
	for(j = 0; j < nmenu_items && j < MAXOPENRECENT; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_submenu1_items[j].callback_action == menuid && l_submenu1_items[j].path != NULL)
			{
				if((w = gtk_item_factory_get_widget(l_subitem_factory1, l_submenu1_items[j].path)))
					gtk_widget_set_name(w, "mamenu");
				break;
			}
		}
	}
	nmenu_items = sizeof(l_submenu2_items) / sizeof(l_submenu2_items[0]);
	for(j = 0; j < nmenu_items; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_submenu2_items[j].callback_action == menuid && l_submenu2_items[j].path != NULL)
			{
				if((w = gtk_item_factory_get_widget(l_subitem_factory2, l_submenu2_items[j].path)))
					gtk_widget_set_name(w, "mamenu");
				break;
			}
		}
	}
	
} // BuildMenus


#if defined(MAKEYBOARD)
void UpdateMenuKbLabels()
{
#ifdef MATRACEGUIGTK
	maTrace("UpdateMenuKbLabels");
#endif
	RebuildMenus();
}
#endif


void RebuildMenus()
{
#ifdef MATRACEGUIGTK
	maTrace("RebuildMenus");
#endif
	if(!g_w[WINDOWAPP])
		return;
	DeleteMenus();
	MakeMenus();
	UpdateMenus();
	gtk_box_pack_start(GTK_BOX(l_main_vbox), l_menubar, FALSE, FALSE, 0);
	gtk_widget_show(l_menubar);
	
} // RebuildMenus


void MakeMenus()
{
#ifdef MATRACEGUIGTK
	maTrace("MakeMenus");
#endif
#if defined(MAKEYBOARD)
	SetupMenuKbLabels();
#endif
	SetupMenuRecentLabels();
	BuildMenus();
}


void buttoncallback(GtkWidget *widget, gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("buttoncallback");
#endif

	if(((mabutton *)callback_data)->skip)
	{
		((mabutton *)callback_data)->skip = 0;
		return;
	}
	
	CommandEventHandler(callback_data, ((mabutton *)callback_data)->id, widget);
}


void gtktextsetred(GtkWidget *text, int red)
{
	if(text)
	{
		if(!pcheckboxred)
		{
			pcheckboxred = gtk_style_copy(gtk_widget_get_style(text));
			pcheckboxred->fg[GTK_STATE_NORMAL] = rgbred;
		}
		
		if(!pcheckboxblack)
		{
			pcheckboxblack = gtk_style_copy(gtk_widget_get_style(text));
			pcheckboxblack->fg[GTK_STATE_NORMAL] = rgbblack;
		}
		
		if(red)
			gtk_widget_set_style(text, pcheckboxred);
		else	
			gtk_widget_set_style(text, pcheckboxblack);
	}

} // gtktextsetred


void checkboxcallback(GtkWidget *widget, gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("checkboxcallback");
#endif

	if(((macheckbox *)callback_data)->skip)
	{
		((macheckbox *)callback_data)->skip = 0;
		return;
	}

	if(((macheckbox *)callback_data)->text)
	{
		if(((macheckbox *)callback_data)->color)
			gtktextsetred(((macheckbox *)callback_data)->text, GTK_TOGGLE_BUTTON(widget)->active ? 1 : 0);
		else
			gtktextsetred(((macheckbox *)callback_data)->text, 0);
	}
	CommandEventHandler(callback_data, ((macheckbox *)callback_data)->id, widget);
}


// popups are menus, the widget here is a menuitem
// ID_POPUP_XXX is in the 24 lsb's, the 0-based menuitem index is in the 25th+ msb's.
void popupcallback(GtkWidget *widget, int id)
{
#ifdef MATRACEGUIGTK
	maTrace("popupcallback");
#endif
	int value = id >> 24;
	int lid = id & 0xffffff;
	int idx = PopupButtonIndexFromId(lid);
	l_popupbutton[idx].value = value;
	CommandEventHandler((gpointer)value, lid, widget);

} // checkboxcallback


void spinbuttoncallback(GtkWidget *widget, maspinbutton *lspinbutton)
{
#ifdef MATRACEGUIGTK
	maTrace("spinbuttoncallback");
#endif
	int value;

	if(lspinbutton->skip)
	{
		lspinbutton->skip = 0;
		return;
	}

	value = (GTK_ADJUSTMENT(widget)->value > 0.0) ? 1 : -1;

	lspinbutton->skip = 1;

	gtk_adjustment_set_value(GTK_ADJUSTMENT(widget), 0.0);	

	switch(lspinbutton->id)
	{
		case ID_SPIN_BEG :
			OnLittleArrowBegin(value); // 1 up, -1 down
		break;
		case ID_SPIN_END:
			OnLittleArrowEnd(value);
		break;
		case ID_SPIN_BUFFER:
			OnLittleArrowBuffer(value);
		break;
		case ID_SPIN_EQOFFSET:
			OnLittleArrowEqOffset(value);
		break;
		default:
			maLogAPI(L"spinbuttoncallback unexpected id", WINDOWAPP, lspinbutton->id);
		break;
	}

} // spinbuttoncallback


#define XBASE 2
#define YBASE 2
#define POSX (XBASE)
#define BEGX (POSX + 98)
#define ENDX (POSX + 200)
#define MENUBARH 24
#define MABUTTONW 44
#define MABUTTONH 34
#define MABUTTONSPACING 6
#define BUTTONTEXTY (YBASE + MABUTTONH)
#define HSLIDERPOSX (POSX)
#define HSLIDERWIDTH (XSIZEDEF - 19)
#define HSLIDERPOSY (YBASE + 54)
#define HSLIDERHEIGHT 20

void *MakeText(int dynamic, int id, machar *label, int xpos, int ypos, int style)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeText");
#endif
	int idx = 0;
	GtkWidget *text;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(dynamic)
	{
		if((idx = TextIndexFromId(id)) < 0)
		{
			for(idx = 0; idx < NUMTEXTS; idx++)
				if(l_text[idx].id == 0)
					break;
			if(idx == NUMTEXTS)
			{
				masprintf(mastr, MAXLOGLINELEN, L"MakeText id=%d already have max %d texts", id, NUMTEXTS);
				maLog(mastr);
				return NULL; 
			}
		}
	}
	
	text = gtk_label_new(ma2fs(fsstr, label));
	
	gtk_fixed_put(GTK_FIXED(l_fixed), text, xpos, ypos);
	
	if(style)
		gtk_widget_set_name(text, "matextB");
	else
		gtk_widget_set_name(text, "matext");

	if(dynamic)
	{
		l_text[idx].id = id;
		l_text[idx].text = (void *)text;
	}

	return text;
	
} // MakeText 


void MakeButtonA(int windowid, int id, machar *label, int xpos, int ypos, int width, int height)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeButton");
#endif
	int idx;
	GtkWidget *button;
	char name[STRLEN64];
	fschar fsstr[MAX_PATH];
	machar mastr[MAXLOGLINELEN];
	
	if((idx = PushButtonIndexFromId(windowid, id)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"MakeButton PushButtonIndexFromId %d failed", id);
		maLog(mastr);
		return; 
	}

	if(id == ID_BTN_PAUSE)
		button = gtk_toggle_button_new_with_label(ma2fs(fsstr, label));	
	else
		button = gtk_button_new_with_label(ma2fs(fsstr, label));
	
	l_button[idx].id = id;
	l_button[idx].btn = button;
	l_button[idx].skip = 0;
	
	fssprintf(name, STRLEN64, "mabutton%s", ma2fs(fsstr, label));
	gtk_widget_set_name(button, (gchar *)name);
	
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(buttoncallback), (gpointer)&l_button[idx]);
	gtk_fixed_put(GTK_FIXED(l_fixed), button, xpos, ypos);
	gtk_widget_set_usize(button, width, height);

} // MakeButtonA


int l_ButtonPos, l_buttonTop;
void MakeButton(int windowid, int id, machar *label)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeButton");
#endif

	MakeButtonA(windowid, id, label, l_ButtonPos, l_buttonTop, MABUTTONW , MABUTTONH);
	l_ButtonPos += (MABUTTONW + MABUTTONSPACING);

} // MakeButton


#define CBYSIZ (14) // checkboxes
#define CBXSIZ (80) // 140 for checkboxes with large font
#define CBXSIZ1 (CBXSIZ + 2) // no label
#define CBXSIZ2 (CBXSIZ + 20)
#define CBXSIZ6 (CBXSIZ + 40)
#define CBXSIZ20 (20)
#define CBXSIZ3 (30)
#define CBXSIZ4 (40)
#define CBXSIZ5 (50)
#define CBXSIZ7 (400) // for advanced settings checkboxes, wide enough for long text (depends on font)

void *MakeCheckbox(int labelid, int id, machar *label, int xpos, int ypos, int width, int red)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeCheckbox");
#endif
	int idx;
	GtkWidget *checkbox;
	machar mastr[MAXLOGLINELEN];
	
	if((idx = CheckboxIndexFromId(id)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"MakeCheckbox CheckboxIndexFromId %d failed", id);
		maLog(mastr);
		return NULL; 
	}
	
	checkbox = gtk_check_button_new();
	gtk_widget_set_usize(GTK_WIDGET(checkbox), width, CBYSIZ);
	
	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
		GTK_SIGNAL_FUNC(checkboxcallback), (gpointer)&l_checkbox[idx]);
	gtk_fixed_put(GTK_FIXED(l_fixed), checkbox, xpos - 3, ypos);

	l_checkbox[idx].id = id;
	l_checkbox[idx].cb = checkbox;
	l_checkbox[idx].color = red;
	l_checkbox[idx].skip = 0;
	
	if(!label || label[0] == L'\0')
		l_checkbox[idx].text = NULL;
	else
		l_checkbox[idx].text = MakeText(labelid == ID_MANONE ? 0 : labelid, id, label, xpos + 16, ypos - 1, 0);

	gtk_widget_set_name(checkbox, "macheckbox");

	return checkbox;

} // MakeCheckbox


#define SLIDERISSCROLLBAR
#if defined(SLIDERISSCROLLBAR)
 #define SLIDERDELTAY 21
#else
 #define SLIDERDELTAY 0
#endif
#define VSLIDERW 20  // vslider width
#define VSLIDERH 102 // vslider height


void *MakeSlider(int id, int minval, int maxval, int xpos, int ypos, int width, int height, int style)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeSlider");
#endif
	int idx;
	GtkObject *adj;
	GtkWidget *slider;
	char name[STRLEN64];
	machar mastr[MAXLOGLINELEN];
	
	if((idx = SliderIndexFromId(id)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"MakeSlider SliderIndexFromId %d failed", id);
		maLog(mastr);
		return NULL; 
	}
	
	adj = gtk_adjustment_new(0.0, (gfloat)minval, (gfloat)(maxval + 1), 1.0, 1.0, 1.0);

 #if GTK_MAJOR_VERSION >= 2 && GTK_MINOR_VERSION >= 14
	gtk_adjustment_set_page_size(GTK_ADJUSTMENT(adj), 0); // since 2.14
 #endif

#if defined(SLIDERISSCROLLBAR)
	slider = gtk_vscrollbar_new(GTK_ADJUSTMENT(adj));
#else
	slider = gtk_vscale_new(GTK_ADJUSTMENT(adj));
	gtk_scale_set_draw_value(GTK_SCALE(slider), FALSE);
#endif

	if(style)
		strcpy(name, "masliderB");
	else
		strcpy(name, "maslider");
	gtk_widget_set_name(slider, (gchar *)name);

	gtk_widget_set_usize(GTK_WIDGET(slider), width, height + SLIDERDELTAY);	
	gtk_range_set_update_policy(GTK_RANGE(slider), GTK_UPDATE_CONTINUOUS);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
		GTK_SIGNAL_FUNC(slidercallback), (gpointer)&l_slider[idx]);
	gtk_fixed_put(GTK_FIXED(l_fixed), slider, xpos, ypos + 2);

	l_slider[idx].id = id;
	l_slider[idx].adj = adj;
	l_slider[idx].skip = 0;
	l_slider[idx].slider = slider;
	
	gtk_widget_set_name(slider, "maslider");

	return adj;

} // MakeSlider


void *MakeSpinButton(int id, int xpos, int ypos)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeSpinButton");
#endif
	int idx;
	GtkObject *adj;
	GtkWidget *spinbutton;
	machar mastr[MAXLOGLINELEN];
	 
	if((idx = SpinButtonIndexFromId(id)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"MakeSpinButton SpinButtonIndexFromId %d failed", id);
		maLog(mastr);
		return NULL; 
	}

	adj = gtk_adjustment_new(0.0, (gfloat)INT_MIN, (gfloat)INT_MAX, 16.0, 16.0, 1.0);
#if GTK_MAJOR_VERSION >= 2 && GTK_MINOR_VERSION >= 14
	gtk_adjustment_set_page_size(GTK_ADJUSTMENT(adj), 0); // since 2.14 
#endif
	spinbutton = gtk_spin_button_new(GTK_ADJUSTMENT(adj), 0.0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(spinbutton), TRUE);
	gtk_widget_set_usize(spinbutton, SPSIZx, SPSIZy);
	gtk_fixed_put(GTK_FIXED(l_fixed), spinbutton, xpos /* + 8 */, ypos /* + 2 */);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
		GTK_SIGNAL_FUNC(spinbuttoncallback), (gpointer)&l_spinbutton[idx]);
	l_spinbutton[idx].id = id;
	l_spinbutton[idx].adj = adj;
	l_spinbutton[idx].skip = 0;

	gtk_widget_set_name(spinbutton, "maspinbutton");

	return adj;

} // MakeSpinButton


void *MakePopup(int id, int nitems, machar **items, int xpos,int ypos, int width, int height)
{
	int i;
	int idx;
	GtkWidget *optionmenu;
	GtkWidget *menu;
	GtkWidget *menuitem;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if((idx = PopupButtonIndexFromId(id)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"MakePopup PopupButtonIndexFromId %d failed", id);
		maLog(mastr);
		return NULL;
	}
	menu = gtk_menu_new();
	gtk_widget_set_name(menu, "mapopup");
	for(i = 0; i < nitems; i++)
	{
		menuitem = gtk_menu_item_new_with_label(ma2fs(fsstr, items[i]));
		gtk_widget_set_name(menuitem, "mapopup");
		gtk_menu_append(GTK_MENU(menu), menuitem);
		gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(popupcallback), (gpointer)((i << 24) + id));
	}  
	optionmenu = gtk_option_menu_new();
	l_popupbutton[idx].optionmenu = optionmenu;
	l_popupbutton[idx].nitems = nitems;
	gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu), menu);
	gtk_widget_set_usize(optionmenu, width, height);
	gtk_fixed_put(GTK_FIXED(l_fixed), optionmenu, xpos, ypos);

	gtk_widget_set_name(optionmenu, "mapopup");

#if defined(MAMOUSEWHEEL)
	// don't scroll popups
	if(id != ID_POPUP_EQPRESET) // this one is fun to scroll
		gtk_signal_connect(GTK_OBJECT(optionmenu), "scroll_event",
			GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
#endif

	return optionmenu;
	
} // MakePopup


#define GTKRCFILE "magtkrc"
int l_gtkinited = 0;
int l_gtkiniting = 0;
void magtkinit()
{
#ifdef MATRACEGUIGTK
	maTrace("magtkinit");
#endif
	fschar gtkrcfile[MAX_PATH];

	if(l_gtkiniting) // don't reenter
		return;
	l_gtkiniting = 1;
	
	ossprintf(gtkrcfile, MAX_PATH, fsS fsC fsS fsC fsS, g_madir, FILESEP, MASETTINGSDIR, FILESEP, GTKRCFILE);
	if(maFileExists(gtkrcfile))
	{
		fschar *p[2];
		p[0] = gtkrcfile;
		p[1] = NULL;
		gtk_rc_set_default_files(p);
	}
									
	if(!gtk_init_check(&g_argc, &g_argv))
	{
		InstanceClearThis();
#if defined(MAUSESHM)
 		if(g_pmashm)
		{
			MAFREE(g_pmashm); // only creator should free this
			g_pmashm = NULL;
		}
#endif
		ClearInitLock();
		gtk_init(&g_argc, &g_argv); // let gtk display error msg and quit the app
	}
#if defined(MASETLOCALE)
		masetlocaledata(); // gtk_init and gtk_init_check reset the locale to C
#endif
	gdk_rgb_init();
	
	l_gtkinited = 1;
	l_gtkiniting = 0;
	
} // magtkinit


int SetupMenuRecentLabels()
{
#ifdef MATRACEGUIGTK
	maTrace("SetupMenuRecentLabels");
#endif
	int i;
	fschar items[MAXOPENRECENT][MAX_PATH];

	for (i = 0; i < MAXOPENRECENT; i++)
		items[i][0] = fsT('\0');

	if(GetRecent(items))
		return 1;
		
	for (i = 0; i < MAXOPENRECENT; i++)
	{
		if(items[i][0] == fsT('\0'))
			break;
		 FilenameFromPathname(items[i], &l_menurecentlabelUTF8[i][1]);
		 l_menurecentlabelUTF8[i][0] = fsT('/');
		 fs2ma(l_menurecentlabel[i], l_menurecentlabelUTF8[i]);
	}
	
	for (; i < MAXOPENRECENT; i++)
	{
		l_menurecentlabelUTF8[i][0] = fsT('\0');
		l_menurecentlabel[i][0] = L'\0';
	}
	
	return 0;
	
} // SetupMenuRecentLabels


void UpdateSubMenusRecent()
{
#ifdef MATRACEGUIGTK
	maTrace("UpdateSubMenusRecent");
#endif
	if(g_w[WINDOWAPP])
		RebuildMenus();
}


int	AppWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("AppWindowMake");
#endif
	GtkWidget *gtkwindow;
#if defined(MAKEYBOARD)
	machar label[32];
#endif
	machar mastr2[MAXLOGLINELEN];
	machar mastr3[MAXLOGLINELEN];
	
	if(!l_gtkinited)
		magtkinit();
	
	l_fixed = gtk_fixed_new();

	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWAPP << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWAPP << 8) + maGDK_CONFIGURE));

#if defined(MAKEYBOARD) || defined(MAMOUSEWHEEL)
	int mask = 0;
#endif

#if defined(MAKEYBOARD)
	mask = GDK_KEY_PRESS_MASK;
	gtk_widget_set_events(gtkwindow, mask);
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
#endif

#if defined(MAMOUSEWHEEL)
	mask |= GDK_SCROLL_MASK;
	gtk_widget_set_events(gtkwindow, GDK_SCROLL_MASK);
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
#endif

	g_w[WINDOWAPP] = gtkwindow;

	l_main_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_main_vbox), 1);
	gtk_container_add(GTK_CONTAINER(gtkwindow), l_main_vbox);

	// menus
	MakeMenus();
	gtk_box_pack_start_defaults(GTK_BOX(l_main_vbox), l_menubar);
	gtk_widget_show(l_menubar);

	// buttons and shortcut labels
	l_ButtonPos = XBASE;
	l_buttonTop = YBASE; // + MENUBARH;

#if defined(MAKEYBOARD)
	mastrcpy(label, LABEL_QUIT);
	MakeText(1, ID_TEXT_BUTTON_QUIT, label, l_ButtonPos + 14, BUTTONTEXTY, 0);
#endif
	MakeButton(WINDOWAPP, ID_BTN_QUIT, LABEL_B_QUIT);

#if defined(MAKEYBOARD)
	mastrcpy(label, LABEL_PREV);
	MakeText(1, ID_TEXT_BUTTON_PREVIOUS, label, l_ButtonPos + 6, BUTTONTEXTY, 0);
#endif
	MakeButton(WINDOWAPP, ID_BTN_PREVIOUS, LABEL_B_PREV);

#if defined(MAKEYBOARD)
	mastrcpy(label, LABEL_PLAY);
	MakeText(1, ID_TEXT_BUTTON_PLAY, label,	l_ButtonPos + 4, BUTTONTEXTY, 0);
#endif
	MakeButton(WINDOWAPP, ID_BTN_PLAY, LABEL_B_PLAY);

#if defined(MAKEYBOARD)
	mastrcpy(label, LABEL_PAUSE);
	MakeText(1, ID_TEXT_BUTTON_PAUSE, label,l_ButtonPos, BUTTONTEXTY, 0);
#endif
	MakeButton(WINDOWAPP, ID_BTN_PAUSE, LABEL_B_PAUSE);
	
#if defined(MAKEYBOARD)
	mastrcpy(label, LABEL_STOP);
	MakeText(1, ID_TEXT_BUTTON_STOP, label,	l_ButtonPos + 4, BUTTONTEXTY, 0);
#endif
	MakeButton(WINDOWAPP, ID_BTN_STOP, LABEL_B_STOP);

#if defined(MAKEYBOARD)
	mastrcpy(label, LABEL_NEXT);
	MakeText(1, ID_TEXT_BUTTON_NEXT, label,	l_ButtonPos + 4, BUTTONTEXTY, 0);
#endif
	MakeButton(WINDOWAPP, ID_BTN_NEXT, LABEL_B_NEXT);
	gtk_box_pack_end_defaults(GTK_BOX(l_main_vbox), l_fixed);
	
	// position slider
	l_hslider.adj = gtk_adjustment_new(0.0, (gfloat)POSMIN, (gfloat)(POSMAX + 1), 1.0, 1.0, 1.0);
#if GTK_MAJOR_VERSION >= 2 && GTK_MINOR_VERSION >= 14
 	gtk_adjustment_set_page_size(GTK_ADJUSTMENT(l_hslider.adj), 0); // since 2.14 
#endif
	l_hslider.id = ID_SLIDER_POSITION;
	l_scale = gtk_hscale_new(GTK_ADJUSTMENT(l_hslider.adj));
	gtk_widget_set_usize(GTK_WIDGET(l_scale), HSLIDERWIDTH, HSLIDERHEIGHT);
	gtk_range_set_update_policy(GTK_RANGE(l_scale), GTK_UPDATE_DELAYED); // GTK_UPDATE_CONTINUOUS GTK_UPDATE_DISCONTINUOUS
	gtk_signal_connect(GTK_OBJECT(l_hslider.adj), "value_changed",
		GTK_SIGNAL_FUNC(hslidercallback), (gpointer)&l_hslider);
	gtk_scale_set_draw_value(GTK_SCALE(l_scale), FALSE);
	gtk_fixed_put(GTK_FIXED(l_fixed), l_scale, HSLIDERPOSX, HSLIDERPOSY);

	// Alt size checkbox
	MakeCheckbox(ID_MANONE, ID_CHK_ALTSIZE, L"", XBASE, YBASE + MABUTTONH + 2, CBXSIZ20, 0); // in front "Quit"

	// repeat controls
	MakeText(1, ID_TEXT_TIMEPOS, NOTIMESTR, POSX + 6, YBASE + 85, 0);	
	MakeCheckbox(ID_MANONE, ID_CHK_REPTSONG, L"Repeat",	POSX + 6, YBASE + 99, CBXSIZ, 1); // red
	MakeSpinButton(ID_SPIN_BEG, BEGX + 2, YBASE + 86);
	MakeText(1, ID_TEXT_TIMEBEG, NOTIMESTR, BEGX + 20, YBASE + 85, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_BEG, L"Begin", BEGX + 20, YBASE + 99, CBXSIZ, 1); // red
	MakeSpinButton(ID_SPIN_END, ENDX + 2, YBASE + 86);
	MakeText(1, ID_TEXT_TIMEEND, NOTIMESTR, ENDX + 20, YBASE + 85, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_END, L"End", ENDX + 20, YBASE + 99, CBXSIZ, 1); // red

	// Volume, Separation, Preamp controls
	#define VOLY (YBASE + 124)
	#define VOLX (XBASE + 2)
	#define VOLLX (VOLX + 0)
	#define VOLRX (VOLX + 31)
	#define SEPX (VOLX + 63)
	#define PREAX (VOLX + 93)

	#define GTK2FIXY 4
	#define GTK2FIXY2 2

	MakeText(0, ID_TEXT_VOLUME, L"Volume", VOLLX + 4, YBASE + 141, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_BALANCE, L"Balance", VOLLX + 4,	YBASE + 120, CBXSIZ, 0);
	MakeSlider(ID_SLIDER_VOLUMEL, VOLUMEMIN, VOLUMEMAX, VOLLX, VOLY + 21 + GTK2FIXY, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_100VOLL, L"100", VOLLX, VOLY + 124 + SLIDERDELTAY + GTK2FIXY, 0);
	MakeSlider(ID_SLIDER_VOLUMER, VOLUMEMIN, VOLUMEMAX, VOLRX, VOLY + 21 + GTK2FIXY, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_100VOLR, L"100", VOLRX, VOLY + 124 + SLIDERDELTAY + GTK2FIXY, 0);
	
	MakeText(1, ID_TEXT_SEP, L"Sep", SEPX, YBASE + 141, 0);
	MakeText(1, ID_TEXT_S, L"s", SEPX - 7, VOLY + 31 + GTK2FIXY, 0);
	MakeSlider(ID_SLIDER_VOLUMESEP, SEPARATIONMIN, SEPARATIONMAX, SEPX, VOLY + 21 + GTK2FIXY, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_M, L"m", SEPX - 7, VOLY + 109 + SLIDERDELTAY + GTK2FIXY, 0);
	MakeText(1, ID_TEXT_100SEP, L"100", SEPX + 3, VOLY + 124 + SLIDERDELTAY + GTK2FIXY, 0);
	
	MakeText(1, ID_TEXT_PREAMP, L"Preamp", PREAX - 2, YBASE + 141, 0);
	MakeSlider(ID_SLIDER_PREAMP, PREAMPMIN, PREAMPMAX, PREAX, VOLY + 21 + GTK2FIXY, VSLIDERW, VSLIDERH, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_LIMITER, L"Limit", PREAX - 2, YBASE + 120, CBXSIZ5, 0); 
	MakeText(1, ID_TEXT_0, L"-00.0", PREAX, VOLY + 124 + SLIDERDELTAY + GTK2FIXY, 0);

	// checkboxes
	MakeCheckbox(ID_MANONE, ID_CHK_EQWINDOW, L"EqWindow", XBASE + 144, YBASE + 120, CBXSIZ, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_EQUALIZER, L"Equalizer",	XBASE + 144, YBASE + 141, CBXSIZ, 0);
	// MakeCheckbox(ID_MANONE, ID_CHK_EQ31BANDS, L"Eq31Bands", XBASE + 144, YBASE + 162, CBXSIZ, 0);
	// MakeCheckbox(ID_MANONE, ID_CHK_EQEXTRA, L"EqExtra", XBASE + 144, YBASE + 183, CBXSIZ, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_EFFECTS, L"Effects", XBASE + 144, YBASE + 162, CBXSIZ, 1); // red

	int cbypos = YBASE + 99;
	
	MakeCheckbox(ID_MANONE, ID_CHK_LISTWINDOW,	L"ListWindow",	XBASE + 220, cbypos += 21, CBXSIZ2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_RANDOM,		L"Random",		XBASE + 220, cbypos += 21, CBXSIZ2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_REPTPLAYED,	L"ReptPlayed",	XBASE + 220, cbypos += 21, CBXSIZ2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_LOOPLOADED,	L"LoopLoaded",	XBASE + 220, cbypos += 21, CBXSIZ2, 1); // red
	MakeCheckbox(ID_MANONE, ID_CHK_LOOPLIST,	L"LoopList",	XBASE + 220, cbypos += 21, CBXSIZ2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_INVERTRIGHT, L"InvertRight",	XBASE + 220, cbypos += 21, CBXSIZ2, 1); // red
	MakeCheckbox(ID_MANONE, ID_CHK_SINGLEPLAY,	L"SinglePlay",	XBASE + 220, cbypos += 21, CBXSIZ2, 1); // red
	// MakeCheckbox(ID_MANONE, ID_CHK_USEM3U,	L"Use m3u",		XBASE + 220, cbypos += 21, CBXSIZ2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_TITLEINFO,	L"TitleInfo",	XBASE + 220, cbypos += 21, CBXSIZ2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_HOSTINENABLE,L"Enable",		XBASE + 220, cbypos += (28 + YPOSADJUST_CHK_ENABLE), CBXSIZ2, 0);

	// mono/stereo
	#define MSTX (XBASE + 129)
	#define MSTY (YBASE + 211 + GTK2FIXY2)
	
	MakeText(1, ID_TEXT_OUTPUT, L"Output Stereo", MSTX + 0, YBASE + 185, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_MONOLEFT, L"L", MSTX + 0, YBASE + 204, CBXSIZ3, 1); // red
	MakeCheckbox(ID_MANONE, ID_CHK_MONORIGHT, L"R", MSTX + 26, YBASE + 204, CBXSIZ3, 1); // red
	MakeCheckbox(ID_TEXT_MONODIFF, ID_CHK_MONODIFF, L"rev", MSTX + 52, YBASE + 204, CBXSIZ4, 1); // red and dynamic
	
	// Output popup button (combo box)
	#define POPX (XBASE + 125)
	#define POPY (YBASE + 220 + GTK2FIXY2)
	#define POPY2 (POPY + 36)
	int i;
	machar *outitems[kOUTMAX];
	machar items[kOUTMAX][STRLEN64];
	
	outitems[0] = fs2ma(mastr3, g_extstrout[kOUTSOUND]);
	for(i = kOUTFIRST; i <= kOUTLAST; i++)
	{
		masprintf(items[i - kOUTFIRST], STRLEN64, L"%ls file", fs2ma(mastr2, &g_extstrout[i][1]));
		outitems[i - kOUTFIRST + 1] = items[i - kOUTFIRST];
	}
	MakePopup(ID_POPUP_OUTPUT, kOUTLAST - kOUTFIRST + 2, outitems, POPX, POPY, 85, 20);
	PopupButtonSetValue(WINDOWAPP, ID_POPUP_OUTPUT, kOUTLAST);
	
	// Mem Buffer spin control
	MakeSpinButton(ID_SPIN_BUFFER, POPX, POPY2 - 2 + GTK2FIXY2);

	// Mem Buffer popup button
	machar *outitems2[] =
	{
		L"Mem",
		L"Vdisk",
		L"Direct",
		L""
	};
	MakePopup(ID_POPUP_BUFFER, 3, outitems2, POPX + 16, POPY2 + GTK2FIXY2, 69, 20);
	PopupButtonSetValue(WINDOWAPP, ID_POPUP_BUFFER, 1);
	MakeText(1, ID_TEXT_BUFFER, L"Song Mem 2047 MB", POPX, POPY2 - 14 + GTK2FIXY2, 0);

#define POPX3 (XBASE + 2)
#define POPY3 (POPY2 + 50)
#define POPY3DELTA 40
#define POPXSIZ3 300
	// Audio Output Device popup button
	machar *outitems3[] =
	{
		L"Output Device",
		L""
	};
	MakePopup(ID_POPUP_AUDIOOUTPUT, 1, outitems3, POPX3, POPY3 + GTK2FIXY2, POPXSIZ3, 20);
	PopupButtonSetValue(WINDOWAPP, ID_POPUP_AUDIOOUTPUT, 1);
	MakeText(1, ID_TEXT_AUDIOOUTPUT, L"Audio Output Device", POPX3, POPY3 - 14 + GTK2FIXY2, 0);

	// Audio Output Host popup button
	machar *outitems4[] =
	{
		L"Output Host",
		L""
	};
	MakePopup(ID_POPUP_AUDIOINPUT, 1, outitems4, POPX3, POPY3 + GTK2FIXY2 + POPY3DELTA, POPXSIZ3, 20);
	PopupButtonSetValue(WINDOWAPP, ID_POPUP_AUDIOINPUT, 1);
	MakeText(1, ID_TEXT_AUDIOINPUT, L"Audio Output Host", POPX3, POPY3 - 14 + GTK2FIXY2 + POPY3DELTA, 0);

	// Audio Input Device popup button
	machar *outitems5[] =
	{
		L"Input Device",
		L""
	};
	MakePopup(ID_POPUP_AUDIOHOSTIN, 1, outitems5, POPX3, POPY3 + GTK2FIXY2 + 2 * POPY3DELTA, POPXSIZ3, 20);
	PopupButtonSetValue(WINDOWAPP, ID_POPUP_AUDIOHOSTIN, 1);
	MakeText(1, ID_TEXT_AUDIOHOSTIN, L"Audio Input Device", POPX3, POPY3 - 14 + GTK2FIXY2 + 2 * POPY3DELTA, 0);

	// Audio Input Host popup button
	machar *outitems6[] =
	{
		L"Input Host",
		L""
	};
	MakePopup(ID_POPUP_AUDIOHOSTOUT, 1, outitems6, POPX3, POPY3 + GTK2FIXY2 + 3 * POPY3DELTA, POPXSIZ3, 20);
	PopupButtonSetValue(WINDOWAPP, ID_POPUP_AUDIOHOSTOUT, 1);
	MakeText(1, ID_TEXT_AUDIOHOSTOUT, L"Audio Input Host", POPX3,	POPY3 - 14 + GTK2FIXY2 + 3 * POPY3DELTA, 0);

	gtk_widget_set_uposition(gtkwindow, (gint)g_sets.mawin[WINDOWAPP].xpos[g_sets.winconf], (gint)g_sets.mawin[WINDOWAPP].ypos[g_sets.winconf]);

	gtk_widget_show_all(gtkwindow);
		
	while(gtk_events_pending())
		gtk_main_iteration();

	return 0;	

} // AppWindowMake


int MenuEventHandler(gpointer callback_data, guint callback_action, GtkWidget *widget)
{
#ifdef MATRACEGUIGTK
 machar mastr[MAXLOGLINELEN];
 masprintf(mastr, MAXLOGLINELEN, L"MenuEventHandler callback_data=0x%x callback_action=%d widget=0x%x",
						(int)callback_data, callback_action, (int)widget);
 maGuiLog(mastr);
#endif

	// always_show_toggle is used as flag set in MenuSetChecked()
	// to tell us to ignore this event
	if(GTK_IS_CHECK_MENU_ITEM(widget) && (GTK_CHECK_MENU_ITEM(widget))->always_show_toggle == 0)
	{
		(GTK_CHECK_MENU_ITEM(widget))->always_show_toggle = 1; // normal value
		return 0;
	}
	
	switch(callback_action)
	{
		case ID_MENU_ABOUT:
			DoWindow(WINDOWABOUT, 1);
		break;
		case ID_MENU_QUIT:
			DoAppQuit();
		break;
		case ID_MENU_PREVIOUS:
			DoPrevious();
		break;
		case ID_MENU_PLAY:
			DoPlay();
		break;
		case ID_MENU_PAUSE:
			DoPause();
		break;
		case ID_MENU_STOP:
			DoStop();
		break;
		case ID_MENU_NEXT:
			DoNext();
		break;
		
		case ID_MENU_OPENLIST:
			DoOpenList();
		break;
		case ID_MENU_MAKELIST:
			DoMakeList();
		break;
		case ID_MENU_SAVELISTAS:
			DoSaveListAs();
		break;
		case ID_MENU_DELETELIST:
			DoDeleteList();
		break;
		
		case ID_MENU_PLAYFILE:
			DoPlayFile();
		break;
		case ID_SUBMENU_OPENRECENT1:
			DoOpenRecent(0);
		break;
		case ID_SUBMENU_OPENRECENT2:
			DoOpenRecent(1);
		break;
		case ID_SUBMENU_OPENRECENT3:
			DoOpenRecent(2);
		break;
		case ID_SUBMENU_OPENRECENT4:
			DoOpenRecent(3);
		break;
		case ID_SUBMENU_OPENRECENT5:
			DoOpenRecent(4);
		break;
		case ID_SUBMENU_OPENRECENT6:
			DoOpenRecent(5);
		break;
		case ID_SUBMENU_OPENRECENT7:
			DoOpenRecent(6);
		break;
		case ID_SUBMENU_OPENRECENT8:
			DoOpenRecent(7);
		break;
		case ID_SUBMENU_OPENRECENT9:
			DoOpenRecent(8);
		break;
		case ID_SUBMENU_OPENRECENT10:
			DoOpenRecent(9);
		break;
		case ID_MENU_PLAYCD:
			DoPlayCD();
		break;
		case ID_MENU_EJECTCD:
			DoEjectCD();
		break;
		case ID_MENU_AUDIOIN:
			DoAudioIn();
		break;
		case ID_MENU_SAVEMASETS:
			DoSave();
		break;
		case ID_MENU_SETSAVED:
			DoSetsSaved();
		break;
		case ID_MENU_SETDEFAULT:
			DoSetsDefault();
		break;
		case ID_MENU_SETFACTORY:
			DoSetsFactory();
		break;
		case ID_MENU_SETCOPY:
			DoSetsCopy();
		break;
		case ID_MENU_SAVEMASETSDEFAULT:
			DoAsDefaults();
		break;
		case ID_MENU_EQUALIZER:
			DoEqualizer((g_sets.eqflags & MAEQACTIVE) ? 0 : 1);
		break;
		case ID_MENU_EQ31BANDS:
			DoEq31Bands((g_sets.eqflags & MAEQ31BANDS) ? 0 : 1);
		break;
		case ID_MENU_EQEXTRA:
			DoEqExtra((g_sets.eqflags & MAEQEXTRA) ? 0 : 1);
		break;
		case ID_MENU_EFFECTS:
			DoEffects((g_sets.effects & EFFECTSON) ? 0 : 1);
		break;
		case ID_MENU_RANDOM:
			DoRandom(g_sets.random ? 0 : 1);
		break;
		case ID_MENU_REPTPLAYED:
			DoReptPlayed(g_sets.reptplayed ? 0 : 1);
		break;
		case ID_MENU_LOOPLOADED:
			DoLoopLoaded(g_sets.looploaded ? 0 : 1);
		break;
		case ID_MENU_LOOPLIST:
			DoLoopList(g_sets.looplist ? 0 : 1);
		break;
		case ID_MENU_MONO:
			DoMono(g_sets.monodiff ? 0 : 1);
		break;
		case ID_MENU_INVERTRIGHT:
			DoInvertRight(g_sets.invertright ? 0 : 1);
		break;
		case ID_MENU_SINGLEPLAY:
			DoSinglePlay(g_sets.singleplay ? 0 : 1);
		break;
		case ID_MENU_INPUTMONITOR:
			DoInMonitor(g_sets.inputmonitor ? 0 : 1);
		break;
		case ID_SUBMENU_TITLEINFO1:
			DoTitleInfo(1);
		break;
		case ID_SUBMENU_TITLEINFO2:
			DoTitleInfo(2);
		break;
		case ID_SUBMENU_TITLEINFO3:
			DoTitleInfo(3);
		break;
		case ID_MENU_AUTOSTART:
			g_sets.autostart = g_sets.autostart ? 0 : 1;
		break;
		case ID_MENU_ERRLOGGING:
			DoErrLogging((g_sets.logflags & kMALOGOFF) ? 1 : 0);
		break;
		case ID_MENU_SETVDISK:
			DoSetVDisk();
		break;
#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
		case ID_MENU_SETAUDIOCD:
			DoWindow(WINDOWAUDIOCD, 1);
		break;
#endif
		case ID_MENU_MULTIPLEINST:
			DoMultipleInst(g_sets.multipleinst ? 0 : 1);
		break;
#if defined(MAKEYBOARD)
		case ID_MENU_KEYBOARD:
			DoKeyboard(g_sets.keyboard ? 0 : 1);
		break;
#endif
#if defined(MAMOUSEWHEEL)
		case ID_MENU_MOUSEWHEEL:
			DoMouseWheel(g_sets.mousewheel ? 0 : 1);
		break;
#endif
		case ID_MENU_ADVANCED:
			DoWindow(WINDOWADVANCED, 1);
		break;
		case ID_MENU_SHOWLIST:
			ToggleWindow(WINDOWLIST);
		break;
		case ID_MENU_SHOWEQ:
			DoEqWindow();
		break;
		case ID_MENU_ZEROLIST:
			 DoZeroList();
		break;
		case ID_MENU_MAKECATALOG:
			 DoMakeCatalog();
		break;
#if !defined(NOTEXTVIEWER)
		case ID_MENU_VIEWCATALOG:
			 DoViewCatalog(0);
		break;
		case ID_MENU_VIEWPLAYLIST:
			 DoWindow(WINDOWPLAYLIST, 1);
		break;
		case ID_MENU_VIEWLOG:
			 DoWindow(WINDOWLOG, 1);
		break;
#endif
		case ID_MENU_CLEARLOG:
			 maLog(&g_logcmdclear);
		break;
#if !defined(NOTEXTVIEWER)
 #if defined(MAKEYBOARD)
		case ID_MENU_EDITKEYBINDINGS:
			 DoEditKeyBindings();
		break;
		case ID_MENU_BLANKKEYBINDINGS:
			 DoBlankKeyBindings();
		break;
		case ID_MENU_FACTORYKEYBINDINGS:
			 DoFactoryKeyBindings();
		break;
 #endif
#endif
		case ID_MENU_RESCANAUDIODEVICES:
			 DoRescanAudioDevices();
		break;
		case ID_MENU_SHOWEFFECTS:
			ToggleWindow(WINDOWEFFECTS);
		break;
		case ID_MENU_SHOWFILEOUT:
			ToggleWindow(WINDOWFILEOUT);
		break;
		case ID_MENU_ALTSIZE:
			DoAltSize(g_sets.winconf ? 0 : 1, 0);
		break;
		case ID_MENU_SAVEDSIZE:
			DoSavedSize();
		break;
		case ID_MENU_DEFAULTSIZE:
			DoDefaultSize();
		break;
		case ID_MENU_FACTORYSIZE:
			DoFactorySize();
		break;
#if !defined(NOTEXTVIEWER)
		case ID_MENU_README:
			DoWindow(WINDOWREADME, 1);
		break;
#endif
		default:
#ifdef MATRACEGUIGTK
			masprintf(mastr, MAXLOGLINELEN, L"MenuEventHandler callback_data=0x%x callback_action=%d widget=0x%x",
							(int)callback_data, callback_action, (int)widget);
			maGuiLog(mastr);
#endif
		return 1;
	}
	
	return 0;
	
} // MenuEventHandler


int CommandEventHandler(gpointer callback_data, guint id, GtkWidget *widget)
{
#ifdef MATRACEGUIGTK
maTrace("CommandEventHandler");
#endif
	switch(id)
	{
		case ID_BTN_QUIT:
			DoAppQuit();
		break;
		case ID_BTN_PREVIOUS:
			DoPrevious();
		break;
		case ID_BTN_PLAY:
			DoPlay();
		break;
		case ID_BTN_PAUSE:
			if(g_state.running)
				DoPause();
			else
				PushButtonPaintUp(WINDOWAPP, ID_BTN_PAUSE);
		break;
		case ID_BTN_STOP:
			DoStop();
		break;
		case ID_BTN_NEXT:
			DoNext();
		break;

		case ID_CHK_ALTSIZE:
			DoAltSize(GTK_TOGGLE_BUTTON(widget)->active, 0);
		break;
		case ID_CHK_REPTSONG:
			DoReptSong(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_BEG:
			DoBoxBeg(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_END:
			DoBoxEnd(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_BALANCE:
			DoBalance(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LIMITER:
			DoLimiter(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQWINDOW:
			DoEqWindow();
		break;
		case ID_CHK_EQUALIZER:
			DoEqualizer(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		// case ID_CHK_EQ31BANDS:
		// 	DoEq31Bands(GTK_TOGGLE_BUTTON(widget)->active);
		// break;
		// case ID_CHK_EQEXTRA:
		// 	 DoEqExtra(GTK_TOGGLE_BUTTON(widget)->active);
		// break;
		case ID_CHK_EFFECTS:
			DoEffects(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_MONOLEFT:
			DoMonoLeft(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_MONORIGHT:
			DoMonoRight(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_MONODIFF:
			DoMonoDiff(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LISTWINDOW:
			DoListWindow(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_RANDOM:
			DoRandom(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_REPTPLAYED:
			DoReptPlayed(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LOOPLOADED:
			DoLoopLoaded(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LOOPLIST:
			DoLoopList(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_INVERTRIGHT:
			DoInvertRight(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SINGLEPLAY:
			DoSinglePlay(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_TITLEINFO:
			DoTitleInfo(0);
		break;
		case ID_CHK_HOSTINENABLE:
			DoHostInEnable(GTK_TOGGLE_BUTTON(widget)->active);
		break;

		case ID_POPUP_OUTPUT:
			OnPopupOutput((int)callback_data);
		break;

		case ID_POPUP_BUFFER:
			OnPopupBuffer((int)callback_data);
		break;

		case ID_POPUP_AUDIOOUTPUT:
			OnPopupAudioOutput((int)callback_data);
		break;
		case ID_POPUP_AUDIOHOSTOUT:
			OnPopupAudioHostOut((int)callback_data);
		break;
		case ID_POPUP_AUDIOINPUT:
			OnPopupAudioInput((int)callback_data);
		break;
		case ID_POPUP_AUDIOHOSTIN:
			OnPopupAudioHostIn((int)callback_data);
		break;

		// list window
		case ID_BTN_INFO:
			OnButtonInfo();
		break;
		case ID_BTN_PLAYLIST:
			OnButtonList();
		break;
		case ID_BTN_LOADED:
			OnButtonLoaded();
		break;
		case ID_BTN_SONGINFO:
			OnButtonSong();
		break;
		case ID_CHK_SHOWINDEX:
			DoShowIndex(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SHOWDIR:
			DoShowDir(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SHOWPATH:
			DoShowPath(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_ADDMODE:
			DoAddMode(GTK_TOGGLE_BUTTON(widget)->active);
		break;

		// equalizer window
		case ID_BTN_EQMINUS:
			OnButtonEqMinus();
		break;
		case ID_BTN_EQPLUS:
			OnButtonEqPlus();
		break;
		case ID_BTN_EQMID:
			OnButtonEqMid();
		break;
		case ID_BTN_EQCOPY:
			OnButtonEqCopy();
		break;
		case ID_BTN_EQPASTE:
			OnButtonEqPaste();
		break;
		case ID_BTN_EQRESTORE:
			OnButtonEqRestore();
		break;
		case ID_BTN_EQSHIFTL:
			OnButtonEqShiftL();
		break;
		case ID_BTN_EQSHIFTR:
			OnButtonEqShiftR();
		break;
		case ID_BTN_EQINVERT:
			OnButtonEqInvert();
		break;

		// equalizer2 window
		case ID_BTN_EQ2MID:
			OnButtonEq2Mid();
		break;
		case ID_BTN_EQ2COPY:
			OnButtonEq2Copy();
		break;
		case ID_BTN_EQ2PASTE:
			OnButtonEq2Paste();
		break;
		case ID_BTN_EQ2RESTORE:
			OnButtonEq2Restore();
		break;

		case ID_POPUP_EQPRESET:
			OnPopupEqPreset((int)callback_data);
		break;

		case ID_CHK_EQUALIZERB:
			DoEqualizer(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQ31BANDSB:
			DoEq31Bands(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQEXTRAB:
			DoEqExtra(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SEPARATELR:
			DoSeparateLR(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQZOOM:
			DoEqZoom(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQLINK:
			DoEqLink(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		
		// effects window
		case ID_CHK_EFFECTSB:
			DoEffects(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SBSMS:
			DoSBSMS(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_PITCH:
			DoPitch(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_TEMPO:
			DoTempo(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SPEED:
			DoSpeed(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		// fileout window
		case ID_BTN_FILEOUTDIR:
			OnButtonFileOutDir();
		break;
#if defined(ENCODEAAC)
		case ID_CHK_ADTS:
			DoBoxADTS(GTK_TOGGLE_BUTTON(widget)->active);
		break;
#endif
#if defined(ENCODEMP4)
		case ID_CHK_M4A:
			DoBoxM4A(GTK_TOGGLE_BUTTON(widget)->active);
		break;
#endif
		case ID_POPUP_BITRATE:
			OnPopupBitRate((int)callback_data);
		break;
		case ID_POPUP_QUALITY:
			OnPopupQuality((int)callback_data);
		break;
		case ID_POPUP_MODE:
			OnPopupMode((int)callback_data);
		break;
		case ID_POPUP_SAMPLERATE:
			OnPopupSampleRate((int)callback_data);
		break;
		
		// advanced settings window
		case ID_CHK_CLOSEREOPEN:
			DoCloseReopen(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_INPUTMONITOR:
			DoInputMonitor(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LOGNOTPLAYABLE: 
			DoLogNotPlayable(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_USEM3U:
			DoUseM3u(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EXITAFTER:
			DoExitAfter(GTK_TOGGLE_BUTTON(widget)->active);
		break;

		// audio cd
#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
		case ID_BTN_AUDIOCDSET:
			OnButtonAudioCDSet();
		break;
		case ID_BTN_AUDIOCDCLEAR:
			OnButtonAudioCDClear();
		break;
		case ID_BTN_AUDIOCDSAVE:
			OnButtonAudioCDSave();
		break;
		case ID_BTN_AUDIOCDCLOSE:
			DoWindow(WINDOWAUDIOCD, 0);
		break;
		case ID_POPUP_AUDIOCD:
			OnPopupAudioCD((int)callback_data);
		break;
		case ID_CHK_CDPARANOIA:
			DoCdParanoia(GTK_TOGGLE_BUTTON(widget)->active);
		break;
#endif

		// prompt number popup
		case ID_BTN_PROMPTNUMOK:
			DoPromptIndexOk();
		break;
		case ID_BTN_PROMPTNUMCANCEL:
			DoWindow(WINDOWPROMPTNUM, 0);
		break;

		default:
#ifdef MATRACEGUIGTK
			masprintf(mastr, MAXLOGLINELEN, L"CommandEventHandler callback_data=0x%x callback_action=%d widget=0x%x",
							(int)callback_data, id, (int)widget);
			maGuiLog(mastr);
#endif
		return 1;
	}
	
	return 0;
	
} // CommandEventHandler


#if defined(MAKEYBOARD)
gint KeyboardEventHandler(GtkWidget *widget, GdkEventKey *event, gpointer data)
{
 #ifdef MATRACEGUIGTK
  maTrace("KeyboardEventHandler");
 #endif
	fschar fskey[STRLEN16] = {fsT('\0')};
	if(!g_sets.keyboard || (g_w[WINDOWEQ] && GTK_WIDGET_HAS_FOCUS(l_eqentry)))
		return(FALSE); // event not handled
		
 	if(event->keyval == GDK_Return) // 0xFF0D
	{
		fskey[4] = MAWXK_RETURN;
		maOnKey(fskey);
	}
	else if(event->keyval == GDK_Escape)
	{
		fskey[4] = MAWXK_ESCAPE;
		maOnKey(fskey);
	}
	else if(event->keyval == GDK_Up) // up arrow
		return(FALSE);
	else if(event->keyval == GDK_Down) // down arrow
		return(FALSE);
	else
	{
		fskey[0] = event->keyval;
		maOnKey(fskey);
	}
	return(TRUE); // event handled
}
#endif

 #if defined(MAMOUSEWHEEL)
  gint MouseWheelEventHandler(GtkWidget *widget, GdkEventScroll *event, gpointer data)
  {
   #ifdef MATRACEGUIGTK
	maTrace("MouseWheelEventHandler");
   #endif

	if(g_sets.mousewheel && event->type == GDK_SCROLL)
	{
		if(event->direction == GDK_SCROLL_UP)
			ChangeVolume(MAWHEELVOLUMEDELTA);
		else if(event->direction == GDK_SCROLL_DOWN)
			ChangeVolume(-MAWHEELVOLUMEDELTA);
	}
	
	return(TRUE); // event handled
	
  } // MouseWheelEventHandler gtk2
#endif


gint AppWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("AppWindowEventHandler");
#endif
	int evtype;
	int windowid = (int)data >> 8;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return(FALSE); // event not handled;

 	evtype = (int)data & 0xff;
	
	switch(evtype)
	{
		case maGDK_DELETE: // all windows come here
			switch(event->type)
			{
				case GDK_DELETE:
					if(windowid == WINDOWAPP)
						DoAppQuit();
					else
						DoWindow(windowid, 0);
				break;
				default:
#ifdef MATRACEGUIGTK
{
machar mastr[MAXLOGLINELEN];
masprintf(mastr, MAXLOGLINELEN, L"AppWindowEventHandler maGDK_DELETE default type=%d data=%d", event->type, (int)data);
maTrace(mastr);
}
#endif
				break;
			}
		break;

		case maGDK_CONFIGURE: // all windows come here
			switch(event->type)
			{
				case GDK_CONFIGURE: // resize, move, etc
					if(event->configure.send_event) // true when moved
					{
#ifdef MATRACEGUIGTK
maTrace("AppWindowEventHandler window moved");
#endif
						DoWindowMoved(windowid);
						return(TRUE); // event handled
					}
					else // must be resize
					{
#ifdef MATRACEGUIGTK
maTrace("AppWindowEventHandler window resized");
#endif
						DoWindowResized(windowid);
					}
				break;

				default:
#ifdef MATRACEGUIGTK
{
machar mastr[MAXLOGLINELEN];
masprintf(mastr, MAXLOGLINELEN, L"AppWindowEventHandler maGDK_CONFIGURE default type=%d data=%d", event->type, (int)data);
maTrace(mastr);
}
#endif
				break;
			}
		break;
	
		default:
#ifdef MATRACEGUIGTK
{
machar mastr[MAXLOGLINELEN];
masprintf(mastr, MAXLOGLINELEN, L"AppWindowEventHandler default evtype=%d type=%d data=%d", evtype, event->type, (int)data);
maTrace(mastr);
}
#endif
		break;
	}

	return(FALSE); // event not handled

} // AppWindowEventHandler


void guiAppYield() 
{
#ifdef MATRACEGUIGTK
	maTrace("guiAppYield");
#endif
} // guiAppYield


void CheckBoxDisable(int windowid, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxDisable");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxDisable CheckboxIndexFromId %d failed", checkbox);
		maLog(mastr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxDisable no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(mastr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_checkbox[idx].cb), FALSE);
	
} // CheckBoxDisable


void CheckBoxEnable(int windowid, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxEnable");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxEnable CheckboxIndexFromId %d failed", checkbox);
		maLog(mastr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxEnable no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(mastr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_checkbox[idx].cb), TRUE);

} // CheckBoxEnable


int CheckBoxGetValue(int windowid, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxGetValue");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxGetValue CheckboxIndexFromId %d failed", checkbox);
		maLog(mastr);
		return 0; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxGetValue no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(mastr);
		return 0;
	}
	
	return(((GTK_TOGGLE_BUTTON(l_checkbox[idx].cb))->active) ? 1 : 0);

} // CheckBoxGetValue


void CheckBoxHide(int windowid, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxHide");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxHide CheckboxIndexFromId %d failed", checkbox);
		maLog(mastr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxHide no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(mastr);
		return;
	}
	
	gtk_widget_hide(l_checkbox[idx].cb);
	
	if(l_checkbox[idx].text)
		gtk_widget_hide(l_checkbox[idx].text);

} // CheckBoxHide


GtkLabel *maGtkGetFirstLabel(GtkContainer *container)
{
	GList *dlist, *free_list;
	GtkWidget *list_item;
	GtkLabel *label = NULL;
	
	free_list = dlist = gtk_container_children(container);
	while(dlist)
	{
		list_item = dlist->data;
		if(GTK_IS_LABEL(list_item))
		{
			label = GTK_LABEL(list_item);
			break;
		}
		dlist = dlist->next;
	}
	g_list_free(free_list);

	return label;
	
} // maGtkGetFirstLabel


void CheckBoxSetDescriptor(int windowid, int checkbox, machar *desc)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxSetDescriptor");
#endif
	GtkLabel *label;
	int idx;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if(!desc)
		return;
		
	if((idx = CheckboxIndexFromId(checkbox)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxSetDescriptor CheckboxIndexFromId %d failed", checkbox);
		maLog(mastr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxSetDescriptor no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(mastr);
		return;
	}

	if(l_checkbox[idx].text)
		gtk_label_set_text(GTK_LABEL(l_checkbox[idx].text), ma2fs(fsstr, desc));
	else
		if(desc && (label = maGtkGetFirstLabel(l_checkbox[idx].cb)))
			gtk_label_set_text(label, ma2fs(fsstr, desc));
	
} // CheckBoxSetDescriptor


/*
void CheckBoxSetFocus(int windowid, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxSetFocus");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if((idx = CheckboxIndexFromId(checkbox)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxSetFocus CheckboxIndexFromId %d failed", checkbox);
		maLog(mastr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxSetFocus no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(mastr);
		return;
	}

	gtk_widget_grab_focus(l_checkbox[idx].cb);
		
} // CheckBoxSetFocus
*/


void CheckBoxSetValue(int windowid, int checkbox, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxSetValue");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxSetValue CheckboxIndexFromId %d failed", checkbox);
		maLog(mastr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxSetValue no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(mastr);
		return;
	}
	
	if(((GTK_TOGGLE_BUTTON(l_checkbox[idx].cb))->active && value) ||
	 (!((GTK_TOGGLE_BUTTON(l_checkbox[idx].cb))->active) && !value))
		return; // already set

	if(l_checkbox[idx].color && l_checkbox[idx].text)
		gtktextsetred(l_checkbox[idx].text, value);
	
	l_checkbox[idx].skip = 1;
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(l_checkbox[idx].cb), value ? TRUE : FALSE);

} // CheckBoxSetValue


void CheckBoxShow(int windowid, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxShow");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxShow CheckboxIndexFromId %d failed", checkbox);
		maLog(mastr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		masprintf(mastr, MAXLOGLINELEN, L"CheckBoxShow no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(mastr);
		return;
	}
	
	gtk_widget_show(l_checkbox[idx].cb);
	
	if(l_checkbox[idx].text)
		gtk_widget_show(l_checkbox[idx].text);

} // CheckBoxShow


/* not used void MenuSetLabel(int item, machar *label)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuSetLabel");
#endif
	machar *p;
	machar *q;
	machar nulabel[STRLEN256];
	machar mastr[MAXLOGLINELEN];
	if(label == NULL)
	{
		maLog(L"MenuGetLabel null label parameter");
		return;
	}
	if(l_commandid[item] == 'NULL')
		return;
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory, item);
	if(!w)
	{
		
		masprintf(mastr, MAXLOGLINELEN, L"MenuGetLabel gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(mastr);
		return;
	}
	mastrcpy(nulabel, gtk_item_factory_path_from_widget(w));
	q = p = nulabel;
	while(p)
	{
		q = p;
		p = mastrchr(p, '/');
		if(p)
			p++;
	}
	mastrcpy(q, label);

	// delete factory entry
	//gtk_item_factory_delete_item(GtkItemFactory *ifactory, const gchar *path);
	//...

	// add factory entry
	//gtk_item_factory_create_item(GtkItemFactory *ifactory, GtkItemFactoryEntry *entry,
	//									gpointer callback_data, guint callback_type);
	//...
	
} // MenuSetLabel



void MenuGetLabel(int item, machar *label)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuGetLabel");
#endif
	machar *p;
	machar *q;
	machar mastr[MAXLOGLINELEN];
	if(label == NULL)
	{
		maLog(L"MenuGetLabel null label parameter");
		return;
	}
	if(l_commandid[item] == 'NULL')
		return;
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory, item);
	if(!w)
	{
		
		masprintf(mastr, MAXLOGLINELEN, L"MenuGetLabel gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(mastr);
		return;
	}
	mastrcpy(mastr, gtk_item_factory_path_from_widget(w));
	p = mastr;
	while(p)
	{
		q = p;
		p = mastrchr(p, '/');
		if(p)
			p++;
	}
	mastrcpy(label, q);
masprintf(mastr, MAXLOGLINELEN, L"MenuGetLabel item=%d label='%ls'", item, label);
maTrace(mastr);
} // MenuGetLabel
*/


void maLogAPI(const machar *errtxt, int windowid, int item)
{
	machar mastr[MAXLOGLINELEN];
	
	masprintf(mastr, MAXLOGLINELEN, L"%ls window=%d item=%d", errtxt, windowid, item);
	maLog(mastr);
}


void DisplayGetSize(int *x, int *y)
{
#ifdef MATRACEGUIGTK
	maTrace("DisplayGetSize");
#endif

	if(!x)
	{
		maLog(L"DisplayGetSize null x parameter");
		return;
	}

	if(!y)
	{
		maLog(L"DisplayGetSize null y parameter");
		return;
	}

	if(!l_gtkinited)
		magtkinit();

	*x = gdk_screen_width();
	*y = gdk_screen_height();

} // DisplayGetSize


void DoTimerRunLoop(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerRunLoop");
#endif
	// should restart the timer here, not add a timer after the callback destroyed it
	l_timerrunloop = g_timeout_add(delay, OnTimerRunLoop, NULL);
}

void DoTimerPlay(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerPlay");
#endif

	l_timerplay = g_timeout_add(delay, OnTimerPlay, NULL);
}


/* void DoTimerStop(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerStop");
#endif

	l_timerstop = g_timeout_add(delay, OnTimerStop, NULL);
}
*/

void DoTimerChangePlaylist(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerChangePlaylist");
#endif

	l_timerchangeplaylist = g_timeout_add(delay, OnTimerChangePlaylist, NULL);
}


void DoTimerPlayPlaylist(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerPlayPlaylist");
#endif

	l_timerplayplaylist = g_timeout_add(delay, OnTimerPlayPlaylist, NULL);
}


void EditTextEnable(int windowid, int edittext)
{
#ifdef MATRACEGUIGTK
	maTrace("EditTextEnable");
#endif
	GtkWidget *w = NULL;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	switch(edittext)
	{
#if !defined(NOTEXTVIEWER)
		case ID_EDITTEXT_VIEWERFIND:
			switch(windowid)
			{
				case WINDOWREADME:
					w = g_viewerReadme.entry;
				break;
				case WINDOWCATALOG:
					w = g_viewerCatalog.entry;
				break;
				case WINDOWPLAYLIST:
					w = g_viewerPlaylist.entry;
				break;
				case WINDOWLOG:
					w = g_viewerLog.entry;
				break;
 #if defined(MAKEYBOARD)
				case WINDOWKEYBINDINGS:
					w = g_viewerKeyBindings.entry;
				break;
 #endif
				default:
					maLogAPI(L"EditTextEnable ID_EDITTEXT_VIEWERFIND invalid windowid", windowid, edittext);
				return;
			}
		break;
#endif
		default: 
			maLogAPI(L"EditTextEnable invalid edittext id", windowid, edittext);
			return;
		break;
	}
	
	if(!w)
	{
		maLogAPI(L"EditTextEnable no widget", windowid, edittext);
		return;
	}

	gtk_widget_set_sensitive(w, TRUE);

} // EditTextEnable


void EditTextDisable(int windowid, int edittext)
{
#ifdef MATRACEGUIGTK
	maTrace("EditTextDisable");
#endif
	GtkWidget *w = NULL;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	switch(edittext)
	{
#if !defined(NOTEXTVIEWER)
		case ID_EDITTEXT_VIEWERFIND:
			switch(windowid)
			{
				case WINDOWREADME:
					w = g_viewerReadme.entry;
				break;
				case WINDOWCATALOG:
					w = g_viewerCatalog.entry;
				break;
				case WINDOWPLAYLIST:
					w = g_viewerPlaylist.entry;
				break;
				case WINDOWLOG:
					w = g_viewerLog.entry;
				break;
 #if defined(MAKEYBOARD)
				case WINDOWKEYBINDINGS:
					w = g_viewerKeyBindings.entry;
				break;
 #endif
				default:
					maLogAPI(L"EditTextDisable ID_EDITTEXT_VIEWERFIND invalid windowid", windowid, edittext);
				return;
			}
		break;
#endif
		default: 
			maLogAPI(L"EditTextDisable invalid edittext id", windowid, edittext);
			return;
		break;
	}
	
	if(!w)
	{
		maLogAPI(L"EditTextDisable no widget", windowid, edittext);
		return;
	}

	gtk_widget_set_sensitive(w, FALSE);

} // EditTextDisable


void EditTextSetText(int windowid, int edittext, machar *p0)
{
 #ifdef MATRACEGUIGTK
	maTrace("EditTextSetText");
 #endif
	GtkWidget *w = NULL;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	switch(edittext)
	{
		case ID_EDITTEXT_EQ:
			w = l_eqentry;
		break;
#if !defined(NOTEXTVIEWER)
		case ID_EDITTEXT_VIEWERFIND:
			switch(windowid)
			{
				case WINDOWREADME:
					w = g_viewerReadme.entry;
				break;
				case WINDOWCATALOG:
					w = g_viewerCatalog.entry;
				break;
				case WINDOWPLAYLIST:
					w = g_viewerPlaylist.entry;
				break;
				case WINDOWLOG:
					w = g_viewerLog.entry;
				break;
 #if defined(MAKEYBOARD)
				case WINDOWKEYBINDINGS:
					w = g_viewerKeyBindings.entry;
				break;
 #endif
				default:
					maLogAPI(L"EditTextSetText ID_EDITTEXT_VIEWERFIND invalid windowid", windowid, edittext);
				return;
			}
		break;
		case ID_EDITTEXT_VIEWERVIEW:
			switch(windowid)
			{
				case WINDOWREADME:
					w = g_viewerReadme.text;
				break;
				case WINDOWCATALOG:
					w = g_viewerCatalog.text;
				break;
				case WINDOWPLAYLIST:
					w = g_viewerPlaylist.text;
				break;
				case WINDOWLOG:
					w = g_viewerLog.text;
				break;
 #if defined(MAKEYBOARD)
				case WINDOWKEYBINDINGS:
					w = g_viewerKeyBindings.text;
				break;
 #endif
				default:
					maLogAPI(L"EditTextSetText ID_EDITTEXT_VIEWERFIND invalid windowid", windowid, edittext);
				return;
			}
			if(!w)
			{
				maLogAPI(L"EditTextSetText null viewer text widget", windowid, edittext);
				return;
			}
			maviewer *v;
			if(!(v = Viewer(windowid)))
			{
				maLogAPI(L"EditTextSetText Viewer failed", windowid, edittext);
				return;
			}
			if(!v->buffer)
			{
				maLogAPI(L"EditTextSetText null buffer", windowid, edittext);
				return;
			}
			size_t len = mastrlen(p0);
			// convert machar p0 to SystemEncoding
			char *p1;
			if((p1 = (char *)MAMALLOC((len + 8) * 4)) == NULL) // max sizeof(UniChar) or max sizeof(UTF-8)
			{
				maLogAPI(L"EditTextSetText MAMALLOC failed", windowid, edittext);
				return;
			}
			ma2fs(p1, p0); // wchar_t to UTF-8
			size_t len2 = fsstrlen(p1);
			gtk_text_buffer_set_text(v->buffer, p1, len2);
			MAFREE(p1);
			return;
		break;
#endif
		default: 
			maLogAPI(L"EditTextSetText invalid edittext id", windowid, edittext);
			return;
		break;
	}
	
	if(!w)
	{
		maLogAPI(L"EditTextSetText no widget", windowid, edittext);
		return;
	}

// gets here on ID_EDITTEXT_VIEWERFIND
	size_t len = mastrlen(p0);
	// convert machar p0 to SystemEncoding
	char *p1;
	if((p1 = (char *)MAMALLOC((len + 8) * 4)) == NULL) // max sizeof(UniChar) or max sizeof(UTF-8)
	{
		maLogAPI(L"EditTextSetText MAMALLOC failed", windowid, edittext);
		return;
	}
	ma2fs(p1, p0);
	gtk_entry_set_text(GTK_ENTRY(w), p1);
	MAFREE(p1);

} // EditTextSetText


void EditTextGetText(int windowid, int edittext, machar *outBuffer, int inBufferLength, long *outTextLength, long from, long to)
{
#ifdef MATRACEGUIGTK
	maTrace("EditTextGetText");
#endif
#if !defined(NOTEXTVIEWER)
	fschar *p1;
	maviewer *v;
#endif
	machar mastr2[MAXLOGLINELEN];

	if(!outTextLength)
	{
		maLogAPI(L"EditTextGetText null outTextLength", windowid, edittext);
		return;
	}

	*outTextLength = 0;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	switch(edittext)
	{
		case ID_EDITTEXT_EQ:
			if(!l_eqentry)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_EQ no widget", windowid, edittext);
				return;
			}
			if(!outBuffer)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_EQ null outBuffer", windowid, edittext);
				return;
			}
			mastrncpy(outBuffer, fs2ma(mastr2, (fschar *)gtk_entry_get_text(GTK_ENTRY(l_eqentry))), inBufferLength);
			if((*outTextLength = mastrlen(outBuffer)) >= inBufferLength)
			{
				*outTextLength = inBufferLength - 1;
				outBuffer[inBufferLength] = L'\0';
			}
		break;
		case ID_EDITTEXT_PROMPTNUM:
			if(!l_promptnumentry)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_PROMPTNUM no widget", windowid, edittext);
				return;
			}
			if(!outBuffer)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_PROMPTNUM null outBuffer", windowid, edittext);
				return;
			}
			mastrncpy(outBuffer, fs2ma(mastr2, (fschar *)gtk_entry_get_text(GTK_ENTRY(l_promptnumentry))), inBufferLength);
			if((*outTextLength = mastrlen(outBuffer)) >= inBufferLength)
			{
				*outTextLength = inBufferLength - 1;
				outBuffer[inBufferLength] = L'\0';
			}
		break;
#if !defined(NOTEXTVIEWER)
		case ID_EDITTEXT_VIEWERFIND:
			if(!(v = Viewer(windowid)))
			{
				maLogAPI(L"EditTextGetText Viewer failed", windowid, edittext);
				return;
			}
			if(!v->entry)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_VIEWERFIND no entry widget", windowid, edittext);
				return;
			}
			if(!outBuffer)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_VIEWERFIND null outBuffer", windowid, edittext);
				return;
			}
			mastrncpy(outBuffer, fs2ma(mastr2, (fschar *)gtk_entry_get_text(GTK_ENTRY(v->entry))), inBufferLength);
			if((*outTextLength = mastrlen(outBuffer)) >= inBufferLength)
			{
				*outTextLength = inBufferLength - 1;
				outBuffer[inBufferLength] = L'\0';
			}
		break;
		case ID_EDITTEXT_VIEWERVIEW:
			if(!(v = Viewer(windowid)))
			{
				maLogAPI(L"EditTextGetText Viewer failed", windowid, edittext);
				return;
			}
			if(!outBuffer)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_VIEWERVIEW null outBuffer", windowid, edittext);
				return;
			}
			if(from < 0 || to < 1 || from > to)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_VIEWERVIEW bad from to values", windowid, edittext);
				return;
			}

			GtkTextIter start;
			GtkTextIter end;
			gtk_text_buffer_get_iter_at_offset(v->buffer, &start, from);
			gtk_text_buffer_get_iter_at_offset(v->buffer, &end, to);
			p1 = gtk_text_buffer_get_text(v->buffer, &start, &end, TRUE);
			if(!p1)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_VIEWERVIEW gtk_text_buffer_get_text failed", windowid, edittext);
				return;
			}
			// p1 is UTF-8, null-terminated
			fs2ma(outBuffer, p1);
			*outTextLength = mastrlen(outBuffer);
			outBuffer[*outTextLength] = L'\0'; //
			g_free(p1);
		break;
#endif // !defined(NOTEXTVIEWER)
		default:
			maLogAPI(L"EditTextGetText no widget", windowid, edittext);		
			return;
		break;
		
	} // switch(edittext)

} // EditTextGetText


#if !defined(NOTEXTVIEWER)
 void EditTextGetSelection(int windowid, int edittext, long *start, long *end)
 {
 #ifdef MATRACEGUIGTK
	maTrace("EditTextGetSelection");
 #endif
	maviewer *v;

	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"EditTextGetSelection Viewer failed", windowid, edittext);
		return;
	}

	gint from = -1;
	gint to = -1;
	GtkTextIter ifrom, ito;

	if(gtk_text_buffer_get_selection_bounds(v->buffer, &ifrom, &ito)) // have selection
	{
		from = gtk_text_iter_get_offset(&ifrom);
		to = gtk_text_iter_get_offset(&ito);
	}
	else
	{
        GtkTextMark *mark = gtk_text_buffer_get_insert(v->buffer);
        GtkTextIter cursor;
        gtk_text_buffer_get_iter_at_mark(v->buffer, &cursor, mark);
		from = to = gtk_text_iter_get_offset(&cursor);
	}	
	if(from > to)
	{
		long tmp = from;
		from = to;
		to = tmp;
	}
	*start = from;
	*end = to;
 
 } // EditTextGetSelection


 void EditTextSetSelection(int windowid, int edittext, long start, long end)
 {
 #ifdef MATRACEGUIGTK
	maTrace("EditTextSetSelection");
 #endif
	maviewer *v;

	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"EditTextSetSelection Viewer failed", windowid, edittext);
		return;
	}

	// scroll into view
	lEditTextShowPosition(v, end);
	
	// select
	GtkTextIter ins;
	GtkTextIter bound;
	
	// we need start and end as visible chars offsets instead of as utf8-encoded machar offsets
	// e.g. 1 for ê instead of 2 for c3aa
	gtk_text_buffer_get_iter_at_offset(v->buffer, &ins, offset_wchar_to_utf8((wchar_t *)v->p0, start));
	gtk_text_buffer_get_iter_at_offset(v->buffer, &bound, offset_wchar_to_utf8((wchar_t *)v->p0, end));
	gtk_text_buffer_select_range(v->buffer, &ins, &bound);

 } // EditTextSetSelection


 void EditTextSetEditable(int windowid, int edittext, int editable)
 {
 #ifdef MATRACEGUIGTK
	maTrace("EditTextSetEditable");
 #endif
	maviewer *v;

	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"EditTextSetEditable Viewer failed", windowid, edittext);
		return;
	}
	
	gtk_text_view_set_editable((GtkTextView *)v->text, editable ? TRUE : FALSE);
	
 } // EditTextSetEditable


 void EditTextSetFocus(int windowid, int edittext)
 {
 #ifdef MATRACEGUIGTK
	maTrace("EditTextSetFocus");
 #endif
	maviewer *v;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	/*
	if(edittext != ID_EDITTEXT_VIEWERVIEW && edittext != ID_EDITTEXT_VIEWERFIND)
	{
		...
		return;
	}
	*/
	
	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"EditTextSetFocus Viewer failed", windowid, edittext);
		return;
	}
	
	if(edittext == ID_EDITTEXT_VIEWERVIEW)
		gtk_widget_grab_focus(v->text);
	else if(edittext == ID_EDITTEXT_VIEWERFIND)
		gtk_widget_grab_focus(v->entry);
	else
	{
		maLog(L"EditTextSetFocus only implemented for viewer text and find entry widgets");
		return;
	}

 } // EditTextSetFocus


 /* int EditTextLoadFile(int windowid, int edittext, fschar *fpath)
 {
 #ifdef MATRACEGUIGTK
	maTrace("EditTextLoadFile");
 #endif
	return -1; // not implemented
 }


 int EditTextSaveFile(int windowid, int edittext, fschar *fpath)
 {
 #ifdef MATRACEGUIGTK
	maTrace("EditTextSaveFile");
 #endif
	return -1; // not implemented
 }
 */

 int EditTextGetSize(int windowid, int edittext, size_t *pfsize)
 {
 #ifdef MATRACEGUIGTK
	maTrace("EditTextSaveFile");
 #endif
	maviewer *v;
	
	*pfsize = 0;
	
	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"EditTextGetSize Viewer failed", windowid, edittext);
		return 1;
	}
	
	*pfsize = gtk_text_buffer_get_char_count(v->buffer); // nchars0

	return 0;

 } // EditTextGetSize


 void EditTextShowPosition(int windowid, int edittext, long pos) // text EnsureVisible
 {
 #ifdef MATRACEGUIGTK
	maTrace("EditTextShowPosition");
 #endif
	maviewer *v;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;
		
	if(edittext != ID_EDITTEXT_VIEWERVIEW) // only implemented for this
	{
		maLogAPI(L"EditTextShowPosition invalid edittext", windowid, edittext);
		return;
	}
	
	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"EditTextShowPosition Viewer failed", windowid, edittext);
		return;
	}
	
	if(!v->text)
		return;
	
	lEditTextShowPosition(v, pos);

 } // EditTextShowPosition


 void lEditTextShowPosition(maviewer *v, long pos) // text EnsureVisible
 {
 #ifdef MATRACEGUIGTK
	maTrace("lEditTextShowPosition");
 #endif

	GtkTextIter iter;
	if(pos < 0)
		gtk_text_buffer_get_end_iter(v->buffer, &iter);
	else
		gtk_text_buffer_get_iter_at_offset(v->buffer, &iter, pos);
	gtk_text_view_scroll_to_iter(v->text, &iter, 0, FALSE, 0, 0); // no x, y alignment

 } // lEditTextShowPosition
#endif


void eqentrycallback(GtkWidget *widget)
{
#ifdef MATRACEGUIGTK
	maTrace("eqentrycallback");
#endif
	const gchar *p;
	
	if((p = gtk_entry_get_text(GTK_ENTRY(l_eqentry))) == NULL || *p == '\0')
		return;
		
	OnEditTextEq();
}


/*
void SplashWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("SplashWindowMake");
#endif
	static GtkWidget *window = NULL;
	GtkWidget *box1;
	GtkWidget *text;
	machar mastr[MAXLOGLINELEN];

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	
	g_w[WINDOWSPLASH] = window;

	masprintf(mastr, MAXLOGLINELEN, L"%ls starting", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(window), mastr);

	gtk_container_set_border_width(GTK_CONTAINER(window), 0);

	box1 = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), box1);

	text = gtk_text_new(NULL, NULL);
	gtk_editable_set_editable(GTK_EDITABLE(text), FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(text), TRUE);
	gtk_text_set_line_wrap(GTK_TEXT(text), TRUE);
	gtk_container_add(GTK_CONTAINER(window), text);

	gtk_text_freeze(GTK_TEXT(text));
	gint position = 0;
	gtk_editable_insert_text(GTK_EDITABLE(text), L"Loading..", 9, &position);
	gtk_text_thaw(GTK_TEXT(text));
	
	gtk_widget_set_uposition(window,
		g_sets.mawin[WINDOWSPLASH].xpos[g_sets.winconf], g_sets.mawin[WINDOWSPLASH].ypos[g_sets.winconf]);
	gtk_widget_set_usize(window,
		g_sets.mawin[WINDOWSPLASH].xsize[g_sets.winconf], g_sets.mawin[WINDOWSPLASH].ysize[g_sets.winconf]);
	
	gtk_widget_show_all(window);
	
	return;
	
} // SplashWindowMake
*/


void EqualizerWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("EqualizerWindowMake");
#endif
	int i;
	GtkWidget *gtkwindow;
	machar *eqnames[EQNUMPRESETS];
	machar eqname[EQNUMPRESETS][EQNAMELEN];
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if(!g_w[WINDOWAPP])
	{
		maLog(L"EqualizerWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWEQ])
	{
		maLog(L"EqualizerWindowMake already made");
		return;
	}

	l_fixed = gtk_fixed_new();
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWEQ << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWEQ << 8) + maGDK_CONFIGURE));
	
#if defined(MAKEYBOARD) || defined(MAMOUSEWHEEL)
	int mask = 0;
 #if defined(MAKEYBOARD)
	mask = GDK_KEY_PRESS_MASK | GDK_BUTTON_RELEASE_MASK;
 #endif
 #if defined(MAMOUSEWHEEL)
	mask |= GDK_SCROLL_MASK;
 #endif
	gtk_widget_set_events(gtkwindow, mask);
#endif

#if defined(MAKEYBOARD)
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "button_release_event",
		GTK_SIGNAL_FUNC(EqualizerWindowEventHandler), (gpointer)maMOUSEBUTTON);
#endif

#if defined(MAMOUSEWHEEL)
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
#endif

	g_w[WINDOWEQ] = gtkwindow;

	l_eq_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_eq_vbox), 1);
	gtk_container_add(GTK_CONTAINER(gtkwindow), l_eq_vbox);
	
	// equalizer buttons
	#define EQMENUBARH 0 // MENUBARH to line up buttons with main window buttons
	l_ButtonPos = XBASE;
	l_buttonTop = YBASE + EQMENUBARH;

	MakeButton(WINDOWEQ, ID_BTN_EQMINUS, LABEL_MINUS);
	MakeButton(WINDOWEQ, ID_BTN_EQPLUS, LABEL_PLUS);
	MakeButton(WINDOWEQ, ID_BTN_EQMID, LABEL_MID);
	MakeButton(WINDOWEQ, ID_BTN_EQCOPY, LABEL_COPY);
	MakeButton(WINDOWEQ, ID_BTN_EQPASTE, LABEL_PASTE);
	MakeButton(WINDOWEQ, ID_BTN_EQRESTORE, LABEL_RESET);
	MakeButton(WINDOWEQ, ID_BTN_EQSHIFTL, LABEL_SHIFTL);
	MakeButton(WINDOWEQ, ID_BTN_EQSHIFTR, LABEL_SHIFTR);
	MakeButton(WINDOWEQ, ID_BTN_EQINVERT, LABEL_INVERT);

	#define PREX (XBASE + 450)
	#define PREY (YBASE + EQMENUBARH)
	#define PREY2 (YBASE + 40 + EQMENUBARH)

	// Equalizer checkbox
	MakeCheckbox(ID_MANONE, ID_CHK_EQUALIZERB, L"Equalizer", PREX, PREY - 2, CBXSIZ, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_EQ31BANDSB, L"Eq31Band", PREX, PREY + 14, CBXSIZ, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_EQEXTRAB, L"EqExtra", PREX, PREY + 30, CBXSIZ, 0);

	// Zoom checkbox
	MakeCheckbox(ID_MANONE, ID_CHK_EQZOOM, L"Zoom", 8, PREY2, CBXSIZ5, 0);

	// Link checkbox
	MakeCheckbox(ID_MANONE, ID_CHK_EQLINK, L"Link sliders", 260, PREY2, CBXSIZ, 0);

	//Separate L/R checkbox
	MakeCheckbox(ID_MANONE, ID_CHK_SEPARATELR, L"Separate L/R", 350, PREY2, CBXSIZ, 0);

	// Offset spin
	MakeText(1, ID_TEXT_EQOFFSET, L"Offset dB", 124, PREY2, 0);
	MakeText(1, ID_TEXT_EQOFFSETVAL, L"000", 204, PREY2, 0);
	MakeSpinButton(ID_SPIN_EQOFFSET, 186, PREY2);
	
	// Presets popup button
 	for(i = 0; i < EQNUMPRESETS; i++)
	{
 		if(fsstrlen(g_sets.eqpresets[i].eqname) == 0 || g_sets.eqpresets[i].eqname[0] == fsT(' '))
 			fssprintf(g_sets.eqpresets[i].eqname, EQNAMELEN, fsT("Preset%d"), i + 1);
		mastrcpy(eqname[i], fs2ma(mastr, g_sets.eqpresets[i].eqname));
		eqnames[i] = eqname[i];
	}  
	MakePopup(ID_POPUP_EQPRESET, EQNUMPRESETS, eqnames, PREX + 80, PREY - 1, 88, 20);
	PopupButtonSetValue(WINDOWEQ, ID_POPUP_EQPRESET, 1); // here or later?

	// Preset name editor
	MakeText(0, ID_TEXT_EQEDIT, L"Preset Name", PREX + 80, PREY + 18, 0);

	// Preset name editor keyboard input
	l_eqentry = gtk_entry_new_with_max_length(64);
	gtk_signal_connect(GTK_OBJECT(l_eqentry), "activate",
		GTK_SIGNAL_FUNC(eqentrycallback), NULL);
	gtk_fixed_put(GTK_FIXED(l_fixed), l_eqentry, PREX + 80, PREY + 33);
	gtk_widget_set_usize(l_eqentry, 72, 23);
	gtk_widget_set_sensitive(l_eqentry, TRUE);

	// equalizer sliders
	#define SLX (XBASE)
	#define SLXDEL (VSLIDERW - 0)
	#define STXPOS (stxpos += SLXDEL)
	#define SLXPOS (slxpos += SLXDEL)
	#define TEXPOS (texpos += SLXDEL)
	#define SPXPOS (spxpos += SLXDEL)
	#define SLYPOS (YBASE + 64 + EQMENUBARH)
	#define T0YPOS (SLYPOS + 67)

	int stxpos = SLX - SLXDEL;
	int slxpos = SLX - SLXDEL;
	int texpos = SLX - SLXDEL - 1;
	//int spxpos = SLX - SLXDEL + 2;

	#define YSTAGGER 12
	int ystagger;
	int style;
	
	const machar *label;
	for(i = 0; i < EQBANDS31; i++)
	{
		switch(i)
		{
			case  0 : style = 0; label = L"20Hz";	break;
			case  1 : style = 0; label = L"25";		break;
			case  2 : style = 1; label = L"31.5";	break;
			case  3 : style = 0; label = L"40";		break;
			case  4 : style = 0; label = L"50";		break;
			case  5 : style = 1; label = L"63";		break;
			case  6 : style = 0; label = L"80";		break;
			case  7 : style = 0; label = L"100";	break;
			case  8 : style = 1; label = L"125";	break;
			case  9 : style = 0; label = L"160";	break;
			case 10 : style = 0; label = L"200";	break;
			case 11 : style = 1; label = L"250";	break;
			case 12 : style = 0; label = L"315";	break;
			case 13 : style = 0; label = L"400";	break;
			case 14 : style = 1; label = L"500";	break;
			case 15 : style = 0; label = L"630";	break;
			case 16 : style = 0; label = L"800";	break;
			case 17 : style = 1; label = L"1kHz";	break;
			case 18 : style = 0; label = L"1.25";	break;
			case 19 : style = 0; label = L"1.6";	break;
			case 20 : style = 1; label = L"2.0";	break;
			case 21 : style = 0; label = L"2.5";	break;
			case 22 : style = 0; label = L"3.15";	break;
			case 23 : style = 1; label = L"4.0";	break;
			case 24 : style = 0; label = L"5.0";	break;
			case 25 : style = 0; label = L"6.3";	break;
			case 26 : style = 1; label = L"8.0";	break;
			case 27 : style = 0; label = L"10";		break;
			case 28 : style = 0; label = L"12.5";	break;
			case 29 : style = 1; label = L"16";		break;
			case 30 : style = 0; label = L"20";		break;
			default : style = 0; label = L"";		break;
		}
		
		if(i % 2)
			ystagger = YSTAGGER;
		else
			ystagger = 0;
		MakeText(0, ID_TEXT_EQBAND0 + i, (machar *)label, STXPOS, SLYPOS - 6 + ystagger, style);
		MakeSlider(ID_SLIDER_EQ0 + i, DBSLIDERMIN, DBSLIDERMAX, SLXPOS, SLYPOS + 21, VSLIDERW, VSLIDERH, style);
		MakeText(1, ID_TEXT_EQ0 + i, L"0000", TEXPOS, SLYPOS + 124 + SLIDERDELTAY + ystagger, style);	
	}

	gtk_box_pack_end_defaults(GTK_BOX(l_eq_vbox), l_fixed);

	if(g_sets.eqflags & MASEPARATELR)
		masprintf(mastr, MAXLOGLINELEN, L"%ls Equalizer Left Channel", g_prognametitle);
	else
		masprintf(mastr, MAXLOGLINELEN, L"%ls Equalizer", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, mastr));

	gtk_widget_show_all(gtkwindow);

} // EqualizerWindowMake


gint EqualizerWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("EqualizerWindowEventHandler");
#endif
	int evtype = (int)data & 0xff;

 	switch(evtype)
	{		
#if defined(MAKEYBOARD)
		case maENTRYKEYPRESS:
			switch(event->type)
			{
				case GDK_BUTTON_RELEASE:
					if(g_sets.keyboard && GTK_WIDGET_HAS_FOCUS(l_eqentry))
						gtk_window_set_focus(GTK_WINDOW(g_w[WINDOWEQ]), NULL);
				break;

				default:
#ifdef MATRACEGUIGTK
{
machar mastr[MAXLOGLINELEN];
masprintf(mastr, MAXLOGLINELEN, L"EqualizerWindowEventHandler maENTRYKEYPRESS default type=%d data=%d", event->type, (int)data);
maTrace(mastr);
}
#endif
				break;
			}
		break;
#endif

// maMOUSEBUTTON...

		default:
#ifdef MATRACEGUIGTK
{
machar mastr[MAXLOGLINELEN];
masprintf(mastr, MAXLOGLINELEN, L"EqualizerWindowEventHandler default evtype=%d type=%d data=%d", evtype, event->type, (int)data);
maTrace(mastr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled

} // EqualizerWindowEventHandler


void Equalizer2WindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("Equalizer2WindowMake");
#endif
	int i;
	GtkWidget *gtkwindow;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if(!g_w[WINDOWAPP])
	{
		maLog(L"Equalizer2WindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWEQ2])
	{
		maLog(L"Equalizer2WindowMake already made");
		return;
	}

	l_fixed = gtk_fixed_new();
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWEQ2 << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWEQ2 << 8) + maGDK_CONFIGURE));
	
#if (defined(MAKEYBOARD) || defined(MAMOUSEWHEEL))
	int mask = 0;
 #if defined(MAKEYBOARD)
	mask = GDK_KEY_PRESS_MASK | GDK_BUTTON_RELEASE_MASK;
 #endif
 #if defined(MAMOUSEWHEEL)
	mask |= GDK_SCROLL_MASK;
 #endif
	gtk_widget_set_events(gtkwindow, mask);
#endif

#if defined(MAKEYBOARD)
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
#endif

#if defined(MAMOUSEWHEEL)
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
#endif

	g_w[WINDOWEQ2] = gtkwindow;

	l_eq_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_eq_vbox), 1);
	gtk_container_add(GTK_CONTAINER(gtkwindow), l_eq_vbox);
	
	// equalizer buttons
	#define EQMENUBARH 0 // MENUBARH to line up buttons with main window buttons
	l_ButtonPos = XBASE + (MABUTTONW + MABUTTONSPACING) + (MABUTTONW + MABUTTONSPACING);
	l_buttonTop = YBASE + EQMENUBARH;

	MakeButton(WINDOWEQ2, ID_BTN_EQ2MID, LABEL_MID);
	MakeButton(WINDOWEQ2, ID_BTN_EQ2COPY, LABEL_COPY);
	MakeButton(WINDOWEQ2, ID_BTN_EQ2PASTE, LABEL_PASTE);
	MakeButton(WINDOWEQ2, ID_BTN_EQ2RESTORE, LABEL_RESET);
	
	// equalizer sliders
	#define SLX (XBASE)
	#define SLXDEL (VSLIDERW - 0)
	#define STXPOS (stxpos += SLXDEL)
	#define SLXPOS (slxpos += SLXDEL)
	#define TEXPOS (texpos += SLXDEL)
	#define SPXPOS (spxpos += SLXDEL)
	#define SLYPOS (YBASE + 64 + EQMENUBARH)
	#define T0YPOS (SLYPOS + 67)

	int stxpos = SLX - SLXDEL;
	int slxpos = SLX - SLXDEL;
	int texpos = SLX - SLXDEL - 1;
	//int spxpos = SLX - SLXDEL + 2;

	#define YSTAGGER 12
	int ystagger;
	int style;
	
	const machar *label;
	for(i = 0; i < EQBANDS31; i++)
	{
		switch(i)
		{
			case  0 : style = 0; label = L"20Hz";	break;
			case  1 : style = 0; label = L"25";		break;
			case  2 : style = 1; label = L"31.5";	break;
			case  3 : style = 0; label = L"40";		break;
			case  4 : style = 0; label = L"50";		break;
			case  5 : style = 1; label = L"63";		break;
			case  6 : style = 0; label = L"80";		break;
			case  7 : style = 0; label = L"100";	break;
			case  8 : style = 1; label = L"125";	break;
			case  9 : style = 0; label = L"160";	break;
			case 10 : style = 0; label = L"200";	break;
			case 11 : style = 1; label = L"250";	break;
			case 12 : style = 0; label = L"315";	break;
			case 13 : style = 0; label = L"400";	break;
			case 14 : style = 1; label = L"500";	break;
			case 15 : style = 0; label = L"630";	break;
			case 16 : style = 0; label = L"800";	break;
			case 17 : style = 1; label = L"1kHz";	break;
			case 18 : style = 0; label = L"1.25";	break;
			case 19 : style = 0; label = L"1.6";	break;
			case 20 : style = 1; label = L"2.0";	break;
			case 21 : style = 0; label = L"2.5";	break;
			case 22 : style = 0; label = L"3.15";	break;
			case 23 : style = 1; label = L"4.0";	break;
			case 24 : style = 0; label = L"5.0";	break;
			case 25 : style = 0; label = L"6.3";	break;
			case 26 : style = 1; label = L"8.0";	break;
			case 27 : style = 0; label = L"10";		break;
			case 28 : style = 0; label = L"12.5";	break;
			case 29 : style = 1; label = L"16";		break;
			case 30 : style = 0; label = L"20";		break;
			default : style = 0; label = L"";		break;
		}
		
		if(i % 2)
			ystagger = YSTAGGER;
		else
			ystagger = 0;
		MakeText(0, ID_TEXT_EQ2BAND0 + i, (machar *)label, STXPOS, SLYPOS - 6 + ystagger, style);
		MakeSlider(ID_SLIDER_EQ2_0 + i, DBSLIDERMIN, DBSLIDERMAX, SLXPOS, SLYPOS + 21, VSLIDERW, VSLIDERH, style);
		MakeText(1, ID_TEXT_EQ2_0 + i, L"0000", TEXPOS, SLYPOS + 124 + SLIDERDELTAY + ystagger, style);	
	}

	gtk_box_pack_end_defaults(GTK_BOX(l_eq_vbox), l_fixed);

	if(g_sets.eqflags & MASEPARATELR) 
		masprintf(mastr, MAXLOGLINELEN, L"%ls Equalizer Right Channel", g_prognametitle);
	else
		masprintf(mastr, MAXLOGLINELEN, L"%ls Equalizer Right Channel (Off)", g_prognametitle); // never happens
	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, mastr));

	gtk_widget_show_all(gtkwindow);

} // Equalizer2WindowMake


void EffectsWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("EffectsWindowMake");
#endif
	GtkWidget *gtkwindow;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(!g_w[WINDOWAPP])
	{
		maLog(L"EffectsWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWEFFECTS])
	{
		maLog(L"EffectsWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWEFFECTS << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWEFFECTS << 8) + maGDK_CONFIGURE));

#if defined(MAKEYBOARD) || defined(MAMOUSEWHEEL)
	int mask = 0;
#endif

#if defined(MAKEYBOARD)
	mask = GDK_KEY_PRESS_MASK;
	gtk_widget_set_events(gtkwindow, mask);
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
#endif

#if defined(MAMOUSEWHEEL)
	mask |= GDK_SCROLL_MASK;
	gtk_widget_set_events(gtkwindow, GDK_SCROLL_MASK);
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
#endif

	g_w[WINDOWEFFECTS] = gtkwindow;

	l_effects_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_effects_vbox), 1);
	gtk_container_add(GTK_CONTAINER(gtkwindow), l_effects_vbox);

	#define EFFX  (XBASE + 32)
	#define EFFY  (YBASE + 22)
	#define EFFY2  (EFFY + 149)
	#define EFFDELX (60)
	#define EFFCBY (EFFY + 167)

	// duplicate main effects switch
	MakeCheckbox(ID_MANONE, ID_CHK_EFFECTSB, L"Effects", EFFX + 2, EFFCBY,	CBXSIZ5 + 10, 1);

	// sbsms
	MakeCheckbox(ID_MANONE, ID_CHK_SBSMS, L"High quality (see Help/README - sbsms)",
																EFFX + 2, EFFCBY + 31, CBXSIZ5 + 20, 1);

	// pitch
	MakeText(0, ID_MANONE, L"Pitch", EFFX - 8, EFFY - 16, 0);
	MakeText(0, ID_MANONE, L"   semitones", EFFX - 2, EFFY - 1, 0);
	MakeSlider(ID_SLIDER_PITCH, EFFECTSPITCHMIN, EFFECTSPITCHMAX, EFFX, EFFY + 21, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_PITCH0, L"-000", EFFX, EFFY2, 0);
	MakeText(0, ID_MANONE, L"Pitch", EFFX + EFFDELX - 8, EFFY - 16, 0);
	MakeSlider(ID_SLIDER_PITCH2, EFFECTSPITCH2MIN, EFFECTSPITCH2MAX, EFFX + EFFDELX, EFFY + 21, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_PITCH02, L"-000", EFFX + EFFDELX, EFFY2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_PITCH, L"Pitch", EFFX + EFFDELX + 2, EFFCBY, CBXSIZ5 + 10, 0);

	// tempo
	MakeText(0, ID_MANONE, L"Tempo", EFFX + 2 * EFFDELX - 8, EFFY - 16, 0);
	MakeText(0, ID_MANONE, L"  x", EFFX + 2 * EFFDELX - 2, EFFY - 1, 0);
	MakeSlider(ID_SLIDER_TEMPO, EFFECTSMIN, EFFECTSMAX, EFFX + 2 * EFFDELX, EFFY + 21, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_TEMPO0, L"-000", EFFX + 2 * EFFDELX, EFFY2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_TEMPO, L"Tempo", EFFX + 2 * EFFDELX + 2, EFFCBY, CBXSIZ5 + 10, 0);

	// speed
	MakeText(0, ID_MANONE, L"Speed", EFFX + 3 * EFFDELX - 8, EFFY - 16, 0);
	MakeText(0, ID_MANONE, L"  x", EFFX + 3 * EFFDELX - 2, EFFY - 1, 0);
	MakeSlider(ID_SLIDER_SPEED, EFFECTSMIN, EFFECTSMAX, EFFX + 3 * EFFDELX, EFFY + 21, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_SPEED0, L"-000", EFFX + 3 * EFFDELX, EFFY2, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_SPEED, L"Speed", EFFX + 3 * EFFDELX + 2, EFFCBY, CBXSIZ5 + 10, 0);

	// keyboard shortcut labels
	#undef EFFX
	#define EFFX (XBASE + 54)
	#undef EFFY
	#define EFFY (YBASE + 159)

	MakeText(1, ID_TEXT_KEYEFECTS,		L"", EFFX - 20,					EFFY + 44, 0);
	MakeText(1, ID_TEXT_KEYPITCHUP,		L"", EFFX - 2,					EFFY - 13 - VSLIDERH, 0);
	MakeText(1, ID_TEXT_KEYPITCHDOWN,	L"", EFFX - 2,					EFFY - 6, 0);

	MakeText(1, ID_TEXT_KEYPITCHSET,	L"", EFFX + EFFDELX - 20,		EFFY + 44, 0);
	MakeText(1, ID_TEXT_KEYPITCH2UP,	L"", EFFX + EFFDELX - 2,		EFFY - 13 - VSLIDERH, 0);
	MakeText(1, ID_TEXT_KEYPITCH2DOWN,	L"", EFFX + EFFDELX - 2,		EFFY - 6, 0);
	MakeText(1, ID_TEXT_KEYPITCHRESET,	L"", EFFX + EFFDELX - 0,		EFFY - 61, 0);

	MakeText(1, ID_TEXT_KEYTEMPOSET,	L"", EFFX + 2 * EFFDELX - 20,	EFFY + 44, 0);
	MakeText(1, ID_TEXT_KEYTEMPOUP,		L"", EFFX + 2 * EFFDELX - 2,	EFFY - 13 - VSLIDERH, 0);
	MakeText(1, ID_TEXT_KEYTEMPODOWN,	L"", EFFX + 2 * EFFDELX - 2,	EFFY - 6, 0);
	MakeText(1, ID_TEXT_KEYTEMPORESET,	L"", EFFX + 2 * EFFDELX - 0,	EFFY - 40, 0);

	MakeText(1, ID_TEXT_KEYSPEEDSET,	L"", EFFX + 3 * EFFDELX - 20,	EFFY + 44, 0);
	MakeText(1, ID_TEXT_KEYSPEEDUP,		L"", EFFX + 3 * EFFDELX - 2,	EFFY - 13 - VSLIDERH, 0);
	MakeText(1, ID_TEXT_KEYSPEEDDOWN,	L"", EFFX + 3 * EFFDELX - 2,	EFFY - 6, 0);
	MakeText(1, ID_TEXT_KEYSPEEDRESET,	L"", EFFX + 3 * EFFDELX - 0,	EFFY - 40, 0);

	gtk_box_pack_end_defaults(GTK_BOX(l_effects_vbox), l_fixed);

	masprintf(mastr, MAXLOGLINELEN, L"%ls Effects", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, mastr));

	gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWEFFECTS].xpos[g_sets.winconf], g_sets.mawin[WINDOWEFFECTS].ypos[g_sets.winconf]);
	gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWEFFECTS].xsize[g_sets.winconf], g_sets.mawin[WINDOWEFFECTS].ysize[g_sets.winconf]);

	gtk_widget_show_all(gtkwindow);

} // EffectsWindowMake


#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
void AudioCDWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("AudioCDWindowMake");
#endif
	GtkWidget *gtkwindow;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(!g_w[WINDOWAPP])
	{
		maLog(L"AudioCDWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWAUDIOCD])
	{
		maLog(L"AudioCDWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWAUDIOCD << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWAUDIOCD << 8) + maGDK_CONFIGURE));
		
	g_w[WINDOWAUDIOCD] = gtkwindow;

	l_audiocd_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_audiocd_vbox), 1);
	gtk_container_add(GTK_CONTAINER(gtkwindow), l_audiocd_vbox);

	// popup button, menu items are appended from maplayer
	MakePopup(ID_POPUP_AUDIOCD, 0, NULL, 130, 11, 120, 20);

	// buttons
	MakeButtonA(WINDOWAUDIOCD, ID_BTN_AUDIOCDSET, L"Set the drive", 5, 10, 100, 30);
	MakeButtonA(WINDOWAUDIOCD, ID_BTN_AUDIOCDCLEAR, L"Clear the drive", 5, 50, 100, 30);
	MakeButtonA(WINDOWAUDIOCD, ID_BTN_AUDIOCDSAVE, L"Save settings", 5, 90, 100, 30);
	MakeButtonA(WINDOWAUDIOCD, ID_BTN_AUDIOCDCLOSE, L"Close", 130, 90, 100, 30);

	// checkbox
	MakeCheckbox(ID_MANONE, ID_CHK_CDPARANOIA, L"CD Paranoia", 138, 55, 100, 1);

	gtk_box_pack_end_defaults(GTK_BOX(l_audiocd_vbox), l_fixed);

	masprintf(mastr, MAXLOGLINELEN, L"%ls AudioCD", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, mastr));

	gtk_widget_set_uposition(gtkwindow,
		g_sets.mawin[WINDOWAUDIOCD].xpos[g_sets.winconf], g_sets.mawin[WINDOWAUDIOCD].ypos[g_sets.winconf]);

	gtk_widget_set_usize(gtkwindow,
		g_sets.mawin[WINDOWAUDIOCD].xsize[g_sets.winconf], g_sets.mawin[WINDOWAUDIOCD].ysize[g_sets.winconf]);

	gtk_widget_show_all(gtkwindow);

} // AudioCDWindowMake
#endif


void advancedclosebuttoncallback(GtkWidget *widget, gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("advancedclosebuttoncallback");
#endif
	DoWindow(WINDOWADVANCED, 0);
}


void AdvancedWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("AdvancedWindowMake");
#endif
	GtkWidget *gtkwindow;
	GtkWidget *button;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(!g_w[WINDOWAPP])
	{
		maLog(L"AdvancedWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWADVANCED])
	{
		maLog(L"AdvancedWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWADVANCED << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWADVANCED << 8) + maGDK_CONFIGURE));

	g_w[WINDOWADVANCED] = gtkwindow;

	l_advanced_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_advanced_vbox), 1);
	gtk_container_add(GTK_CONTAINER(gtkwindow), l_advanced_vbox);

	// checkbox
	MakeCheckbox(ID_MANONE, ID_CHK_CLOSEREOPEN,
		L" Close and re-open sound channel between songs (default no)", 10, 10, CBXSIZ7, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_INPUTMONITOR,
		L" Input Monitor (default yes)", 10, 40, CBXSIZ7, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_LOGNOTPLAYABLE,
		L" Error-log non-playable files when creating a playlist (default no)", 10, 70, CBXSIZ7, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_USEM3U,
		L" Use m3u files (default no)", 10, 100, CBXSIZ7, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_EXITAFTER,
		L" Exit after the playlist has played (default no)", 10, 130, CBXSIZ7, 0);
	
	// Close button
	button = gtk_button_new_with_label(ma2fs(fsstr, L"Close"));
	gtk_widget_set_name(button, "mabuttonClose");
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(advancedclosebuttoncallback), (gpointer)WINDOWADVANCED);
	gtk_fixed_put(GTK_FIXED(l_fixed), button, g_sets.mawin[WINDOWADVANCED].xsize[g_sets.winconf] /2 - 30,
											  g_sets.mawin[WINDOWADVANCED].ysize[g_sets.winconf] - 30);
	gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);

	gtk_box_pack_end_defaults(GTK_BOX(l_advanced_vbox), l_fixed);

	masprintf(mastr, MAXLOGLINELEN, L"%ls Advanced Settings", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, mastr));

	gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWADVANCED].xpos[g_sets.winconf],
										g_sets.mawin[WINDOWADVANCED].ypos[g_sets.winconf]);
	gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWADVANCED].xsize[g_sets.winconf],
									g_sets.mawin[WINDOWADVANCED].ysize[g_sets.winconf]);

	gtk_widget_show_all(gtkwindow);

} // AdvancedWindowMake


machar *mp3bitrate[] =
{
	L"32 (lower quality, smaller files)",
	L"40",
	L"48",
	L"56",
	L"64",
	L"80",
	L"96",
	L"112",
	L"128 (default)",
	L"160",
	L"192",
	L"224",
	L"256",
	L"320 (high quality, bigger files)",
};

machar *mp3quality[] =
{
	L"0 (high quality, slow encode)",
	L"1",
	L"2 (default)",
	L"3",
	L"4",
	L"5",
	L"6",
	L"7",
	L"8",
	L"9",
	L"10 (lower quality, fast encode)",
};

machar *mp3mode[] =
{
	L"Stereo (default)",
	L"Joint Stereo",
	L"Dual Stereo",
	L"Mono",
};

machar *mp3samplerate[] =
{
	L"Auto",
	//" 8000"), // crashes on OSX
	L"11025",
	L"12000",
	L"16000",
	L"22050",
	L"24000",
	L"32000",
	L"44100 (default)",
	L"48000",
	L"Same as input",
};

machar *oggbitrate[] =
{
	L"32 (lower quality, smaller files)",
	L"40",
	L"48",
	L"56",
	L"64",
	L"80",
	L"96",
	L"112",
	L"128 (default)",
	L"160",
	L"192",
	L"224",
	L"256",
	L"320 (high quality, bigger files)",
};

/*
machar *oggquality[] =
{
	L"0 (high quality, slow encode)",
	L"1",
	L"2",
	L"3",
	L"4",
	L"5 (default)",
	L"6",
	L"7",
	L"8",
	L"9",
	L"10 (lower quality, fast encode)",
};
*/

machar *oggmode[] =
{
	L"Stereo (default)",
	// "Joint Stereo"),
	// "Dual Stereo"),
	L"Mono",
};


machar *aacquality[] =
{
	L"130 (~218 kbps)",
	L"120 (~194 kbps)",
	L"110 (~158 kbps)",
	L"100 (~129 kbps default)",
	L" 90 (~103 kbps)",
	L" 80 (~79 kbps)",
	L" 70 (~62 kbps)",
};

machar *mp4quality[] =
{
	L"130 (~218 kbps)",
	L"120 (~194 kbps)",
	L"110 (~158 kbps)",
	L"100 (~129 kbps default)",
	L" 90 (~103 kbps)",
	L" 80 (~79 kbps)",
	L" 70 (~62 kbps)",
};


void FileOutWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("FileOutWindowMake");
#endif
	GtkWidget *gtkwindow;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr2[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(!g_w[WINDOWAPP])
	{
		maLog(L"FileOutWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWFILEOUT])
	{
		maLog(L"FileOutWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWFILEOUT << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWFILEOUT << 8) + maGDK_CONFIGURE));
	
	g_w[WINDOWFILEOUT] = gtkwindow;

	l_fileout_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_fileout_vbox), 1);
	gtk_container_add(GTK_CONTAINER(gtkwindow), l_fileout_vbox);

	#undef POPX
	#undef POPY
	#define POPX (XBASE + 20)
	#define POPY (-24)
	#define POPW (160)
	#define POPH (20)
	#define POPXT (POPX + 1)
	#define POPYT (POPY - 13)
	#define YDEL 34

	MakeText(0, ID_MANONE, L"Put new files in folder", POPXT, POPYT + 1 * YDEL + 2, 0);
	MakeText(1, ID_TEXT_FILEOUTDIR, fs2ma(mastr, g_sets.fileout[g_k[g_sets.output]].outdir), POPXT, POPYT + 1 * YDEL + 18, 0);
	MakeButtonA(WINDOWFILEOUT, ID_BTN_FILEOUTDIR, L"Change folder", POPXT, POPYT + 2 * YDEL, POPW , POPH);
	
#if defined(ENCODEMP3) || defined(ENCODEOGG) || defined(ENCODAAC) || defined(ENCODEMP4)
	switch(g_sets.output)
	{		
 #ifdef ENCODEMP3
		case kOUTMP3 :
			MakeText(0, ID_MANONE, L"Bitrate", POPXT, POPYT + 3 * YDEL, 0);
			MakePopup(ID_POPUP_BITRATE, 14, mp3bitrate, POPX, POPY + 3 * YDEL, POPW, POPH);

			MakeText(0, ID_MANONE, L"Quality", POPXT, POPYT + 4 * YDEL, 0);
			MakePopup(ID_POPUP_QUALITY, 11, mp3quality, POPX, POPY + 4 * YDEL, POPW, POPH);

			MakeText(0, ID_MANONE, L"Mode", POPXT, POPYT + 5 * YDEL, 0);
			MakePopup(ID_POPUP_MODE, 4, mp3mode, POPX, POPY + 5 * YDEL, POPW, POPH);

			MakeText(0, ID_MANONE, L"Sample Rate", POPXT, POPYT + 6 * YDEL, 0);
			MakePopup(ID_POPUP_SAMPLERATE, 10, mp3samplerate, POPX, POPY + 6 * YDEL, POPW, POPH);
		break;
 #endif
 
 #ifdef ENCODEOGG
		case kOUTOGG :
			MakeText(0, ID_MANONE, L"Bitrate", POPXT, POPYT + 3 * YDEL, 0);
			MakePopup(ID_POPUP_BITRATE, 14, oggbitrate, POPX, POPY + 3 * YDEL, POPW, POPH);

			// MakeText(0, ID_MANONE, "Quality", POPXT, POPYT + 4 * YDEL, 0);
			// MakePopup(ID_POPUP_QUALITY, 11, oggquality, POPX, POPY + 4 * YDEL, POPW, POPH);

			// MakeText(0, ID_MANONE, "Mode", POPXT, POPYT + 5 * YDEL, 0);
			// MakePopup(ID_POPUP_MODE, 4, oggmode, POPX, POPY + 5 * YDEL, POPW, POPH);
			MakeText(0, ID_MANONE, L"Mode", POPXT, POPYT + 4 * YDEL, 0);
			MakePopup(ID_POPUP_MODE, 2, oggmode, POPX, POPY + 4 * YDEL, POPW, POPH);
		break;
 #endif
 
 #ifdef ENCODEAAC
		case kOUTAAC :
			MakeCheckbox(ID_MANONE, ID_CHK_ADTS, L"   ADTS Headers", POPXT, POPYT + 3 * YDEL, CBXSIZ6, 0);
			MakeText(0, ID_MANONE, L"Quality", POPXT, POPYT + 4 * YDEL, 0);
			MakePopup(ID_POPUP_QUALITY, 7, aacquality, POPX, POPY + 4 * YDEL, POPW + 8, POPH);
		break;
 #endif
 
 #ifdef ENCODEMP4
		case kOUTMP4 :
			MakeCheckbox(ID_MANONE, ID_CHK_M4A, L"   .m4a extension", POPXT, POPYT + 3 * YDEL, CBXSIZ6, 0);
			MakeText(0, ID_MANONE, L"Quality", POPXT, POPYT + 4 * YDEL, 0);
			MakePopup(ID_POPUP_QUALITY, 7, mp4quality, POPX, POPY + 4 * YDEL, POPW + 8, POPH);
		break;
 #endif
 
		default :
		break;
	} // switch
#endif

	gtk_box_pack_end_defaults(GTK_BOX(l_fileout_vbox), l_fixed);

	masprintf(mastr, MAXLOGLINELEN, L"%ls %ls File Output", g_prognametitle, fs2ma(mastr2, g_extstrout[g_sets.output]));
	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, mastr));
	
	gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWFILEOUT].xpos[g_sets.winconf],
									g_sets.mawin[WINDOWFILEOUT].ypos[g_sets.winconf]);
	gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWFILEOUT].xsize[g_sets.winconf],
									g_sets.mawin[WINDOWFILEOUT].ysize[g_sets.winconf]);

	gtk_widget_show_all(gtkwindow);

} // FileOutWindowMake


void promptnumentrycallback(GtkWidget *widget)
{
#ifdef MATRACEGUIGTK
	maTrace("promptnumentrycallback");
#endif
	gchar *p;
	
	if((p = (gchar *)gtk_entry_get_text(GTK_ENTRY(l_promptnumentry))) == NULL || *p == 0)
		return;
		
	DoPromptIndexOk();
	
} // promptnumentrycallback


#define PROMPTNUMBUTTONW 60
#define PROMPTNUMBUTTONH 48
void PromptNumWindowMake()
{
 	GtkWidget *gtkwindow;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if(!g_w[WINDOWAPP])
	{
		maLog(L"PromptNumWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWPROMPTNUM])
	{
		maLog(L"PromptNumWindowMake already made");
		return;
	}

	l_fixed = gtk_fixed_new();
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWPROMPTNUM << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWPROMPTNUM << 8) + maGDK_CONFIGURE));

	g_w[WINDOWPROMPTNUM] = gtkwindow;

	l_promptnum_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_promptnum_vbox), 1);
	gtk_container_add(GTK_CONTAINER(gtkwindow), l_promptnum_vbox);
	
	// msg
	MakeText(1, ID_TEXT_PROMPTNUM, L"Enter the index of a song to play (1 to 99999, 0 to Cancel)", 10, 10, 0);

	// keyboard input
	l_promptnumentry = gtk_entry_new_with_max_length(MAPROMPTMAX);
	gtk_signal_connect(GTK_OBJECT(l_promptnumentry), "activate",
					GTK_SIGNAL_FUNC(promptnumentrycallback), NULL);
	gtk_fixed_put(GTK_FIXED(l_fixed), l_promptnumentry, 10, 40);
	gtk_widget_set_usize(l_promptnumentry, PROMPTNUMXSIZEDEF - 20, 26);
	gtk_widget_set_sensitive(l_promptnumentry, TRUE);

	// buttons
	l_ButtonPos = PROMPTNUMXSIZEDEF - 2 * (PROMPTNUMBUTTONW + 10);
	l_buttonTop = PROMPTNUMYSIZEDEF - (PROMPTNUMBUTTONH + 10);
	MakeButton(WINDOWPROMPTNUM, ID_BTN_PROMPTNUMCANCEL, LABEL_CANCEL);

	l_ButtonPos = PROMPTNUMXSIZEDEF - (PROMPTNUMBUTTONW + 10);
	l_buttonTop = PROMPTNUMYSIZEDEF - (PROMPTNUMBUTTONH + 10);
	MakeButton(WINDOWPROMPTNUM, ID_BTN_PROMPTNUMOK, LABEL_OK);

	gtk_box_pack_end_defaults(GTK_BOX(l_promptnum_vbox), l_fixed);

	masprintf(mastr, MAXLOGLINELEN, L"%ls Song Index Prompt", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, mastr));

	// gtk_window_set_modal(gtkwindow, 1);
														 
	gtk_widget_set_uposition(gtkwindow,
		g_sets.mawin[WINDOWPROMPTNUM].xpos[g_sets.winconf], g_sets.mawin[WINDOWPROMPTNUM].ypos[g_sets.winconf]);
	
	gtk_widget_set_usize(gtkwindow,
		g_sets.mawin[WINDOWPROMPTNUM].xsize[g_sets.winconf], g_sets.mawin[WINDOWPROMPTNUM].ysize[g_sets.winconf]);

	gtk_widget_show_all(gtkwindow);
	
	// set focus to edit text
	gtk_widget_grab_focus(l_promptnumentry);

} // PromptNumWindowMake


void ListAppend(int windowid, int list, machar *text)
{
#ifdef MATRACEGUIGTK
	maTrace("ListAppend");
#endif
	char *texts[2];

	fschar fsstr[MAXLOGLINELEN];
	ma2fs(fsstr, text); 
	texts[0] = fsstr;
	texts[1] = NULL;
	gtk_clist_append(GTK_CLIST(l_clist), texts);
	g_linenum++;
	
} // ListAppend

 
void ListClear(int windowid, int list)
{
#ifdef MATRACEGUIGTK
	maTrace("ListClear");
#endif

	if(!g_w[windowid] || !l_clist)
		return;

	gtk_clist_clear(GTK_CLIST(l_clist));
	g_linenum = 0;

} // ListClear


int ListGetRowSelected(int windowid, int list)
{
#ifdef MATRACEGUIGTK
	maTrace("ListGetRowSelected");
#endif

	if(!g_w[windowid] || !l_clist)
		return -1;

	if(GTK_CLIST(l_clist)->selection)
		return GPOINTER_TO_INT(GTK_CLIST(l_clist)->selection->data);

	return -1;
}


void ListEnsureVisible(int windowid, int list, int row)
{
#ifdef MATRACEGUIGTK
	maTrace("ListEnsureVisible");
#endif

	if(!g_w[windowid] || !l_clist)
		return;

	if(gtk_clist_row_is_visible(GTK_CLIST(l_clist), row) != GTK_VISIBILITY_NONE)
		return;

	gtk_clist_moveto(GTK_CLIST(l_clist), row, 0, 0.0, 0.0);
}


void ListSelect(int windowid, int list, int row)
{
#ifdef MATRACEGUIGTK
	maTrace("ListSelect");
#endif

	if(!g_w[windowid] || !l_clist)
		return;

	gtk_clist_select_row(GTK_CLIST(l_clist), row, 0);
}


void ListGetText(int windowid, int list, int row, machar *text)
{
#ifdef MATRACEGUIGTK
	maTrace("ListGetText");
#endif

	fschar *p;
	
	if(!g_w[windowid] || !l_clist)
		return;

	if(gtk_clist_get_text(GTK_CLIST(l_clist), row, 0, &p))
	{
		machar mastr2[MAXLOGLINELEN];
		mastrcpy(text, fs2ma(mastr2, p));
	}
	else
		*text = 0;
		
} // ListGetText


/* not used void ListSetText(int windowid, int list, int row, machar *text)
{
#ifdef MATRACEGUIGTK
	maTrace("ListSetText");
#endif
}
*/


void ListSetHeader(int windowid, int list, int col, machar *header)
{
#ifdef MATRACEGUIGTK
	maTrace("ListSetHeader");
#endif
	fschar fsstr[MAXLOGLINELEN];

	if(!g_w[windowid] || !l_clist)
		return;

	gtk_clist_set_column_title(GTK_CLIST(l_clist), col, ma2fs(fsstr, header));

} // ListSetHeader


void SetColumn0Width(int width)
{
	int w;

	if(!g_w[WINDOWLIST] || !l_clist)
		return;

	if(width <= 0)
	{
		switch(g_sets.listboxmode & (LBOXPLAYERINFO | LBOXPLAYLIST | LBOXSONGSLOADED | LBOXSONGINFO))
		{
			case LBOXPLAYERINFO:
				w = g_sets.listcolxsize[g_sets.winconf][0];
			break;
			case LBOXPLAYLIST:
				w = g_sets.listcolxsize[g_sets.winconf][1];
			break;
			case LBOXSONGSLOADED:
				w = g_sets.listcolxsize[g_sets.winconf][2];
			break;
			case LBOXSONGINFO:
				w = g_sets.listcolxsize[g_sets.winconf][3];
			break;
			default:
			return;
		}
	}
	else
		w = width;
	
	gtk_clist_set_column_width(GTK_CLIST(l_clist), 0, w);
				 
	if(width > 0)
		GetColumn0Width();

} // SetColumn0Width

		
void GetColumn0Width()
{
	int width;
	
	if(!g_w[WINDOWLIST] || !l_clist)
		return;

	width = ((GtkCListColumn *)gtk_clist_get_column_widget(GTK_CLIST(l_clist), 0))->width;
	
	if(width < (g_sets.mawin[WINDOWLIST].xsize[g_sets.winconf] - SCROLLERWIDTH))
		width = g_sets.mawin[WINDOWLIST].xsize[g_sets.winconf] - SCROLLERWIDTH;

	switch(g_sets.listboxmode & (LBOXPLAYERINFO | LBOXPLAYLIST | LBOXSONGSLOADED | LBOXSONGINFO))
	{
		case LBOXPLAYERINFO:
			g_sets.listcolxsize[g_sets.winconf][0] = width;
		break;
		case LBOXPLAYLIST:
			g_sets.listcolxsize[g_sets.winconf][1] = width;
		break;
		case LBOXSONGSLOADED:
			g_sets.listcolxsize[g_sets.winconf][2] = width;
		break;
		case LBOXSONGINFO:
			g_sets.listcolxsize[g_sets.winconf][3] = width;
		break;
		default:
		break;
	}

	return;
	
} // GetColumn0Width

		
void ListSetColumnWidth()
{
#ifdef MATRACEGUIGTK
	maTrace("ListSetColumnWidth");
#endif
	
	SetColumn0Width(0);
}


void ListFreeze()
{
	if(l_clist)
		gtk_clist_freeze(GTK_CLIST(l_clist));
}


void ListThaw()
{
	if(l_clist)
		gtk_clist_thaw(GTK_CLIST(l_clist));
}


#define MADOUBLECLICKTIME 2000 // max ms between two clicks of a list double click, big for long playlists...
int l_lastrow;
guint32 l_listclicktime;
void clist_row_selected(GtkWidget *w, gint row, gint c, GdkEventButton *event, gpointer p)
{
#ifdef MATRACEGUIGTK
 machar mastr[MAXLOGLINELEN];
 if(!event)
  masprintf(mastr, MAXLOGLINELEN, L"clist_row_selected row=%d event=0", row);
 else
  masprintf(mastr, MAXLOGLINELEN, L"clist_row_selected row=%d time=%d", row, event->time);
 maTrace(mastr);
#endif

	if(!event)
		return;
		
	if(((event->time - l_listclicktime) < MADOUBLECLICKTIME) && row == l_lastrow) // a double-click
	{
#ifdef MATRACEGUIGTK
maTrace("DoubleClick");
#endif
		l_listclicktime = 0;
		OnListWindowDoubleClick();
		return;
	}
	
	l_lastrow = row;
	l_listclicktime = event->time;
	OnListWindowSingleClick(row + 1);
	
} // clist_row_selected


void clist_row_unselected(GtkWidget *w, gint row, gint c, GdkEventButton *event, gpointer p)
{
#ifdef MATRACEGUIGTK
 machar mastr[MAXLOGLINELEN];
 if(!event)
  masprintf(mastr, MAXLOGLINELEN, L"clist_row_unselected row=%d event=0", row);
 else
  masprintf(mastr, MAXLOGLINELEN, L"clist_row_unselected row=%d time=%d", row, event->time);
 maTrace(mastr);
#endif

	if(!event)
		return;
		
	l_listclicktime = event->time;

} // clist_row_unselected


void clist_resize_column(GtkWidget *w, gint row, gint c, GdkEventButton *event, gpointer p)
{
#ifdef MATRACEGUIGTK
 machar mastr[MAXLOGLINELEN];
 if(!event)
  masprintf(mastr, MAXLOGLINELEN, L"clist_resize_column c=%d event=0", c);
 else
  masprintf(mastr, MAXLOGLINELEN, L"clist_resize_column c=%d time=%d", c, event->time);
 maTrace(mastr);
#endif

	//GetColumn0Width();
	switch(g_sets.listboxmode & (LBOXPLAYERINFO | LBOXPLAYLIST | LBOXSONGSLOADED | LBOXSONGINFO))
	{
		case LBOXPLAYERINFO:
			g_sets.listcolxsize[g_sets.winconf][0] = c;
		break;
		case LBOXPLAYLIST:
			g_sets.listcolxsize[g_sets.winconf][1] = c;
		break;
		case LBOXSONGSLOADED:
			g_sets.listcolxsize[g_sets.winconf][2] = c;
		break;
		case LBOXSONGINFO:
			g_sets.listcolxsize[g_sets.winconf][3] = c;
		break;
		default:
		break;
	}

} // clist_resize_column


void clist_key_pressed(GtkWidget *w, GdkEventKey *event, gpointer p)
{
#ifdef MATRACEGUIGTK
 maTrace("clist_key_pressed");
#endif
	fschar fskey[STRLEN16] = {fsT('\0')};

	if(!event)
		return;
		
	if(event->keyval == GDK_Return) // 0xFF0D
	{
		fskey[4] = MAWXK_RETURN;
		maOnKey(fskey);
	}
	else if(event->keyval == GDK_Escape)
	{
		fskey[4] = MAWXK_ESCAPE;
		maOnKey(fskey);
	}
	else if(event->keyval == GDK_Up) // up arrow
	{
		fskey[4] = MAWXK_UP;
		maOnKey(fskey);
	}
	else if(event->keyval == GDK_Down) // down arrow
	{
		fskey[4] = MAWXK_DOWN;
		maOnKey(fskey);
	}

} // clist_key_pressed


#if defined(__MACUNIX__)
 #define LISTMENUBARH 22 // MENUBARH to line up buttons with main window buttons
#else
 #define LISTMENUBARH 25 // MENUBARH to line up buttons with main window buttons
#endif
void ListWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("ListWindowMake");
#endif
	GtkWidget *gtkwindow;

	if(!g_w[WINDOWAPP])
	{
		maLog(L"ListWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWLIST])
	{
		maLog(L"ListWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);
	
 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWLIST << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWLIST << 8) + maGDK_CONFIGURE));
	
#if defined(MAKEYBOARD) || defined(MAMOUSEWHEEL)
	int mask = 0;
#endif

#if defined(MAKEYBOARD)
	mask = GDK_KEY_PRESS_MASK;
	gtk_widget_set_events(gtkwindow, mask);
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
#endif

#if defined(MAMOUSEWHEEL)
	mask |= GDK_SCROLL_MASK;
	gtk_widget_set_events(gtkwindow, GDK_SCROLL_MASK);
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
#endif

	g_w[WINDOWLIST] = gtkwindow;

	// list buttons
	l_ButtonPos = XBASE;
	l_buttonTop = YBASE + LISTMENUBARH; // line up buttons with main window buttons
	MakeButton(WINDOWLIST, ID_BTN_INFO, LABEL_INFO);
	MakeButton(WINDOWLIST, ID_BTN_PLAYLIST, LABEL_LIST);
	MakeButton(WINDOWLIST, ID_BTN_LOADED, LABEL_LOAD);
	MakeButton(WINDOWLIST, ID_BTN_SONGINFO, LABEL_SONG);
	
	// list checkboxes
	MakeCheckbox(ID_MANONE, ID_CHK_SHOWINDEX, L"Show index", l_ButtonPos + 4, YBASE + LISTMENUBARH + 3 - 13, CBXSIZ, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_SHOWDIR, L"Show dir", l_ButtonPos + 4, YBASE + LISTMENUBARH + 19 - 13, CBXSIZ, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_SHOWPATH, L"Show path", l_ButtonPos + 4, YBASE + LISTMENUBARH + 35 - 13, CBXSIZ, 0);
	MakeCheckbox(ID_MANONE, ID_CHK_ADDMODE, L"Add mode", l_ButtonPos + 84, YBASE + LISTMENUBARH + 3 - 13, CBXSIZ, 0);

	// list
	char *titles[] = {""};
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *scrolled_win;
	g_linenum = 0;

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(gtkwindow), vbox);

	scrolled_win = gtk_scrolled_window_new(NULL, NULL);
	gtk_container_set_border_width(GTK_CONTAINER(scrolled_win), 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_win),
								GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	l_clist = gtk_clist_new_with_titles(1, titles);
	gtk_widget_set_name(l_clist, "malist");
	gtk_clist_set_reorderable(GTK_CLIST(l_clist), FALSE);
	gtk_clist_set_auto_sort(GTK_CLIST(l_clist), FALSE);
	gtk_clist_column_titles_passive(GTK_CLIST(l_clist));
	gtk_container_add(GTK_CONTAINER(scrolled_win), l_clist);
	gtk_signal_connect(GTK_OBJECT(l_clist), "select_row",
						GTK_SIGNAL_FUNC(clist_row_selected), NULL);
	gtk_signal_connect(GTK_OBJECT(l_clist), "unselect_row",
						GTK_SIGNAL_FUNC(clist_row_unselected), NULL);
	gtk_signal_connect(GTK_OBJECT(l_clist), "resize_column",
						GTK_SIGNAL_FUNC(clist_resize_column), NULL);
	gtk_signal_connect(GTK_OBJECT(l_clist), "key_press_event",
						GTK_SIGNAL_FUNC(clist_key_pressed), NULL);

	hbox = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER (hbox), 0);
	gtk_box_pack_start (GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), l_fixed, FALSE, FALSE, 0);	  
	gtk_box_pack_start(GTK_BOX (vbox), scrolled_win, TRUE, TRUE, 0);

	SetColumn0Width(0); // from g_sets
	gtk_clist_set_column_auto_resize(GTK_CLIST(l_clist), 1, FALSE);
	gtk_clist_set_column_justification(GTK_CLIST (l_clist), 1, GTK_JUSTIFY_LEFT);
	gtk_clist_set_selection_mode(GTK_CLIST(l_clist), GTK_SELECTION_BROWSE);

	gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWLIST].xpos[g_sets.winconf], g_sets.mawin[WINDOWLIST].ypos[g_sets.winconf]);
	gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWLIST].xsize[g_sets.winconf], g_sets.mawin[WINDOWLIST].ysize[g_sets.winconf]);
			
	gtk_widget_show_all(gtkwindow);

} // ListWindowMake


void MenuEnable(int menu, int item)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuEnable");
#endif
	
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory1, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory2, item);
	if(!w)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"MenuEnable gtk_item_factory_get_widget_by_action failed menu=%d item=%d", menu, item);
		maLog(mastr);
		return;
	}

	gtk_widget_set_sensitive(w, TRUE);

} // MenuEnable


void MenuDisable(int menu, int item)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuDisable");
#endif
	
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory1, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory2, item);
	if(!w)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"MenuDisable gtk_item_factory_get_widget_by_action failed menu=%d item=%d", menu, item);
		maLog(mastr);
		return;
	}

	gtk_widget_set_sensitive(w, FALSE);

} // MenuDisable


/* int MenuIsChecked(int menu, int item)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuIsChecked");
#endif

	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory1, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory2, item);
	if(!w)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"MenuIsChecked gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(mastr);
		return 0;
	}
	
	return ((GTK_CHECK_MENU_ITEM(w))->active) ? 1 : 0;

} // MenuIsChecked
*/


void MenuSetChecked(int menu, int item, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuSetChecked");
#endif
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory1, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory2, item);
	if(!w)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"MenuSetChecked gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(mastr);
		return;
	}
	
	if(((GTK_CHECK_MENU_ITEM(w))->active && value) || (!((GTK_CHECK_MENU_ITEM(w))->active) && !value))
		return; // already set

	// gtk_check_menu_item_set_active triggers a menu event that we want to ignore
	// so we use always_show_toggle as a flag that will be checked in MenuEventHandler()
	(GTK_CHECK_MENU_ITEM(w))->always_show_toggle = 0;

	gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(w), (value) ? TRUE : FALSE);
		
} // MenuSetChecked


void PopupButtonEnable(int windowid, int popup)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonEnable");
#endif
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonEnable PopupButtonIndexFromId %d failed", popup);
		maLog(mastr);
		return; 
	}
	
	if(!l_popupbutton[idx].optionmenu)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonEnable no popupbutton at index %d (id=%d)", idx, popup);
		maLog(mastr);
		return;
	}

	if(l_popupbutton[idx].optionmenu)
		gtk_widget_set_sensitive(l_popupbutton[idx].optionmenu, TRUE);

} // PopupButtonEnable


void PopupButtonDisable(int windowid, int popup)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonDisable");
#endif

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonDisable PopupButtonIndexFromId %d failed", popup);
		maLog(mastr);
		return; 
	}
	
	if(!l_popupbutton[idx].optionmenu)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonDisable no popupbutton at index %d (id=%d)", idx, popup);
		maLog(mastr);
		return;
	}

	gtk_widget_set_sensitive(l_popupbutton[idx].optionmenu, FALSE);
	
} // PopupButtonDisable


void PopupButtonClear(int windowid, int popup)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonClear");
#endif
	GtkWidget *menu;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonClear PopupButtonIndexFromId %d failed", popup);
		maLog(mastr);
		return; 
	}
	
	if(!(menu = gtk_option_menu_get_menu(l_popupbutton[idx].optionmenu)))
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonClear no popupbutton at index %d (id=%d)", idx, popup);
		maLog(mastr);
		return;
	}

	l_popupbutton[idx].nitems = 0;
	gtk_option_menu_remove_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu));
	menu = gtk_menu_new();
	gtk_widget_set_name(menu, "mapopup");
	gtk_option_menu_set_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), menu);

} // PopupButtonClear


void PopupButtonAppend(int windowid, int popup, machar *text)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonAppend");
#endif
	int idx;
	GtkWidget *menu;
	GtkWidget *menuitem;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	if((idx = PopupButtonIndexFromId(popup)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonAppend PopupButtonIndexFromId %d failed", popup);
		maLog(mastr);
		return; 
	}
	
	if(!(menu = gtk_option_menu_get_menu(l_popupbutton[idx].optionmenu)))
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonAppend no popupbutton at index %d (id=%d)", idx, popup);
		maLog(mastr);
		return;
	}

	menuitem = gtk_menu_item_new_with_label(ma2fs(fsstr, text));
	gtk_widget_set_name(menuitem, "mamenu");
	gtk_menu_shell_append((GtkMenuShell *)menu, menuitem);
	
	gtk_widget_show(menuitem);
	gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
		GTK_SIGNAL_FUNC(popupcallback), (gpointer)((l_popupbutton[idx].nitems << 24) + popup));

	gtk_option_menu_set_history(l_popupbutton[idx].optionmenu, l_popupbutton[idx].value);
	l_popupbutton[idx].nitems = l_popupbutton[idx].nitems + 1;

} // PopupButtonAppend


void PopupButtonSetValue(int windowid, int popup, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonSetValue");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonSetValue PopupButtonIndexFromId %d failed", popup);
		maLog(mastr);
		return; 
	}
	
	l_popupbutton[idx].value = value;
	gtk_option_menu_set_history(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), value);

} // PopupButtonSetValue


void PopupButtonSetText(int windowid, int popup, int item, machar *text)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonSetText");
#endif
	int i;
	GtkWidget *menu;
	GtkWidget *menuitem;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	// we have to rebuild the popup
	// i have no idea how to get the current popup item labels
	// so get them from g_sets
	if(popup != ID_POPUP_EQPRESET // these are the only ones we do
#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
	&& popup != ID_POPUP_AUDIOCD
#endif
	)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonSetText popup id=%d unsupported", popup);
		maLog(mastr);
		return;
	}

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonSetText PopupButtonIndexFromId %d failed", popup);
		maLog(mastr);
		return; 
	}
	
	if(!(menu = gtk_option_menu_get_menu(l_popupbutton[idx].optionmenu)))
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonSetText no popupbutton at index %d (id=%d)", idx, popup);
		maLog(mastr);
		return;
	}
	
	menu = gtk_menu_new();
	gtk_widget_set_name(menu, "mapopup");
	for(i = 0; i < l_popupbutton[idx].nitems; i++)
	{
		menuitem = NULL;
		if(i == popup)
			menuitem = gtk_menu_item_new_with_label(ma2fs(fsstr, text));
		else if(popup == ID_POPUP_EQPRESET)
			menuitem = gtk_menu_item_new_with_label(g_sets.eqpresets[i].eqname);
#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
		else // if(popup == ID_POPUP_AUDIOCD)
			menuitem = gtk_menu_item_new_with_label(g_setscdrom.cdaname[i + 1]);
#endif
		if(menuitem)
		{
			gtk_widget_set_name(menuitem, "mamenu");
			gtk_menu_append(GTK_MENU(menu), menuitem);
			gtk_widget_show(menuitem);
			gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
				GTK_SIGNAL_FUNC(popupcallback), (gpointer)((i << 24) + popup));
		}
	}
	gtk_option_menu_remove_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu));
	gtk_option_menu_set_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), menu);
	gtk_option_menu_set_history(l_popupbutton[idx].optionmenu, l_popupbutton[idx].value);
	
} // PopupButtonSetText


#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
void PopupButtonGetSelection(int windowid, int popup, int *item)
{
#ifdef MATRACEGUIGTK
	maLog(L"PopupButtonGetSelection");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		if(item)
			*item = -1;
		return;
	}
	
	idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonGetSelection PopupButtonIndexFromId %d failed", popup);
		maLog(mastr);
		if(item)
			*item = -1;
		return; 
	}
	
	if(item)
		*item = l_popupbutton[idx].value;

} // PopupButtonGetSelection


void PopupButtonSetSelection(int windowid, int popup, int item)
{
#ifdef MATRACEGUIGTK
	maLog(L"PopupButtonSetSelection");
#endif
	GtkWidget *menu;
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonSetSelection PopupButtonIndexFromId %d failed", popup);
		maLog(mastr);
		return; 
	}
	
	if(!l_popupbutton[idx].optionmenu)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonSetSelection no popup optionmenu at index %d", idx);
		maLog(mastr);
		return;
	}

	if(!(menu = gtk_option_menu_get_menu(l_popupbutton[idx].optionmenu)))
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonSetSelection no popupbutton at index %d (id=%d)", idx, popup);
		maLog(mastr);
		return;
	}
	
	if(item < 0 || item > l_popupbutton[idx].nitems)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PopupButtonSetSelection %d out of bounds, nitems=%d popupid=%d",
													item, l_popupbutton[idx].nitems, popup);
		maLog(mastr);
		return;
	}
	l_popupbutton[idx].value = item;
	gtk_option_menu_set_history(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), item);

} // PopupButtonSetSelection
#endif


/* not used void SpinButtonEnable(int windowid, int spinbutton)
{
#ifdef MATRACEGUIGTK
	maTrace("SpinButtonEnable");
#endif

	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = SpinButtonIndexFromId(spinbutton);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SpinButtonEnable SpinButtonIndexFromId %d failed", spinbutton);
		maLog(mastr);
		return; 
	}
	
	if(!l_spinbutton[idx].adj)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SpinButtonEnable no spinbutton at index %d (id=%d)", idx, spinbutton);
		maLog(mastr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_spinbutton[idx].adj), TRUE);

} // SpinButtonEnable


void SpinButtonDisable(int windowid, int spinbutton)
{
#ifdef MATRACEGUIGTK
	maTrace("SpinButtonDisable");
#endif

	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = SpinButtonIndexFromId(spinbutton);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SpinButtonDisable SpinButtonIndexFromId %d failed", spinbutton);
		maLog(mastr);
		return; 
	}
	
	if(!l_spinbutton[idx].adj)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SpinButtonDisable no spinbutton at index=%d (id=%d)", idx, spinbutton);
		maLog(mastr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_spinbutton[idx].adj), FALSE);

} // SpinButtonDisable
*/


// this s.b. 'ToggleButtonPaintUp' or 'PushButtonSetValue(1)'
// but it is only called from SetPause
void PushButtonPaintUp(int windowid, int button)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonPaintUp");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if((idx = PushButtonIndexFromId(windowid, button)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonPaintUp PushButtonIndexFromId window %d button %d failed", windowid, button);
		maLog(mastr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonPaintUp no button at index %d (window=%d id=%d)", idx, windowid, button);
		maLog(mastr);
		return;
	}
	
	if(!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(l_button[idx].btn)))
		return; // already set

	l_button[idx].skip = 1;
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(l_button[idx].btn), FALSE);

} // PushButtonPaintUp


void PushButtonPaintDown(int windowid, int button)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonPaintDown");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if((idx = PushButtonIndexFromId(windowid, button)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonPaintDown PushButtonIndexFromId %d failed window=%d", button, windowid);
		maLog(mastr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonPaintDown no button at index %d (window=%d id=%d)", idx, windowid, button);
		maLog(mastr);
		return;
	}
	
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(l_button[idx].btn)))
		return; // already set
		
	l_button[idx].skip = 1;
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(l_button[idx].btn), TRUE);

} // PushButtonPaintDown


void PushButtonEnable(int windowid, int button)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonEnable");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if((idx = PushButtonIndexFromId(windowid, button)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonEnable PushButtonIndexFromId %d failed, window=%d", button, windowid);
		maLog(mastr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonEnable no button at index %d (window=%d id=%d)", idx, windowid, button);
		maLog(mastr);
		return;
	}
	
	gtk_widget_set_sensitive(GTK_WIDGET(l_button[idx].btn), TRUE);

} // PushButtonEnable


void PushButtonDisable(int windowid, int button)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonDisable");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if((idx = PushButtonIndexFromId(windowid, button)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonDisable PushButtonIndexFromId %d failed, window=%d", button, windowid);
		maLog(mastr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonDisable no button at index=%d (window=%d id=%d)", idx, windowid, button);
		maLog(mastr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_button[idx].btn), FALSE);

} // PushButtonDisable


void PushButtonSetDescriptor(int windowid, int button, machar *desc)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonSetDescriptor");
#endif
	GtkLabel *label;
	int idx;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if((idx = PushButtonIndexFromId(windowid, button)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonSetDescriptor PushButtonIndexFromId %d failed, window=%d", button, windowid);
		maLog(mastr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonSetDescriptor no button at index %d (window=%d id=%d)", idx, windowid, button);
		maLog(mastr);
		return;
	}

	if(desc && (label = maGtkGetFirstLabel(l_button[idx].btn)))
		gtk_label_set_text(label, ma2fs(fsstr, desc));
} // PushButtonSetDescriptor


void PushButtonGetDescriptor(int windowid, int button, machar *desc)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonGetDescriptor");
#endif
	GtkLabel *label;
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	if(desc)
		mastr[0] = 0;
	else
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonGetDescriptor %d null desc", button);
		maLog(mastr);
		return; 
	}
		
	if((idx = PushButtonIndexFromId(windowid, button)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonGetDescriptor PushButtonIndexFromId %d failed, window=%d", button, windowid);
		maLog(mastr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		masprintf(mastr, MAXLOGLINELEN, L"PushButtonGetDescriptor no button at index %d (window=%d id=%d)", idx, windowid, button);
		maLog(mastr);
		return;
	}

	if((label = maGtkGetFirstLabel(l_button[idx].btn)))
		mastrcpy(desc, fs2ma(mastr, label->label));
	
} // PushButtonGetDescriptor


void hslidercallback(GtkWidget *widget, maslider *lslider)
{
#ifdef MATRACEGUIGTK
maTrace("hslidercallback");
#endif

	if(lslider->skip)
	{
		lslider->skip = 0;
		return;
	}
	OnSliderPosition(GTK_ADJUSTMENT(widget)->value);
}


void slidercallback(GtkWidget *widget, maslider *lslider)
{
#ifdef MATRACEGUIGTK
maTrace("slidercallback");
#endif
	int startValue;
	int idx;
	
	if(lslider->skip)
	{
		lslider->skip = 0;
		return;
	}

	startValue = GTK_ADJUSTMENT(widget)->upper - 1.0 - GTK_ADJUSTMENT(widget)->value; // lower is always 0

	if(lslider->id >= ID_SLIDER_EQ_FIRST && lslider->id <= ID_SLIDER_EQ2_LAST)
	{
		if((idx = lslider->id - ID_SLIDER_EQ_FIRST) <= EQSLIDERLAST)
			OnSliderEq(idx, startValue, 0);
		else
			OnSliderEq2(idx, startValue, 0);
		return;
	}
	
	switch(lslider->id)
	{
		case ID_SLIDER_VOLUMEL :
			OnSliderVolumeL(startValue);
		break;
		case ID_SLIDER_VOLUMER :
			OnSliderVolumeR(startValue);
		break;
		case ID_SLIDER_VOLUMESEP :
			OnSliderSeparation(startValue);
		break;
		case ID_SLIDER_PREAMP :
			OnSliderPreamp(startValue);
		break;
		case ID_SLIDER_PITCH :
			OnSliderPitch(startValue);
		break;
		case ID_SLIDER_PITCH2 :
			OnSliderPitch2(startValue);
		break;
		case ID_SLIDER_TEMPO :
			OnSliderTempo(startValue);
		break;
		case ID_SLIDER_SPEED :
			OnSliderSpeed(startValue);
		break;

		default:
			maLogAPI(L"slidercallback unexpected id", WINDOWAPP, lslider->id);
		break;
	}

} // slidercallback


/* not used
int SliderGetValue(int windowid, int slider) // also ScrollBarGetValue
{
#ifdef MATRACEGUIGTK
	maTrace("SliderGetValue");
#endif
	return 0;
}
*/


void HSliderSetValue(int windowid, int slider, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("HSliderSetValue");
#endif
	if(l_hslider.adj)
	{
		l_hslider.skip = 1;
		gtk_adjustment_set_value(GTK_ADJUSTMENT(l_hslider.adj), value);
	}
}


int IdByWindow(int windowid, int id)
{
#if !defined(NOTEXTVIEWER)
	switch(id)
	{
		case ID_TEXT_VIEWERFOUNDREADME: // ID_TEXT_VIEWERFOUND
		case ID_TEXT_VIEWERFOUNDLOG:
		case ID_TEXT_VIEWERFOUNDCATALOG:
		case ID_TEXT_VIEWERFOUNDPLAYLIST:
 #if defined(MAKEYBOARD)
		case ID_TEXT_VIEWERFOUNDKEYBINDINGS:
 #endif
			switch(windowid)
			{
				case WINDOWREADME:
				return ID_TEXT_VIEWERFOUNDREADME;
				case WINDOWLOG:
				return ID_TEXT_VIEWERFOUNDLOG;
				case WINDOWCATALOG:
				return ID_TEXT_VIEWERFOUNDCATALOG;
				case WINDOWPLAYLIST:
				return ID_TEXT_VIEWERFOUNDPLAYLIST;
 #if defined(MAKEYBOARD)
				case WINDOWKEYBINDINGS:
				return ID_TEXT_VIEWERFOUNDKEYBINDINGS;
 #endif
				default:
					maLog(L"IdByWindow ID_TEXT_VIEWERFOUND invalid windowid");
				break;
			}
		break;

		case ID_BTN_EDITSAVEREADME: // ID_BTN_EDITSAVE
		case ID_BTN_EDITSAVELOG:
		case ID_BTN_EDITSAVECATALOG:
 #if defined(MAKEYBOARD)
		case ID_BTN_EDITSAVEKEYBINDINGS:
 #endif
			switch(windowid)
			{
				case WINDOWREADME:
				return ID_BTN_EDITSAVEREADME; // ID_BTN_EDITSAVE
				case WINDOWLOG:
				return ID_BTN_EDITSAVELOG;
				case WINDOWCATALOG:
				return ID_BTN_EDITSAVECATALOG;
				case WINDOWPLAYLIST:
				return ID_BTN_EDITSAVEPLAYLIST;
 #if defined(MAKEYBOARD)
				case WINDOWKEYBINDINGS:
				return ID_BTN_EDITSAVEKEYBINDINGS;
 #endif
				default:
					maLog(L"IdByWindow ID_BTN_EDITSAVE invalid windowid");
				break;
			}
		break;

		case ID_BTN_VIEWERFINDREADME: // ID_BTN_VIEWERFIND
		case ID_BTN_VIEWERFINDLOG:
		case ID_BTN_VIEWERFINDCATALOG:
 #if defined(MAKEYBOARD)
		case ID_BTN_VIEWERFINDKEYBINDINGS:
 #endif
			switch(windowid)
			{
				case WINDOWREADME:
				return ID_BTN_VIEWERFINDREADME; // ID_BTN_VIEWERFIND
				case WINDOWLOG:
				return ID_BTN_VIEWERFINDLOG;
				case WINDOWCATALOG:
				return ID_BTN_VIEWERFINDCATALOG;
				case WINDOWPLAYLIST:
				return ID_BTN_VIEWERFINDPLAYLIST;
 #if defined(MAKEYBOARD)
				case WINDOWKEYBINDINGS:
				return ID_BTN_VIEWERFINDKEYBINDINGS;
 #endif
				default:
					maLog(L"IdByWindow ID_BTN_VIEWERFIND invalid windowid");
				break;
			}
		break;

		default:
		break;
	}
#endif

	return(id);

} // IdByWindow


int CheckboxIndexFromId(int id)
{
	if(id >= ID_CHECKBOX_FIRST && id <= ID_CHECKBOX_LAST)
		return id - ID_CHECKBOX_FIRST;
	return -1;
}


int TextIndexFromId(int id)
{
	int i;
	for(i = 0; i < NUMTEXTS; i++)
		if(l_text[i].id == id)
			return i;
	return -1;
}


int PushButtonIndexFromId(int windowid, int pbid)
{
	int lpbid;
	
	lpbid = IdByWindow(windowid, pbid);
	if(lpbid >= ID_BTN_FIRST && lpbid <= (ID_BTN_LAST + ID_BTN_LAST_PLUS))
		return lpbid - ID_BTN_FIRST;
	return -1;
}


int PopupButtonIndexFromId(int id)
{
	if(id >= ID_POPUP_FIRST && id <= ID_POPUP_LAST)
		return id - ID_POPUP_FIRST;
	return -1;
}


int SpinButtonIndexFromId(int id)
{
	if(id >= ID_SPIN_FIRST && id <= ID_SPIN_LAST)
		return id - ID_SPIN_FIRST;
	return -1;
}


int SliderIndexFromId(int id)
{
	if(id >= ID_SLIDER_FIRST && id <= ID_SLIDER_LAST)
		return id - ID_SLIDER_FIRST;
	return -1;
}


void SliderSetValue(int windowid, int slider, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("SliderSetValue");
#endif

	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = SliderIndexFromId(slider);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SliderSetValue SliderIndexFromId %d failed", slider);
		maLog(mastr);
		return; 
	}
	
	if(!l_slider[idx].adj)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SliderSetValue no slider at index %d (id=%d)", idx, slider);
		maLog(mastr);
		return;
	}

	l_slider[idx].skip = 1;

	gtk_adjustment_set_value(GTK_ADJUSTMENT(l_slider[idx].adj), 
		GTK_ADJUSTMENT(l_slider[idx].adj)->upper - 1.0 - value); // lower is always 0

} // SliderSetValue


void SliderEnable(int windowid, int slider)
{
#ifdef MATRACEGUIGTK
	maTrace("SliderEnable");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = SliderIndexFromId(slider);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SliderEnable SliderIndexFromId %d failed", slider);
		maLog(mastr);
		return; 
	}
	
	if(!l_slider[idx].adj)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SliderEnable no slider at index %d (id=%d)", idx, slider);
		maLog(mastr);
		return;
	}
	
	//gtk_widget_show(GTK_WIDGET(l_slider[idx].slider));
	gtk_widget_set_sensitive(GTK_WIDGET(l_slider[idx].slider), TRUE);
	
} // SliderEnable


void SliderDisable(int windowid, int slider)
{
#ifdef MATRACEGUIGTK
	maTrace("SliderDisable");
#endif
	int idx;
	machar mastr[MAXLOGLINELEN];
	
	idx = SliderIndexFromId(slider);
	if(idx < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SliderDisable SliderIndexFromId %d failed", slider);
		maLog(mastr);
		return; 
	}
	
	if(!l_slider[idx].slider)
	{
		masprintf(mastr, MAXLOGLINELEN, L"SliderDisable no slider at index %d (id=%d)", idx, slider);
		maLog(mastr);
		return;
	}
	
	gtk_widget_set_sensitive(GTK_WIDGET(l_slider[idx].slider), FALSE);
	//gtk_widget_hide(GTK_WIDGET(l_slider[idx].slider));
	
} // SliderDisable


void StaticTextSetText(int windowid, int statictext, machar *text)
{
#ifdef MATRACEGUIGTK
	maTrace("StaticTextSetText");
#endif
	int idx;
	int textid;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	textid = IdByWindow(windowid, statictext);
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	if((idx = TextIndexFromId(textid)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"StaticTextSetText TextIndexFromId window %d inid %d outid %d failed", windowid, statictext, textid);
		maLog(mastr);
		return; 
	}
 	ma2fs(fsstr, text);
 #if defined(__MAOSX__) || defined(__MACUNIX__) // we need UTF-8-MAC instead of UTF-8
	StrUTF8toUTF8MAC(fsstr);
 #endif
	gtk_label_set_text(GTK_LABEL(l_text[idx].text), fsstr);

} // StaticTextSetText


void StaticTextSetValue(int windowid, int statictext, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("StaticTextSetValue");
#endif
	int idx;
	machar text[STRLEN64];
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	if((idx = TextIndexFromId(statictext)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"StaticTextSetValue TextIndexFromId %d failed", statictext);
		maLog(mastr);
		return; 
	}
	
	masprintf(text, STRLEN64, L"%d", value);
	gtk_label_set_text(GTK_LABEL(l_text[idx].text), ma2fs(fsstr, text));
	
} // StaticTextSetValue


void WindowClose(int windowid)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowClose");
#endif
	/*
	GtkWidget *w;
	
	if(!(w = g_w[windowid]))
	{
		maLog(L"WindowClose no window");
		return;
	}
	
	if(windowid == WINDOWLIST)
		l_clist = NULL;
	
	gtk_widget_destroy(w);
	*/
	WindowDestroy(windowid);
	 
} // WindowClose


void WindowDestroy(int windowid)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowDestroy");
#endif
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowDestroy no window");
		return;
	}
	
	if(windowid == WINDOWLIST)
		l_clist = NULL;
	
	gtk_widget_destroy(g_w[windowid]);
}


/* not used	void WindowGetOrigin(int windowid, int *xpos, int *ypos)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowGetOrigin");
#endif
	Rect r;
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowGetOrigin no window");
		return;
	}
	if(!xpos || !ypos)
	{
		maLog(L"WindowGetOrigin bad pos or size parameter");
		return;
	}
	if(GetWindowBounds((WindowRef)g_w[windowid], kWindowGlobalPortRgn, &r))
	{
		maLog(L"WindowGetOrigin GetWindowBounds failed");
		return;
	}
	*xpos = r.left;
	*ypos = r.top;
	
} // WindowGetOrigin


void WindowGetSize(int windowid, int *xsize, int *ysize)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowGetSize");
#endif
	Rect r;
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowGetSize no window");
		return;
	}
	if(!xsize || !ysize)
	{
		maLog(L"WindowGetSize bad pos or size parameter");
		return;
	}
	if(GetWindowBounds((WindowRef)g_w[windowid], kWindowGlobalPortRgn, &r))
	{
		maLog(L"WindowGetSize GetWindowBounds failed");
		return;
	}
	*xsize = r.right - r.left;
	*ysize = r.bottom - r.top;
	
} // WindowGetSize
*/


void WindowGetCoordinates(int windowid, int *xpos, int *ypos, int *xsize, int *ysize)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowGetCoordinates");
#endif
 	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowGetCoordinates no window");
		return;
	}
	
	// gdk_window_get_position((GTK_WIDGET(g_w[windowid]))->window, xpos, ypos);
	// gdk_window_get_origin((GTK_WIDGET(g_w[windowid]))->window, xpos, ypos);
	gdk_window_get_root_origin((GTK_WIDGET(g_w[windowid]))->window, xpos, ypos); // this is the one
	gdk_window_get_size((GTK_WIDGET(g_w[windowid]))->window, xsize, ysize);

} // WindowGetCoordinates


/*
void WindowItemHide(int windowid, int item)
{
 #ifdef MATRACEGUIGTK
	maTrace("WindowItemHide");
 #endif
	if(item == ID_EDITTEXT_KB_MAIN && l_entry)
	{
		gtk_widget_set_sensitive(l_entry, FALSE);
		gtk_widget_hide(l_entry);
	}
	else
		maLogAPI(L"WindowItemHide no widget", windowid, item);
		
} // WindowItemHide


void WindowItemShow(int windowid, int item)
{
 #ifdef MATRACEGUIGTK
	maTrace("WindowItemShow");
 #endif
	if(item == ID_EDITTEXT_KB_MAIN && l_entry)
	{
		gtk_widget_set_sensitive(l_entry, TRUE);
		gtk_widget_show(l_entry);
	}
	else
		maLogAPI(L"WindowItemShow no widget", windowid, item);

} // WindowItemShow
*/


int WindowIsShown(int windowid)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowIsShown");
#endif
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowIsShown no window");
		return 0;
	}
	return gdk_window_is_visible((GTK_WIDGET(g_w[windowid]))->window) ? 1 : 0;

} // WindowIsShown


void WindowMove(int windowid, int xpos, int ypos)
{
#ifdef MATRACEGUIGTK
//	maTrace("WindowMove");
{
machar mastr[MAXLOGLINELEN];
masprintf(mastr, MAXLOGLINELEN, L"WindowMove window=%d x=%d y=%d ", windowid, xpos, ypos); 
maTrace(mastr);
}
#endif

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	gdk_window_move((GTK_WIDGET(g_w[windowid]))->window, xpos, ypos);

} // WindowMove


void WindowWidgetSetSize(int windowid, int widget, int xsize, int ysize) // only used for the play position slider
{
	if(l_scale)
		gtk_widget_set_usize(GTK_WIDGET(l_scale),
		g_sets.mawin[windowid].xsize[g_sets.winconf] - HSLIDERPOSX - 4, HSLIDERHEIGHT);

} // WindowWidgetSetSize


void WindowSetSize(int windowid, int xsize, int ysize)
{
#ifdef MATRACEGUIGTK
//	maTrace("WindowSetSize");
{
machar mastr[MAXLOGLINELEN];
masprintf(mastr, MAXLOGLINELEN, L"WindowSetSize window=%d w=%d h=%d", windowid, xsize, ysize); 
maTrace(mastr);
}
#endif

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	gdk_window_resize((GTK_WIDGET(g_w[windowid]))->window, xsize, ysize);

} // WindowSetSize


void WindowShow(int windowid)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowShow");
#endif

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	gtk_widget_show(GTK_WIDGET(g_w[windowid]));
	gtk_window_present(GTK_WINDOW(g_w[windowid])); // raises window... only on gtk2

} // WindowShow


void WindowSetTitle(int windowid, machar *title)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowSetTitle");
#endif
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		masprintf(mastr, MAXLOGLINELEN, L"WindowSetTitle null window %d", windowid);
		maLog(mastr);
		return;
	}

	gtk_window_set_title(GTK_WINDOW(g_w[windowid]), ma2fs(fsstr, title));

	while(gtk_events_pending())
	 	gtk_main_iteration();
		
} // WindowSetTitle


void WindowActivate(int windowid)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowActivate");
#endif

	WindowShow(windowid);
	
} // WindowActivate


int maDirSelector(fschar *selectedpath, machar *prompt)
{
#ifdef MATRACEGUIGTK
	maTrace("maDirSelector");
#endif

	int l;
	fschar *p;
	fschar fpath[MAX_PATH];
	
	if(selectedpath && selectedpath[0] != fsT('\0')) // default dir
		p = selectedpath;
	else
		p = NULL;

	for (; ;)
	{
		if(maFileDialog(fpath, WINDOWAPP, prompt, p, NULL, NULL, 0))
			return 1;
		
		if((p = fsstrstr(fpath, "(null)")))
			*p = fsT('\0'); // user accepted empty default
		
		if(maDirExists(fpath))
			break;
	}
	
	if((p = fsstrstr(fpath, "../")))
		*p = fsT('\0'); // remove trailing "../"
		
	if((p = fsstrstr(fpath, "./")))
		*p = fsT('\0'); // remove trailing "./"
	
	if((l = fsstrlen(fpath) - 1) < 0)
		return 1;

	if(fpath[l] == FILESEP)
		fpath[l] = fsT('\0'); // remove trailing '/'
		
	fsstrcpy(selectedpath, fpath);
	
	return 0;
	
} // maDirSelector


void filesel_ok_callback(GtkWidget *w, int *selected)
{
#ifdef MATRACEGUIGTK
	maTrace("filesel_ok_callback");
#endif
  *selected = 1;
}


void filesel_cancel_callback(GtkWidget *w, int *selected)
{
#ifdef MATRACEGUIGTK
	maTrace("filesel_cancel_callback");
#endif
  *selected = 0;
}


GtkWidget *l_filesel = NULL;
int maFileDialog(fschar *selectedpath, int windowid, machar *prompt, fschar *defdir, machar *deffile, machar *wildcard, int flags)
{
#ifdef MATRACEGUIGTK
	maTrace("maFileDialog");
#endif
	int selected = 0;
	fschar deffilepath[MAX_PATH];
	fschar fsstr[MAXLOGLINELEN];
	machar mastr2[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];

	if(!selectedpath)
	{
		maLog(L"maFileDialog null selectedpath parameter");
		return 1;
	}

	if(!l_filesel)
	{
		selected = -1;
		l_filesel = gtk_file_selection_new(ma2fs(fsstr, prompt));
		gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(l_filesel));
		gtk_window_set_position(GTK_WINDOW(l_filesel), GTK_WIN_POS_NONE); // GTK_WIN_POS_MOUSE);
		if(defdir != NULL)
		{
			fssprintf(deffilepath, MAX_PATH, fsS fsC, defdir, FILESEP);
			if(deffile != NULL)
				fsstrcat(deffilepath, ma2fs(fsstr, deffile));
			gtk_file_selection_set_filename(GTK_FILE_SELECTION(l_filesel), deffilepath);
		}
		gtk_signal_connect(GTK_OBJECT(l_filesel), "destroy",
			GTK_SIGNAL_FUNC(gtk_widget_destroyed), &l_filesel);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(l_filesel)->ok_button), "clicked",
			GTK_SIGNAL_FUNC(filesel_ok_callback), (gpointer)&selected);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(l_filesel)->cancel_button), "clicked",
			GTK_SIGNAL_FUNC(filesel_cancel_callback), (gpointer)&selected);
	}
	
	for (; ;)
	{
		if(!GTK_WIDGET_VISIBLE(l_filesel))
		{
			gtk_widget_show(l_filesel);
			while(selected == -1)
				gtk_main_iteration();
		}
		else
		{
			if(l_filesel)
			{
				gtk_widget_destroy(l_filesel);
				l_filesel = NULL;
			}
			return 1;
		}
	
		if(selected == 1)
		{
			if(fsstrlen(gtk_file_selection_get_filename(GTK_FILE_SELECTION(l_filesel))) >= MAX_PATH)
			{
				masprintf(mastr, MAXLOGLINELEN, L"maFileDialog filepath > max %d : %zu", MAX_PATH - 1,
								mastrlen(fs2ma(mastr2, (fschar *)gtk_file_selection_get_filename(GTK_FILE_SELECTION(l_filesel)))));
				maLog(mastr);
				mastrncpy(mastr, fs2ma(mastr2, (fschar *)gtk_file_selection_get_filename(GTK_FILE_SELECTION(l_filesel))), MAXLOGLINELEN - 1);
				mastr[MAXLOGLINELEN - 1] = L'\0';
				maLog(mastr);
				if(l_filesel)
				{
					gtk_widget_destroy(l_filesel);
					l_filesel = NULL;
				}
				return 1;
			}
			
			fsstrcpy(selectedpath, (fschar *)gtk_file_selection_get_filename(GTK_FILE_SELECTION(l_filesel)));
			if(flags & maOVERWRITE_PROMPT)
			{
				if(maFileExists(selectedpath))
				{
					masprintf(mastr, MAXLOGLINELEN, L"This file already exists and will be overwritten'%ls%ls%ls'",
																			g_maeol, g_maeol, fs2ma(mastr2, selectedpath));
					if(maMessageBox(mastr, L"CONTINUE ?", maYES_NO | maICON_QUESTION) != maYES)
						continue;
				}
			}
	
			if(l_filesel)
			{
				gtk_widget_destroy(l_filesel);
				l_filesel = NULL;
			}

			return 0;
		}
		
		if(l_filesel)
		{
			gtk_widget_destroy(l_filesel);
			l_filesel = NULL;
		}
		
		return 1; // cancelled
		
	} // while 1
	
} // maFileDialog


void maFileDialogMFree(maArray *parray)
{
#ifdef MATRACEGUIGTK
	maTrace("maFileDialogMFree");
#endif

	int i;
	
	if(!parray)
		return;
	if(parray->pitems)
	{
		for(i = 0; i < parray->nitems; i++)
			if(parray->pitems[i])
				MAFREE(parray->pitems[i]);
		MAFREE(parray->pitems);
		parray->pitems = NULL;
	}
	parray->nitems = 0;
}


// called from maFileDialogM for multiple selections
fschar l_defaultLocation[MAX_PATH] = fsT("");
int maFileDialogMM(gchar*** selectedpaths, int windowid, machar *prompt, fschar *defdir, machar *deffile, machar *wildcard, int flags)
{
#ifdef MATRACEGUIGTK
	maTrace("maFileDialogMM");
#endif
	int ret;
	int selected = 0;
	fschar deffilepath[MAX_PATH];
	fschar fsstr[MAXLOGLINELEN];

	if(!selectedpaths)
	{
		maLog(L"maFileDialogMM null selectedpaths parameter");
		return 1;
	}

	if(!l_filesel)
	{
		selected = -1;
		l_filesel = gtk_file_selection_new(ma2fs(fsstr, prompt)); // deprecated, need FileChooser here
		gtk_file_selection_set_select_multiple(GTK_FILE_SELECTION(l_filesel), TRUE);
		gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(l_filesel));
		gtk_window_set_position(GTK_WINDOW(l_filesel), GTK_WIN_POS_NONE); // GTK_WIN_POS_MOUSE);
		if(defdir != NULL)
		{
			fssprintf(deffilepath, MAX_PATH, fsS fsC, defdir, FILESEP);
			if(deffile != NULL)
				fsstrcat(deffilepath, ma2fs(fsstr, deffile));
			gtk_file_selection_set_filename(GTK_FILE_SELECTION(l_filesel), deffilepath);
		}
		gtk_signal_connect(GTK_OBJECT(l_filesel), "destroy",
			GTK_SIGNAL_FUNC(gtk_widget_destroyed), &l_filesel);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(l_filesel)->ok_button), "clicked",
			GTK_SIGNAL_FUNC(filesel_ok_callback), (gpointer)&selected);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(l_filesel)->cancel_button), "clicked",
			GTK_SIGNAL_FUNC(filesel_cancel_callback), (gpointer)&selected);
	}
	
	*selectedpaths = NULL;
	
	for (; ;)
	{
		if(!GTK_WIDGET_VISIBLE(l_filesel))
		{
			gtk_widget_show(l_filesel);
			while(selected == -1)
				gtk_main_iteration();
		}
		else
		{
			if(l_filesel)
			{
				gtk_widget_destroy(l_filesel);
				l_filesel = NULL;
			}
			return 1;
		}
	
		if(selected == 1)
		{
			ret = 1; // nok
			if(l_filesel)
			{
				*selectedpaths = gtk_file_selection_get_selections(GTK_FILE_SELECTION(l_filesel));
				ret = 0;
				gtk_widget_destroy(l_filesel);
				l_filesel = NULL;
			}
			return ret;
		}
		
		if(l_filesel)
		{
			gtk_widget_destroy(l_filesel);
			l_filesel = NULL;
		}
		
		return 1; // cancelled
		
	} // while 1
	
} // maFileDialogMM


int maFileDialogM(maArray *parray, int windowid, machar *prompt, fschar *defdir, machar *deffile, machar *wildcard, int flags)
{
#ifdef MATRACEGUIGTK
	maTrace("maFileDialogM");
#endif

	long i;
	long theCount;
	int ret = 0;
	fschar fpath[MAX_PATH + MAX_PATH];
	machar mastr2[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if(!parray)
	{
		maLog(L"maFileDialogM null parray parameter");
		return 1;
	}
	parray->nitems = 0;
	parray->pitems = NULL;

	if(defdir && defdir[0])
		fsstrcpy(l_defaultLocation, defdir);
	else
		l_defaultLocation[0] = fsT('\0');

	char **p;
	if(maFileDialogMM(&p, WINDOWAPP, prompt, defdir, deffile, wildcard, flags))
		goto maFileDialogMErr; // cancelled

	if(p == NULL)
		goto maFileDialogMErr; // no selection
		
	theCount = 0;
	char **pp = p;
	while(*pp++)
		theCount++;

	parray->nitems = theCount;

	if((parray->pitems = (fschar **)MAMALLOC((theCount + 1) * sizeof(fschar *))) == NULL)
	{
		g_strfreev(p);
		maLog(L"maFileDialogM MAMALLOC failed");
		goto maFileDialogMErr;
	}
	
	for(i = 0; i < theCount; i++)
	{
		fsstrcpy(fpath, p[i]);
		if(fsstrlen(fpath) >= MAX_PATH)
		{
			masprintf(mastr, MAXLOGLINELEN, L"maFileDialogM filepath > max %d : %zu", MAX_PATH - 1, fsstrlen(fpath));
			maLog(mastr);
			mastrncpy(mastr, fs2ma(mastr2, fpath), MAXLOGLINELEN - 1);
			mastr[MAXLOGLINELEN - 1] = L'\0';
			maLog(mastr);
			continue;
		}
		
		if((parray->pitems[i] = (fschar *)MAMALLOC(fsstrlen(fpath) + 1)) == NULL)
		{
			g_strfreev(p);
			maFileDialogMFree(parray);
			maLog(L"maFileDialogM MAMALLOC failed");
			goto maFileDialogMErr;
		}
		fsstrcpy(parray->pitems[i], fpath);
	}

	g_strfreev(p);
	
	goto maFileDialogMNoErr;
		
maFileDialogMErr:
	ret = 1;
	
maFileDialogMNoErr:

	return ret;

} //maFileDialogM


GtkWidget *l_msgbox = NULL;
void msgbox_no_callback(GtkWidget *widget, int *ok)
{
	*ok = 0;
}


void msgbox_yes_callback(GtkWidget *widget, int *ok)
{
	*ok = 1;
}


int maMessageBox(machar *s1, machar *s2, int flags)
{
#ifdef MATRACEGUIGTK
	maTrace("maMessageBox");
#endif
	int ok = -1;
	GtkWidget *label;
	GtkWidget *button;
	machar *labelyes = L"Yes";
	machar *labelno = L"No";
	machar lstr[STRLEN512];
	fschar fsstr[MAXLOGLINELEN];
	
	masprintf(lstr, STRLEN512, L"%ls%ls%ls%ls", s2, g_maeol, g_maeol, s1);

	if(!l_gtkinited)
		magtkinit();
	
	if((flags & maOK) == maOK)
		labelyes = L"Ok";

	if(!l_msgbox)
	{
		l_msgbox = gtk_dialog_new();
		gtk_signal_connect(GTK_OBJECT(l_msgbox), "destroy",
			GTK_SIGNAL_FUNC(gtk_widget_destroyed), &l_msgbox);

		gtk_window_set_title(GTK_WINDOW(l_msgbox), ma2fs(fsstr, g_prognametitle));
		gtk_container_set_border_width(GTK_CONTAINER(l_msgbox), 0);
		gtk_widget_set_usize(l_msgbox, 400, 200);

		label = gtk_label_new(ma2fs(fsstr, lstr));
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(l_msgbox)->vbox), label, TRUE, TRUE, 0);
		gtk_widget_show(label);

		button = gtk_button_new_with_label(ma2fs(fsstr, labelyes));

		if((flags & maOK) == maOK)
			gtk_widget_set_name(button, "mabuttonOk");
		else
			gtk_widget_set_name(button, "mabuttonYes");
		gtk_signal_connect(GTK_OBJECT(button), "clicked",
			GTK_SIGNAL_FUNC(msgbox_yes_callback), (gpointer)&ok);
		GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(l_msgbox)->action_area), button, TRUE, TRUE, 0);
		gtk_widget_show(button);

		if((flags & maYES_NO) == maYES_NO)
		{
			button = gtk_button_new_with_label(ma2fs(fsstr, labelno));
			gtk_widget_set_name(button, "mabuttonNo");
			gtk_signal_connect(GTK_OBJECT(button), "clicked",
				GTK_SIGNAL_FUNC(msgbox_no_callback), (gpointer)&ok);
			GTK_WIDGET_SET_FLAGS(button,GTK_CAN_DEFAULT);
			gtk_box_pack_start(GTK_BOX(GTK_DIALOG(l_msgbox)->action_area), button, TRUE, TRUE, 0);
			gtk_widget_show(button);
		}
		
		gtk_widget_grab_default(button);
	}

	if(!GTK_WIDGET_VISIBLE(l_msgbox))
	{
		gtk_widget_show(l_msgbox);
		while(ok == -1)
			gtk_main_iteration();
	}
	else
	{
		if(l_msgbox)
		{
			gtk_widget_destroy(l_msgbox);
			l_msgbox = NULL;
		}
		return 0;
	}

	if(l_msgbox)
	{
		gtk_widget_destroy(l_msgbox);
		l_msgbox = NULL;
	}
	
	return (ok == 1) ? maYES : maNO;
	
} // maMessageBox


void AboutWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("AboutWindowMake");
#endif

	static GtkWidget *gtkwindow = NULL;
	GtkWidget *box1;
	GtkWidget *box2;
	GtkWidget *hbox;
	GtkWidget *button;
	GtkWidget *separator;
	GtkWidget *scrolled_window;
	GtkWidget *text;
	GtkWidget *entry;
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];	

	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);
	
 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWABOUT << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((WINDOWABOUT << 8) + maGDK_CONFIGURE));
	
	g_w[WINDOWABOUT] = gtkwindow;

	masprintf(mastr, MAXLOGLINELEN, L"About %ls", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, mastr));

	gtk_container_set_border_width(GTK_CONTAINER(gtkwindow), 0);

	box1 = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(gtkwindow), box1);

	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 0);

	scrolled_window = gtk_scrolled_window_new(NULL, NULL);
	gtk_box_pack_start(GTK_BOX(box2), scrolled_window, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
		GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	text = gtk_text_view_new();
	GtkTextBuffer *buffer = gtk_text_view_get_buffer((GtkTextView *)text);
	GtkTextIter iter;
	gtk_text_buffer_get_start_iter(buffer, &iter);
	gtk_text_buffer_create_mark(buffer, "ShowPosition", &iter, TRUE);	
	gtk_text_view_set_wrap_mode((GtkTextView *)text, GTK_WRAP_WORD_CHAR);
	gtk_text_view_set_editable((GtkTextView *)text, FALSE);

	gtk_container_add(GTK_CONTAINER(scrolled_window), text);

	gtk_widget_freeze_child_notify(text);

	// convert machar text to SystemEncoding
	char *p1;
	if((p1 = (char *)MAMALLOC((mastrlen(g_abouttext) + 8) * 4)) == NULL) // max sizeof(UniChar) or max sizeof(UTF-8)
	{
		maLog(L"AboutWindowMake MAMALLOC failed");
		// return;
	}
	else
	{
		ma2fs(p1, g_abouttext);
		size_t len2 = fsstrlen(p1);
		gtk_text_buffer_insert(buffer, &iter, p1, len2);
		MAFREE(p1);
	}
	gtk_widget_thaw_child_notify(text);
	
	hbox = gtk_hbutton_box_new();
	gtk_box_pack_start(GTK_BOX(box2), hbox, FALSE, FALSE, 0);

	separator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1), separator, FALSE, TRUE, 0);

	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box2, FALSE, TRUE, 0);

	entry = gtk_entry_new_with_max_length(128);
	gtk_entry_set_text(GTK_ENTRY(entry), ma2fs(fsstr, MOREAMP_HOME_URL));
	gtk_container_add(GTK_CONTAINER(box2), entry);

	button = gtk_button_new_with_label(ma2fs(fsstr, L"Close"));
	gtk_widget_set_name(button, "mabuttonClose");
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(aboutviewercallback), (gpointer)WINDOWABOUT);
	gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 0);
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);

	gtk_widget_set_uposition(gtkwindow,
		g_sets.mawin[WINDOWABOUT].xpos[g_sets.winconf], g_sets.mawin[WINDOWABOUT].ypos[g_sets.winconf]);
	gtk_widget_set_usize(gtkwindow,
		g_sets.mawin[WINDOWABOUT].xsize[g_sets.winconf], g_sets.mawin[WINDOWABOUT].ysize[g_sets.winconf]);
	
	gtk_widget_set_name(text, "matextViewer");

	gtk_widget_show_all(gtkwindow);
	
	return;

} // AboutWindowMake


#if !defined(NOTEXTVIEWER)
 gint ViewerWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
 {
 #ifdef MATRACEGUIGTK
  maTrace("ViewerWindowEventHandler");
 #endif

	maviewer *v;
	int evtype = (int)data & 0xff;
	int windowid = (int)data >> 8;

	switch(evtype)
	{
		case maBUTTONFIND:
			ViewerOnButtonFind(windowid);
		break;
		
		case maBUTTONVPLAY:
			ViewerOnButtonPlay(windowid);
		break;
		
		case maBUTTONEDIT:
			ViewerOnButtonEditSave(windowid);
		break;
		
		case maBUTTONCLOSE:
			DoWindow(windowid, 0);
		break;
		
		case maENTRYKEYPRESS:
			if(event->type == GDK_KEY_PRESS)
			{
				if(!(v = Viewer(windowid)))
				{
					maLog(L"ViewerWindowEventHandler maENTRYKEYPRESS Viewer failed");
					return(FALSE);
				}
				if(v->editable)
					return(FALSE); // event not handled // don't handle anyhting here while editing
				OnViewerKeyPressed(windowid, widget, ((GdkEventKey *)event)->keyval);
			}
		break;

		case maMOUSEBUTTON:
			if(event->type == GDK_BUTTON_PRESS)
			{
				if(((GdkEventButton *)event)->button == 1) // normal processing for left mouse buttton
					return(FALSE);
				if(!(v = Viewer(windowid)))
				{
					maLog(L"ViewerWindowEventHandler GDK_BUTTON_RELEASE Viewer failed");
					return(FALSE);
				}
				if(v->editable)
					return(FALSE); // normal processing while editing (e.g. textview popup menu)
				return(TRUE); // we do nothing with right button press
			}
			else if(event->type == GDK_BUTTON_RELEASE)
			{
				if(!(v = Viewer(windowid)))
				{
					maLog(L"ViewerWindowEventHandler GDK_BUTTON_RELEASE Viewer failed");
					return(FALSE);
				}
				if(v->editable)
					return(FALSE); // don't handle anyhting here while editing (allow edit popup menu)
				if(((GdkEventButton *)event)->button < 4) // 4 and 5 are mouse wheel
				{
					if(((GdkEventButton *)event)->button == 1)
						ViewerOnLeftClick(windowid);
					else
						ViewerOnRightClick(windowid);
				}
			}
		break;

		default:
 #ifdef MATRACEGUIGTK
 {
 machar mastr[MAXLOGLINELEN];
 masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowEventHandler default windowid=%d maevent=%d", windowid, evtype);
 maTrace(mastr);
 }
 #endif
		break;
	}
	
	return(FALSE); // event not handled, propagate the event further
	
 } // ViewerWindowEventHandler


 void OnViewerKeyPressed(int windowid, void *widget, int keyval)
 {
	maviewer *v;

	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"OnViewerKeyPressed Viewer failed", windowid, keyval);
		return;
	}
	
	if(v->editable || widget == v->text)
		return;
		
	if(keyval == GDK_Return) // 0xFF0D)
		ViewerOnButtonFind(windowid);
		
	if(keyval == GDK_Escape)
		WindowActivate(WINDOWAPP);

 } // OnViewerKeyPressed


 void viewerbuttoncallback(GtkWidget *widget, gpointer callback_data)
 {
 #ifdef MATRACEGUIGTK
	maTrace("viewerbuttoncallback");
 #endif
	ViewerWindowEventHandler(widget, NULL, callback_data);
 }


 int ViewerWindowMake(int windowid, machar *wintitle)
 {
	int idx;
	int id;
	maviewer *v;
	fschar *fsp;
	static GtkWidget *gtkwindow = NULL;
	GtkWidget *box1;
	GtkWidget *box2;
	GtkWidget *box3;
	GtkWidget *hbox;
	GtkWidget *button;
	GtkWidget *separator;
	GtkWidget *scrolled_window;
	GtkWidget *text;
	GtkWidget *fixed;
	GtkWidget *entry;
	char name[STRLEN64];
	fschar fsstr[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	gtkwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(gtkwindow), TRUE, TRUE, FALSE);

 	gtk_signal_connect(GTK_OBJECT(gtkwindow), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((windowid << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(gtkwindow), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)((windowid << 8) + maGDK_CONFIGURE));
	
	g_w[windowid] = gtkwindow;

	gtk_container_set_border_width(GTK_CONTAINER(gtkwindow), 0);

	box1 = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(gtkwindow), box1);

	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 0);

	scrolled_window = gtk_scrolled_window_new(NULL, NULL);
	gtk_box_pack_start(GTK_BOX(box2), scrolled_window, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
		GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	text = gtk_text_view_new();
	GtkTextBuffer *buffer = gtk_text_view_get_buffer((GtkTextView *)text);
	GtkTextIter iter;
	gtk_text_buffer_get_start_iter(buffer, &iter);
	gtk_text_buffer_create_mark(buffer, "ShowPosition", &iter, TRUE);	
	gtk_text_view_set_wrap_mode((GtkTextView *)text, GTK_WRAP_WORD_CHAR); // GTK_WRAP_WORD GTK_WRAP_NONE) GTK_WRAP_CHAR 
	gtk_text_view_set_editable((GtkTextView *)text, FALSE); // unset edit mode
	gtk_container_add(GTK_CONTAINER(scrolled_window), text);

	gtk_signal_connect(GTK_OBJECT(text), "button_press_event",
						GTK_SIGNAL_FUNC(ViewerWindowEventHandler),
						(gpointer)((windowid << 8) + maMOUSEBUTTON));
	gtk_signal_connect(GTK_OBJECT(text), "button_release_event",
						GTK_SIGNAL_FUNC(ViewerWindowEventHandler),
						(gpointer)((windowid << 8) + maMOUSEBUTTON));
	gtk_signal_connect(GTK_OBJECT(text), "key_press_event",
						GTK_SIGNAL_FUNC(ViewerWindowEventHandler),
						(gpointer)((windowid << 8) + maENTRYKEYPRESS));

	// gtk_text_view_set_editable((GtkTextView *)text, FALSE);
	
	hbox = gtk_hbutton_box_new();
	gtk_box_pack_start(GTK_BOX(box2), hbox, FALSE, FALSE, 0);

	separator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1), separator, FALSE, TRUE, 0);

	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box2, FALSE, TRUE, 0);

	entry = gtk_entry_new_with_max_length(128);
	gtk_container_add(GTK_CONTAINER(box2), entry);
	gtk_signal_connect(GTK_OBJECT(entry), "key_press_event",
		GTK_SIGNAL_FUNC(ViewerWindowEventHandler),
		(gpointer)((windowid << 8) + maENTRYKEYPRESS));
	separator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1), separator, FALSE, TRUE, 0);

	box3 = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box3, FALSE, TRUE, 0);

	fixed = gtk_fixed_new();
	gtk_box_pack_start(GTK_BOX(box3), fixed, TRUE, TRUE, 0);

	button = gtk_button_new_with_label(ma2fs(fsstr, L"Find"));
	gtk_widget_set_name(button, "mabuttonFind");
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(viewerbuttoncallback),
		(gpointer)((windowid << 8) + maBUTTONFIND));
	gtk_fixed_put(GTK_FIXED(fixed), button, XBASE, 0);
	gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);
	id = IdByWindow(windowid, ID_BTN_VIEWERFIND);
	if((idx = PushButtonIndexFromId(windowid, id)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake PushButtonIndexFromId %d failed, window=%d", ID_BTN_VIEWERFIND, windowid);
		maLog(mastr);
	}
	else
	{
		l_button[idx].id = id;
		l_button[idx].btn = button;
		l_button[idx].skip = 0;
	}

	l_fixed = fixed;
	MakeText(1, IdByWindow(windowid, ID_TEXT_VIEWERFOUND), L"", MABUTTONWDEF + 6, 5, 0);
	gtk_widget_set_name(text, "matext");
	
	if(windowid == WINDOWCATALOG) // || WINDOWPLAYLIST play button in playlist viewer
	{
		button = gtk_button_new_with_label(ma2fs(fsstr, L"Play"));
		gtk_widget_set_name(button, "mabuttonPlay");
		gtk_signal_connect(GTK_OBJECT(button), "clicked",
			GTK_SIGNAL_FUNC(viewerbuttoncallback),
			(gpointer)((windowid << 8) + maBUTTONVPLAY));
		gtk_fixed_put(GTK_FIXED(fixed), button, MABUTTONWDEF + 70, 0);
		gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);
		id = IdByWindow(windowid, ID_BTN_VIEWERPLAY);
		if((idx = PushButtonIndexFromId(windowid, id)) < 0)
		{
			masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake PushButtonIndexFromId %d failed, window=%d", ID_BTN_VIEWERPLAY, windowid);
			maLog(mastr);
		}
		else
		{
			l_button[idx].id = id;
			l_button[idx].btn = button;
			l_button[idx].skip = 0;
		}

		MakeText(1, ID_TEXT_VIEWERPLAY, L"", MABUTTONWDEF + MABUTTONWDEF + 76, 5, 0);
		gtk_widget_set_name(text, "matext");
	}
	
	fixed = gtk_fixed_new();
	gtk_box_pack_start(GTK_BOX(box3), fixed, FALSE, FALSE, 0);

	/*
	l_ButtonPos = XBASE;
	l_buttonTop = 0; // + MENUBARH;
	MakeButton(windowid, ID_BTN_EDITSAVE, LABEL_EDIT);
	*/
	button = gtk_button_new_with_label(ma2fs(fsstr, LABEL_EDIT));
	strcpy(name, "mabuttonEdit"); // sprintf(name, "mabutton%s", "Edit");
	gtk_widget_set_name(button, name);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(viewerbuttoncallback),
		(gpointer)((windowid << 8) + maBUTTONEDIT));
	gtk_fixed_put(GTK_FIXED(fixed), button, XBASE, 0);
	gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);
	id = IdByWindow(windowid, ID_BTN_EDITSAVE);
	if((idx = PushButtonIndexFromId(windowid, id)) < 0)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake PushButtonIndexFromId %d failed, window=%d", ID_BTN_EDITSAVE, windowid);
		maLog(mastr);
	}
	else
	{
		l_button[idx].id = id;
		l_button[idx].btn = button;
		l_button[idx].skip = 0;
	}
	
	button = gtk_button_new_with_label(ma2fs(fsstr, L"Close"));
	gtk_widget_set_name(button, "mabuttonClose");
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(viewerbuttoncallback),
		(gpointer)((windowid << 8) + maBUTTONCLOSE));
	gtk_fixed_put(GTK_FIXED(fixed), button, MABUTTONWDEF + 10, 0);
	gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);

	gtk_window_set_title(GTK_WINDOW(gtkwindow), ma2fs(fsstr, wintitle));

 #if defined(MAKEYBOARD)
	if(windowid == WINDOWKEYBINDINGS)
	{
		gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWKEYBINDINGS].xpos[g_sets.winconf], g_sets.mawin[WINDOWKEYBINDINGS].ypos[g_sets.winconf]);
		gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWKEYBINDINGS].xsize[g_sets.winconf], g_sets.mawin[WINDOWKEYBINDINGS].ysize[g_sets.winconf]);
	}
	else
 #endif
	if(windowid == WINDOWCATALOG)
	{
		gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWCATALOG].xpos[g_sets.winconf], g_sets.mawin[WINDOWCATALOG].ypos[g_sets.winconf]);
		gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWCATALOG].xsize[g_sets.winconf], g_sets.mawin[WINDOWCATALOG].ysize[g_sets.winconf]);
	}
	else if(windowid == WINDOWPLAYLIST)
	{
		gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWPLAYLIST].xpos[g_sets.winconf], g_sets.mawin[WINDOWPLAYLIST].ypos[g_sets.winconf]);
		gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWPLAYLIST].xsize[g_sets.winconf], g_sets.mawin[WINDOWPLAYLIST].ysize[g_sets.winconf]);
	}
	else if(windowid == WINDOWREADME)
	{
		gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWREADME].xpos[g_sets.winconf], g_sets.mawin[WINDOWREADME].ypos[g_sets.winconf]);
		gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWREADME].xsize[g_sets.winconf], g_sets.mawin[WINDOWREADME].ysize[g_sets.winconf]);
	}
	else // WINDOWLOG
	{
		gtk_widget_set_uposition(gtkwindow, g_sets.mawin[WINDOWLOG].xpos[g_sets.winconf], g_sets.mawin[WINDOWLOG].ypos[g_sets.winconf]);
		gtk_widget_set_usize(gtkwindow, g_sets.mawin[WINDOWLOG].xsize[g_sets.winconf], g_sets.mawin[WINDOWLOG].ysize[g_sets.winconf]);
	}
	
	gtk_widget_set_name(text, "matextViewer");

	fsp = ma2fs(fsstr, MALOADINGSTRING);
	gtk_text_buffer_insert(buffer, &iter, fsp, fsstrlen(fsp));
	
	if(!(v = Viewer(windowid)))
	{
		maLog(L"ViewerWindowMake Viewer failed");
		ViewerEnable(windowid, v);
		return 1;
	}

	v->text = text;
	v->entry = entry;
	v->buffer = buffer;
	
	gtk_widget_show_all(gtkwindow);
	
	return ViewerInit(windowid, &v);
	
 } // ViewerWindowMake
#endif


void aboutviewercallback(GtkWidget *widget, gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("aboutviewercallback");
#endif

	 DoWindow(WINDOWABOUT, 0);
}


void maGUIfree()
{
#ifdef MATRACEGUIGTK
	maTrace("maGUIfree");
#endif
} // maGUIfree


void maGUIQuit()
{
#ifdef MATRACEGUIGTK
	maTrace("maGUIQuit");
#endif
	gtk_main_quit();

} // maGUIQuit


int maModKeyDown() // the mouse mod1 key or shift key
{
	int x, y;
	unsigned int m;
	gdk_window_get_pointer(NULL, &x, &y, &m);

	//if(m & GDK_BUTTON3_MASK) // GDK_BUTTON1_MASK = 1 << 8, GDK_BUTTON2_MASK = 1 << 9, GDK_BUTTON3_MASK = 1 << 10,
	// if(m & (1 << 3))  // if(m & GDK_MOD1_MASK) // normally Alt key
	// if(m & (1 << 0))  // if(m & GDK_SHIFT_MASK)
	// if(m & (1 << 9))  // if(m & GDK_BUTTON2_MASK)
	// if(m & (1 << 10)) // if(m & GDK_BUTTON3_MASK)

	if((m & GDK_MOD1_MASK) || // normally the Alt key
		(m & GDK_SHIFT_MASK)) // shift key, in case MOD1 doesn't work, like on MACUNIX/GTK2
		return 1;

	return 0;
	
} // maModKeyDown

#ifdef __cplusplus
}
#endif

#endif // MAGUIGTK2

// eof
