// maGUIosx.cpp

/*
 * MoreAmp
 * Copyright (C) 2004-2014 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "maConfig.h" // included by all moreamp files

// on os x 10.4 avoid compilation warnings such as:
// 'InitCursor' is Deprecated (declared at /System/Library/Frameworks/ApplicationServices.framework/Frameworks/QD.framework/Headers/Quickdraw.h:2059)
#ifndef MAC_OS_X_VERSION_MIN_REQUIRED
    #define MAC_OS_X_VERSION_MIN_REQUIRED MAC_OS_X_VERSION_10_2
#endif
 
// This file contains the code to run with the native osx carbon (Interface Builder) gui.

#if defined(MAGUICARBON)

// #define MATRACEGUIOSX

#include <stdio.h>
#include <string.h>
#include <Events.h>

#include "maGUI.h"
#include "maUtils.h"
#include "maPlayer.h"
#include "maSongList.h"
#include "maMemFile.h"
#include "maTextView.h"

#ifdef __cplusplus
extern "C"
{
#endif

EventLoopTimerRef l_timerchangeplaylist;
EventLoopTimerRef l_timerplayplaylist;
EventLoopTimerRef l_timerrunloop;
EventLoopTimerRef l_timerplay;
// EventLoopTimerRef l_timerstop;

UInt32 l_commandid[ID_MENU_LAST + 1] = {NULL};
int menuchecked[ID_MENU_LAST + 1] = {0}; // keep track of checked menu items here because don't know how to query for checked state 
int g_linenum = 0;
int l_llinemax = 0;
char *l_lline;

#if defined(ENCODEMP3)
 #define MAOSXFILEOUTMP3 fsT("maosxFileOutMp3")
#endif
#if defined(ENCODEOGG)
 #define MAOSXFILEOUTOGG fsT("maosxFileOutOgg")
#endif
#if defined(ENCODEAIF)
 #define MAOSXFILEOUTAIF fsT("maosxFileOutAif")
#endif
#if defined(ENCODEWAV)
 #define MAOSXFILEOUTWAV fsT("maosxFileOutWav")
#endif
#if defined(ENCODERAW)
 #define MAOSXFILEOUTRAW fsT("maosxFileOutRaw")
#endif
#if defined(ENCODEAAC)
 #define MAOSXFILEOUTAAC fsT("maosxFileOutAac")
#endif
#if defined(ENCODEMP4)
 #define MAOSXFILEOUTMP4 fsT("maosxFileOutMp4")
#endif
#if defined(ENCODEWMA)
 #define MAOSXFILEOUTWMA fsT("maosxFileOutWma")
#endif		
#if defined(ENCODEFLAC)
 #define MAOSXFILEOUTFLAC fsT("maosxFileOutFlac")
#endif

#if defined(ENCODEMP3)
 fschar *l_pnibfile = MAOSXFILEOUTMP3;
#elif defined(ENCODEOGG)
 fschar *l_pnibfile = MAOSXFILEOUTOGG;
#elif defined(ENCODEAIF)
 fschar *l_pnibfile = MAOSXFILEOUTAIF;
#elif defined(ENCODEWAV)
 fschar *l_pnibfile = MAOSXFILEOUTWAV;
#elif defined(ENCODERAW)
 fschar *l_pnibfile = MAOSXFILEOUTRAW;
#elif defined(ENCODEAAC)
 fschar *l_pnibfile = MAOSXFILEOUTAAC;
#elif defined(ENCODEMP4)
 fschar *l_pnibfile = MAOSXFILEOUTMP4;
#elif defined(ENCODEWMA)
 fschar *l_pnibfile = MAOSXFILEOUTWMA;
#elif defined(ENCODEFLAC)
 fschar *l_pnibfile = MAOSXFILEOUTFLAC;
#else
 fschar *l_pnibfile = fsT("");
#endif

#define kListSpacer1 54 // room for buttons and keybindings text

OSStatus CommandEventHandler(HICommandExtended *command, int windowid, Rect *r);
OSStatus AppWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus ListWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus FileOutWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus EffectsWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus EqualizerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus Equalizer2WindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
#if !defined(NOTEXTVIEWER)
 OSStatus ViewerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
 OSStatus ViewerEditTextHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
 OSStatus ViewerFindEditTextHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
 void ViewerScrollerActionProc(ControlRef controlRef, ControlPartCode partCode);
 OSStatus ViewerMouseWheelHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
#endif
OSStatus AboutWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus PromptNumWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus AdvancedWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);

void SliderCallback(ControlHandle control, SInt16 part);
ControlActionUPP SliderCallbackProc = NewControlActionUPP(SliderCallback);

OSStatus CheckBoxColorCallback(ControlRef inControl, SInt16 inMessage, SInt16 inDrawDepth, Boolean inDrawInColor);
ControlColorUPP CheckBoxColorCallbackProc = NewControlColorUPP(CheckBoxColorCallback);

void SetCommandId();
int MenuToggle(UInt32 commandid);
void WindowGetOrigin(int windowid, int *xpos, int *ypos);
void WindowGetSize(int windowid, int *xsize, int *ysize);
void GetColumn0Width();
int MakeMenus(IBNibRef nibRef);
void MenuDeleteItem(int item);

#define CMD_MENU_ABOUT 'MMAB' // ID_MENU_FIRST
#define CMD_MENU_QUIT 'MFQU'
#define CMD_MENU_OPENLIST 'MFOP'
#define CMD_MENU_MAKELIST 'MFMA'
#define CMD_MENU_SAVELISTAS 'MFSA'
#define CMD_MENU_DELETELIST 'MFDE'
#define CMD_MENU_PLAYFILE 'MFPL'
#define CMD_MENU_OPENRECENT 'MFOE'
#define CMD_MENU_STOP 'MCST'
#define CMD_MENU_PAUSE 'MCPA'
#define CMD_MENU_PREVIOUS 'MCPR'
#define CMD_MENU_PLAY 'MCPL'
#define CMD_MENU_NEXT 'MCNE'
#define CMD_MENU_SETVDISK 'MSSE'
#define CMD_MENU_MULTIPLEINST 'MSMU'
#if defined(MAKEYBOARD)
 #define CMD_MENU_KEYBOARD 'MSUS'
#endif
#if defined(MAMOUSEWHEEL)
 #define CMD_MENU_MOUSEWHEEL 'MSUM'
#endif
#define CMD_MENU_ADVANCED 'MSAD'
#if (!defined(MANOCDA) && defined(__MAUNIX__))
 #define CMD_MENU_SETAUDIOCD 'NULL'
#endif
#define CMD_MENU_SETFACTORY 'MSFA'
#define CMD_MENU_SETDEFAULT 'MSDE'
#define CMD_MENU_SETSAVED 'MSSD'
#define CMD_MENU_SETCOPY 'MSCO'
#define CMD_MENU_SAVEMASETS 'MSSA'
#define CMD_MENU_SAVEMASETSDEFAULT 'MSSF'
#define CMD_MENU_TITLEINFO 'MSTI'
#define CMD_SUBMENU_TITLEINFO1 'MSTL'
#define CMD_SUBMENU_TITLEINFO2 'MSTS'
#define CMD_SUBMENU_TITLEINFO3 'MSTN'
#define CMD_MENU_RANDOM 'MSRA'
#define CMD_MENU_REPTPLAYED 'MSRE'
#define CMD_MENU_LOOPLOADED 'MSLO'
#define CMD_MENU_LOOPLIST 'MSLL'
#define CMD_MENU_AUTOSTART 'MSAU'
#define CMD_MENU_ERRLOGGING 'MSER'
#define CMD_MENU_SINGLEPLAY 'MSSI'
#define CMD_MENU_INPUTMONITOR 'MSHI'
#define CMD_MENU_EQUALIZER 'MSEQ'
#define CMD_MENU_EFFECTS 'MSEF'
#define CMD_MENU_EQEXTRA 'MSEX'
#define CMD_MENU_MONO 'MSMO'
#define CMD_MENU_INVERTRIGHT 'MSIN'
#define CMD_MENU_EQ31BANDS 'MS31'
#define CMD_MENU_ZEROLIST 'MTZE'
#define CMD_MENU_PLAYCD 'MCPC'
#define CMD_MENU_EJECTCD 'MCEC'
#define CMD_MENU_AUDIOIN 'MCAU'
#define CMD_MENU_MAKECATALOG 'MTMA'
#define CMD_MENU_VIEWCATALOG 'MTVI'
#define CMD_MENU_VIEWPLAYLIST 'MTVS'
#define CMD_MENU_VIEWLOG 'MTVW'
#define CMD_MENU_CLEARLOG 'MTCL'
#if defined(MAKEYBOARD)
 #define CMD_MENU_EDITKEYBINDINGS 'MTED'
 #define CMD_MENU_BLANKKEYBINDINGS 'MTBL'
 #define CMD_MENU_FACTORYKEYBINDINGS 'MTFA'
#endif
#define CMD_MENU_RESCANAUDIODEVICES 'MTRE'
#define CMD_MENU_SHOWLIST 'MHLI'
#define CMD_MENU_SHOWEQ 'MHEQ'
#define CMD_MENU_SHOWEFFECTS 'MHEF'
#define CMD_MENU_SHOWFILEOUT 'MHFI'
#define CMD_MENU_ALTSIZE 'MHAL'
#define CMD_MENU_FACTORYSIZE 'MHFA'
#define CMD_MENU_SAVEDSIZE 'MHSA'
#define CMD_MENU_DEFAULTSIZE 'MHDA'
#define CMD_MENU_README 'MHRE' // ID_MENU_LAST
#define CMD_SUBMENU_OPENRECENT1 'MFO0'
#define CMD_SUBMENU_OPENRECENT2 'MFO1'
#define CMD_SUBMENU_OPENRECENT3 'MFO2'
#define CMD_SUBMENU_OPENRECENT4 'MFO3'
#define CMD_SUBMENU_OPENRECENT5 'MFO4'
#define CMD_SUBMENU_OPENRECENT6 'MFO5'
#define CMD_SUBMENU_OPENRECENT7 'MFO6'
#define CMD_SUBMENU_OPENRECENT8 'MFO7'
#define CMD_SUBMENU_OPENRECENT9 'MFO8'
#define CMD_SUBMENU_OPENRECENT10 'MFO9'

void SetCommandId()
{
	l_commandid[ID_MENU_ABOUT] = CMD_MENU_ABOUT; // ID_MENU_FIRST
	l_commandid[ID_MENU_QUIT] = CMD_MENU_QUIT;
	l_commandid[ID_MENU_OPENLIST] = CMD_MENU_OPENLIST;
	l_commandid[ID_MENU_MAKELIST] = CMD_MENU_MAKELIST;
	l_commandid[ID_MENU_SAVELISTAS] = CMD_MENU_SAVELISTAS;
	l_commandid[ID_MENU_DELETELIST] = CMD_MENU_DELETELIST;
	l_commandid[ID_MENU_PLAYFILE] = CMD_MENU_PLAYFILE;
	l_commandid[ID_MENU_OPENRECENT] = CMD_MENU_OPENRECENT;
	l_commandid[ID_SUBMENU_OPENRECENT1] = CMD_SUBMENU_OPENRECENT1;
	l_commandid[ID_SUBMENU_OPENRECENT2] = CMD_SUBMENU_OPENRECENT2;
	l_commandid[ID_SUBMENU_OPENRECENT3] = CMD_SUBMENU_OPENRECENT3;
	l_commandid[ID_SUBMENU_OPENRECENT4] = CMD_SUBMENU_OPENRECENT4;
	l_commandid[ID_SUBMENU_OPENRECENT5] = CMD_SUBMENU_OPENRECENT5;
	l_commandid[ID_SUBMENU_OPENRECENT6] = CMD_SUBMENU_OPENRECENT6;
	l_commandid[ID_SUBMENU_OPENRECENT7] = CMD_SUBMENU_OPENRECENT7;
	l_commandid[ID_SUBMENU_OPENRECENT8] = CMD_SUBMENU_OPENRECENT8;
	l_commandid[ID_SUBMENU_OPENRECENT9] = CMD_SUBMENU_OPENRECENT9;
	l_commandid[ID_SUBMENU_OPENRECENT10] = CMD_SUBMENU_OPENRECENT10;	
	l_commandid[ID_MENU_STOP] = CMD_MENU_STOP;
	l_commandid[ID_MENU_PAUSE] = CMD_MENU_PAUSE;
	l_commandid[ID_MENU_PREVIOUS] = CMD_MENU_PREVIOUS;
	l_commandid[ID_MENU_PLAY] = CMD_MENU_PLAY;
	l_commandid[ID_MENU_NEXT] = CMD_MENU_NEXT;
	l_commandid[ID_MENU_SETVDISK] = CMD_MENU_SETVDISK;
	l_commandid[ID_MENU_MULTIPLEINST] = CMD_MENU_MULTIPLEINST;
#if defined(MAKEYBOARD)
	l_commandid[ID_MENU_KEYBOARD] = CMD_MENU_KEYBOARD;
#endif
#if defined(MAMOUSEWHEEL)
	l_commandid[ID_MENU_MOUSEWHEEL] = CMD_MENU_MOUSEWHEEL;
#endif
	l_commandid[ID_MENU_ADVANCED] = CMD_MENU_ADVANCED;
#if !defined(MANOCDA) && defined(__MAUNIX__) && !defined(MACDAOSX)
	l_commandid[ID_MENU_SETAUDIOCD] = CMD_MENU_SETAUDIOCD;
#endif
	l_commandid[ID_MENU_SETFACTORY] = CMD_MENU_SETFACTORY;
	l_commandid[ID_MENU_SETDEFAULT] = CMD_MENU_SETDEFAULT;
	l_commandid[ID_MENU_SETSAVED] = CMD_MENU_SETSAVED;
	l_commandid[ID_MENU_SETCOPY] = CMD_MENU_SETCOPY;
	l_commandid[ID_MENU_SAVEMASETS] = CMD_MENU_SAVEMASETS;
	l_commandid[ID_MENU_SAVEMASETSDEFAULT] = CMD_MENU_SAVEMASETSDEFAULT;
	l_commandid[ID_MENU_TITLEINFO] = CMD_MENU_TITLEINFO;
	l_commandid[ID_SUBMENU_TITLEINFO1] = CMD_SUBMENU_TITLEINFO1;
	l_commandid[ID_SUBMENU_TITLEINFO2] = CMD_SUBMENU_TITLEINFO2;
	l_commandid[ID_SUBMENU_TITLEINFO3] = CMD_SUBMENU_TITLEINFO3;
	l_commandid[ID_MENU_RANDOM] = CMD_MENU_RANDOM;
	l_commandid[ID_MENU_REPTPLAYED] = CMD_MENU_REPTPLAYED;
	l_commandid[ID_MENU_LOOPLOADED] = CMD_MENU_LOOPLOADED;
	l_commandid[ID_MENU_LOOPLIST] = CMD_MENU_LOOPLIST;
	l_commandid[ID_MENU_AUTOSTART] = CMD_MENU_AUTOSTART;
	l_commandid[ID_MENU_ERRLOGGING] = CMD_MENU_ERRLOGGING;
	l_commandid[ID_MENU_SINGLEPLAY] = CMD_MENU_SINGLEPLAY;
	l_commandid[ID_MENU_INPUTMONITOR] = CMD_MENU_INPUTMONITOR;
	l_commandid[ID_MENU_EQUALIZER] = CMD_MENU_EQUALIZER;
	l_commandid[ID_MENU_EFFECTS] = CMD_MENU_EFFECTS;
	l_commandid[ID_MENU_EQEXTRA] = CMD_MENU_EQEXTRA;
	l_commandid[ID_MENU_MONO] = CMD_MENU_MONO;
	l_commandid[ID_MENU_INVERTRIGHT] = CMD_MENU_INVERTRIGHT;
	l_commandid[ID_MENU_EQ31BANDS] = CMD_MENU_EQ31BANDS;
	l_commandid[ID_MENU_ZEROLIST] = CMD_MENU_ZEROLIST;
	l_commandid[ID_MENU_PLAYCD] = CMD_MENU_PLAYCD;
	l_commandid[ID_MENU_EJECTCD] = CMD_MENU_EJECTCD;
	l_commandid[ID_MENU_AUDIOIN] = CMD_MENU_AUDIOIN;
	l_commandid[ID_MENU_MAKECATALOG] = CMD_MENU_MAKECATALOG;
#if !defined(NOTEXTVIEWER)
	l_commandid[ID_MENU_VIEWCATALOG] = CMD_MENU_VIEWCATALOG;
	l_commandid[ID_MENU_VIEWPLAYLIST] = CMD_MENU_VIEWPLAYLIST;
	l_commandid[ID_MENU_VIEWLOG] = CMD_MENU_VIEWLOG;
#endif
	l_commandid[ID_MENU_CLEARLOG] = CMD_MENU_CLEARLOG;
#if !defined(NOTEXTVIEWER)
 #if defined(MAKEYBOARD)
	l_commandid[ID_MENU_EDITKEYBINDINGS] = CMD_MENU_EDITKEYBINDINGS;
	l_commandid[ID_MENU_BLANKKEYBINDINGS] = CMD_MENU_BLANKKEYBINDINGS;
	l_commandid[ID_MENU_FACTORYKEYBINDINGS] = CMD_MENU_FACTORYKEYBINDINGS;
 #endif
#endif
	l_commandid[ID_MENU_RESCANAUDIODEVICES] = CMD_MENU_RESCANAUDIODEVICES;
	l_commandid[ID_MENU_SHOWLIST] = CMD_MENU_SHOWLIST;
	l_commandid[ID_MENU_SHOWEQ] = CMD_MENU_SHOWEQ;
	l_commandid[ID_MENU_SHOWEFFECTS] = CMD_MENU_SHOWEFFECTS;
	l_commandid[ID_MENU_SHOWFILEOUT] = CMD_MENU_SHOWFILEOUT;
	l_commandid[ID_MENU_ALTSIZE] = CMD_MENU_ALTSIZE;
	l_commandid[ID_MENU_SAVEDSIZE] = CMD_MENU_SAVEDSIZE;
	l_commandid[ID_MENU_DEFAULTSIZE] = CMD_MENU_DEFAULTSIZE;
	l_commandid[ID_MENU_FACTORYSIZE] = CMD_MENU_FACTORYSIZE;
#if !defined(NOTEXTVIEWER)
	l_commandid[ID_MENU_README] = CMD_MENU_README; // ID_MENU_LAST
#endif
}

EventTypeSpec l_TextInputEvents[] = { { kEventClassTextInput, kEventTextInputUnicodeForKeyEvent } };

#ifdef MATRACEGUIOSX || defined(MAMEMTRACE)
 void maTrace(machar *mastr2);
 void maTrace(macharr *mastr2)
 {
	maLog(mastr2);
 }
#endif

	
void OnTimerChangePlaylist(EventLoopTimerRef theTimer, void *userData); 
void OnTimerPlayPlaylist(EventLoopTimerRef theTimer, void *userData); 
void OnTimerRunLoop(EventLoopTimerRef theTimer, void *userData); 
void OnTimerPlay(EventLoopTimerRef theTimer, void *userData); 
// void OnTimerStop(EventLoopTimerRef theTimer, void *userData); 

void OnTimerChangePlaylist(EventLoopTimerRef theTimer, void *userData) 
{
#ifdef MATRACEGUIOSX
	maTrace("OnTimerChangePlaylist");
#endif
	ChangePlaylist(g_changeplaylist);
}

void OnTimerPlayPlaylist(EventLoopTimerRef theTimer, void *userData) 
{
#ifdef MATRACEGUIOSX
	maTrace("OnTimerPlayPlaylist");
#endif
	PlayPlaylistB(g_newplaylist);
}

void OnTimerRunLoop(EventLoopTimerRef theTimer, void *userData) 
{
#ifdef MATRACEGUIOSX
	maTrace("OnTimerRunLoop");
#endif
	RunLoop();
}

void OnTimerPlay(EventLoopTimerRef theTimer, void *userData) 
{
#ifdef MATRACEGUIOSX
	maTrace("OnTimerPlay");
#endif
	DoPlay();
}

/* void OnTimerStop(EventLoopTimerRef theTimer, void *userData) 
{
#ifdef MATRACEGUIOSX
	maTrace("OnTimerStop");
#endif
	DoStop();
}
*/


/*
void maGuiLog(machar *mastr2);
void maGuiLog(machar *mastr2)
{
	maprintf(L"%ls", mastr2);
	maprintf(L"\n");
}
*/


int main(int argc, char *argv[]) // MAGUICARBON
{
	g_argc = argc;
	g_argv = argv;

	// minimum osx version
	long response;
	OSErr err = Gestalt(gestaltSystemVersion, &response);
	Boolean ok = ((err == noErr) && (response >= 0x00001030));
	if(!ok)
	{
		StandardAlert(kAlertStopAlert, "\pMac OS X 10.3 (minimum) is recommended for MoreAmp OSX", "\p", NULL, NULL);
		// ExitToShell();
	}

	SetCommandId();

	//  timers
	EventLoopRef mainLoop;
	EventLoopTimerUPP timerUPP;
	mainLoop = GetMainEventLoop();
	timerUPP = NewEventLoopTimerUPP(OnTimerChangePlaylist);
	InstallEventLoopTimer(mainLoop, kEventDurationForever, 0, timerUPP, NULL, &l_timerchangeplaylist);
	timerUPP = NewEventLoopTimerUPP(OnTimerPlayPlaylist);
	InstallEventLoopTimer(mainLoop, kEventDurationForever, 0, timerUPP, NULL, &l_timerplayplaylist);
	timerUPP = NewEventLoopTimerUPP(OnTimerRunLoop);
	InstallEventLoopTimer(mainLoop, kEventDurationForever, 0, timerUPP, NULL, &l_timerrunloop);
	timerUPP = NewEventLoopTimerUPP(OnTimerPlay);
	InstallEventLoopTimer(mainLoop, kEventDurationForever, 0, timerUPP, NULL, &l_timerplay);
	// timerUPP = NewEventLoopTimerUPP(OnTimerStop);
	// InstallEventLoopTimer(mainLoop, kEventDurationForever, 0, timerUPP, NULL, &l_timerstop);

	// for drop and quit
	InitAppleEvents(NULL);
	
	if(!OnInit_())		
		return 1; // failed

	// main loop
	RunApplicationEventLoop();
	
	return 0;
	
} // main 


int MakeMenus(IBNibRef nibRef)
{
	int i;
	IBNibRef lnibRef;
	OSStatus status;
	char *nibfile;
	fschar items[MAXOPENRECENT][MAX_PATH];
	fschar fname[MAX_PATH];
	machar mastr2[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
#ifdef MATRACEGUIOSX
	maTrace("MakeMenus");
#endif
	
	lnibRef = nibRef;
	if(!nibRef)
	{
#if !defined(NOTEXTVIEWER)
		nibfile = "maosxApp";
		status = CreateNibReference(CFSTR("maosxApp"), &lnibRef);
#else
		nibfile = "maosxAppNoTextViewer.nib";
		status = CreateNibReference(CFSTR("maosxAppNoTextViewer"), &lnibRef);
#endif
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"MakeMenus CreateNibReference status %d '%ls'", (int)status, nibfile);
			maLog(mastr);
			return 1;
		}
	}

	status = SetMenuBarFromNib(lnibRef, CFSTR("MenuBar"));
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"MakeMenus SetMenuBarFromNib err %d", (int)status);
		maLog(mastr);
		return 1;
	}

	if(!GetRecent(items))
	{
		for (i = 0; i < MAXOPENRECENT; i++)
		{
			if(!items[i][0])
				break;
			FilenameFromPathname(items[i], fname);
			MenuSetLabel(ID_SUBMENU_OPENRECENT1 + i, fs2ma(mastr2, fname));
		}
		for (; i < MAXOPENRECENT; i++)
			MenuDeleteItem(ID_SUBMENU_OPENRECENT1 + i);
	}
	
	if(!nibRef)
		DisposeNibReference(lnibRef);

		return 0;
		
} // MakeMenus


void UpdateSubMenusRecent()
{
#ifdef MATRACEGUIOSX
	maTrace("UpdateSubMenusRecent");
#endif
	if(g_w[WINDOWAPP])
		MakeMenus(NULL);
}


int	AppWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("AppWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess },
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};
	fschar *nibfile;
	IBNibRef nibRef;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	WindowRef windowref;
	machar mastr2[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	InitCursor();

#if !defined(NOTEXTVIEWER)
	nibfile = "maosxApp";
	status = CreateNibReference(CFSTR("maosxApp"), &nibRef);
#else
	nibfile = "maosxAppNoTextViewer.nib";
	status = CreateNibReference(CFSTR("maosxAppNoTextViewer"), &nibRef);
#endif
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"AppWindowMake CreateNibReference status %d '%ls'",
															(int)status, fs2ma(mastr2, nibfile));
		maLog(mastr);
		return 1;
	}

	if(MakeMenus(nibRef))
		return 1;

#if !defined(MAKEYBOARD)
	DisableMenuCommand(NULL, 'MSUS');
#endif
#if !defined(MAMOUSEWHEEL)
	DisableMenuCommand(NULL, 'MSUM');
#endif

	status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
	DisposeNibReference(nibRef);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"AppWindowMake CreateWindowFromNib err %d", (int)status);
		maLog(mastr);
		return 1;
	}

	status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(AppWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWAPP, NULL);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"AppWindowMake InstallWindowEventHandler err %d", (int)status);
		maLog(mastr);
		return 1;
	}

	id.signature = 'MAMP';
							
	// red checkboxes
	id.id = ID_CHK_REPTSONG;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_BEG;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_END;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_EFFECTS;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_MONOLEFT;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_MONORIGHT;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_MONODIFF;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_INVERTRIGHT;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_SINGLEPLAY;
	GetControlByID(windowref, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
		
	// slider (scrollbar) callback proc
	id.id = ID_SLIDER_VOLUMEL;
	GetControlByID(windowref, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	id.id = ID_SLIDER_VOLUMER;
	GetControlByID(windowref, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	id.id = ID_SLIDER_VOLUMESEP;
	GetControlByID(windowref, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	id.id = ID_SLIDER_PREAMP;
	GetControlByID(windowref, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	id.id = ID_SLIDER_POSITION;
	GetControlByID(windowref, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	
	g_w[WINDOWAPP] = windowref;

	// output selector, nib already has one item
	PopupButtonSetText(WINDOWAPP, ID_POPUP_OUTPUT, 0, fs2ma(mastr2, g_extstrout[kOUTSOUND]));
 	machar label[STRLEN64];
	for(int i = kOUTFIRST; i <= kOUTLAST; i++)
	{
		masprintf(label, STRLEN64, L"%ls file",  fs2ma(mastr2, &g_extstrout[i][1]));
		PopupButtonAppend(WINDOWAPP, ID_POPUP_OUTPUT, label);
 	}
	
	HISize min, max;
	GetWindowResizeLimits(windowref, &min, &max);
	min.width = 20;
	min.height = 20;
	SetWindowResizeLimits(windowref, &min, &max);

	MacMoveWindow(windowref, g_sets.mawin[WINDOWAPP].xpos[g_sets.winconf], g_sets.mawin[WINDOWAPP].ypos[g_sets.winconf], false); // front
	SizeWindow(windowref, g_sets.mawin[WINDOWAPP].xsize[g_sets.winconf], g_sets.mawin[WINDOWAPP].ysize[g_sets.winconf], false); // !update
	ShowWindow(windowref);
	
#if defined(MAKEYBOARD)
	UpdateMenuKbLabels();
	UpdateButtonLabels();
#else
	int textid;
	for(textid = ID_TEXT_BUTTON_FIRST; textid <= ID_TEXT_BUTTON_LAST; textid++)
		StaticTextSetText(WINDOWAPP, textid, L'\0');
#endif

	return 0;	

} // AppWindowMake


/*
#define C1(x) ((machar)((x >> 24) & 0xff))
#define C2(x) ((machar)((x >> 16) & 0xff))
#define C3(x) ((machar)((x >>  8) & 0xff))
#define C4(x) ((machar)(x & 0xff))
char g_4str[STRLEN16];
char *C4str(UInt32 x)
{
	sprintf(g_4str, "%c%c%c%c", C1(x), C2(x), C3(x), C4(x));
	return g_4str;
}
*/


OSStatus CommandEventHandler(HICommandExtended *command, int windowid, Rect *r)
{
	short value;
	DataBrowserItemID first;
	DataBrowserItemID last;
	ControlKind outControlKind;

	GetControlKind(command->source.control, &outControlKind);
	if(outControlKind.kind == kControlKindLittleArrows)
	{
		Point pt;
		GetMouse(&pt);
		LocalToGlobal(&pt);
		pt.v -= r->top;
		Rect bounds;
		GetControlBounds(command->source.control, &bounds);
		if(pt.v >= bounds.top + ((bounds.bottom - bounds.top) / 2)) // LittleArrow down
			value = -1;
		else
			value = 1; // LittleArrow up
	}
	else if(outControlKind.kind == kControlKindDataBrowser)
	{
		GetDataBrowserSelectionAnchor(command->source.control, &first, &last);
		value = first;
	}
	else
		value = GetControlValue(command->source.control);
		
	// 'BXXX' are buttons, 'MXXX' are menus (MFiles MControls MSettings ...), 'CXXX' are checkboxs, etc
	switch(command->commandID)
	{
		// app window and menus
		case kHICommandSelectWindow:
		return eventNotHandledErr;
		
		case CMD_MENU_ABOUT:
			DoWindow(WINDOWABOUT, 1);
		break;
		case 'BQUI':
		case CMD_MENU_QUIT:
			DoAppQuit();
		break;
		case 'BPRE':
		case CMD_MENU_PREVIOUS:
			DoPrevious();
		break;
		case 'BPLA':
		case CMD_MENU_PLAY:
			DoPlay();
		break;
		case 'BPAU':
		case CMD_MENU_PAUSE:
			DoPause();
		break;
		case 'BSTO':
		case CMD_MENU_STOP:
			DoStop();
		break;
		case 'BNEX':
		case CMD_MENU_NEXT:
			DoNext();
		break;
		case CMD_MENU_OPENLIST:
			DoOpenList();
		break;
		case CMD_MENU_MAKELIST:
			DoMakeList();
		break;
		case CMD_MENU_SAVELISTAS:
			DoSaveListAs();
		break;
		case CMD_MENU_DELETELIST:
			DoDeleteList();
		break;
		case CMD_MENU_PLAYFILE:
			DoPlayFile();
		break;
		case CMD_SUBMENU_OPENRECENT1:
			DoOpenRecent(0);
		break;
		case CMD_SUBMENU_OPENRECENT2:
			DoOpenRecent(1);
		break;
		case CMD_SUBMENU_OPENRECENT3:
			DoOpenRecent(2);
		break;
		case CMD_SUBMENU_OPENRECENT4:
			DoOpenRecent(3);
		break;
		case CMD_SUBMENU_OPENRECENT5:
			DoOpenRecent(4);
		break;
		case CMD_SUBMENU_OPENRECENT6:
			DoOpenRecent(5);
		break;
		case CMD_SUBMENU_OPENRECENT7:
			DoOpenRecent(6);
		break;
		case CMD_SUBMENU_OPENRECENT8:
			DoOpenRecent(7);
		break;
		case CMD_SUBMENU_OPENRECENT9:
			DoOpenRecent(8);
		break;
		case CMD_SUBMENU_OPENRECENT10:
			DoOpenRecent(9);
		break;
		case CMD_MENU_PLAYCD:
			DoPlayCD();
		break;
		case CMD_MENU_EJECTCD:
			DoEjectCD();
		break;
		case CMD_MENU_AUDIOIN:
			DoAudioIn();
		break;
		case CMD_MENU_SAVEMASETS:
			DoSave();
		break;
		case CMD_MENU_SETSAVED:
			DoSetsSaved();
		break;
		case CMD_MENU_SETDEFAULT:
			DoSetsDefault();
		break;
		case CMD_MENU_SETFACTORY:
			DoSetsFactory();
		break;
		case CMD_MENU_SETCOPY:
			DoSetsCopy();
		break;
		case CMD_MENU_SAVEMASETSDEFAULT:
			DoAsDefaults();
		break;
		case CMD_MENU_EQUALIZER:
			MenuToggle(command->commandID);
			DoEqualizer((g_sets.eqflags & MAEQACTIVE) ? 0 : 1);
		break;
		case CMD_MENU_EQ31BANDS:
			MenuToggle(command->commandID);
			DoEq31Bands((g_sets.eqflags & MAEQ31BANDS) ? 0 : 1);
		break;
		case CMD_MENU_EQEXTRA:
			MenuToggle(command->commandID);
			DoEqExtra((g_sets.eqflags & MAEQEXTRA) ? 0 : 1);
		break;
		case CMD_MENU_EFFECTS:
			MenuToggle(command->commandID);
			DoEffects((g_sets.effects & EFFECTSON) ? 0 : 1);
		break;
		case CMD_MENU_RANDOM:
			MenuToggle(command->commandID);
			DoRandom(g_sets.random ? 0 : 1);
		break;
		case CMD_MENU_REPTPLAYED:
			MenuToggle(command->commandID);
			DoReptPlayed(g_sets.reptplayed ? 0 : 1);
		break;
		case CMD_MENU_LOOPLOADED:
			MenuToggle(command->commandID);
			DoLoopLoaded(g_sets.looploaded ? 0 : 1);
		break;
		case CMD_MENU_LOOPLIST:
			MenuToggle(command->commandID);
			DoLoopList(g_sets.looplist ? 0 : 1);
		break;
		case CMD_MENU_MONO:
			MenuToggle(command->commandID);
			DoMono(g_sets.monodiff ? 0 : 1);
		break;
		case CMD_MENU_INVERTRIGHT:
			MenuToggle(command->commandID);
			DoInvertRight(g_sets.invertright ? 0 : 1);
		break;
		case CMD_MENU_SINGLEPLAY:
			DoSinglePlay(g_sets.singleplay ? 0 : 1);
		break;
		case CMD_MENU_INPUTMONITOR:
			MenuToggle(command->commandID);
			DoInMonitor(g_sets.inputmonitor ? 0 : 1);
		break;
		case CMD_SUBMENU_TITLEINFO1:
			MenuToggle(command->commandID);
			DoTitleInfo(1);
		break;
		case CMD_SUBMENU_TITLEINFO2:
			MenuToggle(command->commandID);
			DoTitleInfo(2);
		break;
		case CMD_SUBMENU_TITLEINFO3:
			MenuToggle(command->commandID);
			DoTitleInfo(3);
		break;
		case CMD_MENU_AUTOSTART:
			MenuToggle(command->commandID);
			g_sets.autostart = g_sets.autostart ? 0 : 1;
		break;
		case CMD_MENU_ERRLOGGING:
			MenuToggle(command->commandID);
			DoErrLogging((g_sets.logflags & kMALOGOFF) ? 1 : 0);
		break;
		case CMD_MENU_SETVDISK:
			DoSetVDisk();
		break;
		case CMD_MENU_MULTIPLEINST:
			DoMultipleInst(g_sets.multipleinst ? 0 : 1);
		break;
#if defined(MAKEYBOARD)
		case CMD_MENU_KEYBOARD:
			DoKeyboard(g_sets.keyboard ? 0 : 1);
		break;
#endif
#if defined(MAMOUSEWHEEL)
		case CMD_MENU_MOUSEWHEEL:
			MenuToggle(command->commandID);
			DoMouseWheel(g_sets.mousewheel ? 0 : 1);
		break;
#endif
		case CMD_MENU_ADVANCED:
			DoWindow(WINDOWADVANCED, 1);
		break;
		case CMD_MENU_SHOWLIST:
			ToggleWindow(WINDOWLIST);
		break;
		case CMD_MENU_SHOWEQ:
			DoEqWindow();
		break;
		case CMD_MENU_ZEROLIST:
			 DoZeroList();
		break;
		case CMD_MENU_MAKECATALOG:
			 DoMakeCatalog();
		break;
#if !defined(NOTEXTVIEWER)
		case CMD_MENU_VIEWCATALOG:
			 DoViewCatalog(0);
		break;
		case CMD_MENU_VIEWPLAYLIST:
			 DoWindow(WINDOWPLAYLIST, 1);
		break;
		case CMD_MENU_VIEWLOG:
			 DoWindow(WINDOWLOG, 1);
		break;
#endif
		case CMD_MENU_CLEARLOG:
			 maLog(&g_logcmdclear);
		break;
#if !defined(NOTEXTVIEWER)
 #if defined(MAKEYBOARD)
		case CMD_MENU_EDITKEYBINDINGS:
			 DoEditKeyBindings();
		break;
		case CMD_MENU_BLANKKEYBINDINGS:
			 DoBlankKeyBindings();
		break;
		case CMD_MENU_FACTORYKEYBINDINGS:
			 DoFactoryKeyBindings();
		break;
  #endif
 #endif
		case CMD_MENU_RESCANAUDIODEVICES:
			 DoRescanAudioDevices();
		break;

		case CMD_MENU_SHOWEFFECTS:
			MenuToggle(command->commandID);
			ToggleWindow(WINDOWEFFECTS);
		break;
		case CMD_MENU_SHOWFILEOUT:
			MenuToggle(command->commandID);
			ToggleWindow(WINDOWFILEOUT);
		break;
		case CMD_MENU_ALTSIZE:
			MenuToggle(command->commandID);
			DoAltSize(g_sets.winconf ? 0 : 1, 0);
		break;
		case CMD_MENU_SAVEDSIZE:
			DoSavedSize();
		break;
		case CMD_MENU_DEFAULTSIZE:
			DoDefaultSize();
		break;
		case CMD_MENU_FACTORYSIZE:
			DoFactorySize();
		break;
#if !defined(NOTEXTVIEWER)
		case CMD_MENU_README:
			DoWindow(WINDOWREADME, 1);
		break;
#endif
		case 'SBEG':
			OnLittleArrowBegin(value); // 1 up, -1 down
		break;
		case 'SEND':
			OnLittleArrowEnd(value);
		break;
		case 'SBUF':
			OnLittleArrowBuffer(value);
		break;
		case 'CALT':
			DoAltSize(value, 0);
		break;
		case 'CRES':
			DoReptSong(value);
		break;
		case 'CBEG':
			DoBoxBeg(value);
		break;
		case 'CEND':
			DoBoxEnd(value);
		break;
		case 'CBAL':
			DoBalance(value);
		break;
		case 'CPRE':
			DoLimiter(value);
		break;
		case 'CEQW':
			DoEqWindow();
		break;
		case 'CEQU':
			DoEqualizer(value);
		break;
		// case 'CE31':
		// 	DoEq31Bands(value);
		// break;
		// case 'CEQE':
		// 	DoEqExtra(value);
		// break;
		case 'CEFF':
			DoEffects(value);
		break;
		case 'CMOL':
			DoMonoLeft(value);
		break;
		case 'CMOR':
			DoMonoRight(value);
		break;
		case 'CMOD':
			DoMonoDiff(value);
		break;
		case 'CLIS':
			ToggleWindow(WINDOWLIST);
		break;
		case 'CRAN':
			DoRandom(value);
		break;
		case 'CREP':
			DoReptPlayed(value);
		break;
		case 'CLOO':
			DoLoopLoaded(value);
		break;
		case 'CLOL':
			DoLoopList(value);
		break;
		case 'CINV':
			DoInvertRight(value);
		break;
		case 'CSIN':
			DoSinglePlay(value);
		break;
		case 'CUMT':
			DoUseM3u(value);
		break;
		case 'CEAT':
			DoExitAfter(value);
		break;
		case 'CTIT':
			DoTitleInfo(0);
		break;
		case 'CENA':
			DoHostInEnable(value);
		break;
		case 'PSOU':
			OnPopupOutput(value - 1);
		break;
		case 'PMEM':
			OnPopupBuffer(value - 1);
		break;
		case 'PAIH':
			OnPopupAudioHostIn(value - 1);
		break;
		case 'PAOH':
			OnPopupAudioHostOut(value - 1);
		break;
		case 'PAOD':
			OnPopupAudioOutput(value - 1);
		break;
		case 'PAID':
			OnPopupAudioInput(value - 1);
		break;

		// list window
		case 'BINF':
			OnButtonInfo();
		break;
		case 'BLIS':
			OnButtonList();
		break;
		case 'BLOA':
			OnButtonLoaded();
		break;
		case 'BSON':
			OnButtonSong();
		break;
		case 'CSHI':
			DoShowIndex(value);
		break;
		case 'CSHD':
			DoShowDir(value);
		break;
		case 'CSHP':
			DoShowPath(value);
		break;
		case 'CADD':
			DoAddMode(value);
		break;
		/* for browser in nib
		case 'LIST':
			OnListWindowSingleClick(0);
		break;
		*/

		// equalizer window
		case 'BMIN':
			OnButtonEqMinus();
		break;
		case 'BPLU':
			OnButtonEqPlus();
		break;
		case 'BMID':
			if(windowid == WINDOWEQ2)
				OnButtonEq2Mid();
			else
				OnButtonEqMid();
		break;
		case 'BCOP':
			if(windowid == WINDOWEQ2)
				OnButtonEq2Copy();
			else
				OnButtonEqCopy();
		break;
		case 'BPAS':
			if(windowid == WINDOWEQ2)
				OnButtonEq2Paste();
			else
				OnButtonEqPaste();
		break;
		case 'BRES':
			if(windowid == WINDOWEQ2)
				OnButtonEq2Restore();
			else
				OnButtonEqRestore();
		break;
		case 'BSHL':
			OnButtonEqShiftL();
		break;
		case 'BSHR':
			OnButtonEqShiftR();
		break;
		case 'BINV':
			OnButtonEqInvert();
		break;
		case 'SOFF':
			OnLittleArrowEqOffset(value);
		break;
		case 'PPRE':
			OnPopupEqPreset(value - 1);
		break;
		case 'CEQB':
			DoEqualizer(value);
		break;
		case 'C31B':
			DoEq31Bands(value);
		break;
		case 'CEXB':
			DoEqExtra(value);
		break;
		case 'CSEP':
			DoSeparateLR(value);
		break;
		case 'CZOO':
			DoEqZoom(value);
		break;
		case 'CLIN':
			DoEqLink(value);
		break;

		// effects window
		case 'CEFB':
			DoEffects(value);
		break;
		case 'CSBS':
			DoSBSMS(value);
		break;
		case 'CPIT':
			DoPitch(value);
		break;
		case 'CTEM':
			DoTempo(value);
		break;
		case 'CSPE':
			DoSpeed(value);
		break;

		// fileout window
		case 'BCHA':
			OnButtonFileOutDir();
		break;
#if defined(ENCODEAAC)
		case 'CADT':
			DoBoxADTS(value);
		break;
#endif
#if defined(ENCODEMP4)
		case 'CM4A':
			DoBoxM4A(value);
		break;
#endif
		case 'PBIT':
			OnPopupBitRate(value - 1);
		break;
		case 'PQUA':
			OnPopupQuality(value - 1);
		break;
		case 'PMOD':
			OnPopupMode(value - 1);
		break;
		case 'PSAM':
			OnPopupSampleRate(value - 1);
		break;
		
#if !defined(NOTEXTVIEWER)
		// viewer window(s)
		case 'BFIN':
			ViewerOnButtonFind(windowid);
		return eventNotHandledErr;
		case 'BVPL':
			ViewerOnButtonPlay(windowid);
		return eventNotHandledErr;
		case 'BEDI':
			ViewerOnButtonEditSave(windowid);
		return eventNotHandledErr;
#endif

		// prompt number popup
		case 'BPRO':
			DoPromptIndexOk();
		break;
		case 'BPRC':
			DoWindow(WINDOWPROMPTNUM, 0);
		break;

		// advanced settings window
		case 'CCRE':
			DoCloseReopen(value);
		break;
		case 'CIMO':
			DoInputMonitor(value);
		break;
		case 'CLNP':
			DoLogNotPlayable(value);
		break;

		default:
		/*
			{
			machar mastr[MAXLOGLINELEN];
			masprintf(mastr, MAXLOGLINELEN, L"CommandEventHandler '%ls' 0x%x", C4str(command->commandID), (int)command->attributes);
			maGuiLog(mastr);
			}
		*/
		return eventNotHandledErr;
	}
	
	return noErr;
	
} // CommandEventHandler


#if defined(MAKEYBOARD)
OSStatus KeyboardEventHandler(EventRef event)
{
	EventRef rawEvent;
	unsigned char charCode;
	fschar fskey[STRLEN16] = {fsT('\0')};

	GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
	GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(machar), NULL, &charCode);
	if(charCode == kDownArrowCharCode)
		fskey[4] = MAWXK_DOWN;
	else if(charCode == kUpArrowCharCode) 
		fskey[4] = MAWXK_UP;
	else if(charCode == kEnterCharCode || charCode == kReturnCharCode || charCode == kLineFeedCharCode) // kEnterCharCode is 3 but we get '/r'
		fskey[4] = MAWXK_RETURN;
	else if(charCode == kEscapeCharCode)
		fskey[4] = MAWXK_ESCAPE;
	else
		fskey[0] = charCode;
	maOnKey(fskey);

	return noErr;

} // KeyboardEventHandler
#endif


OSStatus AppWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
	if((int)userData != WINDOWAPP || !g_w[WINDOWAPP])
		return(eventNotHandledErr);
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
														sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[WINDOWAPP], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, WINDOWAPP, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					DoAppQuit();				
				break;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(WINDOWAPP);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(WINDOWAPP);	
				return eventNotHandledErr;
								
				default:
				return eventNotHandledErr;
			}
		break;

#if defined(MAMOUSEWHEEL)
		case kEventClassMouse:
			if(g_sets.mousewheel && g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					KeyboardEventHandler(event);
				return noErr;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
	}

	return eventNotHandledErr;
	
} // AppWindowEventHandler


void guiAppYield() 
{
#ifdef MATRACEGUIOSX
	maTrace("guiAppYield");
#endif

	EventMask eventMask = highLevelEventMask;
	EventRecord event; 
	UInt32 ticks = 1; // 60 == 1 second
 	WaitNextEvent(eventMask, &event, ticks, NULL);

} // guiAppYield


OSStatus CheckBoxColorCallback(ControlRef inControl, SInt16 inMessage, SInt16 inDrawDepth, Boolean inDrawInColor)
{
	//WindowRef windowref = GetControlOwner(inControl);

	if(!GetControlValue(inControl)) // || !windowref || !IsWindowActive(windowref)))
		return eventNotHandledErr;

	RGBColor color = {0xffff, 0, 0};
	RGBForeColor(&color);
	
	return noErr;
	
} // CheckBoxColorCallback


void CheckBoxDisable(int windowid, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxDisable");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI(L"CheckBoxEnable no widget", windowid, checkbox);		
}


void CheckBoxEnable(int windowid, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxEnable");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI(L"CheckBoxEnable no widget", windowid, checkbox);		
}


int CheckBoxGetValue(int windowid, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxGetValue");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return 0;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		return GetControlValue(cb) ? 1 : 0;
	maLogAPI(L"CheckBoxGetValue no widget", windowid, checkbox);		
	return 0;
}


void CheckBoxHide(int windowid, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxHide");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		HideControl(cb);
	else
		maLogAPI(L"CheckBoxHide no widget", windowid, checkbox);		
}


void CheckBoxSetDescriptor(int windowid, int checkbox, machar *desc)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxSetDescriptor");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef cfstr;
	fschar fsstr[MAX_PATH]; // arbitrary size

	if(!g_w[windowid] || !desc)
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		ma2fs(fsstr, desc);
		cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
		if(cfstr)
		{
			SetControlTitleWithCFString(cb, cfstr);
			CFRelease(cfstr);
		}		
	}
	else
		maLogAPI(L"CheckBoxSetDescriptor no widget", windowid, checkbox);

} // CheckBoxSetDescriptor


void MenuSetLabel(int item, machar *label)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuSetLabel");
#endif
	MenuRef pmenu;
	MenuItemIndex index;
	OSStatus status;
	CFStringRef cfstr;
	fschar fsstr[MAX_PATH];
	machar mastr[MAXLOGLINELEN];

	if(label == NULL)
	{
		maLog(L"MenuSetLabel null label parameter");
		return;
	}
	if(l_commandid[item] == 'NULL')
		return;
	if((status = GetIndMenuItemWithCommandID(NULL, l_commandid[item], 1, &pmenu, &index)))
	{
		masprintf(mastr, MAXLOGLINELEN, L"MenuSetLabel GetIndMenuItemWithCommandID l_commandid[%d]='%c%c%c%c' err=%d", item,
		(machar)((l_commandid[item] >> 24) & 0xff), (machar)((l_commandid[item] >> 16) & 0xff),
		(machar)((l_commandid[item] >>  8) & 0xff), (machar)(l_commandid[item] & 0xff), (int)status);
		maLog(mastr);
		return;
	}
	ma2fs(fsstr, label);
	cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
	SetMenuItemTextWithCFString(pmenu, index, cfstr);
	CFRelease(cfstr);
	
} // MenuSetLabel


void MenuGetLabel(int item, machar *label)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuGetLabel");
#endif
	MenuRef pmenu;
	MenuItemIndex index;
	OSStatus status;
	CFStringRef cfstr;
	CFIndex slen;
	CFIndex outbytes;
	fschar fsstr[STRLEN256];

	if(label == NULL)
	{
		maLog(L"MenuGetLabel null label parameter");
		return;
	}
	if(l_commandid[item] == 'NULL')
		return;
	if((status = GetIndMenuItemWithCommandID(NULL, l_commandid[item], 1, &pmenu, &index)))
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"MenuGetLabel GetIndMenuItemWithCommandID l_commandid[%d]='%c%c%c%c' err=%d", item,
		(machar)((l_commandid[item] >> 24) & 0xff), (machar)((l_commandid[item] >> 16) & 0xff),
		(machar)((l_commandid[item] >>  8) & 0xff), (machar)(l_commandid[item] & 0xff), (int)status);
		maLog(mastr);
		return;
	}

	CopyMenuItemTextAsCFString(pmenu, index, &cfstr);
	if(cfstr == NULL || (slen = CFStringGetLength(cfstr)) <= 0)
		return;
	if(slen >= STRLEN256)
		slen = STRLEN256 - 1;
	CFStringGetBytes(cfstr, CFRangeMake(0, slen), kCFStringEncodingUTF8,
				'?', // loss byte
				FALSE, (UInt8 *)fsstr, STRLEN256 - 1, &outbytes);
	CFRelease(cfstr);
	fsstr[outbytes] = fsT('\0');
	fs2ma(label, fsstr);

} // MenuGetLabel


void MenuDeleteItem(int item)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuDeleteItem");
#endif
	MenuRef pmenu;
	MenuItemIndex index;
	OSStatus status;
	if(l_commandid[item] == 'NULL')
		return;
	if((status = GetIndMenuItemWithCommandID(NULL, l_commandid[item], 1, &pmenu, &index)))
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"MenuDeleteItem GetIndMenuItemWithCommandID l_commandid[%d]='%c%c%c%c' err=%d", item,
		(machar)((l_commandid[item] >> 24) & 0xff), (machar)((l_commandid[item] >> 16) & 0xff),
		(machar)((l_commandid[item] >>  8) & 0xff), (machar)(l_commandid[item] & 0xff), (int)status);
		maLog(mastr);
		return;
	}
	DeleteMenuItem(pmenu, index);

} // MenuDeleteItem


/*
void CheckBoxSetFocus(int windowid, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxSetFocus");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
	{
		SetKeyboardFocus((WindowRef)g_w[windowid], cb, kControlFocusNoPart);
		SetKeyboardFocus((WindowRef)g_w[windowid], cb, kControlFocusNextPart);
	}
	else
		maLogAPI(L"CheckBoxSetFocus no widget", windowid, checkbox);		
}
*/


void CheckBoxSetValue(int windowid, int checkbox, int value)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxSetValue");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		SetControlValue(cb, value ? 1 : 0);
	else
		maLogAPI(L"CheckBoxSetValue no widget", windowid, checkbox);		
}


void CheckBoxShow(int windowid, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxShow");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		ShowControl(cb);
	else
		maLogAPI(L"CheckBoxShow no widget", windowid, checkbox);		
}


void maLogAPI(const machar *errtxt, int windowid, int item)
{
	machar mastr[MAXLOGLINELEN];
	masprintf(mastr, MAXLOGLINELEN, L"%ls window=%d item=%d", errtxt, windowid, item);
	maLog(mastr);
}


void DisplayGetSize(int *x, int *y)
{
#ifdef MATRACEGUIOSX
	maTrace("DisplayGetSize");
#endif
	
	BitMap screenBits;
	GetQDGlobalsScreenBits(&screenBits);

	if(x != NULL)
		*x = screenBits.bounds.right - screenBits.bounds.left;
	else
		maLog(L"DisplayGetSize null x parameter");

	if(y != NULL)
		*y = screenBits.bounds.bottom - screenBits.bounds.top;
	else
		maLog(L"DisplayGetSize null y parameter");
}


void DoTimerRunLoop(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerRunLoop");
#endif
	SetEventLoopTimerNextFireTime(l_timerrunloop, delay * kEventDurationMillisecond);
}


void DoTimerPlay(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerPlay");
#endif
	SetEventLoopTimerNextFireTime(l_timerplay, delay * kEventDurationMillisecond);
}


/* void DoTimerStop(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerStop");
#endif
	SetEventLoopTimerNextFireTime(l_timerstop, delay * kEventDurationMillisecond);
}
*/

void DoTimerChangePlaylist(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerChangePlaylist");
#endif
	SetEventLoopTimerNextFireTime(l_timerchangeplaylist, delay * kEventDurationMillisecond);
}


void DoTimerPlayPlaylist(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerPlayPlaylist");
#endif
	SetEventLoopTimerNextFireTime(l_timerplayplaylist, delay * kEventDurationMillisecond);
}


#if !defined(NOTEXTVIEWER)
 void EditTextGetSelection(int windowid, int edittext, long *start, long *end)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextGetSelection");
 #endif
	maviewer *v;
	TXNOffset lstart; 
	TXNOffset lend;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;
		
	if(!(v = Viewer(windowid)))
	{
		maLog(L"EditTextGetSelection Viewer failed");
		return;
	}

	if(!v->text)
	{
		maLog(L"EditTextGetSelection null TXNobj");
		return;
	}
		
	v->OffsetsValid = 0;
	TXNGetSelection((TXNObject)v->text, &lstart, &lend); // 0-based, ip if no selection
	*start = lstart;
	*end = lend; // char index of first unselected char after selection, and length = *end - *start

	v->scrollCacheS = v->scrollCache;
	v->OffsetsValid = 1;
		
 } // EditTextGetSelection


 void EditTextSetSelection(int windowid, int edittext, long start, long end)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextSetSelection");
 #endif
	maviewer *v;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;
		
	if(edittext != ID_EDITTEXT_VIEWERVIEW)
	{
		maLog(L"EditTextSetSelection only implemented for viewer window");
		return;
	}

	if(!(v = Viewer(windowid)))
	{
		maLog(L"EditTextSetSelection Viewer failed");
		return;
	}

	if(!v->text)
	{
		maLog(L"EditTextSetSelection null TXNobj");
		return;
	}
		
	v->OffsetsValid = 0;
	TXNSetSelection((TXNObject)v->text, start, end);
	TXNShowSelection((TXNObject)v->text, false);
	v->scrollCacheS = v->scrollCache;
	v->OffsetsValid = 1;
		
 } // EditTextSetSelection


 void EditTextSetEditable(int windowid, int edittext, int editable)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextSetEditable");
 #endif

	return; // no op

	/* if the text control is set not editable then we cannot select text or click in it
	ControlRef cb;
	ControlID id;
	Boolean locked;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = edittext;
	
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		locked = (Boolean)!editable;
		if(SetControlData(cb, kControlEditTextPart, kControlEditTextLockedTag, sizeof(Boolean), (void *)&locked) != noErr)
			maLogAPI(L"EditTextSetEditable SetControlData failed", windowid, edittext);
	}
	else
		maLogAPI(L"EditTextSetEditable no widget", windowid, edittext);		
	*/
	
 } // EditTextSetEditable


 void EditTextSetFocus(int windowid, int edittext)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextSetSelection");
 #endif
	maviewer *v;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;
		
	if(edittext != ID_EDITTEXT_VIEWERVIEW && edittext != ID_EDITTEXT_VIEWERFIND)
	{
		ControlID id;
		ControlRef cb;
		id.signature = 'MAMP';
		id.id = ID_EDITTEXT_PROMPTNUM;
		GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
		SetKeyboardFocus((WindowRef)g_w[windowid], cb, kControlFocusNoPart);
		SetKeyboardFocus((WindowRef)g_w[windowid], cb, kControlFocusNextPart);
		return;
	}

	if(!(v = Viewer(windowid)))
	{
		maLog(L"EditTextSetFocus Viewer failed");
		return;
	}

	if(edittext == ID_EDITTEXT_VIEWERFIND)
	{
		if(!v->findedit)
		{
			maLog(L"EditTextSetFocus no find edit text widget");
			return;
		}
		SetKeyboardFocus(GetControlOwner(v->findedit), v->findedit, kControlFocusNoPart); // kludge
		SetKeyboardFocus(GetControlOwner(v->findedit), v->findedit, kControlFocusNextPart);
		return;
	}
	
	if(edittext == ID_EDITTEXT_VIEWERVIEW)
	{
		if(!v->text)
		{
			maLog(L"EditTextSetFocus null TXNobj");
			return;
		}
		TXNFocus((TXNObject)v->text, true);
	}
	
 } // EditTextSetFocus


 /* int EditTextLoadFile(int windowid, int edittext, fschar *fpath)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextLoadFile");
 #endif
	return -1; // not implemented
 }


 int EditTextSaveFile(int windowid, int edittext, fschar *fpath)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextSaveFile");
 #endif
	return -1; // not implemented
 }
 */
 

 int EditTextGetSize(int windowid, int edittext, size_t *pfsize)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextGetSize");
 #endif
	maviewer *v;
	
	*pfsize = 0;
	
	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"EditTextGetSize Viewer failed", windowid, edittext);
		return 1;
	}
	
	if(!v->text)
	{
		maLogAPI(L"EditTextGetSize null TXNobj", windowid, edittext);
		return 1;
	}
	
	/*
	long length = 0;
	*pfsize = TXNDataSize((TXNObject)v->text);
	ItemCount numberOfRuns;
	TXNCountRunsInRange((TXNObject)v->text, 0, *pfsize, &numberOfRuns);
	for(long irun = 0; irun < (long)numberOfRuns; irun ++)
	{
		unsigned long left, right;
		TXNDataType dataType;
		TXNGetIndexedRunInfoFromRange ((TXNObject)v->text, irun, 0, *pfsize, &left, &right, &dataType, 0, NULL);
		if(dataType == kTXNTextData || dataType == kTXNUnicodeTextData)
		{
			Handle han;
			TXNGetDataEncoded((TXNObject)v->text, left, right, &han, dataType);
			if(han)
			{
				long size = GetHandleSize(han) / 2;
				length += size;
				DisposeHandle(han);
			}
		}
	}
	*pfsize = length;
	*/
	*pfsize = (TXNDataSize((TXNObject)v->text)) / sizeof(UniChar); // machars, not bytes
	
	return 0;

 } // EditTextGetSize


 void EditTextShowPosition(int windowid, int edittext, long pos) // text EnsureVisible
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextSetSelection");
 #endif
	maviewer *v;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;
		
	if(edittext != ID_EDITTEXT_VIEWERVIEW) // only implemented for this
	{
		maLogAPI(L"EditTextShowPosition invalid edittext", windowid, edittext);
		return;
	}
	
	if(!(v = Viewer(windowid)))
	{
		maLogAPI(L"EditTextShowPosition Viewer failed", windowid, edittext);
		return;
	}
	
	if(!v->text)
	{
		maLogAPI(L"EditTextShowPosition null TXNobj", windowid, edittext);
		return;
	}
		
	/*
	// scroll to top
	TXNSetSelection((TXNObject)text, 0, 0);
	TXNShowSelection((TXNObject)text, false);
	v->scrollCacheS = v->scrollCache;
	v->OffsetsValid = 1;
	*/
	/*
	// scroll to pos
	v->OffsetsValid = 0;
	v->OffsetsValid = 0;
	TXNSetSelection((TXNObject)v->text, pos, pos);
	TXNShowSelection((TXNObject)v->text, false);
	v->scrollCacheS = v->scrollCache;
	v->OffsetsValid = 1;
	*/
	/* from wxTextCtrl
	{
    Point current, desired;
    TXNOffset selstart, selend;
    TXNGetSelection( m_txn, &selstart, &selend );
    TXNOffsetToPoint( m_txn, selstart, &current );
    TXNOffsetToPoint( m_txn, pos, &desired );
    OSErr theErr = noErr;
    long dv = desired.v - current.v;
    long dh = desired.h - current.h;
    TXNShowSelection( m_txn, kTXNShowStart );
    theErr = TXNScroll( m_txn, kTXNScrollUnitsInPixels, kTXNScrollUnitsInPixels, &dv, &dh );
	}
	*/

	// scroll to bottom pos < 0
	ByteCount len;
	if((len = TXNDataSize((TXNObject)v->text)) <= 0)
		return;
	v->OffsetsValid = 0;
	TXNSetSelection((TXNObject)v->text, len, len);
	TXNShowSelection((TXNObject)v->text, true);
	v->scrollCacheS = v->scrollCache;
	v->OffsetsValid = 1;

 } // EditTextShowPosition
#endif


 void EditTextEnable(int windowid, int edittext)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextEnable");
 #endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = edittext;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI(L"EditTextEnable no widget", windowid, edittext);		

 } // EditTextEnable


 void EditTextDisable(int windowid, int edittext)
 {
 #ifdef MATRACEGUIOSX
	maTrace("EditTextDisable");
 #endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = edittext;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI(L"EditTextDisable no widget", windowid, edittext);		

 } // EditTextDisable


void EditTextSetText(int windowid, int edittext, machar *text)
{
#ifdef MATRACEGUIOSX
	maTrace("EditTextSetText");
#endif
	ControlRef cb;
	ControlID id;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

#if !defined(NOTEXTVIEWER)
	if(edittext == ID_EDITTEXT_VIEWERVIEW)
	{
		maviewer *v;
		size_t len;
		size_t size;
		OSStatus status;
		char *p1 = NULL;
		machar mastr[MAXLOGLINELEN];

		if((len = mastrlen(text)) <= 0)
			return;

		if(!(v = Viewer(windowid)))
		{
			maLogAPI(L"EditTextSetText Viewer failed", windowid, edittext);
			return;
		}

		size = (len + 1) * 4; // max sizeof(UniChar) or max sizeof(UTF-8) 
		if((p1 = (char *)MAMALLOC(size)) == NULL)
		{
			maLogAPI(L"EditTextSetText MAMALLOC failed", windowid, edittext);
			return;
		}
			
		size_t bytesout = wclocal_to_utf8(text, len, p1, size);
		p1[bytesout] = fsT('\0');
		
		bytesout = StrUTF8toUTF16LE(p1);
		status = TXNSetData((TXNObject)v->text, kTXNUnicodeTextData, p1, bytesout, kTXNStartOffset, kTXNEndOffset);
			
		MAFREE(p1);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"EditTextSetText TXNSetData err %d", (int)status);
			maLog(mastr);
			return;
		}
		TXNSetSelection((TXNObject)v->text, 0, 0);
		TXNShowSelection((TXNObject)v->text, false); // scroll to top

	}
	else // !ID_EDITTEXT_VIEWERVIEW
#endif
	{
		id.signature = 'MAMP';
		id.id = edittext;
		GetControlByID((WindowRef)g_w[windowid], &id, &cb);
		if(!cb)
		{
			maLogAPI(L"EditTextSetText no widget", windowid, edittext);
			return;
		}
		fschar fsstr[MAX_PATH];
		CFStringRef cfstr;
		ma2fs(fsstr, text);
		cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
		if(SetControlData(cb, 0, kControlEditTextCFStringTag, sizeof(CFStringRef), &cfstr) != noErr)
			maLogAPI(L"EditTextSetText SetControlData failed", windowid, edittext);
		CFRelease(cfstr);
	}

} // EditTextSetText


#define TEXTMAXLEN STRLEN256
void EditTextGetText(int windowid, int edittext, machar *outBuffer, int inBufferLength, long *outTextLength, long from, long to)
{
#ifdef MATRACEGUIOSX
	maTrace("EditTextGetText");
#endif
	OSStatus status;
#if !defined(NOTEXTVIEWER)
	maviewer *v;
	HIViewRef textView = NULL;
	CFStringRef vtext;
	CFIndex len;
	fschar *p1;
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef cfstr;
	fschar fsstr[TEXTMAXLEN * 4]; // at least inBufferLength
	CFIndex slen;
	CFIndex outbytes;
	size_t outchars;
#if !defined(NOTEXTVIEWER)
	machar mastr[MAXLOGLINELEN];
#endif

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	if(!outTextLength)
	{
		maLogAPI(L"EditTextGetText null outTextLength", windowid, edittext);
		return;
	}

	*outTextLength = 0;
	outBuffer[0] = L'\0';
	
	switch(edittext)
	{
		case ID_EDITTEXT_EQ:		// single-line edit text controls for input
		case ID_EDITTEXT_PROMPTNUM:
#if !defined(NOTEXTVIEWER)
		case ID_EDITTEXT_VIEWERFIND:
#endif
			if(!outBuffer)
			{
				maLogAPI(L"EditTextGetText null outBuffer", windowid, edittext);
				return;
			}
			id.signature = 'MAMP';
			id.id = edittext;
			GetControlByID((WindowRef)g_w[windowid], &id, &cb);
			if(!cb)
			{
				maLogAPI(L"EditTextGetText no widget", windowid, edittext);
				return;
			}
			cfstr = NULL;
			status = GetControlData(cb, 0, kControlEditTextCFStringTag, sizeof(CFStringRef), &cfstr, NULL);			
			if(cfstr == NULL || (slen = CFStringGetLength(cfstr)) <= 0)
				return;
			if(slen >= TEXTMAXLEN)
				slen = TEXTMAXLEN - 1;
			if(slen >= inBufferLength)
				slen = inBufferLength - 1;
			CFStringGetBytes(cfstr, CFRangeMake(0, slen), kCFStringEncodingUTF8,
					'?', // loss byte
					 FALSE, (UInt8 *)fsstr, TEXTMAXLEN - 1, &outbytes);
			CFRelease(cfstr);
			fsstr[outbytes] = fsT('\0');
			fs2ma(outBuffer, fsstr);
			if((outchars = mastrlen(outBuffer)) >= TEXTMAXLEN)
				outchars = TEXTMAXLEN - 1;
			*outTextLength = outchars;
			outBuffer[outchars] = L'\0';
			return;
		break;
		
#if !defined(NOTEXTVIEWER)
		case ID_EDITTEXT_VIEWERVIEW:
			if(!(v = Viewer(windowid)))
			{
				maLogAPI(L"EditTextGetText Viewer failed", windowid, edittext);
				return;
			}
			if(!outBuffer)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_VIEWERVIEW null outBuffer", windowid, edittext);
				return;
			}
			if(from < 0 || to < 1 || from > to)
			{
				maLogAPI(L"EditTextGetText ID_EDITTEXT_VIEWERVIEW 2 bad from to values", windowid, edittext);
				return;
			}
			textView = NULL;
			id.signature = 'MAMP';
			id.id = ID_EDITTEXT_VIEWERVIEW;
			status = HIViewFindByID(HIViewGetRoot((WindowRef)g_w[windowid]), id, &textView);
			if(status != noErr)
			{
				masprintf(mastr, MAXLOGLINELEN, L"EditTextGetText HIViewFindByID err %d", (int)status);
				maLogAPI(mastr, windowid, edittext);
			}
			if(textView != NULL )
			{
				vtext = HIViewCopyText(textView);
				if(vtext != NULL)
				{
					len = CFStringGetLength(vtext);
					if((p1 = (fschar *)MAMALLOC((len + 2) * 4)) == NULL) // max sizeof(UTF-8)
					{
						CFRelease(vtext);
						maLogAPI(L"EditTextGetText MAMALLOC failed", windowid, edittext);
						return;
					}
					if(to > len)
						to = len;
					if(from > to)
						to = len;
					if(from > to)
						from = to;
					CFStringGetBytes(vtext, CFRangeMake(from, to - from), kCFStringEncodingUTF8,
										'?', // loss byte
										FALSE, // no BOM
										(UInt8 *)p1, (len + 2) * 4, // sizeof(p1)
										&outbytes);
					CFRelease(vtext);
					p1[outbytes] = fsT('\0');
					fs2ma(outBuffer, p1);
					MAFREE(p1);
					outchars = mastrlen(outBuffer);
					*outTextLength = outchars;
					outBuffer[outchars] = L'\0';
				}
			}
		break;
#endif
		default:
			maLogAPI(L"EditTextGetText invalid widget", windowid, edittext);		
			return;
		break;
		
	} // switch(edittext)

} // EditTextGetText


/*
void SplashWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("SplashWindowMake");
#endif
	// clone AboutWindowMake
}
*/


OSStatus EqPresetKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus EqPresetKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	EventRef rawEvent;
	unsigned char charCode;

	GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
	GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(machar), NULL, &charCode);

	if(charCode != kEnterCharCode && charCode != kReturnCharCode && charCode != kLineFeedCharCode)
		return eventNotHandledErr;

	OnEditTextEq();
	
	return noErr;
}


void EqualizerWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("EqualizerWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged },
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassMouse,		kEventMouseUp },
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};
	IBNibRef nibRef;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	WindowRef windowref;
	machar mastr[MAXLOGLINELEN];
	
	if(!g_w[WINDOWAPP])
	{
		maLog(L"EqualizerWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEQ])
	{		
		// Search the bundle for a .nib file named 'maosxEq.nib'
		status = CreateNibReference(CFSTR("maosxEq"), &nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"EqualizerWindowMake CreateNibReference err %d 'maosxEq.nib'", (int)status);
			maLog(mastr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"EqualizerWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(mastr);
			return;
		}

		status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(EqualizerWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWEQ, NULL);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"EqualizerWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(mastr);
			return;
		}
		
		id.signature = 'MAMP';
		
		// kb event handler
		id.id = ID_EDITTEXT_EQ;

		GetControlByID(windowref, &id, &cb);	
		InstallEventHandler(GetControlEventTarget(cb), NewEventHandlerUPP(EqPresetKbHandler),
							GetEventTypeCount(l_TextInputEvents), l_TextInputEvents, (void *)WINDOWEQ, NULL);

		// slider (scrollbar) callback proc
		for(id.id = ID_SLIDER_EQ_FIRST; id.id <= ID_SLIDER_EQ_LAST; id.id++)
		{
			GetControlByID(windowref, &id, &cb);
			SetControlAction(cb, SliderCallbackProc);
		}
		
		g_w[WINDOWEQ] = windowref;
		
		if(g_sets.eqflags & MASEPARATELR)
			masprintf(mastr, MAXLOGLINELEN, L"%ls Equalizer Left Channel", g_prognametitle);
		else
			masprintf(mastr, MAXLOGLINELEN, L"%ls Equalizer", g_prognametitle);
		WindowSetTitle(WINDOWEQ, mastr);
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(windowref);
	}
	else
		maLog(L"EqualizerWindowMake already made");

} // EqualizerWindowMake


OSStatus EqualizerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
	
	if((int)userData != WINDOWEQ || !g_w[WINDOWEQ])
		return(eventNotHandledErr);

	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
													sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[WINDOWEQ], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, WINDOWEQ, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					DoWindow(WINDOWEQ, 0);
				return noErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(WINDOWEQ);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(WINDOWEQ);
				return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
 		break;
		
#if defined(MAMOUSEWHEEL) || defined(MAKEYBOARD)
		case kEventClassMouse:
 #if defined(MAMOUSEWHEEL)
 			if(g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
 #endif
 #if defined(MAKEYBOARD)
			// give up kb focus on click in eq window outside Preset Name editor
 			if(g_sets.keyboard && GetEventKind(event) == kEventMouseUp)
				ClearKeyboardFocus((WindowRef)g_w[WINDOWEQ]);
			else
 #endif
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					KeyboardEventHandler(event);
				return noErr;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
	}
	
	return noErr;

} // EqualizerWindowEventHandler


void Equalizer2WindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("Equalizer2WindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged },
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassMouse,		kEventMouseUp },
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};
	IBNibRef nibRef;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	WindowRef windowref;
	machar mastr[MAXLOGLINELEN];
	
	if(!g_w[WINDOWAPP])
	{
		maLog(L"Equalizer2WindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEQ2])
	{		
		// Search the bundle for a .nib file named 'maosxEq2.nib'
		status = CreateNibReference(CFSTR("maosxEq2"), &nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"Equalizer2WindowMake CreateNibReference err %d 'maosxEq2.nib'", (int)status);
			maLog(mastr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"Equalizer2WindowMake CreateWindowFromNib err %d", (int)status);
			maLog(mastr);
			return;
		}

		status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(Equalizer2WindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWEQ2, NULL);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"Equalizer2WindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(mastr);
			return;
		}
		
		id.signature = 'MAMP';
		
		// slider (scrollbar) callback proc
		for(id.id = ID_SLIDER_EQ_FIRST; id.id <= ID_SLIDER_EQ_LAST; id.id++)
		{
			GetControlByID(windowref, &id, &cb);
			SetControlAction(cb, SliderCallbackProc);
		}
		
		g_w[WINDOWEQ2] = windowref;
		
		if(g_sets.eqflags & MASEPARATELR) 
			masprintf(mastr, MAXLOGLINELEN, L"%ls Equalizer Right Channel", g_prognametitle);
		else
			masprintf(mastr, MAXLOGLINELEN, L"%ls Equalizer Right Channel (Off)", g_prognametitle); // never happens
		WindowSetTitle(WINDOWEQ2, mastr);
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(windowref);
	}
	else
		maLog(L"Equalizer2WindowMake already made");

} // Equalizer2WindowMake


OSStatus Equalizer2WindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;

	if((int)userData != WINDOWEQ2 || !g_w[WINDOWEQ2])
		return(eventNotHandledErr);

	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[WINDOWEQ2], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, WINDOWEQ2, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					DoWindow(WINDOWEQ2, 0);
				return noErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(WINDOWEQ2);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(WINDOWEQ2);
				return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
 		break;
		
#if defined(MAMOUSEWHEEL) || defined(MAKEYBOARD)
		case kEventClassMouse:
 #if defined(MAMOUSEWHEEL)
 			if(g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
 #endif
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					KeyboardEventHandler(event);
				return noErr;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
	}
	
	return noErr;

} // Equalizer2WindowEventHandler


void EffectsWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("EffectsWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};  					
	IBNibRef nibRef;
	OSStatus status;
	WindowRef windowref;
	machar mastr[MAXLOGLINELEN];

	if(!g_w[WINDOWAPP])
	{
		maLog(L"EffectsWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEFFECTS])
	{		
		// Search the bundle for a .nib file named 'maosxEffects.nib' 
		status = CreateNibReference(CFSTR("maosxEffects"), &nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"EffectsWindowMake CreateNibReference err %d 'maosxEffects.nib'", (int)status);
			maLog(mastr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"EffectsWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(mastr);
			return;
		}
	
		status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(EffectsWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWEFFECTS, NULL);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"EffectsWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(mastr);
			return;
		}
		
		// slider (scrollbar) callback proc
		ControlID id;
		ControlRef cb;
		id.signature = 'MAMP';
		id.id = ID_SLIDER_PITCH;
		GetControlByID(windowref, &id, &cb);
		SetControlAction(cb, SliderCallbackProc);
		id.id = ID_SLIDER_PITCH2;
		GetControlByID(windowref, &id, &cb);
		SetControlAction(cb, SliderCallbackProc);
		id.id = ID_SLIDER_TEMPO;
		GetControlByID(windowref, &id, &cb);
		SetControlAction(cb, SliderCallbackProc);
		id.id = ID_SLIDER_SPEED;
		GetControlByID(windowref, &id, &cb);
		SetControlAction(cb, SliderCallbackProc);
		
		// red checkboxes
		id.id = ID_CHK_EFFECTSB;
		GetControlByID(windowref, &id, &cb);	
		status = SetControlColorProc(cb, CheckBoxColorCallbackProc);

		id.id = ID_CHK_SBSMS;
		GetControlByID(windowref, &id, &cb);	
		status = SetControlColorProc(cb, CheckBoxColorCallbackProc);

		g_w[WINDOWEFFECTS] = windowref;
		
 #if !defined(MAKEYBOARD)
		int textid;
		for(textid = ID_TEXT_KEYEFFECTS_FIRST; textid <= ID_TEXT_KEYEFFECTS_LAST; textid++)
			StaticTextSetText(WINDOWEFFECTS, textid,  L'\0');
 #endif
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(windowref);
	}
	else
		maLog(L"EffectsWindowMake already made");

} // EffectsWindowMake


OSStatus EffectsWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
	
	if((int)userData != WINDOWEFFECTS || !g_w[WINDOWEFFECTS])
		return(eventNotHandledErr);

	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
													sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[WINDOWEFFECTS], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, WINDOWEFFECTS, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					DoWindow(WINDOWEFFECTS, 0);
				return noErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(WINDOWEFFECTS);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(WINDOWEFFECTS);
				return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
		break;

#if defined(MAMOUSEWHEEL)
		case kEventClassMouse:
			if(g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					KeyboardEventHandler(event);
				return noErr;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
 	}

	return noErr;
	
} // EffectsWindowEventHandler


void FileOutWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("FileOutWindowMake");
#endif
	IBNibRef nibRef;
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
								};  					
	OSStatus status;
	WindowRef windowref;
	machar mastr[MAXLOGLINELEN];

	if(!g_w[WINDOWAPP])
	{
		maLog(L"FileOutWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWFILEOUT])
	{		
		// Search the bundle for a .nib file
		switch(g_sets.output)
		{
#ifdef ENCODEMP3
			case kOUTMP3:
				l_pnibfile = MAOSXFILEOUTMP3;
			break;
#endif
#ifdef ENCODEOGG
			case kOUTOGG:
				l_pnibfile = MAOSXFILEOUTOGG;
			break;
#endif
#ifdef ENCODEAIF
			case kOUTAIF:
				l_pnibfile = MAOSXFILEOUTAIF;
			break;
#endif
#ifdef ENCODEWAV
			case kOUTWAV:
				l_pnibfile = MAOSXFILEOUTWAV;
			break;
#endif
#ifdef ENCODERAW
			case kOUTRAW:
				l_pnibfile = MAOSXFILEOUTRAW;
			break;
#endif
#ifdef ENCODEAAC
			case kOUTAAC:
				l_pnibfile = MAOSXFILEOUTAAC;
			break;
#endif
#ifdef ENCODEMP4
			case kOUTMP4:
				l_pnibfile = MAOSXFILEOUTMP4;
			break;
#endif
#ifdef ENCODEWMA
			case kOUTWMA:
				l_pnibfile = MAOSXFILEOUTWMA;
			break;
#endif
#ifdef ENCODEFLAC
			case kOUTFLAC:
				l_pnibfile = MAOSXFILEOUTFLAC;
			break;
#endif
			case kOUTSOUND:
				// maLog(L"FileOutWindowMake sound output");
			break;
			default:
				maLog(L"FileOutWindowMake unknown output");
			return;
		}
		
		CFStringRef cfstr;
		cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)l_pnibfile, kCFStringEncodingUTF8);
		status = CreateNibReference(cfstr, &nibRef);
		CFRelease(cfstr);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"FileOutWindowMake CreateNibReference err %d '%s.nib'", (int)status, l_pnibfile);
			maLog(mastr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"FileOutWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(mastr);
			return;
		}
	
		status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(FileOutWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWFILEOUT, NULL);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"FileOutWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(mastr);
			return;
		}
		
		g_w[WINDOWFILEOUT] = windowref;
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(windowref);
	}
	else
		maLog(L"FileOutWindowMake already made");

} // FileOutWindowMake


OSStatus FileOutWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;

	if((int)userData != WINDOWFILEOUT || !g_w[WINDOWFILEOUT])
		return(eventNotHandledErr);
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[WINDOWFILEOUT], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, WINDOWFILEOUT, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					DoWindow(WINDOWFILEOUT, 0);
				return noErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(WINDOWFILEOUT);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(WINDOWFILEOUT);
					return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
		break;

		default:
		return eventNotHandledErr;
	}
	
	return noErr;

} // FileOutWindowEventHandler


OSStatus PromptNumKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus PromptNumKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	EventRef rawEvent;
	unsigned char charCode;

	GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
	GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(machar), NULL, &charCode);

	if(charCode != kEnterCharCode && charCode != kReturnCharCode && charCode != kLineFeedCharCode)
		return eventNotHandledErr;

	DoPromptIndexOk();
	
	return noErr;
	
} // PromptNumKbHandler


void PromptNumWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("PromptNumWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess },
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
									{ kEventClassWindow,	kEventWindowClose },
								};
	IBNibRef nibRef;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	WindowRef windowref;
	machar mastr[MAXLOGLINELEN];
	
	if(!g_w[WINDOWAPP])
	{
		maLog(L"PromptNumWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWPROMPTNUM])
	{		
		// Search the bundle for a .nib file named 'maosxPromptNum.nib'
		status = CreateNibReference(CFSTR("maosxPromptNum"), &nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"PromptNumWindowMake CreateNibReference err %d 'maosxPromptNum.nib'", (int)status);
			maLog(mastr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"PromptNumWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(mastr);
			return;
		}

		status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(PromptNumWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWPROMPTNUM, NULL);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"PromptNumWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(mastr);
			return;
		}
		
		id.signature = 'MAMP';
		
		// kb event handler
		id.id = ID_EDITTEXT_PROMPTNUM;
		GetControlByID(windowref, &id, &cb);	
		InstallEventHandler(GetControlEventTarget(cb), NewEventHandlerUPP(PromptNumKbHandler),
							GetEventTypeCount(l_TextInputEvents), l_TextInputEvents, (void *)WINDOWPROMPTNUM, NULL);

		g_w[WINDOWPROMPTNUM] = windowref;
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(windowref);
			
		// set focus to edit text
		SetKeyboardFocus(windowref, cb, kControlFocusNoPart);
		SetKeyboardFocus(windowref, cb, kControlFocusNextPart);
	}
	else
		maLog(L"PromptNumWindowMake already made");

} // PromptNumWindowMake


OSStatus PromptNumWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;

	if((int)userData != WINDOWPROMPTNUM || !g_w[WINDOWPROMPTNUM])
		return(eventNotHandledErr);
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[WINDOWPROMPTNUM], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, WINDOWPROMPTNUM, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					DoWindow(WINDOWPROMPTNUM, 0);
				return noErr;				

				default:
				break;
			}
		break;

		default:
		break;
	}

	return eventNotHandledErr;
	
} // PromptNumWindowEventHandler


void AdvancedWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("AdvancedWindowMake");
#endif
	IBNibRef nibRef;
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
								};  					
	OSStatus status;
	WindowRef windowref;
	machar mastr[MAXLOGLINELEN];

	if(!g_w[WINDOWAPP])
	{
		maLog(L"AdvancedWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWADVANCED])
	{		
		// Search the bundle for a .nib file named 'maosxAdvanced.nib'
		status = CreateNibReference(CFSTR("maosxAdvanced"), &nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"AdvancedWindowMake CreateNibReference err %d 'maosxAdvanced.nib'", (int)status);
			maLog(mastr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"AdvancedWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(mastr);
			return;
		}
	
		status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(AdvancedWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWADVANCED, NULL);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"AdvancedWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(mastr);
			return;
		}
		
		g_w[WINDOWADVANCED] = windowref;
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(windowref);
	}
	else
		maLog(L"AdvancedWindowMake already made");

} // AdvancedWindowMake


OSStatus AdvancedWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
	
	if((int)userData != WINDOWADVANCED || !g_w[WINDOWADVANCED])
		return(eventNotHandledErr);
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[WINDOWADVANCED], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, WINDOWADVANCED, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					DoWindow(WINDOWADVANCED, 0);
				return noErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(WINDOWADVANCED);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(WINDOWADVANCED);
					return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
		break;

		default:
		return eventNotHandledErr;
	}
	
	return noErr;

} // AdvancedWindowEventHandler


void ListAppend(int windowid, int list, machar *text)
{
#ifdef MATRACEGUIOSX
	maTrace("ListAppend");
#endif
	int llinemax;
	int islist = 0;
	ControlID id;
	ControlRef cb;
	DataBrowserItemID item;
	OSStatus status;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(!cb)
	{
		maLogAPI(L"ListAppend no widget", windowid, list);
		return;		
	}

	switch(g_sets.listboxmode & (LBOXPLAYERINFO | LBOXPLAYLIST | LBOXSONGSLOADED | LBOXSONGINFO))
	{
		case LBOXPLAYLIST:
			if(!(llinemax = g_songsnum))
				llinemax = 1;
			islist = 1;
		break;
		case LBOXSONGSLOADED:	
			if(!(llinemax = g_loadednum))
				llinemax = 1;
		break;
		case LBOXPLAYERINFO:
		case LBOXSONGINFO:
		default:
			llinemax = 128;
		break;
	}

	if(llinemax && g_linenum >= llinemax)
	{
		maLog(L"ListAppend reached max list size");
		return;
	}
	
	if(l_lline)
	{
		if(llinemax != l_llinemax)
		{
			MAFREE(l_lline);
			l_lline = NULL;
		}
	}
	
	if(!(l_llinemax = llinemax))
		return;
	
	if(!l_lline && (l_lline = (char *)MAMALLOC(l_llinemax * LISTLINELEN)) == NULL)
	{
		maLog(L"ListAppend MAMALLOC failed");
		return;
	}
	fschar fsstr[LISTLINELEN];
	ma2fs(fsstr, text);
	fsstrncpy(l_lline + g_linenum * LISTLINELEN, fsstr, LISTLINELEN);
	*(l_lline + g_linenum * LISTLINELEN + LISTLINELEN - 1) = '\0';
	
	if(islist)
	{
		if(g_linenum < llinemax - 1)
			status = AddDataBrowserItems(cb, kDataBrowserNoItem, 1, NULL, kDataBrowserItemNoProperty);
		else // last of list
			status = AddDataBrowserItems(cb, kDataBrowserNoItem, g_linenum + 1, NULL, kDataBrowserItemNoProperty);
	}
	else
	{
		item = g_linenum + 1;
		status = AddDataBrowserItems(cb, kDataBrowserNoItem, 1, &item, kDataBrowserItemNoProperty);
	}
				
	if(status != noErr)
	{
		maLog(L"ListAppend AddDataBrowserItems failed");
		return;
	}
	
	g_linenum++;
	
} // ListAppend

 
void ListClear(int windowid, int list)
{
#ifdef MATRACEGUIOSX
	maTrace("ListClear");
#endif
	ControlID id;
	ControlRef cb;
	OSStatus status;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	if(g_linenum)
	{
		id.signature = 'MAMP';
		id.id = list;
		status = GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
		if(status != noErr)
		{
			machar mastr[MAXLOGLINELEN];
			masprintf(mastr, MAXLOGLINELEN, L"ListClear GetControlByID error=%d window=%d list=%d", (int)status, windowid, list);
			maLog(mastr);
		}
		else
		{
			if(cb)
			{
  				status = RemoveDataBrowserItems(cb, kDataBrowserNoItem, 0, NULL, kDataBrowserItemNoProperty);
				if(status != noErr)
				{
					machar mastr[MAXLOGLINELEN];
					masprintf(mastr, MAXLOGLINELEN, L"ListClear RemoveDataBrowserItems error=%d window=%d list=%d",
																	(int)status, windowid, list);
					maLog(mastr);
				}
			}
			else
				maLogAPI(L"ListClear no widget", windowid, list);
		}
		
		g_linenum = 0;
	}
	
	if(l_lline)
	{
		MAFREE(l_lline);
		l_lline = NULL;
	}

} // ListClear


int ListGetRowSelected(int windowid, int list)
{
#ifdef MATRACEGUIOSX
	maTrace("ListGetRowSelected");
#endif
	DataBrowserItemID first;
	DataBrowserItemID last;
	ControlID id;
	ControlRef cb;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return -1;

	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		GetDataBrowserSelectionAnchor(cb, &first, &last);
	else
		maLogAPI(L"ListGetRowSelected no widget", windowid, list);

	return first - 1;
}


void ListEnsureVisible(int windowid, int list, int row)
{
#ifdef MATRACEGUIOSX
	maTrace("ListEnsureVisible");
#endif
	ControlID id;
	ControlRef cb;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
	{
		RevealDataBrowserItem(cb, row + 1, kDataBrowserItemNoProperty,
		kDataBrowserRevealAndCenterInView + kDataBrowserRevealWithoutSelecting);
	}
	else
		maLogAPI(L"ListEnsureVisible no widget", windowid, list);
}


void ListSelect(int windowid, int list, int row)
{
#ifdef MATRACEGUIOSX
	maTrace("ListSelect");
#endif
	ControlID id;
	ControlRef cb;
	DataBrowserItemID item = row + 1;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
  	{
		g_listselect++;
		SetDataBrowserSelectedItems(cb, 1, &item, kDataBrowserItemsAssign);
	}
	else
		maLogAPI(L"ListSelect no widget", windowid, list);
}


void ListGetText(int windowid, int list, int row, machar *text)
{
#ifdef MATRACEGUIOSX
	maTrace("ListGetText");
#endif
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	if(l_lline)
	{
		fschar fsstr[LISTLINELEN];
		strcpy((char *)fsstr, l_lline + row * LISTLINELEN);
		fs2ma(text, fsstr);
	}
	else
		maLogAPI(L"ListGetText no l_lline", windowid, list);

	/*
	Handle items;
	ControlID id;
	ControlRef cb;
	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
  	{
		OSStatus status;
		items = NewHandle(0);

		status = GetDataBrowserItems(cb, (DataBrowserItemID)(row + 1), false, kDataBrowserItemAnyState /w* kDataBrowserItemNoState *w/, items);
		if(status != noErr)
		{
			maLog(L"ListGetText GetDataBrowserItems failed");
			DisposeHandle(items);
			return;
		}
		DisposeHandle(items);
	}
	else
		maLogAPI(L"ListGetText no widget", windowid, list);
	*/
	
} // ListGetText


/* not used void ListSetText(int windowid, int list, int row, machar *text)
{
#ifdef MATRACEGUIOSX
	maTrace("ListSetText");
#endif
}
*/


enum {ListCol1Property = 'COL1'}; // this is set in the .nib column settings, if we have a browser in nib
void ListSetHeader(int windowid, int list, int col, machar *header)
{
#ifdef MATRACEGUIOSX
	maTrace("ListSetHeader");
#endif

	ControlRef cb;
	ControlID id;
	CFStringRef cfstr;
	OSStatus status;
	DataBrowserListViewHeaderDesc desc = {0};
	
	if(!g_w[WINDOWLIST])
		return;

	id.signature = 'MAMP';
	id.id = ID_LIST_CTRL;
	status = GetControlByID((WindowRef)g_w[WINDOWLIST], &id, &cb);
	if(status != noErr)
	{
		maLog(L"ListSetHeader GetControlByID failed");
		return;
	}

	fschar fsstr[MAX_PATH];
	ma2fs(fsstr, header);
	cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
	if(!cfstr)
	{
		maLog(L"ListSetHeader CFStringCreateWithCString failed");
		return;
	}

	status = GetDataBrowserListViewHeaderDesc(cb, ListCol1Property, &desc);
	if(status != noErr)
	{
		maLog(L"ListSetHeader GetDataBrowserListViewHeaderDesc failed");
		// return;
		// try to keep going :
		desc.version = kDataBrowserListViewLatestHeaderDesc;
		desc.minimumWidth = 20; // same as in .nib column info
		desc.maximumWidth = 1024;
		desc.initialOrder = kDataBrowserOrderIncreasing;
		desc.btnFontStyle.flags = kControlUseFontMask + kControlUseJustMask;
		desc.btnFontStyle.font = kControlFontSmallSystemFont;
		desc.btnFontStyle.style = kControlUseThemeFontIDMask;
		// desc.titleOffset = 0;
		// desc.btnFontStyle.just = 0; // left justification
		// desc.btnFontStyle.size;
		// desc.btnFontStyle.mode;
		// desc.btnFontStyle.foreColor;
		// desc.btnFontStyle.backColor;
		// desc.btnContentInfo; 
	}
	
	desc.titleString = cfstr;
	status = SetDataBrowserListViewHeaderDesc(cb, ListCol1Property, &desc);
	CFRelease(cfstr);
	if(status != noErr)
		maLog(L"ListSetHeader SetDataBrowserListViewHeaderDesc failed");

} // ListSetHeader


void SetColumn0Width(int width)
{
	UInt16 w;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	
	if(!g_w[WINDOWLIST])
		return;

	if(width <= 0)
	{
		switch(g_sets.listboxmode & (LBOXPLAYERINFO | LBOXPLAYLIST | LBOXSONGSLOADED | LBOXSONGINFO))
		{
			case LBOXPLAYERINFO:
				w = g_sets.listcolxsize[g_sets.winconf][0];
			break;
			case LBOXPLAYLIST:
				w = g_sets.listcolxsize[g_sets.winconf][1];
			break;
			case LBOXSONGSLOADED:
				w = g_sets.listcolxsize[g_sets.winconf][2];
			break;
			case LBOXSONGINFO:
				w = g_sets.listcolxsize[g_sets.winconf][3];
			break;
			default:
			return;
		}
	}
	else
		w = width;
	
	id.signature = 'MAMP';
	id.id = ID_LIST_CTRL;
	status = GetControlByID((WindowRef)g_w[WINDOWLIST], &id, &cb);
	if(status != noErr)
	{
		maLog(L"SetColumn0Width GetControlByID failed");
		return;
	}
	
	status = SetDataBrowserTableViewColumnWidth(cb, w);
	if(status != noErr)
	{
		maLog(L"SetColumn0Width SetDataBrowserTableViewColumnWidth failed");
		return;
	}

	if(width > 0)
		GetColumn0Width();

} // SetColumn0Width

		
void GetColumn0Width()
{
	UInt16 width;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	
	if(!g_w[WINDOWLIST])
		return;

	id.signature = 'MAMP';
	id.id = ID_LIST_CTRL;
	status = GetControlByID((WindowRef)g_w[WINDOWLIST], &id, &cb);
	if(status != noErr)
	{
		maLog(L"GetColumn0Width GetControlByID failed");
		return;
	}
	
	status = GetDataBrowserTableViewColumnWidth(cb, &width)										;
	if(status != noErr)
	{
		maLog(L"GetColumn0Width GetDataBrowserTableViewColumnWidth failed");
		return;
	}

	if(width < (g_sets.mawin[WINDOWLIST].xsize[g_sets.winconf] - SCROLLERWIDTH))
		width = g_sets.mawin[WINDOWLIST].xsize[g_sets.winconf] - SCROLLERWIDTH;

	switch(g_sets.listboxmode & (LBOXPLAYERINFO | LBOXPLAYLIST | LBOXSONGSLOADED | LBOXSONGINFO))
	{
		case LBOXPLAYERINFO:
			g_sets.listcolxsize[g_sets.winconf][0] = width;
		break;
		case LBOXPLAYLIST:
			g_sets.listcolxsize[g_sets.winconf][1] = width;
		break;
		case LBOXSONGSLOADED:
			g_sets.listcolxsize[g_sets.winconf][2] = width;
		break;
		case LBOXSONGINFO:
			g_sets.listcolxsize[g_sets.winconf][3] = width;
		break;
		default:
		break;
	}

	return;
	
} // GetColumn0Width

		
void ListSetColumnWidth()
{
#ifdef MATRACEGUIOSX
	maTrace("ListSetColumnWidth");
#endif
	SetColumn0Width(0);
}


void ListFreeze()
{
#ifdef MATRACEGUIOSX
	maTrace("ListFreeze");
#endif
}


void ListThaw()
{
#ifdef MATRACEGUIOSX
	maTrace("ListThaw");
#endif
}


void ListResize()
{
#ifdef MATRACEGUIOSX
	maTrace("ListResize");
#endif
	WindowRef windowref;
	HIViewRef contentView;
	HIRect boundsRect;
	
	if((windowref = (WindowRef)g_w[WINDOWLIST]))
	{
		if(HIViewFindByID(HIViewGetRoot(windowref), kHIViewWindowContentID, &contentView) == noErr)
		{
			HIViewGetBounds(contentView, &boundsRect);
			boundsRect.origin.y += kListSpacer1;
			boundsRect.size.height -= kListSpacer1;
			HIViewSetFrame(HIViewGetFirstSubview(contentView), &boundsRect);
			SetColumn0Width((int)(boundsRect.size.width - SCROLLERWIDTH));
		}
	}
	
} // ListResize


OSStatus ListDBItemDataCallback(ControlRef browser, DataBrowserItemID itemID, DataBrowserPropertyID property,
								DataBrowserItemDataRef itemData, Boolean changeValue)
{
	OSStatus status = noErr; 
	CFStringRef cfstr;
	
	if(!changeValue)
	{
		switch(property)
		{
			case ListCol1Property:
				if(itemID < 1 || itemID > (DataBrowserItemID)l_llinemax)
				{
					maLog(L"ListDBItemDataCallback bad itemID");
					status = errDataBrowserItemNotAdded;
					break;
				}
				cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)(l_lline + (itemID - 1) * LISTLINELEN),
					kCFStringEncodingUTF8);
				if(cfstr)
				{
					status = SetDataBrowserItemDataText(itemData, cfstr);
					CFRelease(cfstr);
				}	
				else
				{
					maLog(L"ListDBItemDataCallback CFStringCreateWithCString failed");
					status = errDataBrowserItemNotAdded;
				}
				//if(itemID && itemID == l_llinemax) // on last item
			break;
			default:
				status = errDataBrowserPropertyNotSupported;
			break;
		}
	}
	else
		status = errDataBrowserPropertyNotSupported;

	return status;

} // ListDBItemDataCallback


void ListDBNotificationCallback(ControlRef browser, DataBrowserItemID itemID,
						DataBrowserItemNotification message, DataBrowserItemDataRef itemData)
{
	switch(message)
	{
		case kDataBrowserUserStateChanged:
			GetColumn0Width();
		break;
		case kDataBrowserItemDoubleClicked:
			OnListWindowDoubleClick();
		break;
		case kDataBrowserItemSelected:
			OnListWindowSingleClick((int)itemID); // will do nothing if g_listselect is > 0
		break;
		default:
		break;
	}
	return;
}


OSStatus ListWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;

	if((int)userData != WINDOWLIST || !g_w[WINDOWLIST])
		return(eventNotHandledErr);
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[WINDOWLIST], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, WINDOWLIST, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					DoWindow(WINDOWLIST, 0);
				return noErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(WINDOWLIST);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(WINDOWLIST);
				return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
		break;

#if defined(MAMOUSEWHEEL) || defined(MAKEYBOARD)
		case kEventClassMouse:
 #if defined(MAMOUSEWHEEL)
 			if(g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				HIPoint point;
				GetEventParameter(event, kEventParamWindowMouseLocation, typeHIPoint, NULL, sizeof(point), NULL, &point);
				if(point.y > kListSpacer1 + 23) // mouse pointer is inside the list
					return eventNotHandledErr;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
 #endif
 #if defined(MAKEYBOARD)
			// give up kb focus on click in list window outside list
 			if(g_sets.keyboard && GetEventKind(event) == kEventMouseUp)
			{
				HIPoint point;
				GetEventParameter(event, kEventParamWindowMouseLocation, typeHIPoint, NULL, sizeof(point), NULL, &point);
				if(point.y > kListSpacer1 + 23) // mouse pointer is inside the list
					return eventNotHandledErr;
				ClearKeyboardFocus((WindowRef)g_w[WINDOWLIST]);
			}
			else
 #endif
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					KeyboardEventHandler(event);
				return noErr;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
	}

	return noErr;
	
} // ListWindowEventHandler


OSStatus ListKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus ListKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	EventRef rawEvent;
	unsigned char charCode;
	
	GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
	GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(machar), NULL, &charCode);

	if(charCode != kEnterCharCode && charCode != kReturnCharCode && charCode != kLineFeedCharCode)
		return eventNotHandledErr;

	OnListWindowDoubleClick();
	
	return noErr;
}


void ListWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("ListWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassMouse,		kEventMouseUp },
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};  					
	IBNibRef nibRef;
	WindowRef windowref;
	ControlRef browser;
	ControlID id = {'MAMP', ID_LIST_CTRL};
	OSStatus status;
	machar mastr[MAXLOGLINELEN];

	if(!g_w[WINDOWAPP])
	{
		maLog(L"ListWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWLIST])
	{		
		// Search the bundle for a .nib file named 'maosxList.nib'
		status = CreateNibReference(CFSTR("maosxList"), &nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"ListWindowMake CreateNibReference err %d 'maosxList.nib'", (int)status);
			maLog(mastr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"ListWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(mastr);
			return;
		}

		status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(ListWindowEventHandler), 
											sizeof(eventspec), eventspec, (void *)WINDOWLIST, NULL);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"ListWindowMake InstallWindowEventHandler (window) err %d", (int)status);
			maLog(mastr);
			return;
		}
		
		HISize min, max;
		GetWindowResizeLimits(windowref, &min, &max);
		min.width = 20;
		min.height = 20;
		SetWindowResizeLimits(windowref, &min, &max);

		g_w[WINDOWLIST] = windowref;
		
		// listbox
		// GetControlByID(window, &id, &browser);
		// a DataBrowser created from a nib file seems to have problems detecting mouse doubleclicks
		// with large (1500+) playlists, so we don't put one in the nib file and create it here instead
		
		// for browser not in nib : 	
		Rect bounds;
		bounds.top = kListSpacer1;
		bounds.left = 0;
		bounds.bottom = g_sets.mawin[WINDOWLIST].ysize[g_sets.winconf];
		bounds.right = g_sets.mawin[WINDOWLIST].xsize[g_sets.winconf];
		CreateDataBrowserControl(windowref, &bounds, kDataBrowserListView, &browser);		
		SetControlID(browser, &id);
		SetDataBrowserSelectionFlags(browser, kDataBrowserSelectOnlyOne);

		// browser callbacks
		DataBrowserCallbacks dbCallbacks;
		dbCallbacks.version = kDataBrowserLatestCallbacks;
		InitDataBrowserCallbacks(&dbCallbacks);
		dbCallbacks.u.v1.itemDataCallback =
			NewDataBrowserItemDataUPP((DataBrowserItemDataProcPtr)ListDBItemDataCallback);
		dbCallbacks.u.v1.itemNotificationCallback =
			(DataBrowserItemNotificationUPP)NewDataBrowserItemNotificationWithItemUPP(ListDBNotificationCallback);
		SetDataBrowserCallbacks(browser, &dbCallbacks);
		
		// more stuff for browser not in nib :
		DataBrowserListViewColumnDesc columnDesc;
		columnDesc.headerBtnDesc.titleOffset = 0;
		columnDesc.headerBtnDesc.version = kDataBrowserListViewLatestHeaderDesc;
		columnDesc.headerBtnDesc.btnFontStyle.flags	= kControlUseFontMask | kControlUseJustMask;
		columnDesc.headerBtnDesc.btnContentInfo.contentType = kControlNoContent;
		columnDesc.headerBtnDesc.btnFontStyle.just = teFlushDefault;
		columnDesc.headerBtnDesc.minimumWidth = 20;
		columnDesc.headerBtnDesc.maximumWidth = 1024;
		columnDesc.headerBtnDesc.btnFontStyle.font = kControlFontSmallSystemFont;
		columnDesc.headerBtnDesc.btnFontStyle.style = kControlUseThemeFontIDMask;
		CFStringRef cfstr = CFStringCreateWithCString(kCFAllocatorDefault, "", kCFStringEncodingUTF8);
		columnDesc.headerBtnDesc.titleString = cfstr;
		columnDesc.propertyDesc.propertyID = ListCol1Property;
		columnDesc.propertyDesc.propertyType = kDataBrowserTextType;
		columnDesc.propertyDesc.propertyFlags = kDataBrowserListViewTypeSelectColumn | kDataBrowserListViewSelectionColumn;
		status = AddDataBrowserListViewColumn(browser, &columnDesc, kDataBrowserListViewAppendColumn);
		CFRelease(cfstr);
		AutoSizeDataBrowserListViewColumns(browser);
		SetDataBrowserHasScrollBars(browser, true, true);
		SetDataBrowserTableViewHiliteStyle(browser, kDataBrowserTableViewFillHilite);
		SetDataBrowserListViewHeaderBtnHeight(browser, 17);

		// kb event handler
		status = InstallEventHandler(GetControlEventTarget(browser), NewEventHandlerUPP(ListKbHandler),
							GetEventTypeCount(l_TextInputEvents), l_TextInputEvents, (void *)WINDOWLIST, NULL);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"ListWindowMake InstallEventHandler (kb) err %d", (int)status);
			maLog(mastr);
		}

		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(windowref);
	}
	else
		maLog(L"ListWindowMake already made");

} // ListWindowMake


void MenuEnable(int menu, int item)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuEnable");
#endif
	EnableMenuCommand(NULL, l_commandid[item]);
}


void MenuDisable(int menu, int item)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuDisable");
#endif
	DisableMenuCommand(NULL, l_commandid[item]);
}


/* int MenuIsChecked(int menu, int item)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuIsChecked");
#endif
	return menuchecked[item];
}
*/


void MenuSetChecked(int menu, int item, int value)
{
	OSStatus status;
#ifdef MATRACEGUIOSX
	maTrace("MenuSetChecked");
#endif
	MenuRef pmenu;
	MenuItemIndex index;
	if(l_commandid[item] == 'NULL')
		return;
	if((status = GetIndMenuItemWithCommandID(NULL, l_commandid[item], 1, &pmenu, &index)))
	{
		machar mastr[MAXLOGLINELEN];
		masprintf(mastr, MAXLOGLINELEN, L"MenuSetChecked GetIndMenuItemWithCommandID menu=%d l_commandid[%d]='%c%c%c%c' err=%d",
		menu, item,
		(machar)((l_commandid[item] >> 24) & 0xff), (machar)((l_commandid[item] >> 16) & 0xff),
		(machar)((l_commandid[item] >>  8) & 0xff), (machar)(l_commandid[item] & 0xff), (int)status);
		maLog(mastr);
		return;
	}
	MacCheckMenuItem(pmenu, index, value ? 1 : 0);
	menuchecked[item] = value ? 1 : 0;

} // MenuSetChecked


int MenuToggle(UInt32 commandid)
{
	int item;
	for(item = ID_MENU_FIRST; item <= ID_MENU_LAST; item++)
		if(commandid == l_commandid[item])
		{
			MenuSetChecked(0, item, menuchecked[item] ? 0 : 1);
			return menuchecked[item]; // new value
		}
	return -1;

} // MenuToggle


void PopupButtonEnable(int windowid, int popup)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonEnable");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI(L"PopupButtonEnable no widget", windowid, popup);		

} // PopupButtonEnable


void PopupButtonDisable(int windowid, int popup)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonDisable");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI(L"PopupButtonDisable no widget", windowid, popup);		

} // PopupButtonDisable


void PopupButtonClear(int windowid, int popup)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonClear");
#endif
	ControlRef cb;
	ControlID id;
	MenuRef menu;
    
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
  	if(cb)
	{
		GetControlData(cb, 0, kControlPopupButtonMenuRefTag, sizeof(MenuRef), &menu, NULL);
        DeleteMenuItems(menu, 1, CountMenuItems(menu));
	}
	else
		maLogAPI(L"PopupButtonClear no widget", windowid, popup);		
}


/* crashes */
void PopupButtonAppend(int windowid, int popup, machar *text)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonAppend");
#endif
	ControlRef cb;
	ControlID id;
	MenuRef menu;
	CFStringRef cfstr;
	fschar fsstr[STRLEN256]; // arbitrary size
	machar mastr2[STRLEN256];

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	if(l_commandid[popup] == 'NULL')
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
  	if(cb)
	{
		mastrncpy(mastr2, text, STRLEN256 - 1);
		mastr2[STRLEN256 - 1] = L'\0';
		ma2fs(fsstr, mastr2);

		GetControlData(cb, 0, kControlPopupButtonMenuRefTag, sizeof(MenuRef), &menu, NULL);
		cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
		AppendMenuItemTextWithCFString(menu, cfstr, 0, l_commandid[popup], NULL);
		CFRelease(cfstr);
		
  		if(CountMenuItems(menu) >= 1)
		{
			SetControlMaximum(cb, CountMenuItems(menu));
			SetControlMinimum(cb, 1);
		}
		else
		{
			SetControlMinimum(cb, 0);
			SetControlMaximum(cb, 0);
		}
	}
	else
		maLogAPI(L"PopupButtonAppend no widget", windowid, popup);		

} // PopupButtonAppend
/**/
/*
// doesn't crash
void PopupButtonAppend(int windowid, int popup, machar *text)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonAppend");
#endif
	int l;
	ControlRef cb;
	ControlID id;
	MenuRef menu;
	unsigned char pstr[STRLEN256];
	machar mastr2[STRLEN256];

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
  	if(cb)
	{
		mastrncpy(mastr2, text, STRLEN256 - 1);
		mastr2[STRLEN256 - 1] = L'\0';
		if((l = mastrlen(mastr2)) > 255)
		{
			l = 255;
			mastr2[255] = L'\0';
		}
		pstr[0] = l;
		ma2fs((fschar *)&pstr[1], mastr2);

		GetControlData(cb, 0, kControlPopupButtonMenuRefTag, sizeof(MenuRef), &menu, NULL);
		AppendMenuItemText(menu, pstr); // deprecated: use AppendMenuItemTextWithCFString instead
		if(CountMenuItems(menu) >= 1)
		{
			SetControlMaximum(cb, CountMenuItems(menu));
			SetControlMinimum(cb, 1);
		}
		else
		{
			SetControlMinimum(cb, 0);
			SetControlMaximum(cb, 0);
		}
	}
	else
		maLogAPI(L"PopupButtonAppend no widget", windowid, popup);		

} // PopupButtonAppend
*/

void PopupButtonSetValue(int windowid, int popup, int value)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonSetValue");
#endif
	ControlRef cb;
	ControlID id;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
		SetControlValue(cb, value + 1);
	else
		maLogAPI(L"PopupButtonSetValue no widget", windowid, popup);		
	return;

} // PopupButtonSetValue


void PopupButtonSetText(int windowid, int popup, int item, machar *text)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonSetText");
#endif
	CFStringRef cfstr;
	ControlRef cb;
	ControlID id;
	MenuRef menu;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		fschar fsstr[MAX_PATH];
		ma2fs(fsstr, text);
		GetControlData(cb, 0, kControlPopupButtonMenuRefTag, sizeof(MenuRef), &menu, NULL);
		ma2fs(fsstr, text);
		cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
		if(cfstr)
		{
			SetMenuItemTextWithCFString(menu, /* MenuItemIndex inItem*/ item + 1, cfstr);
			CFRelease(cfstr);
		}

	}
	else
		maLogAPI(L"PopupButtonSetText no widget", windowid, popup);		

} // PopupButtonSetText


/* not used
void PopupButtonSetSelection(int windowid, int popup, int item)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonSetSelection");
#endif
}
*/


/* not used
void SpinButtonEnable(int windowid, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonEnable");
#endif
	PushButtonEnable(windowid, button);
}


void SpinButtonDisable(int windowid, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("SpinButtonDisable");
#endif
	PushButtonDisable(windowid, button);
}
*/


void PushButtonPaintUp(int windowid, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonPaintUp");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		SetControlValue(cb, 0);
	else
		maLogAPI(L"PushButtonPaintUp no widget", windowid, button);		
}


void PushButtonPaintDown(int windowid, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonPaintDown");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		SetControlValue(cb, 1);
	else
		maLogAPI(L"PushButtonPaintDown no widget", windowid, button);		
}


void PushButtonEnable(int windowid, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonEnable");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI(L"PushButtonEnable no widget", windowid, button);		
}


void PushButtonDisable(int windowid, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonDisable");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI(L"PushButtonDisable no widget", windowid, button);		
}


void PushButtonSetDescriptor(int windowid, int button, machar *desc)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonSetDescriptor");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef cfstr;
	fschar fsstr[MAX_PATH]; // arbitrary size

	if(!g_w[windowid] || !desc)
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		ma2fs(fsstr, desc);
		cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
		if(cfstr)
		{
			SetControlTitleWithCFString(cb, cfstr);
			CFRelease(cfstr);
		}
	}
	else
		maLogAPI(L"PushButtonSetDescriptor no widget", windowid, button);
		
} // PushButtonSetDescriptor


void PushButtonGetDescriptor(int windowid, int button, machar *desc)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonGetDescriptor");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef cfstr;
	CFIndex slen;
	CFIndex outbytes;
	fschar fsstr[STRLEN256];

	if(!g_w[windowid] || !desc)
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		CopyControlTitleAsCFString(cb, &cfstr);
		if(cfstr == NULL || (slen = CFStringGetLength(cfstr)) <= 0)
			return;
		if(slen >= STRLEN256)
			slen = STRLEN256 - 1;
		CFStringGetBytes(cfstr, CFRangeMake(0, slen), kCFStringEncodingUTF8,
					'?', // loss byte
					 FALSE, (UInt8 *)fsstr, STRLEN256 - 1, &outbytes);
		CFRelease(cfstr);
		fsstr[outbytes] = fsT('\0');
		fs2ma(desc, fsstr);
	}
	else
		maLogAPI(L"PushButtonGetDescriptor no widget", windowid, button);
}

void SliderCallback(ControlHandle control, SInt16 part)
{
	SInt16 startValue;
	SInt16 delta;
	ControlID id;
	
	startValue = GetControlValue(control);
	
	delta = 0;
	
	switch(part)
	{
		case kControlUpButtonPart:
			if(startValue > GetControlMinimum(control))
				delta = -1;
			break;
		
		case kControlDownButtonPart:
			if(startValue < GetControlMaximum(control))
				delta = 1;
			break;
		
		case kControlPageUpPart:
			if(startValue > GetControlMinimum(control))
				delta = -10;
			break;
		
		case kControlPageDownPart:
			if(startValue < GetControlMaximum(control))
				delta = 10;
			break;
	}
	
	if(delta)
		SetControlValue(control, startValue + delta);

	if(part != kControlIndicatorPart && delta == 0)
		return;
	
	if(GetControlID(control, &id))
	{
		maLogAPI(L"SliderCallback GetControlID failed", WINDOWAPP, id.id);
		return;
	}

	if(id.id >= ID_SLIDER_EQ_FIRST && id.id <= ID_SLIDER_EQ_LAST)
	{
		OnSliderEq(id.id - ID_SLIDER_EQ_FIRST, SliderGetValue(WINDOWEQ, id.id), 0);
		return;
	}
	
	switch(id.id)
	{
		case ID_SLIDER_VOLUMEL:
			OnSliderVolumeL(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMEL));
		break;
		case ID_SLIDER_VOLUMER:
			OnSliderVolumeR(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMER));
		break;
		case ID_SLIDER_VOLUMESEP:
			OnSliderSeparation(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMESEP));
		break;
		case ID_SLIDER_PREAMP:
			OnSliderPreamp(SliderGetValue(WINDOWAPP, ID_SLIDER_PREAMP));
		break;
		case ID_SLIDER_POSITION:
			OnSliderPosition(SliderGetValue(WINDOWAPP, ID_SLIDER_POSITION));
		break;

		case ID_SLIDER_PITCH:
			OnSliderPitch(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_PITCH));
		break;
		case ID_SLIDER_PITCH2:
			OnSliderPitch2(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_PITCH2));
		break;
		case ID_SLIDER_TEMPO:
			OnSliderTempo(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_TEMPO));
		break;
		case ID_SLIDER_SPEED:
			OnSliderSpeed(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_SPEED));
		break;

		default:
			maLogAPI(L"SliderCallback unexpected id", WINDOWAPP, id.id);
		break;
	}

} // SliderCallback


int SliderGetValue(int windowid, int slider) // also ScrollBarGetValue
{
#ifdef MATRACEGUIOSX
	maTrace("SliderGetValue");
#endif
	ControlRef cb;
	ControlID id;
	ControlKind kind;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return 0;

	id.signature = 'MAMP';
	id.id = slider;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		GetControlKind(cb, &kind);
		if(kind.kind == kControlKindScrollBar) // some are really scrollbars and work differently
			return GetControlMaximum(cb) - GetControlValue(cb);
		return GetControlValue(cb);
	}
	else
		maLogAPI(L"SliderGetValue no widget", windowid, slider);		
	return 0;
}


void HSliderSetValue(int windowid, int slider, int value)
{
#ifdef MATRACEGUIOSX
	maTrace("HSliderSetValue");
#endif
	SliderSetValue(windowid, slider, value);
}


void SliderSetValue(int windowid, int slider, int value) // also ScrollBarSetValue
{
#ifdef MATRACEGUIOSX
	maTrace("SliderSetValue");
#endif
	ControlRef cb;
	ControlID id;
	ControlKind kind;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = slider;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		GetControlKind(cb, &kind);
		if(kind.kind == kControlKindScrollBar) // some are really scrollbars and work differently
			SetControlValue(cb, GetControlMaximum(cb) - value); // 'Maximum' is bottom, min is 0
		else
			SetControlValue(cb, value);
	}
	else
		maLogAPI(L"SliderSetValue no widget", windowid, slider);		
	return;
}


void SliderEnable(int windowid, int slider)
{
#ifdef MATRACEGUIOSX
	maTrace("SliderEnable");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = slider;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI(L"SliderEnable no widget", windowid, slider);		
}


void SliderDisable(int windowid, int slider)
{
#ifdef MATRACEGUIOSX
	maTrace("SliderDisable");
#endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = slider;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI(L"SliderDisable no widget", windowid, slider);		
}


/*
void StaticTextSetColor(int windowid, int statictext, short red, short green, short blue)
{
#ifdef MATRACEGUIOSX
	maTrace("StaticTextSetColor");
#endif
	ControlRef cb;
	ControlID id;
	ControlFontStyleRec rec;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = statictext;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		GetControlData(cb, 0, kControlStaticTextStyleTag, sizeof(ControlFontStyleRec), &rec, NULL);
		rec.foreColor.red = red;
		rec.foreColor.green = green;
		rec.foreColor.blue = blue;
		rec.flags = kControlUseAllMask;
		SetControlData(cb, 0, kControlStaticTextStyleTag, sizeof(ControlFontStyleRec), &rec);
	}
	else
		maLogAPI(L"StaticTextSetColor no widget", windowid, statictext);		

} // StaticTextSetColor
*/


void StaticTextSetText(int windowid, int statictext, machar *text)
{
#ifdef MATRACEGUIOSX
	maTrace("StaticTextSetText");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef cfstr;
	fschar fsstr[MAX_PATH];

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = statictext;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		ma2fs(fsstr, text);
		cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
		if(cfstr)
		{
			SetControlData(cb, 0, kControlStaticTextCFStringTag, sizeof(CFStringRef), &cfstr);
			CFRelease(cfstr);
		}
		else
			maLogAPI(L"StaticTextSetText CFStringCreateWithCString failed", windowid, statictext);		
	}
	else
		maLogAPI(L"StaticTextSetText no widget", windowid, statictext);

} // StaticTextSetText


void StaticTextSetValue(int windowid, int statictext, int value)
{
#ifdef MATRACEGUIOSX
	maTrace("StaticTextSetValue");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef cfstr;
	char text[STRLEN64];

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = statictext;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		sprintf(text, "%d", value);
		cfstr = CFStringCreateWithCString(kCFAllocatorDefault, text, kCFStringEncodingUTF8);
		if(cfstr)
		{
			SetControlData(cb, 0, kControlStaticTextCFStringTag, sizeof(CFStringRef), &cfstr);
			CFRelease(cfstr);
		}
		else
			maLogAPI(L"StaticTextSetValue CFStringCreateWithCString failed", windowid, statictext);		
	}
	else
		maLogAPI(L"StaticTextSetValue no widget", windowid, statictext);		

} // StaticTextSetValue


void WindowClose(int windowid)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowClose");
#endif

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowClose no window");
		return;
	}
	DisposeWindow((WindowRef)g_w[windowid]);
	ReleaseWindow((WindowRef)g_w[windowid]);

} // WindowClose


void WindowDestroy(int windowid)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowDestroy");
#endif

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowDestroy no window");
		return;
	}
	
	ReleaseWindow((WindowRef)g_w[windowid]);
	
} // WindowDestroy


void WindowGetOrigin(int windowid, int *xpos, int *ypos)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowGetOrigin");
#endif
	Rect r;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowGetOrigin no window");
		return;
	}
	if(!xpos || !ypos)
	{
		maLog(L"WindowGetOrigin bad pos or size parameter");
		return;
	}
	if(GetWindowBounds((WindowRef)g_w[windowid], kWindowGlobalPortRgn, &r))
	{
		maLog(L"WindowGetOrigin GetWindowBounds failed");
		return;
	}
	*xpos = r.left;
	*ypos = r.top;
	
} // WindowGetOrigin


void WindowGetSize(int windowid, int *xsize, int *ysize)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowGetSize");
#endif
	Rect r;
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowGetSize no window");
		return;
	}
	if(!xsize || !ysize)
	{
		maLog(L"WindowGetSize bad pos or size parameter");
		return;
	}
	if(GetWindowBounds((WindowRef)g_w[windowid], kWindowGlobalPortRgn, &r))
	{
		maLog(L"WindowGetSize GetWindowBounds failed");
		return;
	}
	*xsize = r.right - r.left;
	*ysize = r.bottom - r.top;
	
} // WindowGetSize


void WindowGetCoordinates(int windowid, int *xpos, int *ypos, int *xsize, int *ysize)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowGetCoordinates");
#endif
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowGetCoordinates no window");
		return;
	}

	WindowGetSize(windowid, xsize, ysize);
	WindowGetOrigin(windowid, xpos, ypos);
		
} // WindowGetCoordinates


/*
void WindowItemHide(int windowid, int item)
{
 #ifdef MATRACEGUIOSX
	maTrace("WindowItemHide");
 #endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = item;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		HideControl(cb);
	else
		maLogAPI(L"WindowItemHide no widget", windowid, item);		
} // WindowItemHide


void WindowItemShow(int windowid, int item)
{
 #ifdef MATRACEGUIOSX
	maTrace("WindowItemShow");
 #endif
	ControlID id;
	ControlRef cb;

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = item;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);	
	if(cb)
		ShowControl(cb);
	else
		maLogAPI(L"WindowItemShow no widget", windowid, item);		
} // WindowItemShow
*/


int WindowIsShown(int windowid)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowIsShown");
#endif
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowIsShown no window");
		return 0;
	}
	return MacIsWindowVisible((WindowRef)g_w[windowid]) ? 1 : 0;
}


/*
void WindowWidgetSetSize(int windowid, int widget, int xsize, int ysize)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowWidgetSetSize");
#endif
}
*/


void WindowSetSize(int windowid, int xsize, int ysize)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowSetSize");
#endif
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowSetSize no window");
		return;
	}
	SizeWindow((WindowRef)g_w[windowid], xsize, ysize, true); // update

} // WindowSetSize


void WindowMove(int windowid, int xpos, int ypos)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowMove");
#endif
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowMove no window");
		return;
	}
	MacMoveWindow((WindowRef)g_w[windowid], xpos, ypos, false); // front

} // WindowMove


void WindowShow(int windowid)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowShow");
#endif
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		maLog(L"WindowShow no window");
		return;
	}
	ShowWindow((WindowRef)g_w[windowid]);
	BringToFront((WindowRef)g_w[windowid]);
#if !defined(NOTEXTVIEWER)
	maviewer *v;
	switch(windowid)
	{
		case WINDOWREADME:
		case WINDOWCATALOG:
		case WINDOWPLAYLIST:
		case WINDOWLOG:
 #if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
 #endif
			if(!(v = Viewer(windowid)))
				maLog(L"WindowShow Viewer failed");
			else
			{
				SetKeyboardFocus(GetControlOwner(v->findedit), v->findedit, kControlFocusNoPart); // kludge
				SetKeyboardFocus(GetControlOwner(v->findedit), v->findedit, kControlFocusNextPart);
			}
		break;
		default:
		break;
	}
#endif	
	ActivateWindow((WindowRef)g_w[windowid], true);

} // WindowShow


void WindowSetTitle(int windowid, machar *title)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowSetTitle");
#endif
	CFStringRef cfstr;
	fschar fsstr[MAX_PATH];
	machar mastr2[MAXLOGLINELEN];

	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
	{
		masprintf(mastr2, STRLEN256, L"WindowSetTitle failed on window %d", windowid);
		maLog(mastr2);
		return;
	}
	ma2fs(fsstr, title);
	cfstr = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
	SetWindowTitleWithCFString((WindowRef)g_w[windowid], cfstr);
	CFRelease(cfstr);
  
} // WindowSetTitle


void WindowActivate(int windowid)
{
 #ifdef MATRACEGUIOSX
	maTrace("WindowActivate");
 #endif

	WindowShow(windowid);
	
} // WindowActivate


int maDirSelector(fschar *selectedpath, machar *prompt)
{
	int l;
	NavReplyRecord reply;
	NavDialogOptions dialogOptions;
	FSRef dirAsFSRef;
	AEDesc specDesc;
	OSErr status;
	unsigned char pstr[STRLEN256];
	fschar dirpath[MAX_PATH + MAX_PATH];
	machar mastr2[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
	
	if(!selectedpath)
	{
		maLog(L"maDirSelector null selectedpath parameter");
		return 1;
	}

	status = NavGetDefaultDialogOptions(&dialogOptions);
	if(status != noErr)
	{
		maLog(L"maDirSelector NavGetDefaultDialogOptions failed");
		return 1;
	}

	mastrncpy(mastr2, prompt, MAXLOGLINELEN - 1);
	mastr2[MAXLOGLINELEN - 1] = L'\0';
	if((l = mastrlen(mastr2)) > 255)
	{
		l = 255;
		mastr2[255] = L'\0';
	}
	pstr[0] = l;
	ma2fs((fschar *)&pstr[1], mastr2);
	memcpy(dialogOptions.windowTitle, pstr, l + 1);

	status = NavChooseFolder(NULL, &reply, &dialogOptions, NULL, NULL, NULL);
	/* Deprecated: Use NavCreateChooseFolderDialog instead
	NavCreateChooseFolderDialog(
		const NavDialogCreationOptions *  inOptions,          // can be NULL
		NavEventUPP                       inEventProc,        // can be NULL
		NavObjectFilterUPP                inFilterProc,       // can be NULL
		void *                            inClientData,       // can be NULL
		NavDialogRef *                    outDialog)
	*/
	if(status != noErr && status != userCanceledErr)
	{
		maLog(L"maDirSelector NavChooseFolder failed");
		return 1;
	}

	if(status == userCanceledErr)
		return 1;

	if(!reply.validRecord)
	{
		maLog(L"maDirSelector not validRecord");
		return 1;
	}	

	status = AECoerceDesc(&reply.selection, typeFSRef, &specDesc);
	if(status != noErr)
	{
		maLog(L"maDirSelector AECoerceDesc failed");
		return 1;
	}

	dirAsFSRef = **(FSRef**)specDesc.dataHandle;
	if(specDesc.dataHandle != nil)
		AEDisposeDesc(&specDesc);

	status = FSRefMakePath(&dirAsFSRef, (UInt8 *)dirpath, sizeof(dirpath));
	if(status != noErr)
	{
		maLog(L"maDirSelector FSRefMakePath failed");
		return 1;
	}

	if(fsstrlen(dirpath) >= MAX_PATH) // this is UTF-8-MAC
	{
		masprintf(mastr, MAXLOGLINELEN, L"maFileDialog filepath > max %d : %zu", MAX_PATH - 1, fsstrlen(dirpath));
		maLog(mastr);
		mastrncpy(mastr, fs2ma(mastr2, dirpath), MAXLOGLINELEN - 1);
		mastr[MAXLOGLINELEN - 1] = L'\0';
		maLog(mastr);
		return 1;
	}

	fsstrcpy(selectedpath, dirpath);
	
	return 0;
	
} // maDirSelector


fschar l_defaultLocation[MAX_PATH] = fsT("");
void NavEventCallback(NavEventCallbackMessage inSelector, NavCBRecPtr ioParams, NavCallBackUserData ioUserData);
NavEventUPP NavEventCallbackUPP = NewNavEventUPP(NavEventCallback);
void NavEventCallback(NavEventCallbackMessage inSelector, NavCBRecPtr ioParams, NavCallBackUserData ioUserData)
{
	FSRef theFSRef;
	AEDesc theLocation = {typeNull, NULL};

	if(inSelector == kNavCBStart)
	{
		if(l_defaultLocation[0])
		{
			if(FSPathMakeRef((const UInt8 *)l_defaultLocation, &theFSRef, NULL) == noErr)
			 if(AECreateDesc(typeFSRef, &theFSRef, sizeof(theFSRef), &theLocation) == noErr)
				 NavCustomControl(ioParams->context, kNavCtlSetLocation, (void *)&theLocation);
		}
	}

} // NavEventCallback


int maFileDialog(fschar *selectedpath, int windowid, machar *prompt, fschar *defdir, machar *deffile, machar *wildcard, int flags)
{
	NavDialogCreationOptions dialogOptions;
	NavDialogRef dialog = NULL;
	NavReplyRecord replyRecord;
	FSRef fileAsFSRef;
	CFMutableArrayRef popup;
	int ret = 0;
	size_t len;
	char *pfilter;
	OSStatus status;
	fschar name[MAX_PATH];
	fschar fname[MAX_PATH];
	fschar fpath[MAX_PATH + MAX_PATH];
	fschar fsstr[MAX_PATH];
	machar mastr2[MAXLOGLINELEN];
	machar mastr[MAXLOGLINELEN];
#ifdef MATRACEGUIOSX
	maTrace("maFileDialog");
#endif

	if(!selectedpath)
	{
		maLog(L"maFileDialog null selectedpath parameter");
		return 1;
	}
	
	if(defdir && defdir[0])
		fsstrcpy(l_defaultLocation, defdir);
	else
		l_defaultLocation[0] = fsT('\0');
		
	status = NavGetDefaultDialogCreationOptions(&dialogOptions);
	if(status != noErr)
	{
		maLog(L"maFileDialog NavGetDefaultDialogCreationOptions failed");
		goto maFileDialogErr;
	}

	dialogOptions.windowTitle = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)ma2fs(fsstr, prompt), kCFStringEncodingUTF8);

	masprintf(mastr, MAXLOGLINELEN, L"%ls%lc%ls", fs2ma(mastr2, defdir), FILESEP, deffile); 
	if(mastrlen(mastr) > 1)
		dialogOptions.message = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)ma2fs(fsstr, mastr), kCFStringEncodingUTF8);

	if(flags & maSAVE)
	{
		dialogOptions.saveFileName = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)ma2fs(fsstr, deffile), kCFStringEncodingUTF8);
		status = NavCreatePutFileDialog(&dialogOptions, kNavGenericSignature, kNavGenericSignature,
																	NavEventCallbackUPP, NULL, &dialog);
		if(status != noErr)
		{
			maLog(L"maFileDialog NavCreatePutFileDialog failed");
			goto maFileDialogErr;
		}
	}
	else
	{
		// "(*.maf)|*.maf|Any file (*)|*"
		if(mastrstr(wildcard, fs2ma(mastr2, EXTMAF)))
			pfilter = "*.maf";
		else
			pfilter = "*.*";
		popup = CFArrayCreateMutable(kCFAllocatorDefault, 1, &kCFTypeArrayCallBacks);
		CFArrayAppendValue(popup, CFStringCreateWithCString(kCFAllocatorDefault, (const char *)pfilter, kCFStringEncodingUTF8));
		dialogOptions.popupExtension = popup;

		status = NavCreateGetFileDialog(&dialogOptions, NULL, NavEventCallbackUPP, NULL, NULL, NULL, &dialog);
		if(status != noErr)
		{
			maLog(L"maFileDialog NavCreateGetFileDialog failed");
			goto maFileDialogErr;
		}
	}

	status = NavDialogRun(dialog);
	if(status != noErr)
	{
		maLog(L"maFileDialog NavDialogRun failed");
		goto maFileDialogErr;
	}

	status = NavDialogGetReply(dialog, &replyRecord);
	if(status != noErr && status != userCanceledErr)
	{
		maLog(L"maFileDialog NavDialogGetReply failed");
		goto maFileDialogErr;
	}
	if(status == userCanceledErr)
		goto maFileDialogErr;

	status = AEGetNthPtr(&(replyRecord.selection), 1, typeFSRef, NULL, NULL, &fileAsFSRef, sizeof(FSRef), NULL);
	if(status != noErr)
	{
		maLog(L"maFileDialog AEGetNthPtr failed");
		goto maFileDialogErr;
	}
		
	memset(fpath, 0, sizeof(fpath));
	status = FSRefMakePath(&fileAsFSRef, (UInt8 *)fpath, sizeof(fpath));
	if(status != noErr)
	{
		maLog(L"maFileDialog FSRefMakePath failed");
		goto maFileDialogErr;
	}

	if(fsstrlen(fpath) >= MAX_PATH)
	{
		masprintf(mastr, MAXLOGLINELEN, L"maFileDialog filepath > max %d : %zu", MAX_PATH - 1, fsstrlen(fpath));
		maLog(mastr);
		mastrncpy(mastr, fs2ma(mastr2, fpath), MAXLOGLINELEN - 1);
		mastr[MAXLOGLINELEN - 1] = L'\0';
		maLog(mastr);
		goto maFileDialogErr;
	}

	if(flags & maSAVE)
	{
		if(!CFStringGetCString(replyRecord.saveFileName, fname, MAX_PATH - 1, kCFStringEncodingUTF8))
		{
			maLog(L"maFileDialog CFStringGetCString failed");
			goto maFileDialogErr;
		}

		if((len = fsstrlen(fpath) + sizeof(FILESEP) + fsstrlen(fname)) >= MAX_PATH)
		{
			masprintf(mastr, MAXLOGLINELEN, L"maFileDialog filepath > max %d : %zu", MAX_PATH - 1, len);
			maLog(mastr);
			if(len < MAXLOGLINELEN - 1)
			{
				fssprintf(name, MAXLOGLINELEN, fsS fsC fsS, fpath, FILESEP, fname);
				maLog(fs2ma(mastr2, name));
			}
			goto maFileDialogErr;
		}
		
		fssprintf(selectedpath, MAX_PATH, fsS fsC fsS, fpath, FILESEP, fname); 
	}
	else
		fsstrcpy(selectedpath, fpath);
		
	goto maFileDialogNoErr;

maFileDialogErr:
	ret = 1;
	
maFileDialogNoErr:
	if(dialog)
		NavDialogDispose(dialog);

	return ret;
	
} // maFileDialog


void maFileDialogMFree(maArray *parray)
{
#ifdef MATRACEGUIOSX
	maTrace("maFileDialogMFree");
#endif
	int i;
	
	if(!parray)
		return;
	if(parray->pitems)
	{
		for(i = 0; i < parray->nitems; i++)
			if(parray->pitems[i])
				MAFREE(parray->pitems[i]);
		MAFREE(parray->pitems);
		parray->pitems = NULL;
	}
	parray->nitems = 0;
}


// for multiple selections (from 'Play Song Files')
int maFileDialogM(maArray *parray, int windowid, machar *prompt, fschar *defdir, machar *deffile, machar *wildcard, int flags)
{
	NavDialogCreationOptions dialogOptions;
	NavDialogRef dialog;
	NavReplyRecord replyRecord;
	FSRef fileAsFSRef;
	fschar fpath[MAX_PATH + MAX_PATH];
	fschar fsstr[MAX_PATH + MAX_PATH];
	long i, theCount;
	int ret = 0;
	OSStatus status;
	machar mastr2[STRLEN256];
	machar mastr[MAXLOGLINELEN];
#ifdef MATRACEGUIOSX
	maTrace("maFileDialogM");
#endif
	
	if(!parray)
	{
		maLog(L"maFileDialogM null parray parameter");
		return 1;
	}
	
	parray->nitems = 0;
	parray->pitems = NULL;

	if(defdir && defdir[0])
		fsstrcpy(l_defaultLocation, defdir);
	else
		l_defaultLocation[0] = fsT('\0');

	status = NavGetDefaultDialogCreationOptions(&dialogOptions);
	if(status != noErr)
	{
		maLog(L"maFileDialogM NavGetDefaultDialogCreationOptions failed");
		goto maFileDialogMErr;
	}
	
	dialogOptions.optionFlags |= (kNavAllowMultipleFiles /*+ kNavAllFilesInPopup*/);
	dialogOptions.windowTitle = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)ma2fs(fsstr, prompt), kCFStringEncodingUTF8);
	fssprintf(fsstr, MAX_PATH, fsS fsC fsS, defdir, FILESEP, ma2fs(fsstr, deffile)); 
	if(fsstrlen(fsstr) > 1)
		dialogOptions.message = CFStringCreateWithCString(kCFAllocatorDefault, (const char *)fsstr, kCFStringEncodingUTF8);
	/*
	//"Any file|*|mp3|*.mp3|ogg|*.ogg|wma|*.wma|wav|*.wav|aif|*.aif|aiff|*.aiff|cda|*.cda|aac|*.aac|mp4|*.mp4|m2a|*.m2a|m4a|*.m4a"
	size_t numFilters;
	numFilters = 0;
	if(numFilters)
	{
		CFMutableArrayRef popup;
		popup = CFArrayCreateMutable(kCFAllocatorDefault, numFilters, &kCFTypeArrayCallBacks);
		for ( size_t i = 0; i < numFilters; ++i )
			CFArrayAppendValue(popup, CFStringCreateWithCString(kCFAllocatorDefault, "*.*", kCFStringEncodingUTF8));
	}
	dialogOptions.popupExtension = popup;
	*/
	status = NavCreateGetFileDialog(&dialogOptions, NULL, NavEventCallbackUPP, NULL, NULL, NULL, &dialog);
	if(status != noErr)
	{
		maLog(L"maFileDialogM NavCreateGetFileDialog failed");
		goto maFileDialogMErr;
	}
	
	status = NavDialogRun(dialog);
	if(status != noErr)
	{
		maLog(L"maFileDialogM NavDialogRun failed");
		goto maFileDialogMErr;
	}
	
	status = NavDialogGetReply(dialog, &replyRecord);
	if(status != noErr && status != userCanceledErr)
	{
		maLog(L"maFileDialogM NavDialogGetReply failed");
		goto maFileDialogMErr;
	}
	if(status == userCanceledErr)
		goto maFileDialogMErr;

	status = AECountItems(&replyRecord.selection, &theCount);
	if(status != noErr)
	{
		maLog(L"maFileDialogM AECountItems failed");
		goto maFileDialogMErr;
	}
	if(!theCount)
		goto maFileDialogMErr;
		
	parray->nitems = theCount;
	
	if((parray->pitems = (fschar **)MAMALLOC((theCount + 1) * sizeof(fschar *))) == NULL)
	{
		maFileDialogMFree(parray);
		maLog(L"maFileDialogM MAMALLOC failed");
		goto maFileDialogMErr;
	}
	
	for(i = 1; i <= theCount; i++)
	{
		status = AEGetNthPtr(&(replyRecord.selection), i, typeFSRef, NULL, NULL, &fileAsFSRef, sizeof(FSRef), NULL);
		if(status != noErr)
		{
			maFileDialogMFree(parray);
			maLog(L"maFileDialogM AEGetNthPtr failed");
			goto maFileDialogMErr;
		}
		
		status = FSRefMakePath(&fileAsFSRef, (UInt8 *)fpath, sizeof(fpath));
		if(status != noErr)
		{
			maFileDialogMFree(parray);
			maLog(L"maFileDialogM FSRefMakePath failed");
			goto maFileDialogMErr;
		}

		if(fsstrlen(fpath) >= MAX_PATH)
		{
			masprintf(mastr, MAXLOGLINELEN, L"maFileDialogM filepath > max %d : %zu", MAX_PATH - 1, fsstrlen(fpath));
			maLog(mastr);
			mastrncpy(mastr, fs2ma(mastr2, fpath), MAXLOGLINELEN - 1);
			mastr[MAXLOGLINELEN - 1] = L'\0';
			maLog(mastr);
			continue;
		}

		if((parray->pitems[i - 1] = (fschar *)MAMALLOC(fsstrlen(fpath) + 1)) == NULL)
		{
			maFileDialogMFree(parray);
			maLog(L"maFileDialogM MAMALLOC failed");
			goto maFileDialogMErr;
		}

		fsstrcpy(parray->pitems[i - 1], fpath);
	}
	
	goto maFileDialogMNoErr;
		
maFileDialogMErr:
	ret = 1;
	
maFileDialogMNoErr:
	if(dialog)
		NavDialogDispose(dialog);

	return ret;

} //maFileDialogM


/*
int wxMessageDialog::ShowModal()
{
    int resultbutton = wxID_CANCEL;

    const long style = GetMessageDialogStyle();

    wxASSERT_MSG( (style & 0x3F) != wxYES, wxT("this style is not supported on Mac") );

    AlertType alertType = kAlertPlainAlert;
    if (style & wxICON_EXCLAMATION)
        alertType = kAlertCautionAlert;
    else if (style & wxICON_HAND)
        alertType = kAlertStopAlert;
    else if (style & wxICON_INFORMATION)
        alertType = kAlertNoteAlert;
    else if (style & wxICON_QUESTION)
        alertType = kAlertNoteAlert;

#if TARGET_API_MAC_OSX
    if ( !wxIsMainThread() )
    {
        CFStringRef defaultButtonTitle = NULL;
        CFStringRef alternateButtonTitle = NULL;
        CFStringRef otherButtonTitle = NULL;

        wxMacCFStringHolder cfTitle( m_caption, GetFont().GetEncoding() );
        wxMacCFStringHolder cfText( m_message, GetFont().GetEncoding() );

        wxMacCFStringHolder cfNoString( _("No"), GetFont().GetEncoding() );
        wxMacCFStringHolder cfYesString( _("Yes"), GetFont().GetEncoding() );
        wxMacCFStringHolder cfOKString( _("OK") , GetFont().GetEncoding());
        wxMacCFStringHolder cfCancelString( _("Cancel"), GetFont().GetEncoding() );

        int buttonId[4] = { 0, 0, 0, wxID_CANCEL /w* time-out *w/ };

        if (style & wxYES_NO)
        {
            if ( style & wxNO_DEFAULT )
            {
                defaultButtonTitle = cfNoString;
                alternateButtonTitle = cfYesString;
                buttonId[0] = wxID_NO;
                buttonId[1] = wxID_YES;
            }
            else
            {
                defaultButtonTitle = cfYesString;
                alternateButtonTitle = cfNoString;
                buttonId[0] = wxID_YES;
                buttonId[1] = wxID_NO;
            }
            if (style & wxCANCEL)
            {
                otherButtonTitle = cfCancelString;
                buttonId[2] = wxID_CANCEL;
            }
        }
        else
        {
            // the MSW implementation even shows an OK button if it is not specified, we'll do the same
            buttonId[0] = wxID_OK;
            // using null as default title does not work on earlier systems
            defaultButtonTitle = cfOKString;
            if (style & wxCANCEL)
            {
                alternateButtonTitle = cfCancelString;
                buttonId[1] = wxID_CANCEL;
            }
        }

        CFOptionFlags exitButton;
        OSStatus err = CFUserNotificationDisplayAlert(
            0, alertType, NULL, NULL, NULL, cfTitle, cfText,
            defaultButtonTitle, alternateButtonTitle, otherButtonTitle, &exitButton );
        if (err == noErr)
            resultbutton = buttonId[exitButton];
    }
    else
#endif
    {
        short result;

        AlertStdCFStringAlertParamRec param;
        wxMacCFStringHolder cfNoString( _("No"), GetFont().GetEncoding() );
        wxMacCFStringHolder cfYesString( _("Yes"), GetFont().GetEncoding() );

        wxMacCFStringHolder cfTitle( m_caption, GetFont().GetEncoding() );
        wxMacCFStringHolder cfText( m_message, GetFont().GetEncoding() );

        param.movable = true;
        param.flags = 0;
        param.version = kStdCFStringAlertVersionOne;

        bool skipDialog = false;

        if (style & wxYES_NO)
        {
            if (style & wxCANCEL)
            {
                param.defaultText = cfYesString;
                param.cancelText = (CFStringRef) kAlertDefaultCancelText;
                param.otherText = cfNoString;
                param.helpButton = false;
                param.defaultButton = style & wxNO_DEFAULT ? kAlertStdAlertOtherButton : kAlertStdAlertOKButton;
                param.cancelButton = kAlertStdAlertCancelButton;
            }
            else
            {
                param.defaultText = cfYesString;
                param.cancelText = NULL;
                param.otherText = cfNoString;
                param.helpButton = false;
                param.defaultButton = style & wxNO_DEFAULT ? kAlertStdAlertOtherButton : kAlertStdAlertOKButton;
                param.cancelButton = 0;
            }
        }
        // the MSW implementation even shows an OK button if it is not specified, we'll do the same
        else
        {
            if (style & wxCANCEL)
            {
                // that's a cancel missing
                param.defaultText = (CFStringRef) kAlertDefaultOKText;
                param.cancelText = (CFStringRef) kAlertDefaultCancelText;
                param.otherText = NULL;
                param.helpButton = false;
                param.defaultButton = kAlertStdAlertOKButton;
                param.cancelButton = 0;
            }
            else
            {
                param.defaultText = (CFStringRef) kAlertDefaultOKText;
                param.cancelText = NULL;
                param.otherText = NULL;
                param.helpButton = false;
                param.defaultButton = kAlertStdAlertOKButton;
                param.cancelButton = 0;
            }
        }

        param.position = kWindowDefaultPosition;
        if ( !skipDialog )
        {
            DialogRef alertRef;
            CreateStandardAlert( alertType, cfTitle, cfText, &param, &alertRef );
            RunStandardAlert( alertRef, NULL, &result );
        }
        else
        {
            return wxID_CANCEL;
        }

        if (style & wxOK)
        {
            switch ( result )
            {
            case 1:
                resultbutton = wxID_OK;
                break;

            case 2:
                // TODO: add Cancel button
                // if (style & wxCANCEL)
                //     resultbutton = wxID_CANCEL;
                break;

            case 3:
            default:
                break;
            }
        }
        else if (style & wxYES_NO)
        {
            switch ( result )
            {
            case 1:
                resultbutton = wxID_YES;
                break;

            case 2:
                if (!(style & wxCANCEL))
                    resultbutton = wxID_CANCEL;
                break;

            case 3:
                resultbutton = wxID_NO;
                break;

            default:
                break;
            }
        }
    }

    return resultbutton;
}
*/


int maMessageBox(machar *s1, machar *s2, int flags)
{
#ifdef MATRACEGUIOSX
	maTrace("maMessageBox");
#endif
	SInt16 choice;
	size_t len;
	fschar fsstr[STRLEN256];
	machar mastr2[STRLEN256];
	
	if((flags & maYES_NO) == maYES_NO)
	{
		AlertStdAlertParamRec alertparam = {true, false, nil, "\pYes", "\pNo", nil, 1, 0, kWindowDefaultPosition};
		masprintf(mastr2, STRLEN512, L"%ls :%ls%ls%ls%ls%ls%ls", 
						g_prognametitle, g_maeol, g_maeol, s2, g_maeol, g_maeol, s1);
		ma2fs(&fsstr[1], mastr2);
		StrUTF8toCHARSET(&fsstr[1]);
		if((len = fsstrlen(&fsstr[1])) > 255)
			len = 255;
		fsstr[0] = len;
		StandardAlert(kAlertCautionAlert, (const unsigned char *)fsstr, "\p", &alertparam, &choice);
		return (choice == 1) ? maYES : maNO;
	}
	if((flags & maOK) == maOK)
	{
		AlertStdAlertParamRec alertparam = {true, false, nil, "\pOk", nil, nil, 1, 0, kWindowDefaultPosition};
		masprintf(mastr2, STRLEN512, L"%ls :%ls%ls%ls%ls%ls%ls", g_prognametitle,
			g_maeol, g_maeol, s2, g_maeol, g_maeol, s1);
		ma2fs(&fsstr[1], mastr2);
		StrUTF8toCHARSET(&fsstr[1]);
		if((len = fsstrlen(&fsstr[1])) > 255)
			len = 255;
		fsstr[0] = len;
		StandardAlert(kAlertCautionAlert, (const unsigned char*)fsstr, "\p", &alertparam, &choice);
		return maYES;
	}

	return maNO;
	
} // maMessageBox


#if !defined(NOTEXTVIEWER)
 OSStatus ViewerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
 {
	HICommandExtended command;
	UInt32 attributes;
	Rect r;
	int windowid = (int)userData;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return(eventNotHandledErr);

	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[windowid], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, windowid, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, NULL, sizeof(attributes), NULL, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(windowid);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(windowid);
				return eventNotHandledErr;

				case kEventWindowClose:
					DoWindow(windowid, 0);
				return noErr;
				
				default:
				break;
			}
		break;

		default:
		break;
	}

	return eventNotHandledErr;
	
 } // ViewerWindowEventHandler


 int l_windowid = 0;
 void ViewerOnLeftClick2()
 {
 	ViewerOnLeftClick(l_windowid);
 }


 OSStatus ViewerEditTextHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
 {
	UInt32 modifierKeys = 0;
	UInt16 mousebutton = 0; 
	EventRef rawEvent;
	unsigned char charCode;
	maviewer *v;
	int windowid = (int)userData;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return(eventNotHandledErr);

	switch(GetEventClass(event))
	{
		case kEventClassTextInput: // kEventTextInputUnicodeForKeyEvent:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					if((v = Viewer(windowid)))
					{
						if(!v->editable)
						{
							GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
							GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(machar), NULL, &charCode);
							if(charCode != kUpArrowCharCode && charCode != kDownArrowCharCode && // allow scrolling with up down arrow keys
								charCode != kPageUpCharCode  && charCode != kPageDownCharCode)	  // and up down page keys
								return noErr;
						}
					}
				break;
				default:
				break;
			}
		break;

		case kEventClassControl:
			switch(GetEventKind(event))
		 	{
				case kEventControlSetFocusPart: // main EditText or find EditText about to lose or gain focus
					if((v = Viewer(windowid)))
						if(!v->editable)
							return noErr; // eat this event because of unpredictable (by me) TXN behavior, depending on OSX version
				break;
				
				case kEventControlHit: // viewer EditText left clicked, or right (or ctrl-left) clicked
					if((v = Viewer(windowid)))
						if(!v->editable)
						{
							// Depending on nib settings we get both primary and secondary, or no mousebutton info...
							// Sort of works with maosxViewer.nib settings 'Receives' = 'Activates', 'Clicks' and 'Updates'
							// and 'Behavior' = 'Standard Event Handler'
							// These can be set with Interface Builder 3.2 in OS X 10.6
							GetEventParameter(event, kEventParamKeyModifiers, typeUInt32, NULL,
																				sizeof(modifierKeys), NULL, &modifierKeys);
					
 #if MAC_OS_X_VERSION_MAX_ALLOWED >= 1060 // MAC_OS_X_VERSION_10_6, maybe 10.5
							GetEventParameter(event, kEventParamMouseButton, typeMouseButton, NULL,
																				sizeof(mousebutton),  NULL, &mousebutton);
 #endif
							if((mousebutton & kEventMouseButtonSecondary && !(mousebutton & kEventMouseButtonPrimary)) ||	// right and not left, or
								(!(mousebutton & kEventMouseButtonSecondary) && modifierKeys & controlKey))					// not right and control key
							{
								// right up:
								ViewerOnRightClick(windowid);
								return noErr;
							}
							else
							{
								// left up:
								// ViewerOnLeftClick(windowid); // we need to return before using TXNGetSelection
								l_windowid = windowid;
								matimer_set_timeout(200, (void *)&ViewerOnLeftClick2);
								return noErr;
							}
						}
				break;

				default:
				break;
			}
		break;
		
		default:
		break;
	}

	return eventNotHandledErr;

 } // ViewerEditTextHandler


 OSStatus ViewerFindEditTextHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
 {
	EventRef rawEvent;
	unsigned char charCode;
	maviewer *v;
	int windowid = (int)userData;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return(eventNotHandledErr);
	
	switch(GetEventClass(event))
	{
		case kEventClassTextInput: // kEventTextInputUnicodeForKeyEvent:
			if((v = Viewer(windowid)))
				if(!v->editable)
				{
					GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
					GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(machar), NULL, &charCode);
					if(charCode == kEnterCharCode || charCode == kReturnCharCode || charCode == kLineFeedCharCode)
					{
						ViewerOnButtonFind(windowid);
						return noErr;
					}
					if(charCode == kEscapeCharCode)
					{
						WindowActivate(WINDOWAPP);
						return noErr;
					}
				}
		break;
		default:
		break;
	}

	return eventNotHandledErr;
	
 } // ViewerFindEditTextHandler


 OSStatus ViewerMouseWheelHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
 {
	OSStatus result = eventNotHandledErr;
	EventMouseWheelAxis axis;
	ControlRef cb;
	ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
	SInt32 delta;
	int windowid = (int)userData;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return(eventNotHandledErr);

	GetEventParameter(event, kEventParamMouseWheelAxis, typeMouseWheelAxis,
												NULL, sizeof(EventMouseWheelAxis), NULL, &axis);	
	GetEventParameter(event, kEventParamMouseWheelDelta, typeLongInteger,
															NULL, sizeof(SInt32), NULL, &delta);	

	if(axis == kEventMouseWheelAxisY)
	{
		GetControlByID((WindowRef)g_w[windowid], &id, &cb);
		ViewerScrollerActionProc(cb, delta > 0 ? kControlUpButtonPart : kControlDownButtonPart);
		result = noErr;
	}
	
	return result;
 }


 OSStatus ViewerScrollerMouseWheelHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
 {
	OSStatus result = eventNotHandledErr;
	EventMouseWheelAxis axis;
	SInt32 delta;
	ControlRef cb;
	ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
	int windowid = (int)userData;
	
	if(windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return(eventNotHandledErr);

	GetControlByID((WindowRef)g_w[windowid], &id, &cb);

	GetEventParameter(event, kEventParamMouseWheelAxis, typeMouseWheelAxis,
												NULL, sizeof(EventMouseWheelAxis), NULL, &axis);	
	GetEventParameter(event, kEventParamMouseWheelDelta, typeLongInteger,
															NULL, sizeof(SInt32), NULL, &delta);
	if(axis == kEventMouseWheelAxisY)
	{
		ViewerScrollerActionProc(cb, delta > 0 ? kControlUpButtonPart : kControlDownButtonPart);
		result = noErr;
	}
	
	return result;
 }


/////////////////////////////// TXN

enum
{
	ViewerInstanceDataProperty = 'TXNd',
	ViewerInstanceDataCreator = 'MAMP'
};

maviewer *ViewerByRef(WindowRef window);

const SInt32 maINT32_MAX = 2147483647; // INT32_MAX
ControlActionUPP l_ViewerScrollerControlActionUPP = NULL;
TXNScrollInfoUPP l_ViewerTXNScrollInfoUPP = NULL;


TXNObject WindowGetTXNObj(WindowRef window)
{
	maviewer *v;
	if((v = ViewerByRef(window)) == NULL)
		return NULL;
	return v->TXNobj;
}


maviewer *ViewerByRef(WindowRef window)
{
	OSStatus status;
	maviewer *v;
	status = GetWindowProperty(window, ViewerInstanceDataCreator, ViewerInstanceDataProperty,
								sizeof(maviewer *), NULL, &v);
	if(status != noErr)
	{
		maLog(L"ViewerByRef GetWindowProperty failed");
		return NULL;
	}
	return v;
}


void TextViewSetVertScrollCache(WindowRef window, SInt32 value)
{
	maviewer *v;
	if((v = ViewerByRef(window)) == NULL)
		return;
	v->scrollCache = value;
}


// Tell a control to update its value & maximum.
OSStatus ControlUpdateValues(ControlRef scrollBar, SInt32 value, SInt32 max)
{
	require(IsValidControlHandle(scrollBar), BadControl);
	SetControl32BitValue(scrollBar, value);
	SetControl32BitMaximum(scrollBar, max);
	return noErr;
	BadControl:
	return paramErr;
}


void ViewerTXNScrollInfoCallback(SInt32 value, SInt32 max,
					TXNScrollBarOrientation orientation, SInt32 userData)
{
	OSStatus status;
	ControlRef cb = NULL;
	int windowid = (int)userData;
	
	if(!userData || windowid < WINDOWFIRST || windowid > WINDOWLAST || !g_w[windowid])
		return;

	ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
	status = GetControlByID((WindowRef)g_w[windowid], &id, &cb);

	if(cb != NULL)
	{
		status = ControlUpdateValues(cb, value, max);
		TextViewSetVertScrollCache((WindowRef)g_w[windowid], value);
	}
	else
		maLog(L"ViewerTXNScrollInfoCallback null cb");
}


UInt32 TextViewGetTextWindowHeight(WindowRef window)
{
	OSStatus status = paramErr;
	TXNLongRect textRect;
	require(window != NULL, CantGetRect);
	status = TXNGetRectBounds(WindowGetTXNObj(window), NULL, NULL, &textRect);
	require_noerr(status, CantGetRect);
	return textRect.right - textRect.left;
	CantGetRect:
	return 0;
}


OSStatus TextViewCustomScroll(WindowRef window, OSType signature, TXNScrollUnit scrollUnit,
								SInt32 textViewDelta, SInt32 cacheValue)
{
	OSStatus status = paramErr;
	SInt32 vDelta, hDelta;
	maviewer *v;
	if((v = ViewerByRef(window)) == NULL)
		return paramErr;
	vDelta = textViewDelta;
	hDelta = 0;
	v->scrollCache = cacheValue;
	if(v->TXNobj)
		status = TXNScroll(v->TXNobj, scrollUnit, scrollUnit, &vDelta, &hDelta);
	return status;
}


SInt32 TextViewGetVertScrollCache(WindowRef window)
{
	maviewer *v;
	if((v = ViewerByRef(window)) == NULL)
		return 0;
	return v->scrollCache;
}


UInt32 TextViewGetHeight(WindowRef window)
{
	Rect viewRect = { 0,0,0,0 };
	TXNGetViewRect(WindowGetTXNObj(window), &viewRect);
	return viewRect.bottom-viewRect.top;
}


void ViewerScrollerActionProc(ControlRef controlRef, ControlPartCode partCode)
{
	SInt32 value;
	SInt32 textViewDelta, controlDelta, controlMin, controlMax;
	SInt32 cacheValue;
	TXNScrollUnit scrollUnits;
	ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
	WindowRef window = NULL;
	SInt32 viewHeight = 0;
	scrollUnits = kTXNScrollUnitsInPixels;
	textViewDelta = controlDelta = 0;
	window = GetControlOwner(controlRef);
	if(window == NULL)
	{
		maLog(L"ViewerScrollerActionProc GetControlOwner");
		return;
	}
	value = GetControl32BitValue(controlRef);
	controlMin = GetControl32BitMinimum(controlRef);
	controlMax = GetControl32BitMaximum(controlRef);
	viewHeight = TextViewGetHeight(window);
	switch(partCode)
	{
		case kControlDownButtonPart:
			textViewDelta = controlDelta = 12; // s.b. line height in pixels
			scrollUnits = kTXNScrollUnitsInPixels;
		break;
		case kControlUpButtonPart:
			textViewDelta = controlDelta = -12;
			scrollUnits = kTXNScrollUnitsInPixels;
		break;
		case kControlPageUpPart:
			textViewDelta = -1;
			controlDelta = (viewHeight <= maINT32_MAX ? viewHeight : maINT32_MAX);
			scrollUnits = kTXNScrollUnitsInViewRects;
			controlDelta = -controlDelta;
		break;
		case kControlPageDownPart:
			textViewDelta = 1;
			controlDelta = (viewHeight <= maINT32_MAX ? viewHeight : maINT32_MAX);
			scrollUnits = kTXNScrollUnitsInViewRects;
		break;
		case kControlIndicatorPart:
			cacheValue = 0;
			scrollUnits = kTXNScrollUnitsInPixels;
			cacheValue = TextViewGetVertScrollCache(window);
			textViewDelta = value - (cacheValue <= maINT32_MAX ? cacheValue : maINT32_MAX);
		break;
		default:
		break;
	}
	if(partCode != kControlIndicatorPart)
	{
		value += controlDelta;
		if(value < controlMin)
			value = controlMin;
		if(value > controlMax)
			value = controlMax;
		SetControl32BitValue(controlRef, value);
	}
	
	TextViewCustomScroll(window, id.signature, scrollUnits, textViewDelta, value);

	return;
	
} // ViewerScrollerActionProc


/////////////////////////////// TXN

int ViewerWindowMake(int windowid, machar *wintitle)
{
	SInt32 max;
	SInt32 height;
	maviewer *v;
	ControlRef edit;
	ControlRef findedit;
	ControlID id;
	HIViewRef textView;
	TXNObject TXNobj  = NULL;
	TXNLongRect textRect;
	IBNibRef nibRef;
	WindowRef windowref;
	ControlRef scrollbar;
	OSStatus status;
	EventTypeSpec eventspec[] =	{
									{ kEventClassCommand,   kEventCommandProcess },
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged },
								};
								
	EventTypeSpec mouseWheelEvent = { kEventClassMouse, kEventMouseWheelMoved };

	EventTypeSpec ViewerEditTextEvents[] =	{
												{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
												{ kEventClassControl,	kEventControlSetFocusPart },
												{ kEventClassControl,	kEventControlHit },
											};
	
	EventTypeSpec ViewerFindEditTextEvents[] =	{
													{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
												};
	fschar fsstr[MAX_PATH];
	machar mastr[MAXLOGLINELEN];

	status = CreateNibReference(CFSTR("maosxViewer"), &nibRef);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake CreateNibReference err %d 'maosxViewer.nib'", (int)status);
		maLog(mastr);
		return 1;
	}
	
	status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
	DisposeNibReference(nibRef);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake CreateWindowFromNib err %d 'maosxViewer.nib'", (int)status);
		maLog(mastr);
		return 1;
	}
	
	g_w[windowid] = (void *)windowref;
	id.signature = 'MAMP';
	
	id.id = ID_EDITTEXT_VIEWERVIEW;
	GetControlByID(windowref, &id, &edit);
	
	status = HIViewFindByID(HIViewGetRoot(windowref), id, &textView);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake HIViewFindByID err %d", (int)status);
		maLog(mastr);
	}
	else
	{
		TXNobj = HITextViewGetTXNObject(textView);
		if(!TXNobj)
			maLog(L"ViewerWindowMake HITextViewGetTXNObject failed");
	}

	if(!(v = Viewer(windowid)))
		maLog(L"ViewerWindowMake Viewer failed");
	else
	{
		v->text = TXNobj;
		v->scrollCache = 0;
		v->scrollCacheS = 0;
		v->TXNobj = TXNobj;
		v->editable = 0;
	}

	status = SetWindowProperty(windowref, ViewerInstanceDataCreator, ViewerInstanceDataProperty,
																	sizeof(maviewer *), &v);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake SetWindowProperty err %d", (int)status);
		maLog(mastr);
	}

	// viewer window event handler - handlers get userData == void *widowid and WindowProperty == maviewer *v
	status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(ViewerWindowEventHandler),
										sizeof(eventspec), eventspec, (void *)windowid, NULL);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake InstallWindowEventHandler err %d", (int)status);
		maLog(mastr);
	}

	// edittext input handler
	status = InstallEventHandler(GetControlEventTarget(edit), NewEventHandlerUPP(ViewerEditTextHandler),
				GetEventTypeCount(ViewerEditTextEvents), ViewerEditTextEvents, (void *)windowid, NULL);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake InstallEventHandler err %d", (int)status);
		maLog(mastr);
	}

	// mouse wheel handler
	status = InstallEventHandler(GetControlEventTarget(edit), NewEventHandlerUPP(ViewerMouseWheelHandler),
															1, &mouseWheelEvent, (void *)windowid, NULL);

	// find text input handler
	id.id = ID_EDITTEXT_VIEWERFIND;
	GetControlByID(windowref, &id, &findedit);	
	status = InstallEventHandler(GetControlEventTarget(findedit), NewEventHandlerUPP(ViewerFindEditTextHandler),
			GetEventTypeCount(ViewerFindEditTextEvents), ViewerFindEditTextEvents, (void *)windowid, NULL);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake InstallEventHandler err %d", (int)status);
		maLog(mastr);
	}
	else
		v->findedit = findedit;

 	// scroll bar handler
	id.id = ID_SCROLLBAR_VIEWERV;
	status = GetControlByID(windowref, &id, &scrollbar);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake GetControlByID err %d ", (int)status);
		maLog(mastr);
	}
	else
	{
		if(l_ViewerScrollerControlActionUPP != NULL)
			DisposeControlActionUPP(l_ViewerScrollerControlActionUPP);
		l_ViewerScrollerControlActionUPP = NewControlActionUPP(ViewerScrollerActionProc);
		SetControlAction(scrollbar, l_ViewerScrollerControlActionUPP);
		status = InstallEventHandler(GetControlEventTarget(scrollbar),
									NewEventHandlerUPP(ViewerScrollerMouseWheelHandler),
									1, &mouseWheelEvent, (void *)windowid, NULL);
									
		if(TXNGetRectBounds((TXNObject)v->text, NULL, NULL, &textRect) != noErr)
		{
			maLog(L"TextViewGetTextWindowHeight TXNGetRectBounds failed");
			height = 0;
		}
		else
			height = textRect.right - textRect.left;

		max = height <= maINT32_MAX ? height : maINT32_MAX;
		SetControl32BitMaximum(scrollbar, max);
	}
	if(l_ViewerTXNScrollInfoUPP != NULL)
		DisposeTXNScrollInfoUPP(l_ViewerTXNScrollInfoUPP);
	if((l_ViewerTXNScrollInfoUPP = NewTXNScrollInfoUPP(ViewerTXNScrollInfoCallback)) == NULL)
	{
		masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake NewTXNScrollInfoUPP failed");
		maLog(mastr);
	}
	else if(TXNobj)
			TXNRegisterScrollInfoProc(TXNobj, l_ViewerTXNScrollInfoUPP, (SInt32)windowid);

	if(TXNobj)
	{
		size_t bytesout = wclocal_to_utf8(MALOADINGSTRING, mastrlen(MALOADINGSTRING), fsstr, MAX_PATH);
		fsstr[bytesout] = fsT('\0');
		
		bytesout = StrUTF8toUTF16LE(fsstr);
		status = TXNSetData(TXNobj, kTXNUnicodeTextData, fsstr, bytesout, kTXNStartOffset, kTXNEndOffset);
		if(status != noErr)
		{
			masprintf(mastr, MAXLOGLINELEN, L"ViewerWindowMake TXNSetData err %d 'maosxViewer.nib'", (int)status);
			maLog(mastr);
		}
		TXNFocus(TXNobj, true);
		TXNSetSelection(TXNobj, 0, 0);
		TXNShowSelection(TXNobj, false); // scroll to top
	}
	
	MacMoveWindow(windowref, g_sets.mawin[windowid].xpos[g_sets.winconf], g_sets.mawin[windowid].ypos[g_sets.winconf], false);
	SizeWindow(windowref, g_sets.mawin[windowid].xsize[g_sets.winconf], g_sets.mawin[windowid].ysize[g_sets.winconf], true);

	WindowSetTitle(windowid, wintitle);
	
	if(windowid != WINDOWCATALOG) // hide VPlay button and index text
	{
		CheckBoxHide(windowid, ID_BTN_VIEWERPLAY);
		CheckBoxHide(windowid, ID_TEXT_VIEWERPLAY);
	}

	ShowWindow(windowref);

	return ViewerInit(windowid, &v);
	
} // ViewerWindowMake
#endif


OSStatus AboutWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	UInt32 attributes;

	if((int)userData != WINDOWABOUT || !g_w[WINDOWABOUT])
		return(eventNotHandledErr);
	
	switch(GetEventClass(event))
	{
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						DoWindowMoved(WINDOWABOUT);
					if(attributes & kWindowBoundsChangeUserResize)
						DoWindowResized(WINDOWABOUT);
				break;

				case kEventWindowClose:
					DoWindow(WINDOWABOUT, 0);
				return noErr;

				default:
				break;
			}
		break;

		default:
		break;
	}

	return eventNotHandledErr;
	
} // AboutWindowEventHandler


void AboutWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("AboutWindowMake");
#endif
	IBNibRef nibRef;
	WindowRef windowref;
	OSStatus status;
	ControlRef cb;
	ControlID id = {'MAMP', ID_TEXTVIEW_ABOUT};
	HIViewRef textView;
	TXNObject TXNobj;
	EventTypeSpec eventspec[] = {
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
								};
	machar mastr[MAXLOGLINELEN];

	status = CreateNibReference(CFSTR("maosxAbout"), &nibRef);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"AboutWindowMake CreateNibReference err %d 'maosAbout.nib'", (int)status);
		maLog(mastr);
		return;
	}
	
	status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &windowref);
	DisposeNibReference(nibRef);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"AboutWindowMake CreateWindowFromNib err %d 'maosAbout.nib'", (int)status);
		maLog(mastr);
		return;
	}
	
	status = InstallWindowEventHandler(windowref, NewEventHandlerUPP(AboutWindowEventHandler),
										sizeof(eventspec), eventspec, (void *)WINDOWABOUT, NULL);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"AboutWindowMake InstallWindowEventHandler err %d", (int)status);
		maLog(mastr);
	}

	g_w[WINDOWABOUT] = (void *)windowref;
	
	status = HIViewFindByID(HIViewGetRoot(windowref), id, &textView);
	if(status != noErr)
	{
		masprintf(mastr, MAXLOGLINELEN, L"AboutWindowMake HIViewFindByID err %d", (int)status);
		maLog(mastr);
	}
	else
	{
		TXNobj = HITextViewGetTXNObject(textView);
		if(!TXNobj)
			maLog(L"AboutWindowMake HITextViewGetTXNObject failed");
		else
		{
			fschar fsstr[STRLEN8192]; // sizeof(g_abouttext)
			size_t bytesout = wclocal_to_utf8(g_abouttext, mastrlen(g_abouttext), fsstr, STRLEN8192);
			fsstr[bytesout] = fsT('\0');
		
			bytesout = StrUTF8toUTF16LE(fsstr);
			status = TXNSetData(TXNobj, kTXNUnicodeTextData, fsstr, bytesout, kTXNStartOffset, kTXNEndOffset);

			if(status != noErr)
			{
				masprintf(mastr, MAXLOGLINELEN, L"AboutWindowMake TXNSetData err %d 'maosAbout.nib'", (int)status);
				maLog(mastr);
			}
	
			TXNSetSelection(TXNobj, 0, 0);
			TXNShowSelection(TXNobj, false); // scroll to top
		}
	}
	MacMoveWindow(windowref, g_sets.mawin[WINDOWABOUT].xpos[g_sets.winconf], g_sets.mawin[WINDOWABOUT].ypos[g_sets.winconf], false); // front
	SizeWindow(windowref, g_sets.mawin[WINDOWABOUT].xsize[g_sets.winconf], g_sets.mawin[WINDOWABOUT].ysize[g_sets.winconf], true); // update

	WindowSetTitle(WINDOWABOUT, L"About MoreAmp");
	
	GetControlByID((WindowRef)g_w[WINDOWABOUT], &id, &cb);
	DeactivateControl(cb);
	
	ShowWindow(windowref);

	return;

} // AboutWindowMake


void maGUIfree()
{
	if(l_lline)
	{
		MAFREE(l_lline);
		l_lline = NULL;
	}
}

void maGUIQuit()
{
	QuitApplicationEventLoop();

} // maGUIQuit


int maModKeyDown()
{
	/*
	UInt32 bstate;
	if((bstate = GetCurrentEventButtonState()) & (1 << 1)) // secondary
		return 1;
	if(bstate & (1 << 0)) // primary)
	*/
	if(GetCurrentEventKeyModifiers() & shiftKey)
			return 1;

	KeyMap Keys; 
	unsigned char *BytePtr = (unsigned char*)Keys; 
	GetKeys(Keys);
	if(BytePtr[7] & 1) // Shift 0x38 == 56 = (7 * 8) + 0
		return 1;

	return 0; 

} // maModKeyDown

#ifdef __cplusplus
}
#endif

#endif // MAGUICARBON

// eof

